#ifndef BatchLab_PlotterFactory_h
#define BatchLab_PlotterFactory_h

// Inheritance :
#include <AIDA/IPlotterFactory.h>

#include <vector>

namespace Slash {namespace Core {class ISession;}}

namespace BatchLab {

class BasePlotterFactory : public virtual AIDA::IPlotterFactory {
public: //AIDA/IPlotterFactory
  //virtual AIDA::IPlotter* create(const std::string&);
  virtual AIDA::IMarkerStyle* createMarkerStyle();
  virtual AIDA::ITextStyle* createTextStyle();
  virtual AIDA::ILineStyle* createLineStyle();
  virtual AIDA::IFillStyle* createFillStyle();
  virtual AIDA::IDataStyle* createDataStyle();
  virtual AIDA::IAxisStyle* createAxisStyle();
  virtual AIDA::ITitleStyle* createTitleStyle();
  virtual AIDA::IPlotterStyle* createPlotterStyle();
public:
  BasePlotterFactory
    (Slash::Core::ISession&,const std::string&,const std::string&,int,char**);
  virtual ~BasePlotterFactory();
protected:
  AIDA::IPlotter* loadPlotter(const std::string&,const std::string&,
                              const std::string&,const std::string&,
                              const std::string&);
protected:
  Slash::Core::ISession& fSession;
  std::string fImplementation;
  std::string fLibrary;  
  std::vector<std::string> fArgs;  
};

}

#endif
