#!/bin/csh -f

#
# File produced by the obuild tool version 1.0
# for the package BatchLab with version v1r3p0.
#

#////////////////////////////////////////////////
# Usage :
#   csh> source setup.csh
#////////////////////////////////////////////////

#set verbose  # uncomment this line to have full verbosity.

#////////////////////////////////////////////////
# Set the absolute path of this package.
# If in the below line there is the keyword :
#
#     @@absolute_dir@@
#
# then the package had not been installed.
#
#  Someone has to replace @@absolute_dir@@
# by the absolute path of the package.
# By "absolute path of the package", we mean that
# if the obuild directory of the package is 
# found under :
#    some_path/pack/vers/obuild
# then the "absolute path of the package" is :
#    some_path/pack/vers
#
#  This replacement can be done on the setup
# scripts of the package by using the sh/build 
# with the -i option.
#
#  This replacement can be done recursively
# on the setups of the used packages by using 
# the sh/build script with the -bci option 
# ("bci" for broadcast install).
#
#////////////////////////////////////////////////

set obuild_BatchLab_path="@@absolute_dir@@"


if ( "${obuild_BatchLab_path}" == '@@absolute_dir@@' ) then
  echo '  The package BatchLab had not been installed.'
  echo ''
  echo ' In the file :'
  echo '    BatchLab/<vers>/obuild/setup.csh'
  echo ' someone has to replace '
  echo '    @@absolute_dir@@'
  echo ' by the absolute path of the package.'
  echo '  By "absolute path of the package", we mean that'
  echo ' if the obuild directory of the package is found under :'
  echo '    some_path/pack/vers/obuild'
  echo ' then the "absolute path of the package" is :'
  echo '    some_path/pack/vers'
  echo ''
  echo '  If having the write access, this replacement can be done'
  echo ' on the setup scripts of the package by using the sh/build'
  echo ' with the -i option. This replacement can be done recursively'
  echo ' on the setups of the used packages by using the sh/build script'
  echo ' with the -bci option ("bci" for broadcast install).'
  echo ''
  exit
endif

if ( $?OBUILD_DIR_BIN ) then
  if (  "${OBUILD_DIR_BIN}" == "" ) then
    set obuild_dir_bin=bin_obuild
  else
    set obuild_dir_bin=${OBUILD_DIR_BIN}
  endif
else
  set obuild_dir_bin=bin_obuild
endif

if ( "${obuild_dir_bin}" == "" ) then
  echo "obuild_dir_bin variable not defined."
  exit
endif

/bin/mkdir -p "${obuild_BatchLab_path}/${obuild_dir_bin}"
if ( ! -e "${obuild_BatchLab_path}/${obuild_dir_bin}/obuild_platform" ) then
  if ( ! -e "${obuild_BatchLab_path}/obuild/cpp/obuild_platform.cpp" ) then
    echo "Program source obuild_platform.cpp not found."
    exit
  endif
  if ( $?obuild_cxx_command ) then
    if ( "${obuild_cxx_command}" == "" ) then
      if (  $?OBUILD_CXX ) then
        set obuild_platform_compiler=${OBUILD_CXX}
      else
        set obuild_platform_compiler=c++
      endif
    else
      set obuild_platform_compiler=${obuild_cxx_command}
    endif
  else
    set obuild_platform_compiler=c++
  endif
  ${obuild_platform_compiler} -o "${obuild_BatchLab_path}/${obuild_dir_bin}/obuild_platform" "${obuild_BatchLab_path}/obuild/cpp/obuild_platform.cpp"
  unset obuild_platform_compiler
  if ( ! -e "${obuild_BatchLab_path}/${obuild_dir_bin}/obuild_platform" ) then
    echo "Program obuild_platform not found."
    exit
  endif
endif
set obuild_platform_exe="${obuild_BatchLab_path}/${obuild_dir_bin}/obuild_platform"
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'UNIX'`
if ( ${obuild_platform_result} == yes ) then
set CERNLIB_home="/cern/pro"
endif
unset obuild_platform_result
if ( $?OBUILD_SITE ) then
if ( "${OBUILD_SITE}" == "lxplus_slc4_amd64_gcc34" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set CERNLIB_home="/afs/cern.ch/sw/lcg/external/cernlib/2005/slc4_amd64_gcc34"
endif
unset obuild_platform_result
endif
endif
if ( $?OBUILD_SITE ) then
if ( "${OBUILD_SITE}" == "lx2" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set CERNLIB_home="/cern/pro/lib64"
endif
unset obuild_platform_result
endif
endif
/bin/mkdir -p "${obuild_BatchLab_path}/${obuild_dir_bin}"
if ( ! -e "${obuild_BatchLab_path}/${obuild_dir_bin}/obuild_find" ) then
  if ( ! -e "${obuild_BatchLab_path}/obuild/cpp/obuild_find.cpp" ) then
    echo "Program source obuild_find.cpp not found."
    exit
  endif
  if ( $?obuild_cxx_command ) then
    if ( "${obuild_cxx_command}" == "" ) then
      if (  $?OBUILD_CXX ) then
        set obuild_find_compiler=${OBUILD_CXX}
      else
        set obuild_find_compiler=c++
      endif
    else
      set obuild_find_compiler=${obuild_cxx_command}
    endif
  else
    set obuild_find_compiler=c++
  endif
  ${obuild_find_compiler} -o "${obuild_BatchLab_path}/${obuild_dir_bin}/obuild_find" "${obuild_BatchLab_path}/obuild/cpp/obuild_find.cpp"
  unset obuild_find_compiler
  if ( ! -e "${obuild_BatchLab_path}/${obuild_dir_bin}/obuild_find" ) then
    echo "Program obuild_find not found."
    exit
  endif
endif
set obuild_find_exe="${obuild_BatchLab_path}/${obuild_dir_bin}/obuild_find"
if ( "${obuild_find_exe}" == "" ) then
  echo "Variable obuild_find_exe not defined."
  exit
endif
set obuild_AIDA_path=`"${obuild_find_exe}" AIDA 'v3r2p1'`
if ( "${obuild_find_exe}" == "" ) then
  echo "Variable obuild_find_exe not defined."
  exit
endif
set obuild_HCL_path=`"${obuild_find_exe}" HCL 'v7r*'`
if ( "${obuild_find_exe}" == "" ) then
  echo "Variable obuild_find_exe not defined."
  exit
endif
set obuild_Slash_path=`"${obuild_find_exe}" Slash 'v1r*'`
if ( "${obuild_find_exe}" == "" ) then
  echo "Variable obuild_find_exe not defined."
  exit
endif
set obuild_Lib_path=`"${obuild_find_exe}" Lib 'v8r*'`
if ( "${obuild_find_exe}" == "" ) then
  echo "Variable obuild_find_exe not defined."
  exit
endif
set obuild_Midnight_path=`"${obuild_find_exe}" Midnight 'v4r*'`
if ( "${obuild_find_exe}" == "" ) then
  echo "Variable obuild_find_exe not defined."
  exit
endif
set obuild_Minuit_path=`"${obuild_find_exe}" Minuit 'v1r*'`
if ( "${obuild_find_exe}" == "" ) then
  echo "Variable obuild_find_exe not defined."
  exit
endif
set obuild_Rio_path=`"${obuild_find_exe}" Rio 'v9r*'`
if ( "${obuild_find_exe}" == "" ) then
  echo "Variable obuild_find_exe not defined."
  exit
endif
set obuild_expat_path=`"${obuild_find_exe}" expat 'v1r*'`
if ( "${obuild_find_exe}" == "" ) then
  echo "Variable obuild_find_exe not defined."
  exit
endif
set obuild_zlib_path=`"${obuild_find_exe}" zlib 'v1r*'`
if ( "${obuild_find_exe}" == "" ) then
  echo "Variable obuild_find_exe not defined."
  exit
endif
set obuild_HDF5_path=`"${obuild_find_exe}" HDF5 'v1r*'`

# Set environment variables of this package :
setenv BATCHLABROOT "${obuild_BatchLab_path}"
setenv SLASHROOT "${obuild_Slash_path}"
setenv LIBROOT "${obuild_Lib_path}"
setenv LIBDIRLIB "${obuild_Lib_path}/${obuild_dir_bin}"
setenv BATCHLABDIRLIB "${obuild_BatchLab_path}/${obuild_dir_bin}"

if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if ( ${obuild_platform_result} == yes ) then
  if (  $?DYLD_LIBRARY_PATH ) then
    setenv DYLD_LIBRARY_PATH "${DYLD_LIBRARY_PATH}:${obuild_HCL_path}/${obuild_dir_bin}"
  else
    setenv DYLD_LIBRARY_PATH "${obuild_HCL_path}/${obuild_dir_bin}"
  endif
else
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'CYGWIN'`
if ( ${obuild_platform_result} == yes ) then
if (  $?PATH ) then
  setenv PATH "${PATH}:${obuild_HCL_path}/${obuild_dir_bin}"
else
  setenv PATH "${obuild_HCL_path}/${obuild_dir_bin}"
endif

else
  if (  $?LD_LIBRARY_PATH ) then
    setenv LD_LIBRARY_PATH "${LD_LIBRARY_PATH}:${obuild_HCL_path}/${obuild_dir_bin}"
  else
    setenv LD_LIBRARY_PATH "${obuild_HCL_path}/${obuild_dir_bin}"
  endif
endif
unset obuild_platform_result
endif
unset obuild_platform_result

if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if ( ${obuild_platform_result} == yes ) then
  if (  $?DYLD_LIBRARY_PATH ) then
    setenv DYLD_LIBRARY_PATH "${DYLD_LIBRARY_PATH}:${obuild_Lib_path}/${obuild_dir_bin}"
  else
    setenv DYLD_LIBRARY_PATH "${obuild_Lib_path}/${obuild_dir_bin}"
  endif
else
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'CYGWIN'`
if ( ${obuild_platform_result} == yes ) then
if (  $?PATH ) then
  setenv PATH "${PATH}:${obuild_Lib_path}/${obuild_dir_bin}"
else
  setenv PATH "${obuild_Lib_path}/${obuild_dir_bin}"
endif

else
  if (  $?LD_LIBRARY_PATH ) then
    setenv LD_LIBRARY_PATH "${LD_LIBRARY_PATH}:${obuild_Lib_path}/${obuild_dir_bin}"
  else
    setenv LD_LIBRARY_PATH "${obuild_Lib_path}/${obuild_dir_bin}"
  endif
endif
unset obuild_platform_result
endif
unset obuild_platform_result

if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if ( ${obuild_platform_result} == yes ) then
  if (  $?DYLD_LIBRARY_PATH ) then
    setenv DYLD_LIBRARY_PATH "${DYLD_LIBRARY_PATH}:${obuild_Midnight_path}/${obuild_dir_bin}"
  else
    setenv DYLD_LIBRARY_PATH "${obuild_Midnight_path}/${obuild_dir_bin}"
  endif
else
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'CYGWIN'`
if ( ${obuild_platform_result} == yes ) then
if (  $?PATH ) then
  setenv PATH "${PATH}:${obuild_Midnight_path}/${obuild_dir_bin}"
else
  setenv PATH "${obuild_Midnight_path}/${obuild_dir_bin}"
endif

else
  if (  $?LD_LIBRARY_PATH ) then
    setenv LD_LIBRARY_PATH "${LD_LIBRARY_PATH}:${obuild_Midnight_path}/${obuild_dir_bin}"
  else
    setenv LD_LIBRARY_PATH "${obuild_Midnight_path}/${obuild_dir_bin}"
  endif
endif
unset obuild_platform_result
endif
unset obuild_platform_result

if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if ( ${obuild_platform_result} == yes ) then
  if (  $?DYLD_LIBRARY_PATH ) then
    setenv DYLD_LIBRARY_PATH "${DYLD_LIBRARY_PATH}:${obuild_Minuit_path}/${obuild_dir_bin}"
  else
    setenv DYLD_LIBRARY_PATH "${obuild_Minuit_path}/${obuild_dir_bin}"
  endif
else
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'CYGWIN'`
if ( ${obuild_platform_result} == yes ) then
if (  $?PATH ) then
  setenv PATH "${PATH}:${obuild_Minuit_path}/${obuild_dir_bin}"
else
  setenv PATH "${obuild_Minuit_path}/${obuild_dir_bin}"
endif

else
  if (  $?LD_LIBRARY_PATH ) then
    setenv LD_LIBRARY_PATH "${LD_LIBRARY_PATH}:${obuild_Minuit_path}/${obuild_dir_bin}"
  else
    setenv LD_LIBRARY_PATH "${obuild_Minuit_path}/${obuild_dir_bin}"
  endif
endif
unset obuild_platform_result
endif
unset obuild_platform_result

if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if ( ${obuild_platform_result} == yes ) then
  if (  $?DYLD_LIBRARY_PATH ) then
    setenv DYLD_LIBRARY_PATH "${DYLD_LIBRARY_PATH}:${obuild_Rio_path}/${obuild_dir_bin}"
  else
    setenv DYLD_LIBRARY_PATH "${obuild_Rio_path}/${obuild_dir_bin}"
  endif
else
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'CYGWIN'`
if ( ${obuild_platform_result} == yes ) then
if (  $?PATH ) then
  setenv PATH "${PATH}:${obuild_Rio_path}/${obuild_dir_bin}"
else
  setenv PATH "${obuild_Rio_path}/${obuild_dir_bin}"
endif

else
  if (  $?LD_LIBRARY_PATH ) then
    setenv LD_LIBRARY_PATH "${LD_LIBRARY_PATH}:${obuild_Rio_path}/${obuild_dir_bin}"
  else
    setenv LD_LIBRARY_PATH "${obuild_Rio_path}/${obuild_dir_bin}"
  endif
endif
unset obuild_platform_result
endif
unset obuild_platform_result

if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if ( ${obuild_platform_result} == yes ) then
  if (  $?DYLD_LIBRARY_PATH ) then
    setenv DYLD_LIBRARY_PATH "${DYLD_LIBRARY_PATH}:${obuild_expat_path}/${obuild_dir_bin}"
  else
    setenv DYLD_LIBRARY_PATH "${obuild_expat_path}/${obuild_dir_bin}"
  endif
else
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'CYGWIN'`
if ( ${obuild_platform_result} == yes ) then
if (  $?PATH ) then
  setenv PATH "${PATH}:${obuild_expat_path}/${obuild_dir_bin}"
else
  setenv PATH "${obuild_expat_path}/${obuild_dir_bin}"
endif

else
  if (  $?LD_LIBRARY_PATH ) then
    setenv LD_LIBRARY_PATH "${LD_LIBRARY_PATH}:${obuild_expat_path}/${obuild_dir_bin}"
  else
    setenv LD_LIBRARY_PATH "${obuild_expat_path}/${obuild_dir_bin}"
  endif
endif
unset obuild_platform_result
endif
unset obuild_platform_result

if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if ( ${obuild_platform_result} == yes ) then
  if (  $?DYLD_LIBRARY_PATH ) then
    setenv DYLD_LIBRARY_PATH "${DYLD_LIBRARY_PATH}:${obuild_zlib_path}/${obuild_dir_bin}"
  else
    setenv DYLD_LIBRARY_PATH "${obuild_zlib_path}/${obuild_dir_bin}"
  endif
else
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'CYGWIN'`
if ( ${obuild_platform_result} == yes ) then
if (  $?PATH ) then
  setenv PATH "${PATH}:${obuild_zlib_path}/${obuild_dir_bin}"
else
  setenv PATH "${obuild_zlib_path}/${obuild_dir_bin}"
endif

else
  if (  $?LD_LIBRARY_PATH ) then
    setenv LD_LIBRARY_PATH "${LD_LIBRARY_PATH}:${obuild_zlib_path}/${obuild_dir_bin}"
  else
    setenv LD_LIBRARY_PATH "${obuild_zlib_path}/${obuild_dir_bin}"
  endif
endif
unset obuild_platform_result
endif
unset obuild_platform_result

if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if ( ${obuild_platform_result} == yes ) then
  if (  $?DYLD_LIBRARY_PATH ) then
    setenv DYLD_LIBRARY_PATH "${DYLD_LIBRARY_PATH}:${obuild_HDF5_path}/${obuild_dir_bin}"
  else
    setenv DYLD_LIBRARY_PATH "${obuild_HDF5_path}/${obuild_dir_bin}"
  endif
else
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'CYGWIN'`
if ( ${obuild_platform_result} == yes ) then
if (  $?PATH ) then
  setenv PATH "${PATH}:${obuild_HDF5_path}/${obuild_dir_bin}"
else
  setenv PATH "${obuild_HDF5_path}/${obuild_dir_bin}"
endif

else
  if (  $?LD_LIBRARY_PATH ) then
    setenv LD_LIBRARY_PATH "${LD_LIBRARY_PATH}:${obuild_HDF5_path}/${obuild_dir_bin}"
  else
    setenv LD_LIBRARY_PATH "${obuild_HDF5_path}/${obuild_dir_bin}"
  endif
endif
unset obuild_platform_result
endif
unset obuild_platform_result

if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if ( ${obuild_platform_result} == yes ) then
  if (  $?DYLD_LIBRARY_PATH ) then
    setenv DYLD_LIBRARY_PATH "${DYLD_LIBRARY_PATH}:${obuild_BatchLab_path}/${obuild_dir_bin}"
  else
    setenv DYLD_LIBRARY_PATH "${obuild_BatchLab_path}/${obuild_dir_bin}"
  endif
else
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'CYGWIN'`
if ( ${obuild_platform_result} == yes ) then
if (  $?PATH ) then
  setenv PATH "${PATH}:${obuild_BatchLab_path}/${obuild_dir_bin}"
else
  setenv PATH "${obuild_BatchLab_path}/${obuild_dir_bin}"
endif

else
  if (  $?LD_LIBRARY_PATH ) then
    setenv LD_LIBRARY_PATH "${LD_LIBRARY_PATH}:${obuild_BatchLab_path}/${obuild_dir_bin}"
  else
    setenv LD_LIBRARY_PATH "${obuild_BatchLab_path}/${obuild_dir_bin}"
  endif
endif
unset obuild_platform_result
endif
unset obuild_platform_result

if (  $?PATH ) then
  setenv PATH "${PATH}:${obuild_BatchLab_path}/${obuild_dir_bin}"
else
  setenv PATH "${obuild_BatchLab_path}/${obuild_dir_bin}"
endif

unset obuild_BatchLab_path

#FIXME unset obuild_dir_bin
