// this :
#include <BatchLab/Core/BaseFactory.h>

#include <Lib/Debug.h>
#include <Lib/Cast.h>
#include <Lib/Out.h>
#include <Lib/smanip.h>

#include <Slash/Store/ITree.h>

//////////////////////////////////////////////////////////////////////////////
BatchLab::BaseFactory::BaseFactory(
 Slash::Core::IWriter& aPrinter
,Slash::Store::ITree& aTree
)
:fPrinter(aPrinter)
,fTree(aTree)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Debug::increment("BatchLab::BaseFactory");
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::BaseFactory::~BaseFactory(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Debug::decrement("BatchLab::BaseFactory");
}
//////////////////////////////////////////////////////////////////////////////
bool BatchLab::BaseFactory::manage(
 const std::string& aOptions
) const
//////////////////////////////////////////////////////////////////////////////
// Managed by default.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::string value;
  if(!Lib::smanip::option(aOptions,"manage",value)) return true;
  bool b;
  if(!Lib::smanip::tobool(value,b)) return true;
  return b;
}
//////////////////////////////////////////////////////////////////////////////
bool BatchLab::BaseFactory::manageObject(
 Slash::Store::IObject* aObject
,const std::string& aPath
)
//////////////////////////////////////////////////////////////////////////////
// The string "/not_managed" appears too in path_not_managed().
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(aPath=="/not_managed") return true; //Not managed;
  return fTree.manageObject(aObject,aPath);
}
