//this :
#include <BatchLab/Core/HistogramAllocator.h>

#include <Lib/Out.h>
#include <Lib/Cast.h>
#include <Lib/sout.h>

#include <BatchLab/Core/Histogram.h>

//////////////////////////////////////////////////////////////////////////////
BatchLab::HistogramAllocator::HistogramAllocator(
 Slash::Core::IWriter& aPrinter
)
:fPrinter(aPrinter)
,fName("BatchLab::HistogramAllocator")
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::HistogramAllocator::~HistogramAllocator(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
std::string BatchLab::HistogramAllocator::name(
) const 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{  
  return fName;
}
//////////////////////////////////////////////////////////////////////////////
void* BatchLab::HistogramAllocator::cast(
 const std::string& aClass
) const 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
  if_Lib_SCast(BatchLab::HistogramAllocator)
  else if_Lib_SCast(Slash::Core::IManager)
  else return 0;
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
#define CHECK_HISTO(aCMT) \
  if(!object) return 0;\
  if(!object->isValid()) {\
    Lib::Out out(fPrinter);\
    out << aCMT << " :"\
        << " unable to create a valid histogram."\
        << " Check the booking parameters."\
        << Lib::endl;\
    delete object;\
    return 0;\
  }
//////////////////////////////////////////////////////////////////////////////
BatchLab::Histogram1D* BatchLab::HistogramAllocator::new_Histogram1D(
 Slash::Core::IWriter& aPrinter
,const std::string& aName
,HCL::Histogram& aHclHisto
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  BatchLab::Histogram1D* object = 
    new BatchLab::Histogram1D(aPrinter,aName,aHclHisto);
  CHECK_HISTO("BatchLab::HistogramAllocator::new_Histogram1D")
  return object;
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Histogram1D* BatchLab::HistogramAllocator::new_Histogram1D(
 Slash::Core::IWriter& aPrinter
,const std::string& aName
,const std::string& aTitle
,int aXnumber
,double aXmin
,double aXmax
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  BatchLab::Histogram1D* object = 
    new BatchLab::Histogram1D(aPrinter,aName,aTitle,aXnumber,aXmin,aXmax);
  CHECK_HISTO("BatchLab::HistogramAllocator::new_")
  return object;
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Histogram1D* BatchLab::HistogramAllocator::new_Histogram1D(
 Slash::Core::IWriter& aPrinter
,const std::string& aName
,const std::string& aTitle
,const std::vector<double>& aEdges
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  BatchLab::Histogram1D* object = 
    new BatchLab::Histogram1D(aPrinter,aName,aTitle,aEdges);
  CHECK_HISTO("BatchLab::HistogramAllocator::new_Histogram1D")
  return object;
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Histogram1D* BatchLab::HistogramAllocator::new_Histogram1D(
 const Histogram1D& aFrom
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  BatchLab::Histogram1D* object = new BatchLab::Histogram1D(aFrom);
  CHECK_HISTO("BatchLab::HistogramAllocator::new_Histogram1D")
  return object;
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
BatchLab::Profile1D* BatchLab::HistogramAllocator::new_Profile1D(
 Slash::Core::IWriter& aPrinter
,const std::string& aName
,HCL::Histogram& aHclHisto
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  BatchLab::Profile1D* object = 
    new BatchLab::Profile1D(aPrinter,aName,aHclHisto);
  CHECK_HISTO("BatchLab::HistogramAllocator::new_Profile1D")
  return object;
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Profile1D* BatchLab::HistogramAllocator::new_Profile1D(
 Slash::Core::IWriter& aPrinter
,const std::string& aName
,const std::string& aTitle
,int aXnumber
,double aXmin
,double aXmax
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  BatchLab::Profile1D* object = 
    new BatchLab::Profile1D(aPrinter,aName,aTitle,aXnumber,aXmin,aXmax);
  CHECK_HISTO("BatchLab::HistogramAllocator::new_Profile1D")
  return object;
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Profile1D* BatchLab::HistogramAllocator::new_Profile1D(
 Slash::Core::IWriter& aPrinter
,const std::string& aName
,const std::string& aTitle
,int aXnumber
,double aXmin
,double aXmax
,double aVmin
,double aVmax
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  BatchLab::Profile1D* object = 
    new BatchLab::Profile1D(aPrinter,aName,aTitle,
                            aXnumber,aXmin,aXmax,aVmin,aVmax);
  CHECK_HISTO("BatchLab::HistogramAllocator::new_Profile1D")
  return object;
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Profile1D* BatchLab::HistogramAllocator::new_Profile1D(
 Slash::Core::IWriter& aPrinter
,const std::string& aName
,const std::string& aTitle
,const std::vector<double>& aEdges
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  BatchLab::Profile1D* object = 
    new BatchLab::Profile1D(aPrinter,aName,aTitle,aEdges);
  CHECK_HISTO("BatchLab::HistogramAllocator::new_Profile1D")
  return object;
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Profile1D* BatchLab::HistogramAllocator::new_Profile1D(
 Slash::Core::IWriter& aPrinter
,const std::string& aName
,const std::string& aTitle
,const std::vector<double>& aEdges
,double aVmin
,double aVmax
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  BatchLab::Profile1D* object = 
    new BatchLab::Profile1D(aPrinter,aName,aTitle,aEdges,aVmin,aVmax);
  CHECK_HISTO("BatchLab::HistogramAllocator::new_Prfile1D")
  return object;
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Profile1D* BatchLab::HistogramAllocator::new_Profile1D(
 const Profile1D& aFrom
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  BatchLab::Profile1D* object = new BatchLab::Profile1D(aFrom);
  CHECK_HISTO("BatchLab::HistogramAllocator::new_Profile1D")
  return object;
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
BatchLab::Histogram2D* BatchLab::HistogramAllocator::new_Histogram2D(
 Slash::Core::IWriter& aPrinter
,const std::string& aName
,HCL::Histogram& aHclHisto
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  BatchLab::Histogram2D* object = 
    new BatchLab::Histogram2D(aPrinter,aName,aHclHisto);
  CHECK_HISTO("BatchLab::HistogramAllocator::new_Histogram2D")
  return object;
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Histogram2D* BatchLab::HistogramAllocator::new_Histogram2D(
 Slash::Core::IWriter& aPrinter
,const std::string& aName
,const std::string& aTitle
,int aXnumber
,double aXmin
,double aXmax
,int aYnumber
,double aYmin
,double aYmax
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  BatchLab::Histogram2D* object = 
    new BatchLab::Histogram2D(aPrinter,aName,aTitle,
                              aXnumber,aXmin,aXmax,
                              aYnumber,aYmin,aYmax);
  CHECK_HISTO("BatchLab::HistogramAllocator::new_Histogram2D")
  return object;
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Histogram2D* BatchLab::HistogramAllocator::new_Histogram2D(
 Slash::Core::IWriter& aPrinter
,const std::string& aName
,const std::string& aTitle
,const std::vector<double>& aEdgesX
,const std::vector<double>& aEdgesY
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  BatchLab::Histogram2D* object = 
    new BatchLab::Histogram2D(aPrinter,aName,aTitle,aEdgesX,aEdgesY);
  CHECK_HISTO("BatchLab::HistogramAllocator::new_Histogram2D")
  return object;
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Histogram2D* BatchLab::HistogramAllocator::new_Histogram2D(
 const Histogram2D& aFrom
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  BatchLab::Histogram2D* object = new BatchLab::Histogram2D(aFrom);
  CHECK_HISTO("BatchLab::HistogramAllocator::new_Histogram2D")
  return object;
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
BatchLab::Profile2D* BatchLab::HistogramAllocator::new_Profile2D(
 Slash::Core::IWriter& aPrinter
,const std::string& aName
,HCL::Histogram& aHclHisto
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  BatchLab::Profile2D* object = 
    new BatchLab::Profile2D(aPrinter,aName,aHclHisto);
  CHECK_HISTO("BatchLab::HistogramAllocator::new_Profile2D")
  return object;
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Profile2D* BatchLab::HistogramAllocator::new_Profile2D(
 Slash::Core::IWriter& aPrinter
,const std::string& aName
,const std::string& aTitle
,int aXnumber
,double aXmin
,double aXmax
,int aYnumber
,double aYmin
,double aYmax
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  BatchLab::Profile2D* object = 
    new BatchLab::Profile2D(aPrinter,aName,aTitle,aXnumber,aXmin,aXmax,aYnumber,aYmin,aYmax);
  CHECK_HISTO("BatchLab::HistogramAllocator::new_Profile2D")
  return object;
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Profile2D* BatchLab::HistogramAllocator::new_Profile2D(
 Slash::Core::IWriter& aPrinter
,const std::string& aName
,const std::string& aTitle
,int aXnumber
,double aXmin
,double aXmax
,int aYnumber
,double aYmin
,double aYmax
,double aVmin
,double aVmax
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  BatchLab::Profile2D* object = 
    new BatchLab::Profile2D(aPrinter,aName,aTitle,aXnumber,aXmin,aXmax,aYnumber,aYmin,aYmax,aVmin,aVmax);
  CHECK_HISTO("BatchLab::HistogramAllocator::new_Profile2D")
  return object;
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Profile2D* BatchLab::HistogramAllocator::new_Profile2D(
 Slash::Core::IWriter& aPrinter
,const std::string& aName
,const std::string& aTitle
,const std::vector<double>& aEdgesX
,const std::vector<double>& aEdgesY
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  BatchLab::Profile2D* object = 
    new BatchLab::Profile2D(aPrinter,aName,aTitle,aEdgesX,aEdgesY);
  CHECK_HISTO("BatchLab::HistogramAllocator::new_Profile2D")
  return object;
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Profile2D* BatchLab::HistogramAllocator::new_Profile2D(
 Slash::Core::IWriter& aPrinter
,const std::string& aName
,const std::string& aTitle
,const std::vector<double>& aEdgesX
,const std::vector<double>& aEdgesY
,double aVmin
,double aVmax
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  BatchLab::Profile2D* object = 
    new BatchLab::Profile2D(aPrinter,aName,aTitle,aEdgesX,aEdgesY,aVmin,aVmax);
  CHECK_HISTO("BatchLab::HistogramAllocator::new_Profile2D")
  return object;
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Profile2D* BatchLab::HistogramAllocator::new_Profile2D(
 const Profile2D& aFrom
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  BatchLab::Profile2D* object = new BatchLab::Profile2D(aFrom);
  CHECK_HISTO("BatchLab::HistogramAllocator::new_Profile2D")
  return object;
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
BatchLab::Histogram3D* BatchLab::HistogramAllocator::new_Histogram3D(
 Slash::Core::IWriter& aPrinter
,const std::string& aName
,HCL::Histogram& aHclHisto
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  BatchLab::Histogram3D* object = 
    new BatchLab::Histogram3D(aPrinter,aName,aHclHisto);
  CHECK_HISTO("BatchLab::HistogramAllocator::new_Histogram3D")
  return object;
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Histogram3D* BatchLab::HistogramAllocator::new_Histogram3D(
 Slash::Core::IWriter& aPrinter
,const std::string& aName
,const std::string& aTitle
,int aXnumber
,double aXmin
,double aXmax
,int aYnumber
,double aYmin
,double aYmax
,int aZnumber
,double aZmin
,double aZmax
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  BatchLab::Histogram3D* object = 
    new BatchLab::Histogram3D(aPrinter,aName,aTitle,aXnumber,aXmin,aXmax,aYnumber,aYmin,aYmax,aZnumber,aZmin,aZmax);
  CHECK_HISTO("BatchLab::HistogramAllocator::new_Histogram3D")
  return object;
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Histogram3D* BatchLab::HistogramAllocator::new_Histogram3D(
 Slash::Core::IWriter& aPrinter
,const std::string& aName
,const std::string& aTitle
,const std::vector<double>& aEdgesX
,const std::vector<double>& aEdgesY
,const std::vector<double>& aEdgesZ
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  BatchLab::Histogram3D* object = 
    new BatchLab::Histogram3D(aPrinter,aName,aTitle,aEdgesX,aEdgesY,aEdgesZ);
  CHECK_HISTO("BatchLab::HistogramAllocator::new_Histogram3D")
  return object;
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Histogram3D* BatchLab::HistogramAllocator::new_Histogram3D(
 const Histogram3D& aFrom
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  BatchLab::Histogram3D* object = new BatchLab::Histogram3D(aFrom);
  CHECK_HISTO("BatchLab::HistogramAllocator::new_Histogram3D")
  return object;
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
#include <BatchLab/Core/Cloud.h>
//////////////////////////////////////////////////////////////////////////////
BatchLab::Cloud1D* BatchLab::HistogramAllocator::new_Cloud1D(
 Slash::Core::IWriter& aPrinter
,const std::string& aName
,const std::string& aTitle
,int aLimit
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  BatchLab::Cloud1D* object = 
    new BatchLab::Cloud1D(aPrinter,aName,aTitle,aLimit);
  CHECK_HISTO("BatchLab::HistogramAllocator::new_Cloud1D")
  return object;
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Cloud1D* BatchLab::HistogramAllocator::new_Cloud1D(
 const Cloud1D& aFrom
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  BatchLab::Cloud1D* object = new BatchLab::Cloud1D(aFrom);
  CHECK_HISTO("BatchLab::HistogramAllocator::new_Cloud1D")
  return object;
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Cloud2D* BatchLab::HistogramAllocator::new_Cloud2D(
 Slash::Core::IWriter& aPrinter
,const std::string& aName
,const std::string& aTitle
,int aLimit
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  BatchLab::Cloud2D* object = 
    new BatchLab::Cloud2D(aPrinter,aName,aTitle,aLimit);
  CHECK_HISTO("BatchLab::HistogramAllocator::new_Cloud2D")
  return object;
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Cloud2D* BatchLab::HistogramAllocator::new_Cloud2D(
 const Cloud2D& aFrom
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  BatchLab::Cloud2D* object = new BatchLab::Cloud2D(aFrom);
  CHECK_HISTO("BatchLab::HistogramAllocator::new_Cloud2D")
  return object;
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Cloud3D* BatchLab::HistogramAllocator::new_Cloud3D(
 Slash::Core::IWriter& aPrinter
,const std::string& aName
,const std::string& aTitle
,int aLimit
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  BatchLab::Cloud3D* object = 
    new BatchLab::Cloud3D(aPrinter,aName,aTitle,aLimit);
  CHECK_HISTO("BatchLab::HistogramAllocator::new_Cloud3D")
  return object;
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Cloud3D* BatchLab::HistogramAllocator::new_Cloud3D(
 const Cloud3D& aFrom
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  BatchLab::Cloud3D* object = new BatchLab::Cloud3D(aFrom);
  CHECK_HISTO("BatchLab::HistogramAllocator::new_Cloud3D")
  return object;
}
