// this :
#include <BatchLab/MySQL/MySQLManager.h>

// Lib :
#include <Lib/Cast.h>
#include <Lib/Manager.h>

// BatchLab :
#include <BatchLab/MySQL/MySQLTree.h>

//////////////////////////////////////////////////////////////////////////////
BatchLab::MySQLManager::MySQLManager(
 Slash::Core::ISession& aSession
)
:fName("MySQLManager")
,fSession(aSession)
,fMySQL(0)
,fMemoryTree(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fMemoryTree = 
    Lib_findManager(fSession,"MemoryTree",AIDA::ITree);
  if(!fMemoryTree) {
    Lib::Out out(fSession.printer());
    out << "BatchLab::MySQLManager::MySQLManager :"
        << " MemoryTree not found." << Lib::endl;
    return;
  }

  fMySQL = new MYSQL;
  mysql_init(fMySQL);
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::MySQLManager::~MySQLManager(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  delete fMySQL;
}
//////////////////////////////////////////////////////////////////////////////
const std::string& BatchLab::MySQLManager::name(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fName;
}
//////////////////////////////////////////////////////////////////////////////
void* BatchLab::MySQLManager::cast(
 const std::string& aClass
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(aClass=="BatchLab::MySQLManager") {
    return Lib_SCast(MySQLManager);
  } else if(aClass=="Slash::Store::IStoreManager") {
    return Lib_SCast(Slash::Store::IStoreManager);
  } else if(aClass=="Slash::Core::IManager") {
    return Lib_SCast(Slash::Core::IManager);
  } else {
    return 0;
  }
}
//////////////////////////////////////////////////////////////////////////////
MYSQL* BatchLab::MySQLManager::mysql(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fMySQL;
}
//////////////////////////////////////////////////////////////////////////////
AIDA::ITree* BatchLab::MySQLManager::createTree(
 const std::string& aName
,bool //aReadOnly
,bool //aCreateNew
,const std::string&
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!fMySQL) return 0;
  if(!fMemoryTree) return 0;
  MySQLTree* tree = new MySQLTree(fSession,aName,false,false,
                                  *this,*fMemoryTree,fSession.verboseLevel());
  fSession.addManager(tree);
  return tree;
}
//////////////////////////////////////////////////////////////////////////////
AIDA::ITuple* BatchLab::MySQLManager::createTuple(
 AIDA::ITree&
,const std::string&
,const std::string&
,const std::string&
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return 0;
}
