// this :
#include <BatchLab/XML/Manager.h>

// Lib:
#include <Slash/Core/ISession.h>
#include <Lib/Out.h>
#include <Lib/Cast.h>

//////////////////////////////////////////////////////////////////////////////
BatchLab::XML::Manager::Manager(
 Slash::Core::ISession& aSession
)
:fName("XML_Manager")
,fSession(aSession)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::XML::Manager::~Manager(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
std::string BatchLab::XML::Manager::name(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fName;
}
//////////////////////////////////////////////////////////////////////////////
void* BatchLab::XML::Manager::cast(
 const std::string& aClass
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if_Lib_SCast(BatchLab::XML::Manager)
  else if_Lib_SCast(Slash::Store::IStoreManager)
  else if_Lib_SCast(Slash::Core::IManager)
  else return 0;
}

#include <BatchLab/XML/Tree.h>
//////////////////////////////////////////////////////////////////////////////
Slash::Store::ITree* BatchLab::XML::Manager::createTree(
 const std::string& aName
,bool aReadOnly
,bool aCreateNew
,const std::string& aOptions
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  XML::Tree* tree = new XML::Tree(fSession,aName,aReadOnly,aCreateNew,aOptions,
                                *this,fSession.verboseLevel());
  if(!tree) return 0;
  if(!tree->isValid()) {
    delete tree;
    return 0;
  }
  fSession.addManager(tree);
  return tree;
}

//#include <BatchLab/XML/XML_Tuple.h>
//////////////////////////////////////////////////////////////////////////////
Slash::Store::IObject* BatchLab::XML::Manager::createObject(
 Slash::Store::ITree& //aTree
,const std::string& //aClass
,const std::string& //aPath
,const std::string& //aName
,const std::string& //aTitle
,const std::vector<std::string>& //aArgs
,const std::string& //aOptions
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Out out(fSession.printer());
  out << "BatchLab::XML::Manager::createObject :" 
      << " dummy."
      << Lib::endl;
  return 0;
}
//////////////////////////////////////////////////////////////////////////////
Slash::Store::IObject* BatchLab::XML::Manager::createObject(
 Slash::Store::ITree& //aTree
,const std::string& //aClass
,const std::string& //aPath
,const std::string& //aName
,const std::string& //aTitle
,const std::vector<Slash::Store::IStoreManager::Range>& //aArgs
,const std::string& //aOptions
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Out out(fSession.printer());
  out << "BatchLab::XML::Manager::createObject :" 
      << " dummy."
      << Lib::endl;
  return 0;
}
