@ECHO OFF
SETLOCAL

REM #
REM # File produced by the obuild tool version 1.0
REM # for the package CoinGtk with version v1r50p4.
REM #

REM #////////////////////////////////////////////////
REM # Usage :
REM #   DOS> CD some_path\pack\version\obuild
REM #   DOS> DOS\build_CoinGtk
REM #
REM #////////////////////////////////////////////////

REM #////////////////////////////////////////////////
REM #/// Get path of this file :
REM #////////////////////////////////////////////////
SET obuild_CoinGtk_path=%~dp0
REM # Remove ending \obuild\DOS\
SET obuild_CoinGtk_path=%obuild_CoinGtk_path:~0,-12%

REM #////////////////////////////////////////////////
REM #/// Treat arguments :
REM #////////////////////////////////////////////////

SET obuild_verbose=no
SET obuild_debug=no
SET obuild_optimize=yes
SET obuild_set_x=no

:next_arg
IF "%1%" == "" GOTO end_args

IF NOT "%1%" == "-v" GOTO end_if_v
  SET obuild_verbose=yes
  SHIFT
  GOTO next_arg
:end_if_v

IF NOT "%1%" == "-g" GOTO end_if_g
  SET obuild_debug=yes
  SHIFT
  GOTO next_arg
:end_if_g

IF NOT "%1%" == "-x" GOTO end_if_x
  SET obuild_set_x=yes
  SHIFT
  GOTO next_arg
:end_if_x

:end_args

REM #////////////////////////////////////////////////
REM #/// End arguments.
REM #////////////////////////////////////////////////

IF %obuild_set_x% == yes ECHO ON

IF %obuild_debug% == yes SET obuild_optimize=no

IF "%OBUILD_DIR_BIN%" == "" (
  SET obuild_dir_bin=bin_obuild
) ELSE (
  SET obuild_dir_bin=%OBUILD_DIR_BIN%
)

IF "%obuild_dir_bin%" == "" (
  ECHO obuild_dir_bin variable not defined.
  GOTO obuild_return
)

IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%" MKDIR "%obuild_CoinGtk_path%\%obuild_dir_bin%"

IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%" MKDIR "%obuild_CoinGtk_path%\%obuild_dir_bin%"
IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%\obuild_platform.exe" (
  cl.exe /nologo /DWIN32 /MD /O2 /W3  /GX /GR /Fe"%obuild_CoinGtk_path%\%obuild_dir_bin%\obuild_platform.exe" "%obuild_CoinGtk_path%\obuild\cpp\obuild_platform.cpp" 1> cl_exe_error
  IF ERRORLEVEL 1 TYPE cl_exe_error
  IF NOT ERRORLEVEL 1 DEL cl_exe_error 
  IF EXIST obuild_platform.obj DEL obuild_platform.obj
)

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_CoinGtk_0=%%d
cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_CoinGtk_0%"
SET obuild_pwd_CoinGtk_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_1
SET obuild_cxx_command=cl.exe
:end_if_platform_1
SET obuild_platform_result=
IF "%obuild_cxx_command%" == ""  ECHO Variable obuild_cxx_command not defined.  && GOTO obuild_return

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_CoinGtk_0=%%d
cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_CoinGtk_0%"
SET obuild_pwd_CoinGtk_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_3
SET obuild_cxx_optimize=/O2
:end_if_platform_3
SET obuild_platform_result=

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_CoinGtk_0=%%d
cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_CoinGtk_0%"
SET obuild_pwd_CoinGtk_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_5
SET obuild_cxx_debug=/ZI /Od
:end_if_platform_5
SET obuild_platform_result=

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_CoinGtk_0=%%d
cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_CoinGtk_0%"
SET obuild_pwd_CoinGtk_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_7
SET obuild_cxx_options=/nologo /DWIN32 /MD /GX /GR /W3
:end_if_platform_7
SET obuild_platform_result=

IF NOT %obuild_debug% == yes GOTO else_if_db_build_lib_CoinGtk_sh_8
  SET obuild_cxx_debug_local=%obuild_cxx_debug%
  GOTO end_if_db_build_lib_CoinGtk_sh_8
:else_if_db_build_lib_CoinGtk_sh_8
  SET obuild_cxx_debug_local=
:end_if_db_build_lib_CoinGtk_sh_8

IF NOT %obuild_optimize% == yes GOTO else_if_opt_build_lib_CoinGtk_sh_9
  SET obuild_cxx_optimize_local=%obuild_cxx_optimize%
  GOTO end_if_opt_build_lib_CoinGtk_sh_9
:else_if_opt_build_lib_CoinGtk_sh_9
  SET obuild_cxx_optimize_local=
:end_if_opt_build_lib_CoinGtk_sh_9


SET obuild_cxx_macros=%obuild_cxx_macros% /DHAVE_CONFIG_H
SET obuild_cxx_macros=%obuild_cxx_macros% /DSOGTK_INTERNAL
SET obuild_cxx_macros=%obuild_cxx_macros% /DSOGTK_DEBUG=0
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_CoinGtk_0=%%d
cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_CoinGtk_0%"
SET obuild_pwd_CoinGtk_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_13
SET obuild_cxx_macros=%obuild_cxx_macros% /DSOGTK_MAKE_DLL
:end_if_platform_13
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_CoinGtk_0=%%d
cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_CoinGtk_0%"
SET obuild_pwd_CoinGtk_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_14
SET obuild_cxx_macros=%obuild_cxx_macros% /DCOIN_DLL
:end_if_platform_14
SET obuild_platform_result=

IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%" MKDIR "%obuild_CoinGtk_path%\%obuild_dir_bin%"
IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%\obuild_find.exe" (
  cl.exe /nologo /DWIN32 /MD /O2 /W3 /GX /GR /Fe"%obuild_CoinGtk_path%\%obuild_dir_bin%\obuild_find.exe" "%obuild_CoinGtk_path%\obuild\cpp\obuild_find.cpp" 1> cl_exe_error
  IF ERRORLEVEL 1 TYPE cl_exe_error
  IF NOT ERRORLEVEL 1 DEL cl_exe_error 
  IF EXIST obuild_find.obj DEL obuild_find.obj
)
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_CoinGtk_0=%%d
cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinGL v1r*`) DO SET obuild_CoinGL_path=%%j
cd "%obuild_pwd_CoinGtk_0%"
SET obuild_pwd_CoinGtk_0=
IF NOT DEFINED obuild_CoinGL_path  ECHO Can't find CoinGL package.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_CoinGtk_0=%%d
cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinGL v1r*`) DO SET obuild_CoinGL_path=%%j
cd "%obuild_pwd_CoinGtk_0%"
SET obuild_pwd_CoinGtk_0=
IF NOT DEFINED obuild_CoinGL_path  ECHO Can't find CoinGL package.  && GOTO obuild_return

SET obuild_cxx_includes=/I"%obuild_CoinGtk_path%\include"
SET obuild_cxx_includes=%obuild_cxx_includes% /I"%obuild_CoinGtk_path%\src"
SET obuild_cxx_includes=%obuild_cxx_includes% /I"%obuild_CoinGtk_path%\data"
SET obuild_cxx_includes=%obuild_cxx_includes% /I"%obuild_CoinGL_path%\include"

IF EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%\lib_CoinGtk" RMDIR /S /Q "%obuild_CoinGtk_path%\%obuild_dir_bin%\lib_CoinGtk"
IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%\lib_CoinGtk" MKDIR "%obuild_CoinGtk_path%\%obuild_dir_bin%\lib_CoinGtk"

@IF %obuild_verbose% == yes @ECHO ON 
cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_CoinGtk\SoAny.obj  /Tp"..\src\Inventor\Gtk\SoAny.cpp" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_CoinGtk_path%\obuild"

cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_CoinGtk\SoAnyMaterialList.obj  /Tp"..\src\Inventor\Gtk\SoAnyMaterialList.cpp" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_CoinGtk_path%\obuild"

cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_CoinGtk\SoAnyMaterialListBuiltins.obj  /Tp"..\src\Inventor\Gtk\SoAnyMaterialListBuiltins.cpp" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_CoinGtk_path%\obuild"

cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_CoinGtk\SoGtk.obj  /Tp"..\src\Inventor\Gtk\SoGtk.cpp" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_CoinGtk_path%\obuild"

cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_CoinGtk\SoGtkCommon.obj  /Tp"..\src\Inventor\Gtk\SoGtkCommon.cpp" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_CoinGtk_path%\obuild"

cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_CoinGtk\SoGtkComponent.obj  /Tp"..\src\Inventor\Gtk\SoGtkComponent.cpp" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_CoinGtk_path%\obuild"

cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_CoinGtk\SoGtkCursor.obj  /Tp"..\src\Inventor\Gtk\SoGtkCursor.cpp" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_CoinGtk_path%\obuild"

cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_CoinGtk\SoGtkGLWidget.obj  /Tp"..\src\Inventor\Gtk\SoGtkGLWidget.cpp" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_CoinGtk_path%\obuild"

cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_CoinGtk\SoGtkGLWidgetCommon.obj  /Tp"..\src\Inventor\Gtk\SoGtkGLWidgetCommon.cpp" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_CoinGtk_path%\obuild"

cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_CoinGtk\SoGtkGraphEditor.obj  /Tp"..\src\Inventor\Gtk\SoGtkGraphEditor.cpp" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_CoinGtk_path%\obuild"

cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_CoinGtk\SoGtkMaterialList.obj  /Tp"..\src\Inventor\Gtk\SoGtkMaterialList.cpp" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_CoinGtk_path%\obuild"

cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_CoinGtk\SoGtkObject.obj  /Tp"..\src\Inventor\Gtk\SoGtkObject.cpp" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_CoinGtk_path%\obuild"

cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_CoinGtk\SoGtkRenderArea.obj  /Tp"..\src\Inventor\Gtk\SoGtkRenderArea.cpp" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_CoinGtk_path%\obuild"

cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_CoinGtk\SoGtkRoster.obj  /Tp"..\src\Inventor\Gtk\SoGtkRoster.cpp" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_CoinGtk_path%\obuild"

cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_CoinGtk\SoGtkDevice.obj  /Tp"..\src\Inventor\Gtk\devices\SoGtkDevice.cpp" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_CoinGtk_path%\obuild"

cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_CoinGtk\SoGtkInputFocus.obj  /Tp"..\src\Inventor\Gtk\devices\SoGtkInputFocus.cpp" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_CoinGtk_path%\obuild"

cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_CoinGtk\SoGtkKeyboard.obj  /Tp"..\src\Inventor\Gtk\devices\SoGtkKeyboard.cpp" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_CoinGtk_path%\obuild"

cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_CoinGtk\SoGtkMouse.obj  /Tp"..\src\Inventor\Gtk\devices\SoGtkMouse.cpp" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_CoinGtk_path%\obuild"

cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_CoinGtk\SoGtkSpaceball.obj  /Tp"..\src\Inventor\Gtk\devices\SoGtkSpaceball.cpp" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_CoinGtk_path%\obuild"

cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_CoinGtk\ExaminerViewer.obj  /Tp"..\src\Inventor\Gtk\viewers\ExaminerViewer.cpp" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_CoinGtk_path%\obuild"

cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_CoinGtk\FullViewer.obj  /Tp"..\src\Inventor\Gtk\viewers\FullViewer.cpp" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_CoinGtk_path%\obuild"

cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_CoinGtk\PlaneViewer.obj  /Tp"..\src\Inventor\Gtk\viewers\PlaneViewer.cpp" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_CoinGtk_path%\obuild"

cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_CoinGtk\SoGtkConstrainedViewer.obj  /Tp"..\src\Inventor\Gtk\viewers\SoGtkConstrainedViewer.cpp" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_CoinGtk_path%\obuild"

cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_CoinGtk\SoGtkExaminerViewer.obj  /Tp"..\src\Inventor\Gtk\viewers\SoGtkExaminerViewer.cpp" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_CoinGtk_path%\obuild"

cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_CoinGtk\SoGtkFlyViewer.obj  /Tp"..\src\Inventor\Gtk\viewers\SoGtkFlyViewer.cpp" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_CoinGtk_path%\obuild"

cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_CoinGtk\SoGtkFullViewer.obj  /Tp"..\src\Inventor\Gtk\viewers\SoGtkFullViewer.cpp" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_CoinGtk_path%\obuild"

cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_CoinGtk\SoGtkPlaneViewer.obj  /Tp"..\src\Inventor\Gtk\viewers\SoGtkPlaneViewer.cpp" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_CoinGtk_path%\obuild"

cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_CoinGtk\SoGtkViewer.obj  /Tp"..\src\Inventor\Gtk\viewers\SoGtkViewer.cpp" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_CoinGtk_path%\obuild"

cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_CoinGtk\SoGtkWalkViewer.obj  /Tp"..\src\Inventor\Gtk\viewers\SoGtkWalkViewer.cpp" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_CoinGtk_path%\obuild"

cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_CoinGtk\WalkViewer.obj  /Tp"..\src\Inventor\Gtk\viewers\WalkViewer.cpp" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_CoinGtk_path%\obuild"

cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_CoinGtk\GtkNativePopupMenu.obj  /Tp"..\src\Inventor\Gtk\widgets\GtkNativePopupMenu.cpp" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_CoinGtk_path%\obuild"

cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_CoinGtk\SoAnyThumbWheel.obj  /Tp"..\src\Inventor\Gtk\widgets\SoAnyThumbWheel.cpp" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_CoinGtk_path%\obuild"

cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_CoinGtk\SoGtkPopupMenu.obj  /Tp"..\src\Inventor\Gtk\widgets\SoGtkPopupMenu.cpp" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_CoinGtk_path%\obuild"

cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_CoinGtk\gtkthumbwheel.obj  /Tp"..\src\Inventor\Gtk\widgets\gtkthumbwheel.cpp" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_CoinGtk_path%\obuild"

@IF %obuild_verbose% == yes @ECHO OFF 

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_CoinGtk_0=%%d
cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_CoinGtk_0%"
SET obuild_pwd_CoinGtk_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_58
SET obuild_cxx_linker_command=link.exe
:end_if_platform_58
SET obuild_platform_result=
IF "%obuild_cxx_linker_command%" == ""  ECHO Variable obuild_cxx_linker_command not defined.  && GOTO obuild_return

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_CoinGtk_0=%%d
cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_CoinGtk_0%"
SET obuild_pwd_CoinGtk_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_60
SET obuild_cxx_linker_debug=/DEBUG
:end_if_platform_60
SET obuild_platform_result=

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_CoinGtk_0=%%d
cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_CoinGtk_0%"
SET obuild_pwd_CoinGtk_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_62
SET obuild_cxx_linker_options=/nologo
:end_if_platform_62
SET obuild_platform_result=

IF NOT %obuild_debug% == yes GOTO else_if_db_build_lib_CoinGtk_sh_63
  SET obuild_cxx_linker_debug_local=%obuild_cxx_linker_debug%
  GOTO end_if_db_build_lib_CoinGtk_sh_63
:else_if_db_build_lib_CoinGtk_sh_63
  SET obuild_cxx_linker_debug_local=
:end_if_db_build_lib_CoinGtk_sh_63

IF NOT %obuild_optimize% == yes GOTO else_if_opt_build_lib_CoinGtk_sh_64
  SET obuild_cxx_linker_optimize_local=%obuild_cxx_linker_optimize%
  GOTO end_if_opt_build_lib_CoinGtk_sh_64
:else_if_opt_build_lib_CoinGtk_sh_64
  SET obuild_cxx_linker_optimize_local=
:end_if_opt_build_lib_CoinGtk_sh_64

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_CoinGtk_0=%%d
cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_CoinGtk_0%"
SET obuild_pwd_CoinGtk_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_66
SET obuild_linked_paths=/LIBPATH:"%obuild_CoinGL_path%\%obuild_dir_bin%"
SET obuild_linked_libraries=osc_Coin.lib
:end_if_platform_66
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_CoinGtk_0=%%d
cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_CoinGtk_0%"
SET obuild_pwd_CoinGtk_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_68
SET obuild_linked_libraries=%obuild_linked_libraries% glu32.lib opengl32.lib gdi32.lib user32.lib
:end_if_platform_68
SET obuild_platform_result=

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_CoinGtk_0=%%d
cd "%obuild_CoinGtk_path%\%obuild_dir_bin%"
IF EXIST .\lib_CoinGtk\tmp_objs DEL .\lib_CoinGtk\tmp_objs
FOR %%f IN (.\lib_CoinGtk\*.obj) DO ECHO %%f >> .\lib_CoinGtk\tmp_objs

REM # Create the archive library CoinGtk :
@IF %obuild_verbose% == yes @ECHO ON 
lib.exe /nologo /machine:ix86 /out:.\lib_CoinGtk\CoinGtk.arc @.\lib_CoinGtk\tmp_objs
@IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 

REM # Build the obuild_windef.exe utility program :
cl.exe /nologo /DWIN32 /MD /O2 /W3 /Feobuild_windef.exe "%obuild_CoinGtk_path%\obuild\cpp\obuild_windef.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
IF EXIST obuild_windef.obj DEL obuild_windef.obj

REM # Building the .def file :
@IF %obuild_verbose% == yes @ECHO ON 
dumpbin.exe /symbols /out:.\lib_CoinGtk\tmp .\lib_CoinGtk\CoinGtk.arc 1> dumpbin_exe_error .\lib_CoinGtk\CoinGtk.arc
@IF ERRORLEVEL 1 @TYPE dumpbin_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL dumpbin_exe_error
@IF %obuild_verbose% == yes @ECHO OFF 
.\obuild_windef.exe CoinGtk < .\lib_CoinGtk\tmp > .\lib_CoinGtk\CoinGtk.def
REM # Building the linking library :
REM # It produces a .exp file.
@IF %obuild_verbose% == yes @ECHO ON 
lib.exe /nologo /machine:ix86 /out:.\CoinGtk.lib /def:.\lib_CoinGtk\CoinGtk.def 1> lib_exe_error
@IF ERRORLEVEL 1 @TYPE lib_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL lib_exe_error
@IF %obuild_verbose% == yes @ECHO OFF 

REM # Building the DLL :
IF EXIST .\CoinGtk.dll DEL .\CoinGtk.dll
@IF %obuild_verbose% == yes @ECHO ON 
link.exe /nologo /dll /out:.\CoinGtk.dll .\CoinGtk.exp .\lib_CoinGtk\CoinGtk.arc %obuild_linked_paths% %obuild_linked_libraries%
@IF %obuild_verbose% == yes @ECHO OFF 

cd "%obuild_pwd_CoinGtk_0%"
SET obuild_pwd_CoinGtk_0=
REM # Some cleanup :
IF EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%\lib_CoinGtk\tmp_objs" DEL "%obuild_CoinGtk_path%\%obuild_dir_bin%\lib_CoinGtk\tmp_objs"
IF EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%\CoinGtk.exp" DEL "%obuild_CoinGtk_path%\%obuild_dir_bin%\CoinGtk.exp"

:obuild_return
ENDLOCAL
@ECHO ON
