
#include <Inventor/Xt/SoXt.h>
#include <Inventor/Xt/viewers/SoXtExaminerViewer.h>

#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoScale.h>
#include <Inventor/nodes/SoCube.h>
#include <Inventor/errors/SoDebugError.h>

#include <Inventor/engines/SoTimeCounter.h>

#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <Xm/PushB.h>

static void buttonCbk(Widget,XtPointer,XtPointer) {
  SoDebugError::postInfo("buttonCbk","exiting...");
  XtAppContext context = SoXt::getAppContext();
  XtAppSetExitFlag(context);  
}

//////////////////////////////////////////////////////////////////////////////
int main(
 int /*aArgc*/
,char** aArgv
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  /*
  Arg args[1];
  XtSetArg(args[0], XtNgeometry,XtNewString("100x100"));
  XtAppContext appContext;
  Widget top = XtAppInitialize(&appContext,
			       "CoinXt_cube",NULL,(Cardinal)0,
			       &aArgc,aArgv,
			       NULL,args,1);
  if (top==NULL) exit(1);

  SoXt::init(top);
  */

  Widget top = SoXt::init(aArgv[0]);
  if (top==NULL) exit(1);

  // Create a scene :

  SoSeparator* root=new SoSeparator;
  root->ref();

  SoMaterial* material = new SoMaterial;
  material->diffuseColor.setValue (SbColor(1,1,0));
  root->addChild(material);

  SoScale* scale = new SoScale;
  scale->scaleFactor.setValue(0.1F,0.1F,0.1F);
  //scale->scaleFactor.setValue(0.5F,0.5F,0.5F);
  root->addChild(scale);

  SoCube* cube = new SoCube;
  root->addChild(cube);

  SoXtExaminerViewer* viewer = new SoXtExaminerViewer(top);
    
  Widget buttonsParent = viewer->getAppPushButtonParent();
  if(buttonsParent) {
    Widget button = XtCreateManagedWidget
      ("Esc",xmPushButtonWidgetClass,buttonsParent,NULL,0);
    XtAddCallback(button,XmNactivateCallback,buttonCbk,(XtPointer)0);
    viewer->addAppPushButton(button);
  } else {
    SoDebugError::postInfo("main","no app buttons parent !");
  }
  viewer->setBackgroundColor(SbColor(0.4F,0.4F,0.4F));
  viewer->setSceneGraph(root);
  viewer->viewAll();
  viewer->setSize(SbVec2s(700,500));
  //viewer->show();
  viewer->setTitle("CoinXt");
  //viewer->setViewing(FALSE);
  //viewer->setDecoration(FALSE);
  //viewer->setAutoClipping(FALSE);

  SoXt::show(top);

  //XtRealizeWidget(top);

  SoXt::mainLoop();

  //Cleanup
  root->unref();

  delete viewer;

  //SoXt::clear();  

  return 0;
}
