#ifndef G4Examples_Environment_h
#define G4Examples_Environment_h

#include <Lib/argZero.h>

#include <Lib/Printer.h>
#include <Lib/System.h>

//////////////////////////////////////////////////////////////////////////////
inline bool check_envs(
 const std::string& aArg0
,bool aCheckG4Env = false
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!Lib::argZero::checkPackEnv(aArg0,"OnXLab")) return false;
  if(!Lib::argZero::checkPackEnv(aArg0,"G4Lab")) return false;
  if(!Lib::argZero::checkPackEnv(aArg0,"G4Examples")) return false;

  if(aCheckG4Env) {

    Lib::Printer printer;
    std::string fs = Lib::System::fileSeparator();
    std::string dir = "Resources"+fs+"Geant4"+fs+"data"+fs;
  
   {std::string to = dir+"G4NDL*";
    if(!Lib::argZero::checkEnv(aArg0,"NeutronHPCrossSections",to,
                            printer,true)) return false;}
  
   {std::string to = dir+"PhotonEvaporation*";
    if(!Lib::argZero::checkEnv(aArg0,"G4LEVELGAMMADATA",to,
                            printer,true)) return false;}
  
   {std::string to = dir+"RadioactiveDecay*";
    if(!Lib::argZero::checkEnv(aArg0,"G4RADIOACTIVEDATA",to,
                            printer,true)) return false;}
  
   {std::string to = dir+"G4EMLOW*";
    if(!Lib::argZero::checkEnv(aArg0,"G4LEDATA",to,
                            printer,true)) return false;}
  
  }

  return true;
}

#endif
