@ECHO OFF
SETLOCAL

REM #
REM # File produced by the obuild tool version 1.0
REM # for the package G4Lab with version v8r3p0.
REM #

REM #////////////////////////////////////////////////
REM # Usage :
REM #   DOS> CD some_path\pack\version\obuild
REM #   DOS> DOS\build_G4Lab_config_Geant4
REM #
REM #////////////////////////////////////////////////

REM #////////////////////////////////////////////////
REM #/// Get path of this file :
REM #////////////////////////////////////////////////
SET obuild_G4Lab_path=%~dp0
REM # Remove ending \obuild\DOS\
SET obuild_G4Lab_path=%obuild_G4Lab_path:~0,-12%

REM #////////////////////////////////////////////////
REM #/// Treat arguments :
REM #////////////////////////////////////////////////

SET obuild_verbose=no
SET obuild_debug=no
SET obuild_optimize=yes
SET obuild_set_x=no

:next_arg
IF "%1%" == "" GOTO end_args

IF NOT "%1%" == "-v" GOTO end_if_v
  SET obuild_verbose=yes
  SHIFT
  GOTO next_arg
:end_if_v

IF NOT "%1%" == "-g" GOTO end_if_g
  SET obuild_debug=yes
  SHIFT
  GOTO next_arg
:end_if_g

IF NOT "%1%" == "-x" GOTO end_if_x
  SET obuild_set_x=yes
  SHIFT
  GOTO next_arg
:end_if_x

:end_args

REM #////////////////////////////////////////////////
REM #/// End arguments.
REM #////////////////////////////////////////////////

IF %obuild_set_x% == yes ECHO ON

IF %obuild_debug% == yes SET obuild_optimize=no

IF "%OBUILD_DIR_BIN%" == "" (
  SET obuild_dir_bin=bin_obuild
) ELSE (
  SET obuild_dir_bin=%OBUILD_DIR_BIN%
)

IF "%obuild_dir_bin%" == "" (
  ECHO obuild_dir_bin variable not defined.
  GOTO obuild_return
)

IF NOT EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%" MKDIR "%obuild_G4Lab_path%\%obuild_dir_bin%"

IF NOT EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%" MKDIR "%obuild_G4Lab_path%\%obuild_dir_bin%"
IF NOT EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%\obuild_platform.exe" (
  cl.exe /nologo /DWIN32 /MD /O2 /W3  /GX /GR /Fe"%obuild_G4Lab_path%\%obuild_dir_bin%\obuild_platform.exe" "%obuild_G4Lab_path%\obuild\cpp\obuild_platform.cpp" 1> cl_exe_error
  IF ERRORLEVEL 1 TYPE cl_exe_error
  IF NOT ERRORLEVEL 1 DEL cl_exe_error 
  IF EXIST obuild_platform.obj DEL obuild_platform.obj
)

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_G4Lab_0=%%d
cd "%obuild_G4Lab_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_G4Lab_0%"
SET obuild_pwd_G4Lab_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_1
SET CLHEP_home=C:\cygwin\usr\local\CLHEP\2.0.3.2
:end_if_platform_1
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_G4Lab_0=%%d
cd "%obuild_G4Lab_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_G4Lab_0%"
SET obuild_pwd_G4Lab_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_3
SET Geant4_system=WIN32-VC
:end_if_platform_3
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_G4Lab_0=%%d
cd "%obuild_G4Lab_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_G4Lab_0%"
SET obuild_pwd_G4Lab_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_5
SET Geant4_home=C:\cygwin\usr\local\geant4\geant4-09-01-patch-01
:end_if_platform_5
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_G4Lab_0=%%d
cd "%obuild_G4Lab_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_G4Lab_0%"
SET obuild_pwd_G4Lab_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_7
SET obuild_cxx_command=cl.exe
:end_if_platform_7
SET obuild_platform_result=
IF "%obuild_cxx_command%" == ""  ECHO Variable obuild_cxx_command not defined.  && GOTO obuild_return

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_G4Lab_0=%%d
cd "%obuild_G4Lab_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_G4Lab_0%"
SET obuild_pwd_G4Lab_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_9
SET obuild_cxx_optimize=/O2
:end_if_platform_9
SET obuild_platform_result=

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_G4Lab_0=%%d
cd "%obuild_G4Lab_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_G4Lab_0%"
SET obuild_pwd_G4Lab_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_11
SET obuild_cxx_debug=/ZI /Od
:end_if_platform_11
SET obuild_platform_result=

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_G4Lab_0=%%d
cd "%obuild_G4Lab_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_G4Lab_0%"
SET obuild_pwd_G4Lab_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_13
SET obuild_cxx_options=/nologo /DWIN32 /MD /GX /GR /W3
:end_if_platform_13
SET obuild_platform_result=

IF NOT %obuild_debug% == yes GOTO else_if_db_build_dll_G4Lab_config_Geant4_sh_14
  SET obuild_cxx_debug_local=%obuild_cxx_debug%
  GOTO end_if_db_build_dll_G4Lab_config_Geant4_sh_14
:else_if_db_build_dll_G4Lab_config_Geant4_sh_14
  SET obuild_cxx_debug_local=
:end_if_db_build_dll_G4Lab_config_Geant4_sh_14

IF NOT %obuild_optimize% == yes GOTO else_if_opt_build_dll_G4Lab_config_Geant4_sh_15
  SET obuild_cxx_optimize_local=%obuild_cxx_optimize%
  GOTO end_if_opt_build_dll_G4Lab_config_Geant4_sh_15
:else_if_opt_build_dll_G4Lab_config_Geant4_sh_15
  SET obuild_cxx_optimize_local=
:end_if_opt_build_dll_G4Lab_config_Geant4_sh_15



FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_G4Lab_0=%%d
cd "%obuild_G4Lab_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_G4Lab_0%"
SET obuild_pwd_G4Lab_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_17
SET obuild_cxx_includes=/I%CLHEP_home%\include
:end_if_platform_17
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_G4Lab_0=%%d
cd "%obuild_G4Lab_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_G4Lab_0%"
SET obuild_pwd_G4Lab_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_19
SET obuild_cxx_includes=%obuild_cxx_includes% /I%Geant4_home%\include
:end_if_platform_19
SET obuild_platform_result=

IF EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%\dll_G4Lab_config_Geant4" RMDIR /S /Q "%obuild_G4Lab_path%\%obuild_dir_bin%\dll_G4Lab_config_Geant4"
IF NOT EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%\dll_G4Lab_config_Geant4" MKDIR "%obuild_G4Lab_path%\%obuild_dir_bin%\dll_G4Lab_config_Geant4"

@IF %obuild_verbose% == yes @ECHO ON 
cd "%obuild_G4Lab_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\dll_G4Lab_config_Geant4\config_Geant4.obj  /Tp"..\source\config_Geant4.cxx" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_G4Lab_path%\obuild"

@IF %obuild_verbose% == yes @ECHO OFF 

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_G4Lab_0=%%d
cd "%obuild_G4Lab_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_G4Lab_0%"
SET obuild_pwd_G4Lab_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_22
SET obuild_linked_libraries=/LIBPATH:%Geant4_home%\lib\%Geant4_system% libG4readout.a libG4run.a libG4event.a libG4tracking.a libG4processes.a libG4digits_hits.a libG4track.a libG4particles.a libG4geometry.a libG4graphics_reps.a libG4materials.a libG4intercoms.a libG4global.a
:end_if_platform_22
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_G4Lab_0=%%d
cd "%obuild_G4Lab_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_G4Lab_0%"
SET obuild_pwd_G4Lab_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_24
SET obuild_linked_libraries=%obuild_linked_libraries% %CLHEP_home%\lib\CLHEP.lib
:end_if_platform_24
SET obuild_platform_result=

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_G4Lab_0=%%d
cd "%obuild_G4Lab_path%\%obuild_dir_bin%"
IF EXIST .\dll_G4Lab_config_Geant4\tmp_objs DEL .\dll_G4Lab_config_Geant4\tmp_objs
FOR %%f IN (.\dll_G4Lab_config_Geant4\*.obj) DO ECHO %%f >> .\dll_G4Lab_config_Geant4\tmp_objs

REM # Create the archive library G4Lab_config_Geant4 :
@IF %obuild_verbose% == yes @ECHO ON 
lib.exe /nologo /machine:ix86 /out:.\dll_G4Lab_config_Geant4\G4Lab_config_Geant4.arc @.\dll_G4Lab_config_Geant4\tmp_objs
@IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 

REM # Build the obuild_windef.exe utility program :
cl.exe /nologo /DWIN32 /MD /O2 /W3 /Feobuild_windef.exe "%obuild_G4Lab_path%\obuild\cpp\obuild_windef.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
IF EXIST obuild_windef.obj DEL obuild_windef.obj

REM # Building the .def file :
@IF %obuild_verbose% == yes @ECHO ON 
dumpbin.exe /symbols /out:.\dll_G4Lab_config_Geant4\tmp .\dll_G4Lab_config_Geant4\G4Lab_config_Geant4.arc 1> dumpbin_exe_error .\dll_G4Lab_config_Geant4\G4Lab_config_Geant4.arc
@IF ERRORLEVEL 1 @TYPE dumpbin_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL dumpbin_exe_error
@IF %obuild_verbose% == yes @ECHO OFF 
.\obuild_windef.exe G4Lab_config_Geant4 < .\dll_G4Lab_config_Geant4\tmp > .\dll_G4Lab_config_Geant4\G4Lab_config_Geant4.def
REM # Building the linking library :
REM # It produces a .exp file.
@IF %obuild_verbose% == yes @ECHO ON 
lib.exe /nologo /machine:ix86 /out:.\dll_G4Lab_config_Geant4\G4Lab_config_Geant4.lib /def:.\dll_G4Lab_config_Geant4\G4Lab_config_Geant4.def 1> lib_exe_error
@IF ERRORLEVEL 1 @TYPE lib_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL lib_exe_error
@IF %obuild_verbose% == yes @ECHO OFF 

REM # Building the DLL :
IF EXIST .\G4Lab_config_Geant4.dll DEL .\G4Lab_config_Geant4.dll
@IF %obuild_verbose% == yes @ECHO ON 
link.exe /nologo /dll /out:.\G4Lab_config_Geant4.dll .\dll_G4Lab_config_Geant4\G4Lab_config_Geant4.exp .\dll_G4Lab_config_Geant4\G4Lab_config_Geant4.arc %obuild_linked_paths% %obuild_linked_libraries%
@IF %obuild_verbose% == yes @ECHO OFF 

cd "%obuild_pwd_G4Lab_0%"
SET obuild_pwd_G4Lab_0=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_G4Lab_0=%%d
cd "%obuild_G4Lab_path%\%obuild_dir_bin%"
cd ..\..\..
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_dir_top=%%d
cd "%obuild_pwd_G4Lab_0%"
SET obuild_pwd_G4Lab_0=
IF NOT EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%" MKDIR "%obuild_G4Lab_path%\%obuild_dir_bin%"
IF NOT EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%\obuild_subf.exe" (
  cl.exe /nologo /DWIN32 /MD /O2 /W3 /GX /GR /Fe"%obuild_G4Lab_path%\%obuild_dir_bin%\obuild_subf.exe" "%obuild_G4Lab_path%\obuild\cpp\obuild_subf.cpp" 1> cl_exe_error
  IF ERRORLEVEL 1 TYPE cl_exe_error
  IF NOT ERRORLEVEL 1 DEL cl_exe_error 
  IF EXIST obuild_subf.obj DEL obuild_subf.obj
)
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_G4Lab_0=%%d
cd "%obuild_G4Lab_path%\%obuild_dir_bin%"
IF EXIST G4Lab_config_Geant4.save DEL G4Lab_config_Geant4.save
ECHO obuild_package=G4Lab >> G4Lab_config_Geant4.save
ECHO obuild_package=v8r3p0 >> G4Lab_config_Geant4.save
ECHO obuild_cxx_command=%obuild_cxx_command% >> G4Lab_config_Geant4.save
ECHO obuild_cxx_debug=%obuild_cxx_debug% >> G4Lab_config_Geant4.save
ECHO obuild_cxx_optimize=%obuild_cxx_optimize% >> G4Lab_config_Geant4.save
ECHO obuild_cxx_options=%obuild_cxx_options% >> G4Lab_config_Geant4.save
ECHO obuild_cxx_macros=%obuild_cxx_macros% >> G4Lab_config_Geant4.save
ECHO obuild_cxx_dll_builder_options=%obuild_cxx_dll_builder_options% >> G4Lab_config_Geant4.save
ECHO obuild_cxx_includes=%obuild_cxx_includes% >> G4Lab_config_Geant4.save
ECHO obuild_linked_paths=%obuild_linked_paths% >> G4Lab_config_Geant4.save
ECHO obuild_linked_libraries=%obuild_linked_libraries% >> G4Lab_config_Geant4.save
.\obuild_subf.exe G4Lab_config_Geant4.save "%obuild_dir_top%" @@top@@
.\obuild_subf.exe G4Lab_config_Geant4.save "%CLHEP_home%" %%CLHEP_BASE_DIR%%
.\obuild_subf.exe G4Lab_config_Geant4.save "%Geant4_home%" %%G4INSTALL%%
cd "%obuild_pwd_G4Lab_0%"
SET obuild_pwd_G4Lab_0=
SET obuild_dir_top=
REM # Some cleanup :
IF EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%\dll_G4Lab_config_Geant4\tmp_objs" DEL "%obuild_G4Lab_path%\%obuild_dir_bin%\dll_G4Lab_config_Geant4\tmp_objs"
IF EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%\G4Lab_config_Geant4.exp" DEL "%obuild_G4Lab_path%\%obuild_dir_bin%\G4Lab_config_Geant4.exp"

:obuild_return
ENDLOCAL
@ECHO ON
