
set pwd_dir="`pwd`"

set package_dir=`eval dirname \"${pwd_dir}\"`

#echo ${package_dir}

setenv G4LABTEMPLATEFOURROOT "${package_dir}"

setenv G4LABROOT "${OSC_HOME_DIR}/Resources/G4Lab"

set CLHEP_home=/usr/local/CLHEP/2.0.3.1
set g4_home=/usr/local/geant4/8.3.p01

set lib_path="${CLHEP_home}/lib:${g4_home}/lib:."

if ( `uname` == "Linux" ) then
  set lib_curr=`printenv LD_LIBRARY_PATH`
  if ( "${lib_curr}" == "" ) then
    setenv LD_LIBRARY_PATH "${lib_path}"
  else
    if ( `echo "${lib_curr}" | grep "${lib_path}" ` == "" ) then
      setenv LD_LIBRARY_PATH "${LD_LIBRARY_PATH}:${lib_path}"
    endif
  endif
  unset lib_curr
  unset lib_path
endif

if ( `uname` == "Darwin" ) then
  set lib_curr=`printenv DYLD_LIBRARY_PATH`
  if ( "${lib_curr}" == "" ) then
    setenv DYLD_LIBRARY_PATH "${lib_path}"
  else
    if ( `echo "${lib_curr}" | grep "${lib_path}" ` == "" ) then
      setenv DYLD_LIBRARY_PATH "${DYLD_LIBRARY_PATH}:${lib_path}"
    endif
  endif
  unset lib_curr
  unset lib_path
endif

setenv G4LEVELGAMMADATA "${g4_home}/data/G4EMLOW4.2"
