
// Geant4 :
#include <G4RunManager.hh>

// Lib :
#include <Lib/Out.h>

// G4Simple :
#include <G4Simple/Detector.h>
#include <G4Simple/Primary.h>
#include <G4Simple/PhysicsList.h>
#include <G4Simple/RunAction.h>
#include <G4Simple/EventAction.h>
#include <G4Simple/SteppingAction.h>

//////////////////////////////////////////////////////////////////////////////
int main(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Out out;

  G4RunManager* runManager = new G4RunManager;

  runManager->SetUserInitialization(new G4Simple::Detector);
  runManager->SetUserInitialization(new G4Simple::PhysicsList); 
  runManager->SetUserAction(new G4Simple::RunAction(out));
  runManager->SetUserAction(new G4Simple::PrimaryGeneratorAction);
  runManager->SetUserAction(new G4Simple::EventAction);
  runManager->SetUserAction(new G4Simple::SteppingAction());
  //runManager->SetUserAction(new G4Lab::TrackingAction);

  //Initialize G4 kernel
  runManager->Initialize();
    
  runManager->BeamOn(3);

  delete runManager;

  return 0;
}
