@ECHO OFF
SETLOCAL

REM #
REM # File produced by the obuild tool version 1.0
REM # for the package HCL with version v7r0p2.
REM #

REM #////////////////////////////////////////////////
REM # Usage :
REM #   DOS> CD some_path\pack\version\obuild
REM #   DOS> DOS\build_HCL
REM #
REM #////////////////////////////////////////////////

REM #////////////////////////////////////////////////
REM #/// Get path of this file :
REM #////////////////////////////////////////////////
SET obuild_HCL_path=%~dp0
REM # Remove ending \obuild\DOS\
SET obuild_HCL_path=%obuild_HCL_path:~0,-12%

REM #////////////////////////////////////////////////
REM #/// Treat arguments :
REM #////////////////////////////////////////////////

SET obuild_verbose=no
SET obuild_debug=no
SET obuild_optimize=yes
SET obuild_set_x=no

:next_arg
IF "%1%" == "" GOTO end_args

IF NOT "%1%" == "-v" GOTO end_if_v
  SET obuild_verbose=yes
  SHIFT
  GOTO next_arg
:end_if_v

IF NOT "%1%" == "-g" GOTO end_if_g
  SET obuild_debug=yes
  SHIFT
  GOTO next_arg
:end_if_g

IF NOT "%1%" == "-x" GOTO end_if_x
  SET obuild_set_x=yes
  SHIFT
  GOTO next_arg
:end_if_x

:end_args

REM #////////////////////////////////////////////////
REM #/// End arguments.
REM #////////////////////////////////////////////////

IF %obuild_set_x% == yes ECHO ON

IF %obuild_debug% == yes SET obuild_optimize=no

IF "%OBUILD_DIR_BIN%" == "" (
  SET obuild_dir_bin=bin_obuild
) ELSE (
  SET obuild_dir_bin=%OBUILD_DIR_BIN%
)

IF "%obuild_dir_bin%" == "" (
  ECHO obuild_dir_bin variable not defined.
  GOTO obuild_return
)

IF NOT EXIST "%obuild_HCL_path%\%obuild_dir_bin%" MKDIR "%obuild_HCL_path%\%obuild_dir_bin%"

IF NOT EXIST "%obuild_HCL_path%\%obuild_dir_bin%" MKDIR "%obuild_HCL_path%\%obuild_dir_bin%"
IF NOT EXIST "%obuild_HCL_path%\%obuild_dir_bin%\obuild_platform.exe" (
  cl.exe /nologo /DWIN32 /MD /O2 /W3  /GX /GR /Fe"%obuild_HCL_path%\%obuild_dir_bin%\obuild_platform.exe" "%obuild_HCL_path%\obuild\cpp\obuild_platform.cpp" 1> cl_exe_error
  IF ERRORLEVEL 1 TYPE cl_exe_error
  IF NOT ERRORLEVEL 1 DEL cl_exe_error 
  IF EXIST obuild_platform.obj DEL obuild_platform.obj
)

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_HCL_0=%%d
cd "%obuild_HCL_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_HCL_0%"
SET obuild_pwd_HCL_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_1
SET obuild_cxx_command=cl.exe
:end_if_platform_1
SET obuild_platform_result=
IF "%obuild_cxx_command%" == ""  ECHO Variable obuild_cxx_command not defined.  && GOTO obuild_return

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_HCL_0=%%d
cd "%obuild_HCL_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_HCL_0%"
SET obuild_pwd_HCL_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_3
SET obuild_cxx_optimize=/O2
:end_if_platform_3
SET obuild_platform_result=

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_HCL_0=%%d
cd "%obuild_HCL_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_HCL_0%"
SET obuild_pwd_HCL_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_5
SET obuild_cxx_debug=/ZI /Od
:end_if_platform_5
SET obuild_platform_result=

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_HCL_0=%%d
cd "%obuild_HCL_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_HCL_0%"
SET obuild_pwd_HCL_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_7
SET obuild_cxx_options=/nologo /DWIN32 /MD /GX /GR /W3
:end_if_platform_7
SET obuild_platform_result=

IF NOT %obuild_debug% == yes GOTO else_if_db_build_lib_HCL_sh_8
  SET obuild_cxx_debug_local=%obuild_cxx_debug%
  GOTO end_if_db_build_lib_HCL_sh_8
:else_if_db_build_lib_HCL_sh_8
  SET obuild_cxx_debug_local=
:end_if_db_build_lib_HCL_sh_8

IF NOT %obuild_optimize% == yes GOTO else_if_opt_build_lib_HCL_sh_9
  SET obuild_cxx_optimize_local=%obuild_cxx_optimize%
  GOTO end_if_opt_build_lib_HCL_sh_9
:else_if_opt_build_lib_HCL_sh_9
  SET obuild_cxx_optimize_local=
:end_if_opt_build_lib_HCL_sh_9



SET obuild_cxx_includes=/I"%obuild_HCL_path%\include"

IF EXIST "%obuild_HCL_path%\%obuild_dir_bin%\lib_HCL" RMDIR /S /Q "%obuild_HCL_path%\%obuild_dir_bin%\lib_HCL"
IF NOT EXIST "%obuild_HCL_path%\%obuild_dir_bin%\lib_HCL" MKDIR "%obuild_HCL_path%\%obuild_dir_bin%\lib_HCL"

@IF %obuild_verbose% == yes @ECHO ON 
cd "%obuild_HCL_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_HCL\Axis.obj  /Tp"..\source\Axis.cxx" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HCL_path%\obuild"

cd "%obuild_HCL_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_HCL\Histogram.obj  /Tp"..\source\Histogram.cxx" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_HCL_path%\obuild"

@IF %obuild_verbose% == yes @ECHO OFF 

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_HCL_0=%%d
cd "%obuild_HCL_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_HCL_0%"
SET obuild_pwd_HCL_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_15
SET obuild_cxx_linker_command=link.exe
:end_if_platform_15
SET obuild_platform_result=
IF "%obuild_cxx_linker_command%" == ""  ECHO Variable obuild_cxx_linker_command not defined.  && GOTO obuild_return

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_HCL_0=%%d
cd "%obuild_HCL_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_HCL_0%"
SET obuild_pwd_HCL_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_17
SET obuild_cxx_linker_debug=/DEBUG
:end_if_platform_17
SET obuild_platform_result=

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_HCL_0=%%d
cd "%obuild_HCL_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_HCL_0%"
SET obuild_pwd_HCL_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_19
SET obuild_cxx_linker_options=/nologo
:end_if_platform_19
SET obuild_platform_result=

IF NOT %obuild_debug% == yes GOTO else_if_db_build_lib_HCL_sh_20
  SET obuild_cxx_linker_debug_local=%obuild_cxx_linker_debug%
  GOTO end_if_db_build_lib_HCL_sh_20
:else_if_db_build_lib_HCL_sh_20
  SET obuild_cxx_linker_debug_local=
:end_if_db_build_lib_HCL_sh_20

IF NOT %obuild_optimize% == yes GOTO else_if_opt_build_lib_HCL_sh_21
  SET obuild_cxx_linker_optimize_local=%obuild_cxx_linker_optimize%
  GOTO end_if_opt_build_lib_HCL_sh_21
:else_if_opt_build_lib_HCL_sh_21
  SET obuild_cxx_linker_optimize_local=
:end_if_opt_build_lib_HCL_sh_21

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_HCL_0=%%d
cd "%obuild_HCL_path%\%obuild_dir_bin%"
IF EXIST .\lib_HCL\tmp_objs DEL .\lib_HCL\tmp_objs
FOR %%f IN (.\lib_HCL\*.obj) DO ECHO %%f >> .\lib_HCL\tmp_objs

REM # Create the archive library HCL :
@IF %obuild_verbose% == yes @ECHO ON 
lib.exe /nologo /machine:ix86 /out:.\lib_HCL\HCL.arc @.\lib_HCL\tmp_objs
@IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 

REM # Build the obuild_windef.exe utility program :
cl.exe /nologo /DWIN32 /MD /O2 /W3 /Feobuild_windef.exe "%obuild_HCL_path%\obuild\cpp\obuild_windef.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
IF EXIST obuild_windef.obj DEL obuild_windef.obj

REM # Building the .def file :
@IF %obuild_verbose% == yes @ECHO ON 
dumpbin.exe /symbols /out:.\lib_HCL\tmp .\lib_HCL\HCL.arc 1> dumpbin_exe_error .\lib_HCL\HCL.arc
@IF ERRORLEVEL 1 @TYPE dumpbin_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL dumpbin_exe_error
@IF %obuild_verbose% == yes @ECHO OFF 
.\obuild_windef.exe HCL < .\lib_HCL\tmp > .\lib_HCL\HCL.def
REM # Building the linking library :
REM # It produces a .exp file.
@IF %obuild_verbose% == yes @ECHO ON 
lib.exe /nologo /machine:ix86 /out:.\HCL.lib /def:.\lib_HCL\HCL.def 1> lib_exe_error
@IF ERRORLEVEL 1 @TYPE lib_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL lib_exe_error
@IF %obuild_verbose% == yes @ECHO OFF 

REM # Building the DLL :
IF EXIST .\HCL.dll DEL .\HCL.dll
@IF %obuild_verbose% == yes @ECHO ON 
link.exe /nologo /dll /out:.\HCL.dll .\HCL.exp .\lib_HCL\HCL.arc %obuild_linked_paths% %obuild_linked_libraries%
@IF %obuild_verbose% == yes @ECHO OFF 

cd "%obuild_pwd_HCL_0%"
SET obuild_pwd_HCL_0=
REM # Some cleanup :
IF EXIST "%obuild_HCL_path%\%obuild_dir_bin%\lib_HCL\tmp_objs" DEL "%obuild_HCL_path%\%obuild_dir_bin%\lib_HCL\tmp_objs"
IF EXIST "%obuild_HCL_path%\%obuild_dir_bin%\HCL.exp" DEL "%obuild_HCL_path%\%obuild_dir_bin%\HCL.exp"

:obuild_return
ENDLOCAL
@ECHO ON
