//*****************************************************************************
//
// Test the SoCoordinateAxis class
//
//*****************************************************************************
#include <stdlib.h>
#include <math.h>

#include <HEPVis/Gui/SoGui.h>

#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoCamera.h>
#include <Inventor/engines/SoElapsedTime.h>
#include <Inventor/engines/SoTimeCounter.h>
#include <Inventor/actions/SoWriteAction.h>

#include <HEPVis/nodes/SoCoordinateAxis.h>

int main(int, char **argv)
{

   // Initialize Inventor and Xt
   SoGuiWidget myWindow = SoGui::init(argv[0]);
   if (myWindow == NULL) exit(1);

   SoCoordinateAxis::initClass();

   SoSeparator *root = new SoSeparator;
   root->ref();

   SoCoordinateAxis *TheAxis   = new SoCoordinateAxis();
   TheAxis->fNDivision = 3;
   TheAxis->fDivisionLength = 0.2F;

   SoElapsedTime *TheCounter = new SoElapsedTime;
   TheCounter->speed.setValue(0.1F);
   TheAxis->fDivisionLength.connectFrom(&TheCounter->timeOut);

   SoTimeCounter* TimeClick = new SoTimeCounter;
   TimeClick->step.setValue(1);
   TimeClick->min.setValue(0);
   TimeClick->max.setValue(10);
   TimeClick->frequency.setValue(0.02F);
   TheAxis->fNDivision.connectFrom(&TimeClick->output);

   root->addChild(TheAxis);

   SoGuiExaminerViewer* myViewer = new SoGuiExaminerViewer(myWindow);
   myViewer->setSceneGraph(root);
   myViewer->setTitle("test");
   myViewer->show();
   myViewer->viewAll();
   myViewer->getCamera()->position.setValue(SbVec3f(0,0,20));

   SoGui::show(myWindow);
   SoGui::mainLoop();

   root->unref();
   delete myViewer;

#ifdef SoFreePackage //Cleanup
   SoCoordinateAxis::clearClass();
   SoGui::clear();  
#endif

   return 0;
}












