#include <HEPVis/Gui/SoGui.h>

#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoMaterial.h>

#include <HEPVis/nodes/SoTextTTF.h>

#include <stdlib.h>

//////////////////////////////////////////////////////////////////////////////
int main (
 int aArgc
,char** aArgv
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  SoGuiWidget widget = SoGui::init(aArgv[0]);
  if (widget==NULL) exit(1);

  SbString arg1 = (aArgc>=2?aArgv[1]:"");

  SoTextTTF::initClass();

  SoSeparator* sceneGraph = new SoSeparator;
  sceneGraph->ref();

  SoMaterial* material = new SoMaterial;
  material->diffuseColor.setValue(1, 0, 0);
  sceneGraph->addChild(material);

  SoTextTTF* textTTF = new SoTextTTF();
  textTTF->rescale.setValue(200);
  textTTF->size.setValue(15);
  textTTF->horizontalJustification.setValue(SoTextTTF::CENTER);
  if(arg1!="") textTTF->fontName.setValue(arg1);
  textTTF->string.set1Value(0,"abcdefghijklmnopqrstuvwxyz");
  textTTF->string.set1Value(1,"ABCDEFGHIJKLMNOPQRSTUVWXYZ");
  textTTF->string.set1Value(2,"0123456789");
  textTTF->string.set1Value(3,"!\"#$%&'()*+,-./:;<=>?@[\\]^_`{}~");
  sceneGraph->addChild(textTTF);

  SoGuiExaminerViewer* examinerViewer = new SoGuiExaminerViewer(widget);
  examinerViewer->setSize(SbVec2s(800,200));
  examinerViewer->setSceneGraph(sceneGraph);
  examinerViewer->viewAll();
  examinerViewer->show();

  SoGui::show(widget);
  SoGui::mainLoop();

  sceneGraph->unref();
  delete examinerViewer;

#ifdef SoFreePackage //Cleanup
  SoTextTTF::clearClass();

  SoGui::clear();  
#endif

  return 0; 
}

