/*
 * To Test manip. In fact it is pure Inventor, no HEPVis here.
 */

#include <HEPVis/Gui/SoGui.h>

#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoCube.h>
#include <Inventor/nodes/SoTranslation.h>

#include <Inventor/manips/SoTransformBoxManip.h>

#include <stdlib.h> //exit

//////////////////////////////////////////////////////////////////////////////
int main (
 int aArgc
,char** aArgv
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  // Set up the main window
  SoGuiWidget topWidget=SoGui::init(aArgv[0]);
  if (!topWidget) exit(1);

  // initialize HEPVis used classes :

  SoSeparator* sceneGraph = new SoSeparator;
  sceneGraph->ref();

 {SoSeparator* soSep = new SoSeparator;
  sceneGraph->addChild(soSep);

  SoTranslation* trans = new SoTranslation();
  trans->translation.setValue(10,0,0);
  soSep->addChild(trans);

  SoCube* soCube = new SoCube;
  soSep->addChild(soCube);}

 {SoSeparator* soSep = new SoSeparator;
  sceneGraph->addChild(soSep);

  SoTransformBoxManip* manip = new SoTransformBoxManip();
  soSep->addChild(manip);

  SoCube* soCube = new SoCube;
  soSep->addChild(soCube);}

  SoGuiExaminerViewer* examinerViewer = new SoGuiExaminerViewer(topWidget);
  examinerViewer->setSceneGraph(sceneGraph);
  examinerViewer->show();

  SoGui::show(topWidget);
  SoGui::mainLoop();

  sceneGraph->unref();
  delete examinerViewer;

  return 0; 
}
