
import CoinPython as Inventor

Inventor.SoDB.init()
Inventor.SoNodeKit.init()

root = Inventor.SoSeparator()

camera = Inventor.SoPerspectiveCamera()
root.addChild(camera)

scale = Inventor.SoScale()
scale.scaleFactor.setValue(Inventor.SbVec3f(0.1,0.1,0.1))
root.addChild(scale)

appearanceKit = Inventor.SoAppearanceKit()
root.addChild(appearanceKit)

import HEPVis

## Utils :
HEPVis.Utils_initClasses()

grid = HEPVis.SoGrid()
root.addChild(grid)

text = HEPVis.SoTextHershey()
root.addChild(text)

axis = HEPVis.SoAxis()
root.addChild(axis)

## Geometry :
HEPVis.Geometry_initClasses()

tubs = HEPVis.SoTubs()
root.addChild(tubs)

## Detector :
HEPVis.Detector_initClasses()

detectorExample = HEPVis.SoDetectorExample()
root.addChild(detectorExample)

writeAction = Inventor.SoWriteAction()
writeAction.getOutput().setBinary(Inventor.FALSE)
writeAction.apply(root)

del writeAction
del root
