   
#include <HEPVis/Gui/SoGui.h>

#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoLightModel.h>
#include <Inventor/nodes/SoDirectionalLight.h>
#include <Inventor/nodes/SoOrthographicCamera.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoCube.h>

#include <HEPVis/SDL/SoSDL_Viewer.h>

//Darwin : "main" becomes "SDL_main" through a cpp macro in SDL.h.

//////////////////////////////////////////////////////////////////////////////
int main( 
 int /*argc*/
,char* argv[]
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  SoGuiWidget topWidget = SoGui::init(argv[0]);
  if(!topWidget) return 1;

  SoSeparator* sceneGraph = new SoSeparator;
  sceneGraph->ref();

  SoLightModel* lightModel = new SoLightModel;
  lightModel->model.setValue(SoLightModel::PHONG);
  //lightModel->model.setValue(SoLightModel::BASE_COLOR);
  sceneGraph->addChild(lightModel);

  SoDirectionalLight* light = new SoDirectionalLight;
  light->color.setValue(1,1,1);
  light->direction.setValue(SbVec3f(1,-1,-10));
  sceneGraph->addChild(light);

  SoOrthographicCamera* camera = new SoOrthographicCamera;
  camera->viewportMapping.setValue(SoCamera::ADJUST_CAMERA);
  camera->position.setValue(0,0,10);
  camera->orientation.setValue(SbRotation(SbVec3f(0,1,0),0));
  camera->height.setValue(10);
  camera->nearDistance.setValue(1);
  camera->farDistance.setValue(100);
  camera->focalDistance.setValue(10);
  sceneGraph->addChild(camera);

  SoMaterial* material = new SoMaterial;
  material->diffuseColor.setValue(SbColor(1,1,0));
  sceneGraph->addChild(material);

  sceneGraph->addChild(new SoCube);

  SoSDL_Viewer* viewer = new SoSDL_Viewer(topWidget);
  viewer->setSceneGraph(sceneGraph);
  //viewer->viewAll();
  viewer->setBackgroundColor(SbColor(0.8F,0.8F,0.8F));
    
  SoSDL::mainLoop();
    
  sceneGraph->unref();

  delete viewer;

  SoSDL::clear();
	
  return 0;
}

