#include <math.h>
#include <stdlib.h>

#include <HEPVis/Gui/SoGui.h>

#include <Inventor/nodes/SoSeparator.h>

#include <HEPVis/nodes/SoBackPrimitive.h>

#include <HEPVis/nodekits/SoArrowButton.h>
#include <HEPVis/nodekits/SoScrolledList.h>
#include <HEPVis/nodekits/SoSelectionBox.h>

static void okCB(void*,SoNode*);

//////////////////////////////////////////////////////////////////////////////
int main(
 int
,char ** aArgv
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  SoGuiWidget widget=SoGui::init(aArgv[0]);
  if(widget==NULL) exit(1);

  SoBackPrimitive::initClass();

  SoPrimitive::initClass();
  SoForm::initClass();
  SoArrowButton::initClass();
  SoList::initClass();
  SoScrolledList::initClass();
  SoSelectionBox::initClass();

  SoSeparator* sceneGraph=new SoSeparator;
  sceneGraph->ref();

  SoSelectionBox* selectionBox = new SoSelectionBox;
  selectionBox->items.set1Value(0,"item 1");
  selectionBox->items.set1Value(1,"item 2");
  selectionBox->items.set1Value(2,"item 3");
  selectionBox->items.set1Value(3,"item 4");
  selectionBox->items.set1Value(4,"item 5");
  selectionBox->items.set1Value(5,"item 6");
  selectionBox->items.set1Value(6,"item 7");
  selectionBox->addOkCallback(okCB,NULL);
  sceneGraph->addChild(selectionBox);

  // View the new object in an Examiner Viewer
  SoGuiExaminerViewer* viewer = new SoGuiExaminerViewer(widget);
  viewer->setSceneGraph(sceneGraph);
  viewer->viewAll();
  viewer->show();

  SoGui::show(widget);
  SoGui::mainLoop();

  sceneGraph->unref();
  delete viewer;

#ifdef SoFreePackage //Cleanup
  SoSelectionBox::clearClass();
  SoPrimitive::clearClass();
  SoForm::clearClass();
  SoArrowButton::clearClass();
  SoList::clearClass();
  SoScrolledList::clearClass();

  SoBackPrimitive::clearClass();

  SoGui::clear();  
#endif

  return 0; 
}
//////////////////////////////////////////////////////////////////////////////
static void okCB (
 void* /*aUserData*/
,SoNode* aNode
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  SoSelectionBox* selectionBox = (SoSelectionBox*)aNode;
  if(selectionBox==NULL) return;
  const SbString& selection = selectionBox->getSelection();
  printf("Selected file : %s\n",selection.getString());
}

