#include <math.h>
#include <stdlib.h>

#include <HEPVis/Gui/SoGui.h>

// SGI : SoOffscreenRenderer.h include glx.h !
#ifdef __COIN__
#include <Inventor/SoOffscreenRenderer.h>
#endif

#include <Inventor/nodes/SoOrthographicCamera.h>
#include <Inventor/nodes/SoPerspectiveCamera.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoTexture2.h>
#include <Inventor/nodes/SoCube.h>
#include <Inventor/nodes/SoTexture2Transform.h>
#include <Inventor/nodes/SoTransform.h>
#include <Inventor/nodes/SoDirectionalLight.h>
#include <Inventor/nodes/SoSpotLight.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoRotationXYZ.h>
#include <Inventor/nodes/SoFont.h>
#include <Inventor/nodes/SoText2.h>
#include <Inventor/nodes/SoText3.h>

//////////////////////////////////////////////////////////////////////////////
int main(
 int
,char ** aArgv
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  SoGuiWidget myWindow=SoGui::init(aArgv[0]);
  if(myWindow==NULL) exit(1);

  SoSeparator* sceneGraph = new SoSeparator;
  sceneGraph->ref();

  int h = 20;
  int w = 40;
  unsigned char* buffer = new unsigned char[3 * w * h];
  unsigned char* p = buffer;
  int row,col;
  /*
  for(row=0;row<5;row++) 
    for(col=0;col<w;col++) {*p = 255;p++;*p = 0;p++;*p = 0;p++;} 
  for(row=5;row<10;row++) 
    for(col=0;col<w;col++) {*p = 0;p++;*p = 255;p++;*p = 0;p++;} 
  for(row=10;row<h;row++) 
    for(col=0;col<w;col++) {*p = 0;p++;*p = 0;p++;*p = 255;p++;}
    */
  for(row=0;row<h;row++) {
    for(col=0;col<20;col++) {*p = 255;p++;*p =   0;p++;*p = 0;p++;} 
    for(col=20;col<w;col++) {*p =   0;p++;*p = 255;p++;*p = 0;p++;} 
  }

  /*
  SoDirectionalLight* light = new SoDirectionalLight;
  light->color.setValue(1.0,1.0,1.0);
  light->direction.setValue(SbVec3f(0.0,0.0,-1.0));
  sceneGraph->addChild(light);

  SoMaterial* material = new SoMaterial;
  material->diffuseColor.setValue(1.0, 1.0, 1.0);
  sceneGraph->addChild(material);
  */

  // Generate the texture map
  SoTexture2* texture2 = new SoTexture2;
  //texture2->filename.setValue("../data/brick_1.rgb");
#ifdef __COIN__
  texture2->image.setValue(SbVec2s(w,h),SoOffscreenRenderer::RGB,buffer);
#else
  texture2->image.setValue(SbVec2s(w,h),3,buffer);
#endif
  sceneGraph->addChild(texture2);

  /*
  SoTexture2Transform* texture2transform = new SoTexture2Transform;
  texture2transform->translation.setValue(SbVec2f(((float)col)/number,
                                                  ((float)row)/number));
  texture2transform->scaleFactor.setValue(SbVec2f(1./number,1./number));
  separator->addChild(texture2transform);
  */

  SoCube* cube = new SoCube;
  sceneGraph->addChild(cube);
  
  // View the new object in an Examiner Viewer
  SoGuiExaminerViewer *myViewer=new SoGuiExaminerViewer(myWindow);
  //myViewer->setBackgroundColor(SbColor(
  //                               0.593759,0.980484,0.593759 //palegreen
  //                               ));
  myViewer->setSceneGraph(sceneGraph);
  //myViewer->setHeadlight(FALSE);
  myViewer->viewAll();
  myViewer->show();

  SoGui::show(myWindow);
  SoGui::mainLoop();

  sceneGraph->unref();
  delete myViewer;

#ifdef SoFreePackage //Cleanup
  SoGui::clear();  
#endif

  return 0; 
}
