#include <math.h>
#include <stdlib.h>

#include <HEPVis/Gui/SoGui.h>

#include <Inventor/nodes/SoSeparator.h>

#include <HEPVis/nodes/SoBackPrimitive.h>
#include <HEPVis/nodes/SoGrid.h>

#include <HEPVis/nodekits/SoPrimitive.h>
#include <HEPVis/nodekits/SoText.h>

static void activateCB(void*,SoNode*);

//////////////////////////////////////////////////////////////////////////////
int main(
 int
,char ** aArgv
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  SoGuiWidget myWindow=SoGui::init(aArgv[0]);
  if(myWindow==NULL) exit(1);

  SoBackPrimitive::initClass();
  SoGrid::initClass();

  SoPrimitive::initClass();
  SoText::initClass();

  SoSeparator* sceneGraph=new SoSeparator;
  sceneGraph->ref();

  SoText* text = new SoText();
  text->shadowThickness.setValue(0.1F);
  text->marginWidth.setValue(0.1F);
  text->marginHeight.setValue(0.1F);
  text->editable.setValue(TRUE);
  text->value.set1Value(0,"");
  text->addActivateCallback(activateCB,NULL);
  sceneGraph->addChild(text);

  // View the new object in an Examiner Viewer
  SoGuiExaminerViewer *myViewer=new SoGuiExaminerViewer(myWindow);
  myViewer->setSceneGraph(sceneGraph);
  myViewer->viewAll();
  myViewer->show();

  SoGui::show(myWindow);
  SoGui::mainLoop();

  sceneGraph->unref();
  delete myViewer;

#ifdef SoFreePackage //Cleanup
  SoText::clearClass();
  SoPrimitive::clearClass();
  SoGrid::clearClass();

  SoBackPrimitive::clearClass();

  SoGui::clear();  
#endif

  return 0; 
}
//////////////////////////////////////////////////////////////////////////////
static void activateCB (
 void* /*aUserData*/
,SoNode* aNode
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  SoText* text = (SoText*)aNode;
  if(text==NULL) return;
  const SbString& s = text->value[0];
  if(s=="exit") {
#ifdef SoFreePackage //Cleanup
    SoGui::sendExit();  
#else
    exit(EXIT_SUCCESS);
#endif
  } else {
    printf("%s\n",s.getString());
  }
}

