#include <math.h>
#include <stdlib.h>

#include <HEPVis/Gui/SoGui.h>

#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoMaterial.h>

#include <HEPVis/nodes/SoTextVtk.h>

int main(int, char ** argv) {
  
  SoGuiWidget widget=SoGui::init(argv[0]);
  if (widget==NULL) exit(1);

  // You must initialize a new class

  SoTextVtk::initClass();

  SoSeparator* sceneGraph = new SoSeparator;
  sceneGraph->ref();

  // Set up the material for the object to be drawn

  SoMaterial* material = new SoMaterial;
  material->diffuseColor.setValue(1, 0, 0);
  sceneGraph->addChild(material);

  SoTextVtk* textVtk = new SoTextVtk();
  textVtk->string.set1Value(0,"Vtk");
  textVtk->string.set1Value(1,"abcdefghijklmnopqrstuvwxyz");
  textVtk->string.set1Value(2,"ABCDEFGHIJKLMNOPQRSTUVWXYZ");
  textVtk->string.set1Value(3,"0123456789");
  textVtk->string.set1Value(4,"!\"#$%&'()*+,-./:;<=>?@[\\]^_`{}~");
  sceneGraph->addChild(textVtk);

  SoGuiExaminerViewer *viewer=new SoGuiExaminerViewer(widget);
  viewer->setSceneGraph(sceneGraph);
  viewer->viewAll();
  viewer->show();

  SoGui::show(widget);
  SoGui::mainLoop();

  sceneGraph->unref();
  delete viewer;

#ifdef SoFreePackage //Cleanup
  SoTextVtk::clearClass();
  SoGui::clear();  
#endif

  return 0; 
}

