/////////////////////////////////////////////////////////////
//
// Simple example of SoXtGui
//
/////////////////////////////////////////////////////////////

#include <math.h>
#include <iostream>
using std::cout;
using std::endl;

#include <stdlib.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/Xt/SoXt.h>
#include "HEPVis/Xt/SoXtGui.h"
#include <Xm/CascadeB.h>

int  main(int, char ** argv);
int  trigButtonCB(void*);
int  quitButtonCB(void*);

Widget _testMenuButton;

SoSeparator   *root;   
Widget         myWindow;

SoXtGui *myViewer = NULL;

int main(int, char ** argv)
{
          
  myWindow = SoXt::init(argv[0]);
  if (myWindow == NULL) {
    cout << endl << "SoXt::init failed to initialise X11 => exit" << endl; 
    exit(1);}
  
  // one can hang some graphics on here
  //
  SoSeparator *root = new SoSeparator();
  root->ref();
  
 
///////////////////////////////////////////////////////////////
//
//   Create the viewer
//   =================
// 
///////////////////////////////////////////////////////////////

 myViewer = new SoXtGui(myWindow); 

 myViewer->setTitle        ("SoXtGui test");
 myViewer->setHelpURL      ("http://l3www.cern.ch/~cmscan/");
 myViewer->resizeMain(550, 650);
 myViewer->getViewer(SoXtGui::EXAMINER);

 myViewer->setTrigCallback (trigButtonCB,NULL);
 myViewer->setQuitCallback (quitButtonCB,NULL);
   
 myViewer->setErrorMessage("this is an error message");
 myViewer->addText("This is some text \n");

 #ifdef __KCC
InfoStream infoStream(myViewer);
 infoStream << "." <<std::endl;
 infoStream << "This is some more text," << std::endl;
 infoStream << "and some more." << std::endl;
#endif 
 
///////////////////////////////////////////////////////////////
// Add a "Test" menu button
///////////////////////////////////////////////////////////////
 Widget theMenuBar = myViewer->getMenuBar(); 
 Cardinal ac = 0;
 Arg      args[256];
 XtSetArg(args[ac], XmNlabelString,  XmStringCreateSimple((char*)"TestMenu")); ac++;
 XtSetArg(args[ac], XmNx,                                      50); ac++;
 XtSetArg(args[ac], XmNy,                                       5); ac++;
 XtSetArg(args[ac], XmNwidth,                                  54); ac++;
 XtSetArg(args[ac], XmNheight,                                 25); ac++;       
 _testMenuButton = XmCreateCascadeButton(theMenuBar,(char*) "testMenuButton",args,ac);
 XtManageChild(_testMenuButton);


 myViewer->setSceneGraph(root);
 myViewer->show();

 myViewer->getCurrentViewer()->viewAll();
 myViewer->getCurrentViewer()->saveHomePosition();
 
 SoXt::show(myWindow);   
 
 SoXt::mainLoop();     // we never return from here...
    
 return 0;
}



int trigButtonCB(void *)
{
/////////////////////////////////////////////////////////////////////////
//  
// Callback for TRIG button 
//
/////////////////////////////////////////////////////////////////////////

   cout << endl << "This is the trigButton callback..." << endl;

   return 0;
}

int quitButtonCB(void *)
{
/////////////////////////////////////////////////////////////////////////
//  
// Callback for QUIT button 
//
/////////////////////////////////////////////////////////////////////////

   cout << endl << "This is the quitButton CB..." << endl;

   return 0;
}







