#ifndef HEPVis_SbPlane_h
#define HEPVis_SbPlane_h

/*
 * An SbPlane class that uses doubles instead of floats.
 * Used by the BooleanProcessor.
 */

#include <Inventor/SbVec3d.h>

namespace HEPVis {

class SbPlane {
public:
  SbPlane();
  SbPlane(const SbVec3d& normal,double D);
  SbPlane(const SbVec3d& normal,const SbVec3d& point);
  // To follow CLHEP.
  // Constructor from four numbers - creates plane a*x+b*y+c*z+d=0.
  //SbPlane(double a,double b,double c,double d);
  double getDistance(const SbVec3d& point) const;
  const SbVec3d& getNormal() const;
  double getDistanceFromOrigin() const;
public:
  double distance(const SbVec3d& point) const; //CLHEP compatibility
private:
  SbVec3d m_normal;
  double m_distance;
};

}

#endif
