#!/bin/csh -f

#
# File produced by the obuild tool version 1.0
# for the package HEPVis with version v6r10p0.
#

#////////////////////////////////////////////////
# Usage :
#   csh> source setup.csh
#////////////////////////////////////////////////

#set verbose  # uncomment this line to have full verbosity.

#////////////////////////////////////////////////
# Set the absolute path of this package.
# If in the below line there is the keyword :
#
#     @@absolute_dir@@
#
# then the package had not been installed.
#
#  Someone has to replace @@absolute_dir@@
# by the absolute path of the package.
# By "absolute path of the package", we mean that
# if the obuild directory of the package is 
# found under :
#    some_path/pack/vers/obuild
# then the "absolute path of the package" is :
#    some_path/pack/vers
#
#  This replacement can be done on the setup
# scripts of the package by using the sh/build 
# with the -i option.
#
#  This replacement can be done recursively
# on the setups of the used packages by using 
# the sh/build script with the -bci option 
# ("bci" for broadcast install).
#
#////////////////////////////////////////////////

set obuild_HEPVis_path="@@absolute_dir@@"


if ( "${obuild_HEPVis_path}" == '@@absolute_dir@@' ) then
  echo '  The package HEPVis had not been installed.'
  echo ''
  echo ' In the file :'
  echo '    HEPVis/<vers>/obuild/setup.csh'
  echo ' someone has to replace '
  echo '    @@absolute_dir@@'
  echo ' by the absolute path of the package.'
  echo '  By "absolute path of the package", we mean that'
  echo ' if the obuild directory of the package is found under :'
  echo '    some_path/pack/vers/obuild'
  echo ' then the "absolute path of the package" is :'
  echo '    some_path/pack/vers'
  echo ''
  echo '  If having the write access, this replacement can be done'
  echo ' on the setup scripts of the package by using the sh/build'
  echo ' with the -i option. This replacement can be done recursively'
  echo ' on the setups of the used packages by using the sh/build script'
  echo ' with the -bci option ("bci" for broadcast install).'
  echo ''
  exit
endif

if ( $?OBUILD_DIR_BIN ) then
  if (  "${OBUILD_DIR_BIN}" == "" ) then
    set obuild_dir_bin=bin_obuild
  else
    set obuild_dir_bin=${OBUILD_DIR_BIN}
  endif
else
  set obuild_dir_bin=bin_obuild
endif

if ( "${obuild_dir_bin}" == "" ) then
  echo "obuild_dir_bin variable not defined."
  exit
endif

/bin/mkdir -p "${obuild_HEPVis_path}/${obuild_dir_bin}"
if ( ! -e "${obuild_HEPVis_path}/${obuild_dir_bin}/obuild_platform" ) then
  if ( ! -e "${obuild_HEPVis_path}/obuild/cpp/obuild_platform.cpp" ) then
    echo "Program source obuild_platform.cpp not found."
    exit
  endif
  if ( $?obuild_cxx_command ) then
    if ( "${obuild_cxx_command}" == "" ) then
      if (  $?OBUILD_CXX ) then
        set obuild_platform_compiler=${OBUILD_CXX}
      else
        set obuild_platform_compiler=c++
      endif
    else
      set obuild_platform_compiler=${obuild_cxx_command}
    endif
  else
    set obuild_platform_compiler=c++
  endif
  ${obuild_platform_compiler} -o "${obuild_HEPVis_path}/${obuild_dir_bin}/obuild_platform" "${obuild_HEPVis_path}/obuild/cpp/obuild_platform.cpp"
  unset obuild_platform_compiler
  if ( ! -e "${obuild_HEPVis_path}/${obuild_dir_bin}/obuild_platform" ) then
    echo "Program obuild_platform not found."
    exit
  endif
endif
set obuild_platform_exe="${obuild_HEPVis_path}/${obuild_dir_bin}/obuild_platform"
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if ( ${obuild_platform_result} == yes ) then
set Motif_home="/sw"
endif
unset obuild_platform_result
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Motif_home="/usr/X11R6"
endif
unset obuild_platform_result
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if ( ${obuild_platform_result} == yes ) then
set Qt_home="/usr/local/Qt/4.1.4"
endif
unset obuild_platform_result
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Qt_home="/usr/local/Qt/4.1.4"
endif
unset obuild_platform_result
if ( $?OBUILD_SITE ) then
if ( "${OBUILD_SITE}" == "lxplus_slc3_ia32_gcc323" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Qt_home="/afs/cern.ch/user/g/gybarran/software/Qt/4.1.4/slc3_ia32_gcc323"
endif
unset obuild_platform_result
endif
endif
if ( $?OBUILD_SITE ) then
if ( "${OBUILD_SITE}" == "lxplus_slc4_ia32_gcc34" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Qt_home="/afs/cern.ch/user/g/gybarran/software/Qt/4.1.4/slc4_ia32_gcc34"
endif
unset obuild_platform_result
endif
endif
if ( $?OBUILD_SITE ) then
if ( "${OBUILD_SITE}" == "lxplus_slc4_amd64_gcc34" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Qt_home="/afs/cern.ch/user/g/gybarran/software/Qt/4.1.4/slc4_amd64_gcc34"
endif
unset obuild_platform_result
endif
endif
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if ( ${obuild_platform_result} == yes ) then
set SDL_home="/Library/Frameworks/SDL.framework"
endif
unset obuild_platform_result
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set SDL_home="/usr/local/SDL/1.2.11"
endif
unset obuild_platform_result
if ( $?OBUILD_SITE ) then
if ( "${OBUILD_SITE}" == "lxplus_slc3_ia32_gcc323" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set SDL_home="/afs/cern.ch/sw/contrib/SDL/1.2.11/slc3_ia32_gcc323"
endif
unset obuild_platform_result
endif
endif
if ( $?OBUILD_SITE ) then
if ( "${OBUILD_SITE}" == "lxplus_slc4_ia32_gcc34" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set SDL_home="/afs/cern.ch/sw/contrib/SDL/1.2.11/slc4_ia32_gcc34"
endif
unset obuild_platform_result
endif
endif
if ( $?OBUILD_SITE ) then
if ( "${OBUILD_SITE}" == "lxplus_slc4_amd64_gcc34" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set SDL_home="/afs/cern.ch/sw/contrib/SDL/1.2.11/slc4_amd64_gcc34"
endif
unset obuild_platform_result
endif
endif
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if ( ${obuild_platform_result} == yes ) then
set curl_home="/usr"
endif
unset obuild_platform_result
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set curl_home="/usr"
endif
unset obuild_platform_result
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if ( ${obuild_platform_result} == yes ) then
set gtk_home="/sw"
endif
unset obuild_platform_result
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set gtk_home="/usr"
endif
unset obuild_platform_result
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if ( ${obuild_platform_result} == yes ) then
set Python_home="/Library/Frameworks/Python.framework"
endif
unset obuild_platform_result
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Python_home="/usr/local/Python/2.5.1"
endif
unset obuild_platform_result
if ( $?OBUILD_SITE ) then
if ( "${OBUILD_SITE}" == "lxplus_slc4_ia32_gcc34" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Python_home="/afs/cern.ch/sw/lcg/external/Python/2.5/slc4_ia32_gcc34"
endif
unset obuild_platform_result
endif
endif
if ( $?OBUILD_SITE ) then
if ( "${OBUILD_SITE}" == "lxplus_slc4_amd64_gcc34" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Python_home="/afs/cern.ch/sw/lcg/external/Python/2.5/slc4_amd64_gcc34"
endif
unset obuild_platform_result
endif
endif
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Python_vers="2.5"
endif
unset obuild_platform_result
if ( $?OBUILD_SITE ) then
if ( "${OBUILD_SITE}" == "lxplus_slc4_ia32_gcc34" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Python_vers="2.5"
endif
unset obuild_platform_result
endif
endif
if ( $?OBUILD_SITE ) then
if ( "${OBUILD_SITE}" == "lxplus_slc4_amd64_gcc34" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Python_vers="2.5"
endif
unset obuild_platform_result
endif
endif
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'OSF1'`
if ( ${obuild_platform_result} == yes ) then
set Python_home="/usr/local/Python/2.3.4"
endif
unset obuild_platform_result
/bin/mkdir -p "${obuild_HEPVis_path}/${obuild_dir_bin}"
if ( ! -e "${obuild_HEPVis_path}/${obuild_dir_bin}/obuild_find" ) then
  if ( ! -e "${obuild_HEPVis_path}/obuild/cpp/obuild_find.cpp" ) then
    echo "Program source obuild_find.cpp not found."
    exit
  endif
  if ( $?obuild_cxx_command ) then
    if ( "${obuild_cxx_command}" == "" ) then
      if (  $?OBUILD_CXX ) then
        set obuild_find_compiler=${OBUILD_CXX}
      else
        set obuild_find_compiler=c++
      endif
    else
      set obuild_find_compiler=${obuild_cxx_command}
    endif
  else
    set obuild_find_compiler=c++
  endif
  ${obuild_find_compiler} -o "${obuild_HEPVis_path}/${obuild_dir_bin}/obuild_find" "${obuild_HEPVis_path}/obuild/cpp/obuild_find.cpp"
  unset obuild_find_compiler
  if ( ! -e "${obuild_HEPVis_path}/${obuild_dir_bin}/obuild_find" ) then
    echo "Program obuild_find not found."
    exit
  endif
endif
set obuild_find_exe="${obuild_HEPVis_path}/${obuild_dir_bin}/obuild_find"
if ( "${obuild_find_exe}" == "" ) then
  echo "Variable obuild_find_exe not defined."
  exit
endif
set obuild_zlib_path=`"${obuild_find_exe}" zlib 'v1r*'`
if ( "${obuild_find_exe}" == "" ) then
  echo "Variable obuild_find_exe not defined."
  exit
endif
set obuild_png_path=`"${obuild_find_exe}" png 'v1r*'`
if ( "${obuild_find_exe}" == "" ) then
  echo "Variable obuild_find_exe not defined."
  exit
endif
set obuild_jpeg_path=`"${obuild_find_exe}" jpeg 'v1r*'`
if ( "${obuild_find_exe}" == "" ) then
  echo "Variable obuild_find_exe not defined."
  exit
endif
set obuild_dvi2bitmap_path=`"${obuild_find_exe}" dvi2bitmap 'v1r*'`
if ( "${obuild_find_exe}" == "" ) then
  echo "Variable obuild_find_exe not defined."
  exit
endif
set obuild_freetype2_path=`"${obuild_find_exe}" freetype2 'v1r*'`
if ( "${obuild_find_exe}" == "" ) then
  echo "Variable obuild_find_exe not defined."
  exit
endif
set obuild_CoinXt_path=`"${obuild_find_exe}" CoinXt 'v1r*'`
if ( "${obuild_find_exe}" == "" ) then
  echo "Variable obuild_find_exe not defined."
  exit
endif
set obuild_CoinWin_path=`"${obuild_find_exe}" CoinWin 'v1r*'`
if ( "${obuild_find_exe}" == "" ) then
  echo "Variable obuild_find_exe not defined."
  exit
endif
set obuild_CoinQt_path=`"${obuild_find_exe}" CoinQt 'v1r*'`
if ( "${obuild_find_exe}" == "" ) then
  echo "Variable obuild_find_exe not defined."
  exit
endif
set obuild_CoinGtk_path=`"${obuild_find_exe}" CoinGtk 'v1r*'`
if ( "${obuild_find_exe}" == "" ) then
  echo "Variable obuild_find_exe not defined."
  exit
endif
set obuild_SoSDL_path=`"${obuild_find_exe}" SoSDL 'v1r*'`
if ( "${obuild_find_exe}" == "" ) then
  echo "Variable obuild_find_exe not defined."
  exit
endif
set obuild_CoinPython_path=`"${obuild_find_exe}" CoinPython 'v1r*'`

# Execute setup of used packages :
source "${obuild_zlib_path}/obuild/setup.csh"

source "${obuild_png_path}/obuild/setup.csh"

source "${obuild_jpeg_path}/obuild/setup.csh"

source "${obuild_dvi2bitmap_path}/obuild/setup.csh"

source "${obuild_freetype2_path}/obuild/setup.csh"

if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'UNIX'`
if ( ${obuild_platform_result} == yes ) then
source "${obuild_CoinXt_path}/obuild/setup.csh"
endif
unset obuild_platform_result

if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
source "${obuild_CoinQt_path}/obuild/setup.csh"
endif
unset obuild_platform_result

if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
source "${obuild_CoinGtk_path}/obuild/setup.csh"
endif
unset obuild_platform_result

source "${obuild_SoSDL_path}/obuild/setup.csh"

source "${obuild_CoinPython_path}/obuild/setup.csh"

# Set environment variables of this package :

  if (  $?TTFPATH ) then
    setenv TTFPATH "${TTFPATH}:${obuild_HEPVis_path}/fonts"
  else
    setenv TTFPATH "${obuild_HEPVis_path}/fonts"
  endif

  if (  $?PYTHONPATH ) then
    setenv PYTHONPATH "${PYTHONPATH}:${obuild_HEPVis_path}/scripts/Python"
  else
    setenv PYTHONPATH "${obuild_HEPVis_path}/scripts/Python"
  endif

  if (  $?PYTHONPATH ) then
    setenv PYTHONPATH "${PYTHONPATH}:${obuild_HEPVis_path}/${obuild_dir_bin}"
  else
    setenv PYTHONPATH "${obuild_HEPVis_path}/${obuild_dir_bin}"
  endif

if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if ( ${obuild_platform_result} == yes ) then
  if (  $?DYLD_LIBRARY_PATH ) then
    setenv DYLD_LIBRARY_PATH "${DYLD_LIBRARY_PATH}:${obuild_HEPVis_path}/${obuild_dir_bin}"
  else
    setenv DYLD_LIBRARY_PATH "${obuild_HEPVis_path}/${obuild_dir_bin}"
  endif
else
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'CYGWIN'`
if ( ${obuild_platform_result} == yes ) then
if (  $?PATH ) then
  setenv PATH "${PATH}:${obuild_HEPVis_path}/${obuild_dir_bin}"
else
  setenv PATH "${obuild_HEPVis_path}/${obuild_dir_bin}"
endif

else
  if (  $?LD_LIBRARY_PATH ) then
    setenv LD_LIBRARY_PATH "${LD_LIBRARY_PATH}:${obuild_HEPVis_path}/${obuild_dir_bin}"
  else
    setenv LD_LIBRARY_PATH "${obuild_HEPVis_path}/${obuild_dir_bin}"
  endif
endif
unset obuild_platform_result
endif
unset obuild_platform_result

unset obuild_HEPVis_path

#FIXME unset obuild_dir_bin
