#!/bin/sh -f

#
# File produced by the obuild tool version 1.0
# for the package HEPVis with version v6r10p0.
#

#////////////////////////////////////////////////
# Usage :
#   sh> . setup.sh
#////////////////////////////////////////////////

#set -x  # uncomment this line to have full verbosity.

#////////////////////////////////////////////////
# Set the absolute path of this package.
# If in the below line there is the keyword :
#
#     @@absolute_dir@@
#
# then the package had not been installed.
#
#  Someone has to replace @@absolute_dir@@
# by the absolute path of the package.
# By "absolute path of the package", we mean that
# if the obuild directory of the package is 
# found under :
#    some_path/pack/vers/obuild
# then the "absolute path of the package" is :
#    some_path/pack/vers
#
#  This replacement can be done on the setup
# scripts of the package by using the sh/build 
# with the -i option.
#
#  This replacement can be done recursively
# on the setups of the used packages by using 
# the sh/build script with the -bci option 
# ("bci" for broadcast install).
#
#////////////////////////////////////////////////

obuild_HEPVis_path="@@absolute_dir@@"

if [ "${obuild_HEPVis_path}" = '@@absolute_dir@@' ] ; then
  echo '  The package HEPVis had not been installed.'
  echo ''
  echo ' In the file :'
  echo '    HEPVis/<vers>/obuild/setup.sh'
  echo ' someone has to replace '
  echo '    @@absolute_dir@@'
  echo ' by the absolute path of the package.'
  echo '  By "absolute path of the package", we mean that'
  echo ' if the obuild directory of the package is found under :'
  echo '    some_path/pack/vers/obuild'
  echo ' then the "absolute path of the package" is :'
  echo '    some_path/pack/vers'
  echo ''
  echo '  If having the write access, this replacement can be done'
  echo ' on the setup scripts of the package by using the sh/build'
  echo ' with the -i option. This replacement can be done recursively'
  echo ' on the setups of the used packages by using the sh/build script'
  echo ' with the -bci option ("bci" for broadcast install).'
  echo ''
  return
fi

if [  "${OBUILD_DIR_BIN}" = "" ] ; then
  obuild_dir_bin=bin_obuild
else
  obuild_dir_bin=${OBUILD_DIR_BIN}
fi

if [ "${obuild_dir_bin}" = "" ] ; then
  echo "obuild_dir_bin variable not defined."
  return
fi

/bin/mkdir -p "${obuild_HEPVis_path}/${obuild_dir_bin}"
if [ ! -e "${obuild_HEPVis_path}/${obuild_dir_bin}/obuild_platform" ] ; then
  if [ ! -e "${obuild_HEPVis_path}/obuild/cpp/obuild_platform.cpp" ] ; then
    echo "Program source obuild_platform.cpp not found."
    return
  fi
  if [ "${obuild_cxx_command}" = "" ] ; then 
    if [  "${OBUILD_CXX}" != "" ] ; then
      obuild_platform_compiler=${OBUILD_CXX}
    else
      obuild_platform_compiler=c++ 
    fi
  else
    obuild_platform_compiler=${obuild_cxx_command} 
  fi
  ${obuild_platform_compiler} -o "${obuild_HEPVis_path}/${obuild_dir_bin}/obuild_platform" "${obuild_HEPVis_path}/obuild/cpp/obuild_platform.cpp"
  unset obuild_platform_compiler
  if [ ! -e "${obuild_HEPVis_path}/${obuild_dir_bin}/obuild_platform" ] ; then
    echo "Program obuild_platform not found."
    return
  fi
fi
obuild_platform_exe="${obuild_HEPVis_path}/${obuild_dir_bin}/obuild_platform"
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if [ ${obuild_platform_result} = yes ] ; then
Motif_home="/sw"
fi
unset obuild_platform_result
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
Motif_home="/usr/X11R6"
fi
unset obuild_platform_result
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if [ ${obuild_platform_result} = yes ] ; then
Qt_home="/usr/local/Qt/4.1.4"
fi
unset obuild_platform_result
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
Qt_home="/usr/local/Qt/4.1.4"
fi
unset obuild_platform_result
if [ "${OBUILD_SITE}" = "lxplus_slc3_ia32_gcc323" ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
Qt_home="/afs/cern.ch/user/g/gybarran/software/Qt/4.1.4/slc3_ia32_gcc323"
fi
unset obuild_platform_result
fi
if [ "${OBUILD_SITE}" = "lxplus_slc4_ia32_gcc34" ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
Qt_home="/afs/cern.ch/user/g/gybarran/software/Qt/4.1.4/slc4_ia32_gcc34"
fi
unset obuild_platform_result
fi
if [ "${OBUILD_SITE}" = "lxplus_slc4_amd64_gcc34" ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
Qt_home="/afs/cern.ch/user/g/gybarran/software/Qt/4.1.4/slc4_amd64_gcc34"
fi
unset obuild_platform_result
fi
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if [ ${obuild_platform_result} = yes ] ; then
SDL_home="/Library/Frameworks/SDL.framework"
fi
unset obuild_platform_result
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
SDL_home="/usr/local/SDL/1.2.11"
fi
unset obuild_platform_result
if [ "${OBUILD_SITE}" = "lxplus_slc3_ia32_gcc323" ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
SDL_home="/afs/cern.ch/sw/contrib/SDL/1.2.11/slc3_ia32_gcc323"
fi
unset obuild_platform_result
fi
if [ "${OBUILD_SITE}" = "lxplus_slc4_ia32_gcc34" ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
SDL_home="/afs/cern.ch/sw/contrib/SDL/1.2.11/slc4_ia32_gcc34"
fi
unset obuild_platform_result
fi
if [ "${OBUILD_SITE}" = "lxplus_slc4_amd64_gcc34" ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
SDL_home="/afs/cern.ch/sw/contrib/SDL/1.2.11/slc4_amd64_gcc34"
fi
unset obuild_platform_result
fi
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if [ ${obuild_platform_result} = yes ] ; then
curl_home="/usr"
fi
unset obuild_platform_result
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
curl_home="/usr"
fi
unset obuild_platform_result
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if [ ${obuild_platform_result} = yes ] ; then
gtk_home="/sw"
fi
unset obuild_platform_result
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
gtk_home="/usr"
fi
unset obuild_platform_result
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if [ ${obuild_platform_result} = yes ] ; then
Python_home="/Library/Frameworks/Python.framework"
fi
unset obuild_platform_result
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
Python_home="/usr/local/Python/2.5.1"
fi
unset obuild_platform_result
if [ "${OBUILD_SITE}" = "lxplus_slc4_ia32_gcc34" ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
Python_home="/afs/cern.ch/sw/lcg/external/Python/2.5/slc4_ia32_gcc34"
fi
unset obuild_platform_result
fi
if [ "${OBUILD_SITE}" = "lxplus_slc4_amd64_gcc34" ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
Python_home="/afs/cern.ch/sw/lcg/external/Python/2.5/slc4_amd64_gcc34"
fi
unset obuild_platform_result
fi
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
Python_vers="2.5"
fi
unset obuild_platform_result
if [ "${OBUILD_SITE}" = "lxplus_slc4_ia32_gcc34" ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
Python_vers="2.5"
fi
unset obuild_platform_result
fi
if [ "${OBUILD_SITE}" = "lxplus_slc4_amd64_gcc34" ] ; then
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
Python_vers="2.5"
fi
unset obuild_platform_result
fi
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'OSF1'`
if [ ${obuild_platform_result} = yes ] ; then
Python_home="/usr/local/Python/2.3.4"
fi
unset obuild_platform_result
/bin/mkdir -p "${obuild_HEPVis_path}/${obuild_dir_bin}"
if [ ! -e "${obuild_HEPVis_path}/${obuild_dir_bin}/obuild_find" ] ; then
  if [ ! -e "${obuild_HEPVis_path}/obuild/cpp/obuild_find.cpp" ] ; then
    echo "Program source obuild_find.cpp not found."
    return
  fi
  if [ "${obuild_cxx_command}" = "" ] ; then
    if [  "${OBUILD_CXX}" != "" ] ; then
      obuild_find_compiler=${OBUILD_CXX}
    else
      obuild_find_compiler=c++
    fi
  else
    obuild_find_compiler=${obuild_cxx_command}
  fi
  ${obuild_find_compiler} -o "${obuild_HEPVis_path}/${obuild_dir_bin}/obuild_find" "${obuild_HEPVis_path}/obuild/cpp/obuild_find.cpp"
  unset obuild_find_compiler
  if [ ! -e "${obuild_HEPVis_path}/${obuild_dir_bin}/obuild_find" ] ; then
    echo "Program obuild_find not found."
    return
  fi
fi
obuild_find_exe="${obuild_HEPVis_path}/${obuild_dir_bin}/obuild_find"
if [ "${obuild_find_exe}" = "" ] ; then
  echo "Variable obuild_find_exe not defined."
  return
fi
obuild_zlib_path=`"${obuild_find_exe}" zlib 'v1r*'`
if [ "${obuild_zlib_path}" = "" ] ; then
  echo "Can't find zlib package."
  return
fi
if [ "${obuild_find_exe}" = "" ] ; then
  echo "Variable obuild_find_exe not defined."
  return
fi
obuild_png_path=`"${obuild_find_exe}" png 'v1r*'`
if [ "${obuild_png_path}" = "" ] ; then
  echo "Can't find png package."
  return
fi
if [ "${obuild_find_exe}" = "" ] ; then
  echo "Variable obuild_find_exe not defined."
  return
fi
obuild_jpeg_path=`"${obuild_find_exe}" jpeg 'v1r*'`
if [ "${obuild_jpeg_path}" = "" ] ; then
  echo "Can't find jpeg package."
  return
fi
if [ "${obuild_find_exe}" = "" ] ; then
  echo "Variable obuild_find_exe not defined."
  return
fi
obuild_dvi2bitmap_path=`"${obuild_find_exe}" dvi2bitmap 'v1r*'`
if [ "${obuild_dvi2bitmap_path}" = "" ] ; then
  echo "Can't find dvi2bitmap package."
  return
fi
if [ "${obuild_find_exe}" = "" ] ; then
  echo "Variable obuild_find_exe not defined."
  return
fi
obuild_freetype2_path=`"${obuild_find_exe}" freetype2 'v1r*'`
if [ "${obuild_freetype2_path}" = "" ] ; then
  echo "Can't find freetype2 package."
  return
fi
if [ "${obuild_find_exe}" = "" ] ; then
  echo "Variable obuild_find_exe not defined."
  return
fi
obuild_CoinXt_path=`"${obuild_find_exe}" CoinXt 'v1r*'`
if [ "${obuild_CoinXt_path}" = "" ] ; then
  echo "Can't find CoinXt package."
  return
fi
if [ "${obuild_find_exe}" = "" ] ; then
  echo "Variable obuild_find_exe not defined."
  return
fi
obuild_CoinWin_path=`"${obuild_find_exe}" CoinWin 'v1r*'`
if [ "${obuild_CoinWin_path}" = "" ] ; then
  echo "Can't find CoinWin package."
  return
fi
if [ "${obuild_find_exe}" = "" ] ; then
  echo "Variable obuild_find_exe not defined."
  return
fi
obuild_CoinQt_path=`"${obuild_find_exe}" CoinQt 'v1r*'`
if [ "${obuild_CoinQt_path}" = "" ] ; then
  echo "Can't find CoinQt package."
  return
fi
if [ "${obuild_find_exe}" = "" ] ; then
  echo "Variable obuild_find_exe not defined."
  return
fi
obuild_CoinGtk_path=`"${obuild_find_exe}" CoinGtk 'v1r*'`
if [ "${obuild_CoinGtk_path}" = "" ] ; then
  echo "Can't find CoinGtk package."
  return
fi
if [ "${obuild_find_exe}" = "" ] ; then
  echo "Variable obuild_find_exe not defined."
  return
fi
obuild_SoSDL_path=`"${obuild_find_exe}" SoSDL 'v1r*'`
if [ "${obuild_SoSDL_path}" = "" ] ; then
  echo "Can't find SoSDL package."
  return
fi
if [ "${obuild_find_exe}" = "" ] ; then
  echo "Variable obuild_find_exe not defined."
  return
fi
obuild_CoinPython_path=`"${obuild_find_exe}" CoinPython 'v1r*'`
if [ "${obuild_CoinPython_path}" = "" ] ; then
  echo "Can't find CoinPython package."
  return
fi

# Execute setup of used packages :
if [ ! -e "${obuild_zlib_path}/obuild/setup.sh" ] ; then
  echo "setup.sh not found for package zlib."
  return
fi
. "${obuild_zlib_path}/obuild/setup.sh"

if [ ! -e "${obuild_png_path}/obuild/setup.sh" ] ; then
  echo "setup.sh not found for package png."
  return
fi
. "${obuild_png_path}/obuild/setup.sh"

if [ ! -e "${obuild_jpeg_path}/obuild/setup.sh" ] ; then
  echo "setup.sh not found for package jpeg."
  return
fi
. "${obuild_jpeg_path}/obuild/setup.sh"

if [ ! -e "${obuild_dvi2bitmap_path}/obuild/setup.sh" ] ; then
  echo "setup.sh not found for package dvi2bitmap."
  return
fi
. "${obuild_dvi2bitmap_path}/obuild/setup.sh"

if [ ! -e "${obuild_freetype2_path}/obuild/setup.sh" ] ; then
  echo "setup.sh not found for package freetype2."
  return
fi
. "${obuild_freetype2_path}/obuild/setup.sh"

if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'UNIX'`
if [ ${obuild_platform_result} = yes ] ; then
if [ ! -e "${obuild_CoinXt_path}/obuild/setup.sh" ] ; then
  echo "setup.sh not found for package CoinXt."
  return
fi
. "${obuild_CoinXt_path}/obuild/setup.sh"

fi
unset obuild_platform_result
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
if [ ! -e "${obuild_CoinQt_path}/obuild/setup.sh" ] ; then
  echo "setup.sh not found for package CoinQt."
  return
fi
. "${obuild_CoinQt_path}/obuild/setup.sh"

fi
unset obuild_platform_result
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if [ ${obuild_platform_result} = yes ] ; then
if [ ! -e "${obuild_CoinGtk_path}/obuild/setup.sh" ] ; then
  echo "setup.sh not found for package CoinGtk."
  return
fi
. "${obuild_CoinGtk_path}/obuild/setup.sh"

fi
unset obuild_platform_result
if [ ! -e "${obuild_SoSDL_path}/obuild/setup.sh" ] ; then
  echo "setup.sh not found for package SoSDL."
  return
fi
. "${obuild_SoSDL_path}/obuild/setup.sh"

if [ ! -e "${obuild_CoinPython_path}/obuild/setup.sh" ] ; then
  echo "setup.sh not found for package CoinPython."
  return
fi
. "${obuild_CoinPython_path}/obuild/setup.sh"

# Set environment variables of this package :

  if [  "${TTFPATH}" = "" ] ; then
    TTFPATH="${obuild_HEPVis_path}/fonts"
    export TTFPATH
  else
    TTFPATH="${TTFPATH}:${obuild_HEPVis_path}/fonts"
    export TTFPATH
  fi

  if [  "${PYTHONPATH}" = "" ] ; then
    PYTHONPATH="${obuild_HEPVis_path}/scripts/Python"
    export PYTHONPATH
  else
    PYTHONPATH="${PYTHONPATH}:${obuild_HEPVis_path}/scripts/Python"
    export PYTHONPATH
  fi

  if [  "${PYTHONPATH}" = "" ] ; then
    PYTHONPATH="${obuild_HEPVis_path}/${obuild_dir_bin}"
    export PYTHONPATH
  else
    PYTHONPATH="${PYTHONPATH}:${obuild_HEPVis_path}/${obuild_dir_bin}"
    export PYTHONPATH
  fi

if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if [ ${obuild_platform_result} = yes ] ; then
  if [  "${DYLD_LIBRARY_PATH}" = "" ] ; then
    DYLD_LIBRARY_PATH="${obuild_HEPVis_path}/${obuild_dir_bin}"
    export DYLD_LIBRARY_PATH
  else
    DYLD_LIBRARY_PATH="${DYLD_LIBRARY_PATH}:${obuild_HEPVis_path}/${obuild_dir_bin}"
    export DYLD_LIBRARY_PATH
  fi
else
if [ "${obuild_platform_exe}" = "" ] ; then
  echo "Variable obuild_platform_exe not defined."
  return
fi
obuild_platform_result=`"${obuild_platform_exe}" 'CYGWIN'`
if [ ${obuild_platform_result} = yes ] ; then
if [  "${PATH}" = "" ] ; then
  PATH="${obuild_HEPVis_path}/${obuild_dir_bin}"
  export PATH
else
  PATH="${PATH}:${obuild_HEPVis_path}/${obuild_dir_bin}"
  export PATH
fi
else
  if [  "${LD_LIBRARY_PATH}" = "" ] ; then
    LD_LIBRARY_PATH="${obuild_HEPVis_path}/${obuild_dir_bin}"
    export LD_LIBRARY_PATH
  else
    LD_LIBRARY_PATH="${LD_LIBRARY_PATH}:${obuild_HEPVis_path}/${obuild_dir_bin}"
    export LD_LIBRARY_PATH
  fi
fi
unset obuild_platform_result
fi
unset obuild_platform_result

unset obuild_HEPVis_path

#FIXME unset obuild_dir_bin
