#include <HEPVis/SbBasic.h>

#ifdef HEPVisXt

/* this */
#include <HEPVis/Xt/PainterWidgetP.h>

#include <X11/StringDefs.h>

#ifdef __cplusplus
extern "C"{
#endif
static void InitClass();
static void InitWidget(Widget, Widget,ArgList,Cardinal*);
static void DestroyWidget(Widget);
static void ResizeWidget(Widget);
static void ExposeWidget(Widget, XEvent*, Region);
#ifdef __cplusplus
}
#endif

static XtResource resources [] ={
{XtNexposeCallback   ,XtCCallback  ,XtRCallback,sizeof(XtCallbackList),
 XtOffset(PainterWidget,painter.expose_callback),XtRImmediate,(XtPointer)NULL},
{XtNresizeCallback   ,XtCCallback  ,XtRCallback,sizeof(XtCallbackList),
 XtOffset(PainterWidget,painter.resize_callback),XtRImmediate,(XtPointer)NULL}
};


PainterClassRec  painterClassRec = {
/* Core Class Part */
{
    (WidgetClass) &compositeClassRec, /* pointer to superclass ClassRec   */
    "Painter",         		/* widget resource class name       */
    sizeof(PainterRec),	        /* size in bytes of widget record   */
    InitClass,                  /* class_initialize                 */
    NULL, 			/* dynamic initialization           */
    FALSE,       		/* has class been initialized?      */
    InitWidget,                 /* initialize                       */
    NULL,			/* notify that initialize called    */
    XtInheritRealize,           /* XCreateWindow for widget         */
    NULL,     		        /* widget semantics name to proc map*/
    0, 			        /* number of entries in actions     */
    resources,                  /* resources for subclass fields    */
    XtNumber(resources),        /* number of entries in resources   */
    NULLQUARK,		        /* resource class quarkified        */
    TRUE,			/* compress MotionNotify for widget */
    TRUE,			/* compress Expose events for widget*/
    TRUE,			/* compress enter and leave events  */
    TRUE,			/* select for VisibilityNotify      */
    DestroyWidget,	        /* free data for subclass pointers  */
    ResizeWidget,               /* geom manager changed widget size */
    ExposeWidget,       	/* rediplay window                  */
    NULL,		        /* set subclass resource values     */
    NULL,			/* notify that set_values called    */
    XtInheritSetValuesAlmost,   /* set_values got "Almost" geo reply*/
    NULL,		        /* notify that get_values called    */
    XtInheritAcceptFocus,       /* assign input focus to widget     */
    XtVersion,	                /* version of intrinsics used       */
    NULL,		        /* list of callback offsets         */
    XtInheritTranslations,      /* translations                     */	
    XtInheritQueryGeometry,     /* return preferred geometry        */
    XtInheritDisplayAccelerator,/* display your accelerator         */
    NULL		        /* pointer to extension record      */
},
/* Composite Class Part */
{
    XtInheritGeometryManager,   /* geometry manager for children   */
    XtInheritChangeManaged,     /* change managed state of child   */
    XtInheritInsertChild,       /* physically add child to parent  */
    XtInheritDeleteChild,       /* physically remove child         */
    NULL		        /* pointer to extension record     */
},
/*Painter*/
{
   0
}
   
};

WidgetClass painterWidgetClass = (WidgetClass)&painterClassRec;
/***************************************************************************/
static void InitClass (
)
/***************************************************************************/
/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
{
}
/***************************************************************************/
static void InitWidget (
 Widget aRequest
,Widget This
,ArgList aArgs
,Cardinal* aArgn
)
/***************************************************************************/
/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
{
  if(aRequest->core.width<=0)  This->core.width  = 100;
  if(aRequest->core.height<=0) This->core.height = 100;
  aRequest = NULL;
  aArgs = NULL;
  aArgn = 0;
}
/***************************************************************************/
static void DestroyWidget (
 Widget This
)
/***************************************************************************/
/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
{
  This = NULL;
}
/***************************************************************************/
static void ResizeWidget (
 Widget This
)
/***************************************************************************/
/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
{
/* Call the Resize procedure (XtInheritResize) */
  if(painterWidgetClass->core_class.superclass->core_class.resize!=NULL)
    (painterWidgetClass->core_class.superclass->core_class.resize)(This);

  XtCallCallbacks(This,XtNresizeCallback,NULL);
}
/***************************************************************************/
static void ExposeWidget (
 Widget  This
,XEvent* aEvent
,Region aRegion
)
/***************************************************************************/
/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
{
  if(painterWidgetClass->core_class.superclass->core_class.expose!=NULL)
    (painterWidgetClass->core_class.superclass->core_class.expose)
      (This,aEvent,aRegion);

  XtCallCallbacks(This,XtNexposeCallback,NULL);
}

#endif
