@ECHO OFF
SETLOCAL

REM #
REM # File produced by the obuild tool version 1.0
REM # for the package KUIP with version v1r950303p18.
REM #

REM #////////////////////////////////////////////////
REM # Usage :
REM #   DOS> CD some_path\pack\version\obuild
REM #   DOS> DOS\build_kuipsh
REM #
REM #////////////////////////////////////////////////

REM #////////////////////////////////////////////////
REM #/// Get path of this file :
REM #////////////////////////////////////////////////
SET obuild_KUIP_path=%~dp0
REM # Remove ending \obuild\DOS\
SET obuild_KUIP_path=%obuild_KUIP_path:~0,-12%

REM #////////////////////////////////////////////////
REM #/// Treat arguments :
REM #////////////////////////////////////////////////

SET obuild_verbose=no
SET obuild_debug=no
SET obuild_optimize=yes
SET obuild_set_x=no

:next_arg
IF "%1%" == "" GOTO end_args

IF NOT "%1%" == "-v" GOTO end_if_v
  SET obuild_verbose=yes
  SHIFT
  GOTO next_arg
:end_if_v

IF NOT "%1%" == "-g" GOTO end_if_g
  SET obuild_debug=yes
  SHIFT
  GOTO next_arg
:end_if_g

IF NOT "%1%" == "-x" GOTO end_if_x
  SET obuild_set_x=yes
  SHIFT
  GOTO next_arg
:end_if_x

:end_args

REM #////////////////////////////////////////////////
REM #/// End arguments.
REM #////////////////////////////////////////////////

IF %obuild_set_x% == yes ECHO ON

IF %obuild_debug% == yes SET obuild_optimize=no

IF "%OBUILD_DIR_BIN%" == "" (
  SET obuild_dir_bin=bin_obuild
) ELSE (
  SET obuild_dir_bin=%OBUILD_DIR_BIN%
)

IF "%obuild_dir_bin%" == "" (
  ECHO obuild_dir_bin variable not defined.
  GOTO obuild_return
)

IF NOT EXIST "%obuild_KUIP_path%\%obuild_dir_bin%" MKDIR "%obuild_KUIP_path%\%obuild_dir_bin%"

IF NOT EXIST "%obuild_KUIP_path%\%obuild_dir_bin%" MKDIR "%obuild_KUIP_path%\%obuild_dir_bin%"
IF NOT EXIST "%obuild_KUIP_path%\%obuild_dir_bin%\obuild_platform.exe" (
  cl.exe /nologo /DWIN32 /MD /O2 /W3  /GX /GR /Fe"%obuild_KUIP_path%\%obuild_dir_bin%\obuild_platform.exe" "%obuild_KUIP_path%\obuild\cpp\obuild_platform.cpp" 1> cl_exe_error
  IF ERRORLEVEL 1 TYPE cl_exe_error
  IF NOT ERRORLEVEL 1 DEL cl_exe_error 
  IF EXIST obuild_platform.obj DEL obuild_platform.obj
)

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_KUIP_0=%%d
cd "%obuild_KUIP_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_KUIP_0%"
SET obuild_pwd_KUIP_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_1
SET obuild_c_command=cl.exe
:end_if_platform_1
SET obuild_platform_result=
IF "%obuild_c_command%" == ""  ECHO Variable obuild_c_command not defined.  && GOTO obuild_return

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_KUIP_0=%%d
cd "%obuild_KUIP_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_KUIP_0%"
SET obuild_pwd_KUIP_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_3
SET obuild_c_optimize=/O2
:end_if_platform_3
SET obuild_platform_result=

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_KUIP_0=%%d
cd "%obuild_KUIP_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_KUIP_0%"
SET obuild_pwd_KUIP_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_5
SET obuild_c_debug=/ZI /Od
:end_if_platform_5
SET obuild_platform_result=

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_KUIP_0=%%d
cd "%obuild_KUIP_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_KUIP_0%"
SET obuild_pwd_KUIP_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_7
SET obuild_c_options=/nologo /DWIN32 /MD /W3
:end_if_platform_7
SET obuild_platform_result=

IF NOT %obuild_debug% == yes GOTO else_if_db_build_app_kuipsh_sh_8
  SET obuild_c_debug_local=%obuild_c_debug%
  GOTO end_if_db_build_app_kuipsh_sh_8
:else_if_db_build_app_kuipsh_sh_8
  SET obuild_c_debug_local=
:end_if_db_build_app_kuipsh_sh_8

IF NOT %obuild_optimize% == yes GOTO else_if_opt_build_app_kuipsh_sh_9
  SET obuild_c_optimize_local=%obuild_c_optimize%
  GOTO end_if_opt_build_app_kuipsh_sh_9
:else_if_opt_build_app_kuipsh_sh_9
  SET obuild_c_optimize_local=
:end_if_opt_build_app_kuipsh_sh_9



SET obuild_c_includes=/I"%obuild_KUIP_path%\include"

IF EXIST "%obuild_KUIP_path%\%obuild_dir_bin%\app_kuipsh" RMDIR /S /Q "%obuild_KUIP_path%\%obuild_dir_bin%\app_kuipsh"
IF NOT EXIST "%obuild_KUIP_path%\%obuild_dir_bin%\app_kuipsh" MKDIR "%obuild_KUIP_path%\%obuild_dir_bin%\app_kuipsh"

@IF %obuild_verbose% == yes @ECHO ON 
cd "%obuild_KUIP_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\app_kuipsh\kuipsh.obj "..\applications\kuipsh.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_KUIP_path%\obuild"

cd "%obuild_KUIP_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\app_kuipsh\uprogcdf.obj "..\applications\uprogcdf.c" 1> cl_exe_error
@IF ERRORLEVEL 1 @TYPE cl_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL cl_exe_error
cd "%obuild_KUIP_path%\obuild"

@IF %obuild_verbose% == yes @ECHO OFF 

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_KUIP_0=%%d
cd "%obuild_KUIP_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_KUIP_0%"
SET obuild_pwd_KUIP_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_15
SET obuild_c_linker_command=link.exe
:end_if_platform_15
SET obuild_platform_result=
IF "%obuild_c_linker_command%" == ""  ECHO Variable obuild_c_linker_command not defined.  && GOTO obuild_return

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_KUIP_0=%%d
cd "%obuild_KUIP_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_KUIP_0%"
SET obuild_pwd_KUIP_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_17
SET obuild_c_linker_debug=/DEBUG
:end_if_platform_17
SET obuild_platform_result=

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_KUIP_0=%%d
cd "%obuild_KUIP_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_KUIP_0%"
SET obuild_pwd_KUIP_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_19
SET obuild_c_linker_options=/nologo
:end_if_platform_19
SET obuild_platform_result=

IF NOT %obuild_debug% == yes GOTO else_if_db_build_app_kuipsh_sh_20
  SET obuild_c_linker_debug_local=%obuild_c_linker_debug%
  GOTO end_if_db_build_app_kuipsh_sh_20
:else_if_db_build_app_kuipsh_sh_20
  SET obuild_c_linker_debug_local=
:end_if_db_build_app_kuipsh_sh_20

IF NOT %obuild_optimize% == yes GOTO else_if_opt_build_app_kuipsh_sh_21
  SET obuild_c_linker_optimize_local=%obuild_c_linker_optimize%
  GOTO end_if_opt_build_app_kuipsh_sh_21
:else_if_opt_build_app_kuipsh_sh_21
  SET obuild_c_linker_optimize_local=
:end_if_opt_build_app_kuipsh_sh_21

SET obuild_linked_paths=/LIBPATH:"%obuild_KUIP_path%\%obuild_dir_bin%"
SET obuild_linked_libraries=KUIP.lib

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_KUIP_0=%%d
cd "%obuild_KUIP_path%\%obuild_dir_bin%"
IF EXIST .\app_kuipsh\tmp_objs DEL .\app_kuipsh\tmp_objs
FOR %%f IN (.\app_kuipsh\*.obj) DO ECHO %%f >> .\app_kuipsh\tmp_objs
REM # Link kuipsh :
IF EXIST .\kuipsh.exe DEL .\kuipsh.exe
@IF %obuild_verbose% == yes @ECHO ON 
%obuild_c_linker_command% %obuild_c_linker_debug_local% %obuild_c_linker_optimize_local% %obuild_c_linker_options% /out:.\kuipsh.exe @.\app_kuipsh\tmp_objs %obuild_linked_paths% %obuild_linked_libraries%
@IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 

cd "%obuild_pwd_KUIP_0%"
SET obuild_pwd_KUIP_0=
REM # Some cleanup :
IF EXIST "%obuild_KUIP_path%\%obuild_dir_bin%\app_kuipsh\tmp_objs" DEL "%obuild_KUIP_path%\%obuild_dir_bin%\app_kuipsh\tmp_objs"
IF EXIST "%obuild_KUIP_path%\%obuild_dir_bin%\kuipsh.ilk" DEL "%obuild_KUIP_path%\%obuild_dir_bin%\kuipsh.ilk"
IF EXIST "%obuild_KUIP_path%\%obuild_dir_bin%\kuipsh.pdb" DEL "%obuild_KUIP_path%\%obuild_dir_bin%\kuipsh.pdb"
IF EXIST "%obuild_KUIP_path%\%obuild_dir_bin%\app_kuipsh\tmp_objs" DEL "%obuild_KUIP_path%\%obuild_dir_bin%\app_kuipsh\tmp_objs"
IF EXIST "%obuild_KUIP_path%\%obuild_dir_bin%\kuipsh.exp" DEL "%obuild_KUIP_path%\%obuild_dir_bin%\kuipsh.exp"

:obuild_return
ENDLOCAL
@ECHO ON
