
#include <Lib/Printer.h>
#include <Lib/Out.h>
#include <Lib/Arguments.h>
#include <Lib/Cloner.h>
#include <Lib/System.h>

//////////////////////////////////////////////////////////////////////////////
int main (
 int aArgc
,char** aArgv
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Printer printer;
  Lib::Out out(printer);

  Lib::Arguments args(aArgc,aArgv);

  if(args.isAnArgument("-h")) {
    out << "Lib_clone :" << Lib::endl;
    out << "Usage :" << Lib::endl;
    out << "  OS> Lib_clone.exe -h" << Lib::endl;
    out << "  OS> Lib_clone.exe [-verbose] -path=<source path> -clone=<pack> -to=<name>" << Lib::endl;
    out << "For example :" << Lib::endl;
    out << "  OS> Lib_clone.exe -path=/projects/OnX/v13r0/templates/OnXTemplateOne -clone=OnXTemplateOne -to=Xxx" << Lib::endl;
    return Lib::System::exitSuccess();
  }

  bool verbose = false;
  std::string sverbose;
  if(args.find("-verbose",sverbose)) {
    if(sverbose=="") verbose = true;
  }

  std::string path;
  if(!args.find("-path",path)) {
    out << "  OS> Lib_clone -path=<source path> -clone=<pack> -to=<name>" 
        << Lib::endl;
    return Lib::System::exitFailure();
  }

  std::string from;
  if(!args.find("-clone",from)) {
    out << "  OS> Lib_clone -path=<source path> -clone=<pack> -to=<name>" 
        << Lib::endl;
    return Lib::System::exitFailure();
  }

  std::string to;
  if(!args.find("-to",to)) {
    out << "  OS> Lib_clone -path=<source path> -clone=<pack> -to=<name>" 
        << Lib::endl;
    return Lib::System::exitFailure();
  }

  bool debug = args.isAnArgument("-debug");

  bool status = Lib::Cloner::clone(path,from,to,printer,verbose,debug);

  return status?Lib::System::exitSuccess():Lib::System::exitFailure();
}

// embed code :
#include <Printer.cxx>
#include <Out.cxx>
#include <Arguments.cxx>
#include <smanip.cxx>
#include <sout.cxx>
#include <cmanip.cxx>
#include <System.cxx>
#include <fmanip.cxx>
#include <dirmanip.cxx>
#include <Cloner.cxx>
