// this :
#include <Lib/Expression.h>

#include <Lib/Debug.h>
#include <Lib/Out.h>
#include <Lib/smanip.h>
#include <Lib/Functions.h>
#include <Lib/mmanip.h>
#include <Lib/valuemanip.h>
#include <Lib/Array.h>

#include <math.h>

#define NotFound (-1)

extern "C" {
  static double Lib_RandomFlat_shoot(double);
}

//////////////////////////////////////////////////////////////////////////////
Lib::Expression::Expression(
 eType aType
)
:fType(aType)
,fFunction(COS)
,fIndex(NotFound)
,fA(0),fB(0),fC(0),fD(0),fE(0),fF(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Debug::increment("Lib::Expression");
}
//////////////////////////////////////////////////////////////////////////////
Lib::Expression::Expression(
 eType aType
,Expression* aA
)
:fType(aType)
,fFunction(COS)
,fIndex(NotFound)
,fA(aA),fB(0),fC(0),fD(0),fE(0),fF(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Debug::increment("Lib::Expression");
}
//////////////////////////////////////////////////////////////////////////////
Lib::Expression::Expression(
 eType aType
,Expression* aA
,Expression* aB
)
:fType(aType)
,fFunction(COS)
,fIndex(NotFound)
,fA(aA),fB(aB),fC(0),fD(0),fE(0),fF(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Debug::increment("Lib::Expression");
}
//////////////////////////////////////////////////////////////////////////////
Lib::Expression::Expression(
 eType aType
,eFunction aFunction
,Expression* aA
)
:fType(aType)
,fFunction(aFunction)
,fIndex(NotFound)
,fA(aA),fB(0),fC(0),fD(0),fE(0),fF(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Debug::increment("Lib::Expression");
}
//////////////////////////////////////////////////////////////////////////////
Lib::Expression::Expression(
 eType aType
,eFunction aFunction
,Expression* aA
,Expression* aB
)
:fType(aType)
,fFunction(aFunction)
,fIndex(NotFound)
,fA(aA),fB(aB),fC(0),fD(0),fE(0),fF(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Debug::increment("Lib::Expression");
}
//////////////////////////////////////////////////////////////////////////////
Lib::Expression::Expression(
 eType aType
,eFunction aFunction
,Expression* aA
,Expression* aB
,Expression* aC
)
:fType(aType)
,fFunction(aFunction)
,fIndex(NotFound)
,fA(aA),fB(aB),fC(aC),fD(0),fE(0),fF(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Debug::increment("Lib::Expression");
}
//////////////////////////////////////////////////////////////////////////////
Lib::Expression::Expression(
 eType aType
,eFunction aFunction
,Expression* aA
,Expression* aB
,Expression* aC
,Expression* aD
)
:fType(aType)
,fFunction(aFunction)
,fIndex(NotFound)
,fA(aA),fB(aB),fC(aC),fD(aD),fE(0),fF(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Debug::increment("Lib::Expression");
}
//////////////////////////////////////////////////////////////////////////////
Lib::Expression::Expression(
 eType aType
,eFunction aFunction
,Expression* aA
,Expression* aB
,Expression* aC
,Expression* aD
,Expression* aE
)
:fType(aType)
,fFunction(aFunction)
,fIndex(NotFound)
,fA(aA),fB(aB),fC(aC),fD(aD),fE(aE),fF(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Debug::increment("Lib::Expression");
}
//////////////////////////////////////////////////////////////////////////////
Lib::Expression::Expression(
 eType aType
,eFunction aFunction
,Expression* aA
,Expression* aB
,Expression* aC
,Expression* aD
,Expression* aE
,Expression* aF
)
:fType(aType)
,fFunction(aFunction)
,fIndex(NotFound)
,fA(aA),fB(aB),fC(aC),fD(aD),fE(aE),fF(aF)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Debug::increment("Lib::Expression");
}
//////////////////////////////////////////////////////////////////////////////
Lib::Expression::Expression(
 eType aType
,unsigned int aNumber
)
:fType(aType)
,fFunction(COS)
,fIndex(NotFound)
,fA(0),fB(0),fC(0),fD(0),fE(0),fF(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Debug::increment("Lib::Expression");
  fVariable.set(aNumber);
}
//////////////////////////////////////////////////////////////////////////////
Lib::Expression::Expression(
 eType aType
,double aNumber
)
:fType(aType)
,fFunction(COS)
,fIndex(NotFound)
,fA(0),fB(0),fC(0),fD(0),fE(0),fF(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Debug::increment("Lib::Expression");
  fVariable.set(aNumber);
}
//////////////////////////////////////////////////////////////////////////////
Lib::Expression::Expression(
 eType aType
,const std::string& aString
)
:fType(aType)
,fFunction(COS)
,fIndex(NotFound)
,fA(0),fB(0),fC(0),fD(0),fE(0),fF(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Debug::increment("Lib::Expression");
  fVariable.set(aString);
}
//////////////////////////////////////////////////////////////////////////////
Lib::Expression::Expression(
 eType aType
,const std::string& aName
,int aIndex
)
:fType(aType)
,fFunction(COS)
,fName(aName)
,fIndex(aIndex)
,fA(0),fB(0),fC(0),fD(0),fE(0),fF(0)
//////////////////////////////////////////////////////////////////////////////
// aName needed to not confuse with the constructor (eType,unsigned int).
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Debug::increment("Lib::Expression");
}
//////////////////////////////////////////////////////////////////////////////
Lib::Expression::~Expression(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  delete fA;
  delete fB;
  delete fC;
  delete fD;
  delete fE;
  delete fF;
  Debug::decrement("Lib::Expression");
}
/*
//////////////////////////////////////////////////////////////////////////////
void Lib::Expression::print(
 Slash::Core::IWriter& aPrinter
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Out out(aPrinter);
  out << "Type : " << this << " " << (int)fType << endl;
  if(!fVariable.is_none()) fVariable.print(aPrinter);
  if(fA) fA->print(aPrinter);
  if(fB) fB->print(aPrinter);
}
*/
//////////////////////////////////////////////////////////////////////////////
Lib::Value& Lib::Expression::ret(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fReturn;
}
extern "C" {
  typedef double(*Func)(double);
}

#define EXEC(aExpression)\
  if(!(aExpression)->execute(aInput,aError)) {\
    fReturn.setNone();\
    return false;\
  }

#define OPER(aOperation,aArg)\
 {if(!Lib::valuemanip::aOperation(fReturn,aArg,aError)) {\
    fReturn.setNone();\
    return false;\
  }}

#define OPERU(aOperation)\
 {if(!Lib::valuemanip::aOperation(fReturn,aError)) {\
    fReturn.setNone();\
    return false;\
  }}

#define TO_D(aVariable,aD)\
 {if(!Lib::valuemanip::to_double(aVariable,aD)) {\
   aError = "Lib::Expression::execute : can't convert Variable to double.";\
   fReturn.setNone();\
   return false;\
 }}

//////////////////////////////////////////////////////////////////////////////
bool Lib::Expression::execute(
 const std::vector<Lib::Value>& aInput
,std::string& aError //Inited by the caller to optimize.
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  //FIXME : handle ret values of execute().
  switch(fType) {
  case GT:
    if(!fA || !fB) break;
    EXEC(fA)
    EXEC(fB)
    fReturn = fA->ret();
    OPER(if_gt,fB->ret())
    return true;
  case GE:
    if(!fA || !fB) break;
    EXEC(fA)
    EXEC(fB)
    fReturn = fA->ret();
    OPER(if_ge,fB->ret())
    return true;
  case LT:
    if(!fA || !fB) break;
    EXEC(fA)
    EXEC(fB)
    fReturn = fA->ret();
    OPER(if_lt,fB->ret())
    return true;
  case LE:
    if(!fA || !fB) break;
    EXEC(fA)
    EXEC(fB)
    fReturn = fA->ret();
    OPER(if_le,fB->ret())
    return true;
  case EQ:
    if(!fA || !fB) break;
   {EXEC(fA)
    EXEC(fB)
    Lib::Value& va = fA->ret();
    Lib::Value& vb = fB->ret();
    if( (fA->fType==NAME) && 
        (va.type()==Slash::Core::IValue::STRING) &&
        (vb.type()==Slash::Core::IValue::STRING) ){
      fReturn.set(smanip::match(va.get_string(),vb.get_string()));
      return true;
    } else {
      fReturn = va;
      OPER(if_eq,vb)
      return true;
    }}
  case NE:
    if(!fA || !fB) break;
   {EXEC(fA)
    EXEC(fB)
    Lib::Value& va = fA->ret();
    Lib::Value& vb = fB->ret();
    if( (fA->fType==NAME) && 
        (va.type()==Slash::Core::IValue::STRING) &&
        (vb.type()==Slash::Core::IValue::STRING) ){
      fReturn.set(smanip::match(va.get_string(),
                                vb.get_string())?false:true);
      return true;
    } else {
      fReturn = va;
      OPER(if_ne,vb)
      return true;
    }}
  case AND:
    if(!fA || !fB) break;
    EXEC(fA)
    EXEC(fB)
    fReturn = fA->ret();
    OPER(if_and,fB->ret());
    return true;
  case OR:
    if(!fA || !fB) break;
    EXEC(fA)
    EXEC(fB)
    fReturn = fA->ret();
    OPER(if_or,fB->ret());
    return true;
  case NOT:
    if(!fA) break;
    EXEC(fA)
    fReturn = fA->ret();
    OPERU(do_not)
    return true;
  case ASSIGN:
    if(!fA) break;
    EXEC(fA)
    fReturn = fA->ret(); //FIXME : or fReturn.assign(fA->ret()); ???
    return true;
  case ADD:
    if(!fA || !fB) break;
    EXEC(fA)
    EXEC(fB)
    fReturn = fA->ret();
    OPER(add,fB->ret())
    return true;
  case MUL:
    if(!fA || !fB) break;
    EXEC(fA)
    EXEC(fB)
    fReturn = fA->ret();
    OPER(multiply,fB->ret())
    return true;
  case SUB:
    if(!fA || !fB) break;
    EXEC(fA)
    EXEC(fB)
    fReturn = fA->ret();
    OPER(subtract,fB->ret())
    return true;
  case DIV:{
    if(!fA || !fB) break;
    EXEC(fA)
    EXEC(fB)
    fReturn = fA->ret();
    OPER(divide,fB->ret())
    return true;
  case MINUS:
    if(!fA) break;
    EXEC(fA)
    fReturn = fA->ret();
    OPERU(minus)
    return true;
  case NAME:
    if( (fIndex<0) || (fIndex>=(int)aInput.size()) ) {
      aError = std::string("Expression::execute : index out of range")
             + " " + Lib::smanip::tostring((int)fIndex)
             + " range [0," + Lib::smanip::tostring((int)aInput.size())
             + "] for variable "+fName+".";
      fReturn.setNone();
      return false;
    }
    fReturn = aInput[fIndex];
    return true;
  case UNSIGNED_INTEGER:
  case REAL:
  case STRING:
    fReturn = fVariable;
    return true;
  case PI:
    fReturn.set(Lib::mmanip::pi());
    return true;
  case BOOL_TRUE:
    fReturn.set(true);
    return true;
  case BOOL_FALSE:
    fReturn.set(false);
    return true;
  case FUNC:
    if(!fA) break;
   {EXEC(fA)
    Lib::Value& va = fA->ret();
    if(va.type()==Slash::Core::IValue::ARRAY_DOUBLE) {
      Func func = 0;
      switch(fFunction) {
      case COS:  func = ::cos;break;
      case SIN:  func = ::sin;break;
      case COSH: func = ::cosh;break;
      case SINH: func = ::sinh;break;
      case TANH: func = ::tanh;break;
      case ATAN: func = ::atan;break;
      case SQRT: func = ::sqrt;break;
      case EXP:  func = ::exp;break;
      case FABS: func = ::fabs;break;
      //FIXME : have to chech domain :
      case TAN:  func = ::tan;break;
      case ACOS: func = ::acos;break;
      case ASIN: func = ::asin;break;
      case LOG:  func = ::log;break;
      case LOG10:func = ::log10;break;
      //
      case RNDM: func = Lib_RandomFlat_shoot;break;
      case NCO:{  
        std::vector<unsigned int> is;
        fReturn.set((unsigned int)va.get_array_double(is).size());
        return true;}
      case VSUM:{
        std::vector<unsigned int> is;
        const std::vector<double>& stdv = va.get_array_double(is);
        double dv = 0;
        unsigned int number = stdv.size();
        for(unsigned int index=0;index<number;index++) dv += stdv[index];
        fReturn.set(dv);
        return true;} 
      case POW:
      case GAUSS:
      case BW:
      case EXPO:
      case POL1:
      case POL2:
      case POL3:
      case POL4:
      case TOINT:
      case MOD:
      case ARRAY:
      case CAUCHY:
        func = 0;
        break;
      }
      if(!func) break;
     {std::vector<unsigned int> is;
      const std::vector<double>& stdv = va.get_array_double(is);
      fReturn.set(is,stdv);}
      // In the below, we need a non const method.
      std::vector<double>& stdv = fReturn.array_double();
      unsigned int number = stdv.size();
      for(unsigned int index=0;index<number;index++) { 
        //FIXME : have to chech domain :
        stdv[index] = func(stdv[index]);
      }
      return true;
    } else {
      double x;
      TO_D(va,x)
      switch(fFunction) {      
      case COS:  fReturn.set(::cos(x));return true;
      case SIN:  fReturn.set(::sin(x));return true;
      case COSH: fReturn.set(::cosh(x));return true;
      case SINH: fReturn.set(::sinh(x));return true;
      case TANH: fReturn.set(::tanh(x));return true;
      case ATAN: fReturn.set(::atan(x));return true;
      case SQRT: fReturn.set(::sqrt(x));return true;
      // Check domain :      
      case TAN:  {
        if(!Lib::mmanip::in_domain_tan(x)) {
          aError = std::string("Expression::execute : ")
                 + " tan : variable value " + Lib::smanip::tostring(x)
                 + " out of domain.";
          fReturn.setNone();
          return false;
        }
        fReturn.set(::tan(x));
        return true;
      }
      case ACOS: {
        if(!Lib::mmanip::in_domain_acos(x)) {
          aError = std::string("Expression::execute : ")
                 + " acos : variable value " + Lib::smanip::tostring(x)
                 + " out of domain.";
          fReturn.setNone();
          return false;
        }
        fReturn.set(::acos(x));
        return true;
      }
      case ASIN: {
        if(!Lib::mmanip::in_domain_acos(x)) {
          aError = std::string("Expression::execute : ")
                 + " asin : variable value " + Lib::smanip::tostring(x)
                 + " out of domain.";
          fReturn.setNone();
          return false;
        }
        fReturn.set(::asin(x));
        return true;
      }
      case LOG:{  
        if(!Lib::mmanip::in_domain_log(x)) {
          aError = std::string("Expression::execute : ")
                 + " log : variable value " + Lib::smanip::tostring(x)
                 + " out of domain.";
          fReturn.setNone();
          return false;
        }
        fReturn.set(::log(x));
        return true;
      }
      case LOG10:{
        if(!Lib::mmanip::in_domain_log(x)) {
          aError = std::string("Expression::execute : ")
                 + " log10 : variable value " + Lib::smanip::tostring(x)
                 + " out of domain.";
          fReturn.setNone();
          return false;
        }
        fReturn.set(::log10(x));
        return true;
      }
      case EXP:  fReturn.set(::exp(x));return true;
      case FABS: fReturn.set(::fabs(x));return true;
      case TOINT: fReturn.set((double)int(x));return true;
      //FIXME : Random as a field.
      case RNDM: fReturn.set(Lib_RandomFlat_shoot(x));return true;
      case POW:
        if(!fB) break;
       {EXEC(fB)
        double d;
        TO_D(fB->ret(),d)
        fReturn.set(::pow(x,d));
        return true;}
      case MOD:
        if(!fB) break;
       {EXEC(fB)
        double d;
        TO_D(fB->ret(),d)
        fReturn.set(::fmod(x,d));
        return true;}
      case ARRAY:
        if(!fB || !fC) break;
       {int n = (int)x;
        if(n<0) n = 0;
        EXEC(fB)
        double b;
        TO_D(fB->ret(),b)
        EXEC(fC)
        double c;
        TO_D(fC->ret(),c)
        std::vector<unsigned int> orders(1);
        orders[0] = n;
        Lib::Array<double> v(orders);
        if(n>=2) {
          std::vector<double>& stdv = v.vector();
          double delta = (c - b)/(n-1);
          for(int i=0;i<n;i++) stdv[i] = b + i * delta;
        }
        fReturn.set(v.orders(),v.vector());
        return true;}
      case GAUSS:
        if(!fB || !fC || !fD) break;
       {EXEC(fB)
        EXEC(fC)
        EXEC(fD)
        double b;
        TO_D(fB->ret(),b)
        double c;
        TO_D(fC->ret(),c)
        double d;
        TO_D(fD->ret(),d)
        Lib::Function::Gaussian func(b,c,d);
        fReturn.set(func.value(x));
        return true;}
      case BW:
        if(!fB || !fC || !fD) break;
       {EXEC(fB)
        EXEC(fC)
        EXEC(fD)
        double b;
        TO_D(fB->ret(),b)
        double c;
        TO_D(fC->ret(),c)
        double d;
        TO_D(fD->ret(),d)
        Lib::Function::BreitWigner func(b,c,d);
        fReturn.set(func.value(x));
        return true;}
      case CAUCHY:
        if(!fB || !fC || !fD) break;
       {EXEC(fB)
        EXEC(fC)
        EXEC(fD)
        double b;
        TO_D(fB->ret(),b)
        double c;
        TO_D(fC->ret(),c)
        double d;
        TO_D(fD->ret(),d)
        Lib::Function::Cauchy func(b,c,d);
        fReturn.set(func.value(x));
        return true;}
      case EXPO:
        if(!fB || !fC) break;
       {EXEC(fB)
        EXEC(fC)
        double b;
        TO_D(fB->ret(),b)
        double c;
        TO_D(fC->ret(),c)
        Lib::Function::Exponential func(b,c);
        fReturn.set(func.value(x));
        return true;}
      case POL1:
        if(!fB || !fC) break;
       {EXEC(fB)
        EXEC(fC)
        double b;
        TO_D(fB->ret(),b)
        double c;
        TO_D(fC->ret(),c)
        std::vector<double> params(2);
        params[0] = b;
        params[1] = c;
        Lib::Function::Polynomial func(params);
        fReturn.set(func.value(x));
        return true;}
      case POL2:
        if(!fB || !fC || !fD) break;
       {EXEC(fB)
        EXEC(fC)
        EXEC(fD)
        double b;
        TO_D(fB->ret(),b)
        double c;
        TO_D(fC->ret(),c)
        double d;
        TO_D(fD->ret(),d)
        std::vector<double> params(3);
        params[0] = b;
        params[1] = c;
        params[2] = d;
        Lib::Function::Polynomial func(params);
        fReturn.set(func.value(x));
        return true;}
      case POL3:
        if(!fB || !fC || !fD || !fE) break;
       {EXEC(fB)
        EXEC(fC)
        EXEC(fD)
        EXEC(fE)
        double b;
        TO_D(fB->ret(),b)
        double c;
        TO_D(fC->ret(),c)
        double d;
        TO_D(fD->ret(),d)
        double e;
        TO_D(fE->ret(),e)
        std::vector<double> params(4);
        params[0] = b;
        params[1] = c;
        params[2] = d;
        params[3] = e;
        Lib::Function::Polynomial func(params);
        fReturn.set(func.value(x));
        return true;}
      case POL4:
        if(!fB || !fC || !fD || !fE || !fF) break;
       {EXEC(fB)
        EXEC(fC)
        EXEC(fD)
        EXEC(fE)
        EXEC(fF)
        double b;
        TO_D(fB->ret(),b)
        double c;
        TO_D(fC->ret(),c)
        double d;
        TO_D(fD->ret(),d)
        double e;
        TO_D(fE->ret(),e)
        double f;
        TO_D(fF->ret(),f)
        std::vector<double> params(5);
        params[0] = b;
        params[1] = c;
        params[2] = d;
        params[3] = e;
        params[4] = f;
        Lib::Function::Polynomial func(params);
        fReturn.set(func.value(x));
        return true;}
      case NCO:  break;
      case VSUM:  break;
      }
    }}
    break;
  }
  }
  aError = std::string("Expression::execute : Can't apply on type ")
         + Lib::smanip::tostring((int)fType) + " : bad return value.";
  fReturn.setNone();
  return false;
}

#include <stdlib.h>
extern "C" {
//////////////////////////////////////////////////////////////////////////////
double Lib_RandomFlat_shoot(
 double //aSeed
)
//////////////////////////////////////////////////////////////////////////////
// Shoot random numbers in [0,1] according a flat distribution.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  //FIXME srandom(aSeed);  
  double value  = (double)::rand();
  value /= (double)RAND_MAX;
  return value;
}
}
