// this :
#include <Lib/Handler.h>

#include <Slash/Data/IAccessor.h>
#include <Lib/Debug.h>

//////////////////////////////////////////////////////////////////////////////
Lib::Handler::Handler(
 Slash::Data::IAccessor* aType
,void* aObject
,void* aTag
)
:fAccessor(aType)
,fObject(aObject)
,fTag(aTag)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Debug::increment();
}
//////////////////////////////////////////////////////////////////////////////
Lib::Handler::Handler(
 const Handler& aHandler
)
:IHandler()
,fAccessor(aHandler.fAccessor)
,fObject(aHandler.fObject)
,fTag(aHandler.fTag)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Debug::increment();
}
//////////////////////////////////////////////////////////////////////////////
Lib::Handler::~Handler(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Debug::decrement();
}
//////////////////////////////////////////////////////////////////////////////
Lib::Handler& Lib::Handler::operator=(
 const Handler& aHandler
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fAccessor = aHandler.fAccessor;
  fObject = aHandler.fObject;
  fTag = aHandler.fTag;
  return *this;
}
//////////////////////////////////////////////////////////////////////////////
Slash::Data::IAccessor* Lib::Handler::type(
) const 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
  return fAccessor;
}
//////////////////////////////////////////////////////////////////////////////
void* Lib::Handler::object(
) const 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
  return fObject;
}
//////////////////////////////////////////////////////////////////////////////
void* Lib::Handler::tag(
) const 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
  return fTag;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::Handler::isEqual(
 const Slash::Data::IHandler& aHandler
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(fAccessor->name()!=aHandler.type()->name()) return false;
  if(fObject!=aHandler.object()) return false;
  if(fTag!=aHandler.tag()) return false;
  return true;
}

