
#include <Lib/StreamBuffer.h>

#include <Lib/iostream.h>

//////////////////////////////////////////////////////////////////////////////
Lib::StreamDestination::~StreamDestination(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
int Lib::StreamDestination::receive(
 const std::string&
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return 0;
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
Lib::StreamBuffer::StreamBuffer(
 Lib::StreamDestination* aDestination
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fDestination = aDestination;
  fCount = 0;
  fSize = 4095;
  fBuffer = new char[fSize+1];
}
//////////////////////////////////////////////////////////////////////////////
Lib::StreamBuffer::~StreamBuffer(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  delete fDestination;
  delete [] fBuffer;
}
//////////////////////////////////////////////////////////////////////////////
int Lib::StreamBuffer::overflow(
 int aChar
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  int result = 0;
  if(fCount>=fSize) {
    fBuffer[fCount] = '\0';
    fCount = 0;
    result = receiveString ();
  }
  fBuffer[fCount] = aChar;
  fCount++;
  if(aChar=='\n') {
    fBuffer[fCount] = '\0';
    fCount = 0;
    result = receiveString ();
  }
  return result;
}
//////////////////////////////////////////////////////////////////////////////
int Lib::StreamBuffer::sync(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fBuffer[fCount] = '\0';
  fCount = 0;
  return receiveString ();
}
#ifdef WIN32
//////////////////////////////////////////////////////////////////////////////
int Lib::StreamBuffer::underflow(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return 0;
}
#endif
//////////////////////////////////////////////////////////////////////////////
int Lib::StreamBuffer::receiveString (
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::string stringToSend = fBuffer;
  int result;
  if(fDestination) {
    result =  fDestination->receive(stringToSend);
  } else {
     // Should use cerr is redirecting cerr.
    //    cout << stringToSend.c_str() << cout.flush();
    result = 0;
  }
  return result;
}


// To test stream and extern compilation, linking 
// (especially on Windows) :

#include <Lib/strstream.h>
namespace Lib { class CoutBuffer : public std::streambuf {};}
Lib::CoutBuffer Lib_coutBuffer;
std::ostream Lib_cout(&Lib_coutBuffer);
double Lib_double = 3.14;
#include <vector>
std::vector<std::string> Lib_vector(2,"Hello");

