
#include <Lib/Printer.h>
#include <Lib/System.h>
#include <Lib/Debug.h>
#include <Lib/Arguments.h>

#include <Lib/InternetSocket.h>

//////////////////////////////////////////////////////////////////////////////
int main (
 int aArgc
,char** aArgv
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Arguments args(aArgc,aArgv);

  int verbose = 0;
  if(args.isAnArgument("-verbose")) verbose = 1;

  Lib::Printer printer;
  Lib::InternetSocket client(printer,verbose);

  if(!client.connect()) return Lib::System::exitFailure();

  client.sendString("debug : send 0");
  client.sendString("");
  client.sendString("debug : send 1");

  client.sendString("Lib::text");
  std::vector<std::string> text;
  text.push_back("Line 1");
  text.push_back("Line 2");
  text.push_back("Line 3");
  text.push_back("Line 4");
  client.sendText(text);

  while(1) {    
  }

  Lib::Debug::balance(printer);

  return Lib::System::exitSuccess();
}
