#include <Lib/Functions.h>
#include <Lib/Printer.h>
#include <Lib/Out.h>
#include <Lib/sout.h>

//////////////////////////////////////////////////////////////////////////////
int main(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Printer printer;
  Lib::Out out(printer);

  // LAL variable syntax :
 {std::string script = "x2+2*x0";
  Lib::Function::Scripted func(script,printer);
  if(!func.isValid()) {
    out << "Lib_functions : problem with funciotn." << Lib::endl;
    return 1;
  }

  out << "script : " << Lib::sout(script) << Lib::endl;
  std::vector<std::string> vars = func.variableNames();
  for(unsigned int index=0;index<vars.size();index++) {
    out << " " << vars[index] << Lib::endl;
  }

  std::vector<double> xs(2);
  xs[0] = 1; //x0
  xs[1] = 2; //x2
  double val;
  std::string serror;
  if(!func.value(xs,val,serror)) {
    out << "Lib_functions : problem to get value." << Lib::endl;
    return 1;
  }
  out << "Should be 4 : " << val << Lib::endl;}

  // xyz variable syntax :
 {std::string script = "y+2*x";
  Lib::Function::Scripted func(script,printer);
  if(!func.isValid()) {
    out << "Lib_functions : problem with funciotn." << Lib::endl;
    return 1;
  }

  out << "script : " << Lib::sout(script) << Lib::endl;
  std::vector<std::string> vars = func.variableNames();
  for(unsigned int index=0;index<vars.size();index++) {
    out << " " << vars[index] << Lib::endl;
  }

  std::vector<double> xs(2);
  xs[0] = 1; //x
  xs[1] = 2; //y
  double val;
  std::string serror;
  if(!func.value(xs,val,serror)) {
    out << "Lib_functions : problem to get value." << Lib::endl;
    return 1;
  }
  out << "Should be 4 : " << val << Lib::endl;}

  // AIDA/SLAC variable syntax :
 {std::string script = "x[2]+2*x[0]";
  Lib::Function::Scripted func(script,printer);
  if(!func.isValid()) {
    out << "Lib_functions : problem with funciotn." << Lib::endl;
    return 1;
  }

  out << "script : " << Lib::sout(script) << Lib::endl;
  std::vector<std::string> vars = func.variableNames();
  for(unsigned int index=0;index<vars.size();index++) {
    out << " " << vars[index] << Lib::endl;
  }

  std::vector<double> xs(2);
  xs[0] = 1; //x[0]
  xs[1] = 2; //x[2]
  double val;
  std::string serror;
  if(!func.value(xs,val,serror)) {
    out << "Lib_functions : problem to get value." << Lib::endl;
    return 1;
  }
  out << "Should be 4 : " << val << Lib::endl;}

 {std::string script = "gauss(x[0],H,M,W)+pol2(x[1],A,B,C)";
  Lib::Function::Scripted func(script,printer);
  if(!func.isValid()) {
    out << "Lib_functions : problem with funciotn." << Lib::endl;
    return 1;
  }

  out << "script : " << Lib::sout(script) << Lib::endl;
  std::vector<std::string> vars = func.variableNames();
  for(unsigned int index=0;index<vars.size();index++) {
    out << " " << vars[index] << Lib::endl;
  }}


  return 0;
}

