
#include <Lib/Printer.h>
#include <Lib/GZipWriter.h>
#include <Lib/GZipReader.h>
#include <Lib/Out.h>
#include <Lib/smanip.h>
#include <Lib/Debug.h>

int main(int,char**) {

  Lib::Printer printer;
  {
    std::string file = "Lib_test_gzip.data.gz";

    { // Write the file :
      Lib::GZipWriter zwriter(file,printer);
      Lib::Out out(zwriter);
      for(int index=0;index<10000;index++)
        out << "Hello zip : " << index << Lib::endl;
    }

    { // Read the file :
      Lib::GZipReader zreader(file,printer);
      Lib::Out out(printer);
      char buffer[256];
      do {
        int len;
        if(!zreader.read(buffer,sizeof(buffer),len)) break;
        out << Lib::smanip::tostring(buffer,len);
        if(len<(int)sizeof(buffer)) break;
      } while (true);
      out << "Lib_zip : end." << Lib::endl;
    }
  }
  Lib::Debug::balance(printer);

  return 0;
}
