
#include <Lib/Printer.h>
#include <Lib/Out.h>
#include <Lib/sout.h>
#include <Lib/BaseML.h>
#include <Lib/ItemML.h>
#include <Lib/Element.h>
#include <Lib/Debug.h>

int main(int,char**) {

  Lib::Printer printer;

 {Lib::Out out(printer);

  int verboseLevel = 0;

  Lib::ItemMLFactory factory;
  Lib::BaseML objectML(factory,verboseLevel);
  std::vector<std::string> tags;
  tags.push_back("objects");
  tags.push_back("object");
  objectML.setTags(tags);
  objectML.loadFile("$LIBROOT/data/objects.oml",false,printer);

  Lib::ItemML* top = objectML.topItem();
  if(top) {
    // objects :
    out << "Lib_objectML :" << Lib::endl;

    const std::list<Lib::ItemML*>& list = top->children();
    std::list<Lib::ItemML*>::const_iterator it;
    for(it=list.begin();it!=list.end();++it) {
      // object :
      std::string sclass;
      (*it)->attributeValue("","class",sclass);

      std::string name;
      (*it)->attributeValue("","name",name);
      out << " object"
          << " class " << Lib::sout(sclass) 
          << " name " << Lib::sout(name) 
          << Lib::endl;

      const std::list<Lib::Element*> props = (*it)->properties();
      std::list<Lib::Element*>::const_iterator pit;
      for(pit=props.begin();pit!=props.end();++pit) {
        std::string name;
        (*pit)->attributeValue("name",name);
        out << "  "
            << " field "
            << " name " << Lib::sout(name)
            << " value " << Lib::sout((*pit)->value()) 
            << Lib::endl;
      }

/*
      std::vector<std::string> atbs = (*it)->attributes();
      unsigned int atbn = atbs.size()/2;
       
      for(unsigned int index=0;index<atbn;index++) {
        const std::string& atb = atbs[2*index];
        const std::string& atbv = atbs[2*index+1];
        if(atb=="name") {
        } else {
          out << "  "
              << " field "
              << " name " << Lib::sout(atb) 
              << " value " << Lib::sout(atbv) 
              << Lib::endl;
        }
      }
*/

    }
  }

  }
  Lib::Debug::balance(printer);
 
  return 0;
}
