
#include <Lib/System.h>
#include <Lib/Printer.h>
#include <Lib/Out.h>
#include <Lib/sout.h>
#include <Lib/Debug.h>
#include <Lib/Arguments.h>

#include <Lib/InternetSocket.h>

//////////////////////////////////////////////////////////////////////////////
int main (
 int aArgc
,char** aArgv
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Arguments args(aArgc,aArgv);

  int verbose = 0;
  if(args.isAnArgument("-verbose")) verbose = 1;

  Lib::Printer printer;
  Lib::Out out(printer);

  Lib::InternetSocket server(printer,verbose);

  while(1) {
    if(!server.accept()) return Lib::System::exitFailure();

    while(1) {
      std::string s;
      if(!server.waitString(s)) break;
      if(s=="Lib::text") {
        std::vector<std::string> text;
        if(!server.waitText(text)) break;
        unsigned int l = text.size();
        out << "Lib_server : text : " << l << Lib::endl;
        for(unsigned int index=0;index<l;index++) {
          out << text[index] << Lib::endl;
        }
      } else {
        out << "Lib_server : string : " << Lib::sout(s) << Lib::endl;
      }
    }

    server.disconnect();
  }

  Lib::Debug::balance(printer);

  return Lib::System::exitSuccess();
}
