
#include <Lib/Printer.h>
/*
#include <Lib/GZipWriter.h>
#include <Lib/GZipReader.h>
#include <Lib/smanip.h>
*/
#include <Lib/Out.h>
#include <Lib/Debug.h>

#include <zip.h>

bool write(Slash::Core::IWriter& aPrinter) {
  std::string file = "Lib_test_zip.zip";

  Lib::Out out(aPrinter);
  out << "Write " << file << "..." << Lib::endl;

//#ifdef WIN32
//  zlib_filefunc_def ffunc;
//  fill_win32_filefunc(&ffunc);
//  zipFile zf = zipOpen2(file.c_str(),APPEND_STATUS_CREATE,NULL,&ffunc);
//#else
  zipFile zf = zipOpen(file.c_str(),APPEND_STATUS_CREATE);
//#endif
  if(!zf) {
    Lib::Out out(aPrinter);
    out << "error opening " << file << Lib::endl;
    return false;
  }

 {zip_fileinfo zi;

  zi.tmz_date.tm_sec = 0;
  zi.tmz_date.tm_min = 0;
  zi.tmz_date.tm_hour = 0;
  zi.tmz_date.tm_mday = 0;
  zi.tmz_date.tm_mon = 0;
  zi.tmz_date.tm_year = 0;
  //filetime(filenameinzip,&zi.tmz_date,&zi.dosDate);

  zi.dosDate = 0;
  zi.internal_fa = 0;
  zi.external_fa = 0;

  std::string file_in_zip = "in_file_1";
  int err = 
    //zipOpenNewFileInZip3(zf,file_in_zip.c_str(),&zi,
    zipOpenNewFileInZip(zf,file_in_zip.c_str(),&zi,
      NULL,0,NULL,0,NULL /* comment*/,
      Z_DEFLATED,Z_DEFAULT_COMPRESSION);
  if(err!=ZIP_OK) {
    Lib::Out out(aPrinter);
    out << "error in file " << file << Lib::endl;
    return false;
  }

 {std::string item = "item_1";
  int size_write = item.size();
  err = zipWriteInFileInZip(zf,item.c_str(),size_write);
  if(err<0) {
    Lib::Out out(aPrinter);
    out << "error writing in file " << file << Lib::endl;
    return false;
  }}

 {std::string item = "item_2";
  int size_write = item.size();
  err = zipWriteInFileInZip(zf,item.c_str(),size_write);
  if(err<0) {
    Lib::Out out(aPrinter);
    out << "error writing in file " << file << Lib::endl;
    return false;
  }}

  err = zipCloseFileInZip(zf);
  if(err!=ZIP_OK) {
    Lib::Out out(aPrinter);
    out << "error in closing sub file in file " << file << Lib::endl;
    return false;
  }

  } // End sub file.

  int err = zipClose(zf,NULL);
  if(err!=ZIP_OK) {
    Lib::Out out(aPrinter);
    out << "error in closing file " << file << Lib::endl;
    return false;
  }

  return true;
}

#include <unzip.h>

bool read(Slash::Core::IWriter& aPrinter) {
  std::string file = "Lib_test_zip.zip";

  Lib::Out out(aPrinter);
  out << "Read " << file << "..." << Lib::endl;

  unzFile uf = unzOpen(file.c_str());
  if(!uf) {
    Lib::Out out(aPrinter);
    out << "error opening " << file << Lib::endl;
    return false;
  }

  unz_global_info gi;
  int err = unzGetGlobalInfo(uf,&gi);
  if(err!=UNZ_OK) {
    Lib::Out out(aPrinter);
    out << "error in file " << file << Lib::endl;
    return false;
  }

  for (uLong i=0;i<gi.number_entry;i++) {

    uLong ratio=0;

    unz_file_info file_info;
    char file_in_zip[256];
    err = unzGetCurrentFileInfo
      (uf,&file_info,file_in_zip,sizeof(file_in_zip),NULL,0,NULL,0);
    if(err!=UNZ_OK) {
      Lib::Out out(aPrinter);
      out << "error in file " << file << Lib::endl;
      return false;
    }

    Lib::Out out(aPrinter);
    out << std::string(file_in_zip) << Lib::endl;

    err = unzOpenCurrentFilePassword(uf,NULL);
    if(err!=UNZ_OK) {
      Lib::Out out(aPrinter);
      out << "error in file " << file << Lib::endl;
      return false;
    }

    uLong size_buf = file_info.uncompressed_size;
    char* buf = new char[size_buf];
    int nread = unzReadCurrentFile(uf,buf,size_buf);
    if(nread<0) {
      Lib::Out out(aPrinter);
      out << "error in file " << file << Lib::endl;
      return false;
    }
    if(nread>0) {
      for(int i=0;i<nread;i++) printf("%c",buf[i]);
      printf("\n");
    }
    
    if (i<gi.number_entry-1) {
      err = unzGoToNextFile(uf);
      if(err!=UNZ_OK) {
        Lib::Out out(aPrinter);
        out << "error in file " << file << Lib::endl;
        break;
      }
    }
  }


 {int err = unzClose(uf);
  if(err!=UNZ_OK) {
    Lib::Out out(aPrinter);
    out << "error in closing file " << file << Lib::endl;
    return false;
  }}

  return true;
}

int main(int,char**) {

  Lib::Printer printer;
  {
    write(printer);
    read(printer);
  }
  Lib::Debug::balance(printer);

  return 0;
}
