//
// Generic file included by the tests/OnX_o*.cxx files.
//

#include <Lib/Debug.h>
#include <Lib/System.h>
#include <Lib/Arguments.h>
#include <Lib/Out.h>
#include <Lib/sout.h>
#include <Lib/Manager.h>
#include <Lib/argZero.h>

#include <Slash/UI/IUI_Manager.h>

#include <OnX/Core/Main.h>

//////////////////////////////////////////////////////////////////////////////
int main (
 int aArgc
,char** aArgv
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(aArgc<=0) return Lib::System::exitFailure();

 {bool is_Mac_app = false;
  if(!Lib::argZero::startMacApp(aArgv[0],"OnX",is_Mac_app)) return 1;}

 {Lib::Arguments args(aArgc,aArgv);
  OnX::Main onxMain(false,false,args.tovector());
  if(!onxMain.isValid()) return Lib::System::exitFailure();

  Slash::Core::ISession* session = onxMain.session();
  if(!session) return Lib::System::exitFailure();

  Slash::UI::IUI_Manager* uiManager = 
    Lib_findManager(*session,"UI_Manager",Slash::UI::IUI_Manager);
  if(!uiManager) {
    Lib::Out out(session->printer());
    out << "OnX_o<GUI> :"
        << " UI_Manager not found." 
        << Lib::endl;
    return Lib::System::exitFailure();
  }


  std::string file;
  if(!onxMain.findFile(session->printer(),file)) 
    return Lib::System::exitFailure();

  OnX::GUI_UI* ui = new OnX::GUI_UI(*session,file,onxMain.args());
  if(!ui->isValid()) {
    delete ui;
    Lib::Out out(session->printer());
    out << "OnX_o<GUI> :"
        << " Problem when creating the UI object." 
        << Lib::endl;
    return Lib::System::exitFailure();
  }

  uiManager->add(ui); //uiManager takes the ui ownership.
  ui->show();
  ui->executeCallbacks("*","create");
  ui->steer();
  //ui->executeCallbacks("*","destroy");
  ui->hide();

  } // Session destructor will delete the ui object.

  // Some libraries (for exa Coin, gtk) may have declared 
  // C functions with ::atexit. To ease debugging we call
  // explicitly ::exit here.
  Lib::System::exit();

  return 0;
}
