
#include <Lib/Debug.h>
#include <Lib/Printer.h>
#include <Lib/Out.h>
#include <Lib/System.h>
#include <Lib/Manager.h>

#include <Slash/UI/IScriptManager.h>
#include <OnX/Core/Session.h>

//////////////////////////////////////////////////////////////////////////////
int main (
 int aArgc
,char** aArgv
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{

  Lib::Printer printer;

 {std::string interp;
  std::string script;
  if(aArgc==3) {
    interp = aArgv[1];
    script = aArgv[2];
  } else {
    Lib::Out out(printer);
    out << "Usage :" << Lib::endl;
    out << " OS> obatch <interp> <script>" << Lib::endl;
    out << "Examples :" << Lib::endl;
    out << "   OS> obatch Python \"import OnX_exa_hello\"" << Lib::endl;
    out << " UNIX> obatch tcl \"source $ONXROOT/examples/Tcl/batch.tcl\"" 
        << Lib::endl;
    return 0;
  }

  std::string sessionFile = Lib::System::getenv("ONXSESSION");
  if(sessionFile=="") sessionFile = "$ONXROOT/scripts/OnX/Session.onx";

  OnX::Session session(sessionFile,0);

  // No UI needed then no UI created !

  Slash::UI::IScriptManager* sm = 
    Lib_findManager(session,"ScriptManager",Slash::UI::IScriptManager);
  if(!sm) {
    Lib::Out out(printer);
    out << "OnX_obatch :"
        << " ScriptManager not found." 
        << Lib::endl;
    return 0;
  }

  sm->executeScript(interp,script);

  } // Session destructor will delete the ui object.

  Lib::Debug::balance(printer);

  return 0;
}



