#ifndef OnX_ScriptManager_h
#define OnX_ScriptManager_h

// Inheritance :
#include <Slash/Core/IManager.h>
#include <Slash/UI/IScriptManager.h>

#include <list>

namespace Slash {namespace Core {class ISession;}}

namespace OnX {

class ScriptManager
:public virtual Slash::Core::IManager 
,public virtual Slash::UI::IScriptManager 
{
public: //Slash::Core::IManager
  virtual std::string name() const;
  virtual void* cast(const std::string&) const;
public: //Slash::UI::IScriptManager
  virtual Slash::UI::IInterpreter* addInterpreter(const std::string&,
                              const std::string&,
                              const std::string&,
                              const std::string&,
                              const std::string&,
                              const std::string&,
                              Slash::UI::IInterpreter::Function,
                              void*);
  virtual Slash::UI::IInterpreter* findInterpreter(const std::string&) const;
  virtual Slash::UI::IInterpreter* findInterpreterFromSuffix(const std::string&) const;
  virtual bool executeScript(const std::string&,const std::string&);
  virtual void recordExecutedScripts(bool);
  virtual bool record(const std::string&,const std::string&);
  virtual std::vector<std::string> names() const;
public:
  ScriptManager(Slash::Core::ISession&);
  virtual ~ScriptManager();
private:
  void closeLog();
private:
  Slash::Core::ISession& fSession;
  std::string fName;
  std::list<Slash::UI::IInterpreter*> fList;
  std::string fLogFile;
};

}

#endif




