#ifndef OnX_QCommandLine_h
#define OnX_QCommandLine_h

#include <vector>
#include <string>
#include <qlineedit.h>

namespace OnX {

class QCommandLine : public QLineEdit  {
  Q_OBJECT
public:
  QCommandLine(QWidget*,const char* = 0);
  virtual ~QCommandLine();
  const std::string& getValue() const;
signals:
  void complete();
public slots:
  virtual void execute();
private:
  void keyPressEvent(QKeyEvent*);
private:
  std::vector<std::string> fHistory;
  int fHistoryPos;
  std::string fValue;
};

}

#endif
