@ECHO OFF
SETLOCAL

REM #
REM # File produced by the obuild tool version 1.0
REM # for the package OnX with version v17r5p0.
REM #

REM #////////////////////////////////////////////////
REM # Usage :
REM #   DOS> CD some_path\pack\version\obuild
REM #   DOS> DOS\run
REM # or :
REM #   DOS> call DOS\run.bat
REM #
REM #////////////////////////////////////////////////

REM #////////////////////////////////////////////////
REM #/// Get path of this file :
REM #////////////////////////////////////////////////
SET obuild_OnX_path=%~dp0
REM # Remove ending \obuild\DOS\
SET obuild_OnX_path=%obuild_OnX_path:~0,-12%

SET obuild_verbose=no
SET obuild_set_x=no
SET obuild_do_mains=yes
SET obuild_group=main

REM #////////////////////////////////////////////////
REM #/// Treat arguments :
REM #////////////////////////////////////////////////

:next_arg
IF "%1%" == "" GOTO end_args

IF NOT "%1%" == "-h" GOTO end_if_h
  ECHO Usage :
  ECHO   DOS\run [Options]
  ECHO Options :
  ECHO   -v : verbose.
  ECHO   -x : execute with ECHO ON"
  ECHO   -nm : build the not-main components.
  ECHO   -group group : build the given group of components.
  GOTO obuild_return
:end_if_h

IF NOT "%1%" == "-v" GOTO end_if_v
  SET obuild_verbose=yes
  SHIFT
  GOTO next_arg
:end_if_v

IF NOT "%1%" == "-x" GOTO end_if_x
  SET obuild_set_x=yes
  SHIFT
  GOTO next_arg
:end_if_x

IF NOT "%1%" == "-nm" GOTO end_if_nm
  SET obuild_do_mains=no
  SHIFT
  GOTO next_arg
:end_if_nm

IF NOT "%1%" == "-group" GOTO end_if_group
  SHIFT
  SET obuild_group=%1%
  SHIFT
  GOTO next_arg
:end_if_group

:end_args

REM #////////////////////////////////////////////////
REM #/// End arguments.
REM #////////////////////////////////////////////////

IF %obuild_set_x% == yes ECHO ON

IF "%OBUILD_DIR_BIN%" == "" (
  SET obuild_dir_bin=bin_obuild
) ELSE (
  SET obuild_dir_bin=%OBUILD_DIR_BIN%
)

IF "%obuild_dir_bin%" == "" (
  ECHO obuild_dir_bin variable not defined.
  GOTO obuild_return
)

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OnX_0=%%d
IF NOT %obuild_group% == main GOTO end_if_group_0
  IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_onx.exe"  GOTO end_if_run_1
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_OnX_path%\%obuild_dir_bin%\OnX_onx.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_1
:end_if_group_0
IF NOT %obuild_group% == main GOTO end_if_group_1
  IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_onx_config.exe"  GOTO end_if_run_3
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_OnX_path%\%obuild_dir_bin%\OnX_onx_config.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_3
:end_if_group_1
IF NOT %obuild_group% == main GOTO end_if_group_2
  IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_server.exe"  GOTO end_if_run_5
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_OnX_path%\%obuild_dir_bin%\OnX_server.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_5
:end_if_group_2
IF NOT %obuild_group% == Python GOTO end_if_group_3
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnX_path%/examples/Python/OnX_exa_hello.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_3
IF NOT %obuild_group% == Python GOTO end_if_group_4
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnX_path%/examples/Python/OnX_exa_OnX.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_4
IF NOT %obuild_group% == Python GOTO end_if_group_5
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnX_path%/examples/Python/OnX_exa_cube.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_5
IF NOT %obuild_group% == Python GOTO end_if_group_6
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnX_path%/examples/Python/OnX_exa_detector.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_6
IF NOT %obuild_group% == Python GOTO end_if_group_7
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnX_path%/examples/Python/OnX_exa_cylinder.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_7
IF NOT %obuild_group% == Python GOTO end_if_group_8
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnX_path%/examples/Python/OnX_exa_images.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_8
IF NOT %obuild_group% == Python GOTO end_if_group_9
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnX_path%/examples/Python/OnX_exa_shapes.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_9
IF NOT %obuild_group% == Python GOTO end_if_group_10
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnX_path%/examples/Python/OnX_exa_menu.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_10
IF NOT %obuild_group% == Python GOTO end_if_group_11
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnX_path%/examples/Python/OnX_exa_tree.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_11
IF NOT %obuild_group% == Java GOTO end_if_group_12
@IF %obuild_verbose% == yes @ECHO ON 
    java -classpath "%obuild_OnX_path%\%obuild_dir_bin%/OnX.jar;%obuild_OnX_path%\%obuild_dir_bin%/OnX_exa_Java_cube.jar" OnX_exa_Java_cube
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_12
IF NOT %obuild_group% == Java GOTO end_if_group_13
@IF %obuild_verbose% == yes @ECHO ON 
    java -classpath "%obuild_OnX_path%\%obuild_dir_bin%/OnX.jar;%obuild_OnX_path%\%obuild_dir_bin%/OnX_exa_Java_detector.jar" OnX_exa_Java_detector
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_13
IF NOT %obuild_group% == Java GOTO end_if_group_14
@IF %obuild_verbose% == yes @ECHO ON 
    java -classpath "%obuild_OnX_path%\%obuild_dir_bin%/OnX.jar;%obuild_OnX_path%\%obuild_dir_bin%/OnX_exa_Java_hello.jar" OnX_exa_Java_hello
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_14
IF NOT %obuild_group% == Java GOTO end_if_group_15
@IF %obuild_verbose% == yes @ECHO ON 
    java -classpath "%obuild_OnX_path%\%obuild_dir_bin%/OnX.jar;%obuild_OnX_path%\%obuild_dir_bin%/OnX_exa_Java_shapes.jar" OnX_exa_Java_shapes
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_15
IF NOT %obuild_group% == Java GOTO end_if_group_16
@IF %obuild_verbose% == yes @ECHO ON 
    java -classpath "%obuild_OnX_path%\%obuild_dir_bin%/OnX.jar;%obuild_OnX_path%\%obuild_dir_bin%/OnX_exa_Java_std_vector.jar" OnX_exa_Java_std_vector
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_16
IF NOT %obuild_group% == Java GOTO end_if_group_17
@IF %obuild_verbose% == yes @ECHO ON 
    java -classpath "%obuild_OnX_path%\%obuild_dir_bin%/OnX.jar;%obuild_OnX_path%\%obuild_dir_bin%/OnX_exa_Java_typemaps.jar" OnX_exa_Java_typemaps
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_17


cd "%obuild_pwd_OnX_0%"
SET obuild_pwd_OnX_0=
:obuild_return
ENDLOCAL
@ECHO ON
