#ifndef OnX_Accessors_h
#define OnX_Accessors_h

// Inheritance :
#include <OnX/Inventor/InventorAccessor.h>

namespace Slash {namespace Core {class ISession;}}
class SoNode;

namespace OnX {

class AccessorAccessor : public Lib::BaseAccessor {
public:
  AccessorAccessor(Slash::Core::ISession&);
  virtual ~AccessorAccessor();
public: //Slash::Data::IAccessor
  virtual std::string name() const;
  virtual Slash::Data::IIterator* iterator();
  virtual Slash::Core::IValue* findValue(Slash::Data::IAccessor::Data,const std::string&,void*);
private:
  Slash::Core::ISession& fSession;
  std::string fName;
};

class SceneGraph {
public:
  SoNode* fNode;
  SoNode* fParent;
};

class SceneGraphAccessor : public Lib::BaseAccessor {
public:
  SceneGraphAccessor(Slash::Core::ISession&);
  virtual ~SceneGraphAccessor();
public: //Slash::Data::IAccessor
  virtual std::string name() const;
  virtual Slash::Data::IIterator* iterator();
  virtual Slash::Core::IValue* findValue(Slash::Data::IAccessor::Data,const std::string&,void*);
  virtual void destroy(Slash::Data::IAccessor::Data,void*);
  virtual void set(Slash::Data::IAccessor::Data,
                   const std::string&,const std::string&,void*);
private:
  void getSceneGraphs();
  void clear();
private:
  Slash::Core::ISession& fSession;
  std::string fName;  
  SceneGraph* fSceneGraphs;
  unsigned int fNumber;
};

}

#endif
