// Dummy file to help building the onx-config system for HEPVis and Inventor.

#include <Slash/Core/IWriter.h>
#include <Lib/Printer.h>
#include <OnX/Helpers/OnX.h>

// OpenGL :
#include <OnX/OpenGL/OpenGL.h>

// Inventor :
#include <Inventor/nodes/SoSeparator.h>

// HEPVis :
#include <HEPVis/nodes/SoStyle.h>

extern "C" {
  void HEPVisUtils_initClasses();
  void HEPVisGeometry_initClasses();
  void HEPVisDetector_initClasses();
  void HEPVisPlotter_initClasses();
  void HEPVisGUI_initClasses();
}

extern "C" {

//////////////////////////////////////////////////////////////////////////////
void OnX_config_opengl(
 Slash::UI::IUI& aUI
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  // Put some code in order to be sure to build correctly.
  Lib::Printer printer;
  session_setColor(aUI.session(),"0 0 0");

  glBegin(GL_POLYGON);
  glEnd();

  // Inventor :
  new SoSeparator();

  // HEPVis :
  HEPVisUtils_initClasses();
  HEPVisGeometry_initClasses();
  HEPVisDetector_initClasses();
  HEPVisPlotter_initClasses();
  HEPVisGUI_initClasses();
}

}
