// this :
#include <OnX/Core/BaseCyclic.h>

#include <Slash/Core/ISession.h>
#include <Lib/Manager.h>
#include <Lib/Debug.h>

#include <Slash/UI/IScriptManager.h>

//////////////////////////////////////////////////////////////////////////////
OnX::BaseCyclic::BaseCyclic(
 Slash::Core::ISession& aSession
,const std::string& aName
,int aDelay
,const std::string& aInterpreter
,const std::string& aScript
)
:fSession(aSession)
,fName(aName)
,fDelay(aDelay>=0?aDelay:0)
,fInterpreter(aInterpreter)
,fScript(aScript)
,fScriptManager(0)
,fCounter(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Debug::increment("OnX::BaseCyclic");
  fScriptManager = Lib_findManager(fSession,"ScriptManager",Slash::UI::IScriptManager);
}
//////////////////////////////////////////////////////////////////////////////
OnX::BaseCyclic::~BaseCyclic(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Debug::decrement("OnX::BaseCyclic");
}
//////////////////////////////////////////////////////////////////////////////
std::string OnX::BaseCyclic::name(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fName;
}
//////////////////////////////////////////////////////////////////////////////
void OnX::BaseCyclic::setDelay(
 int aDelay
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(aDelay<=0) return;
  fDelay = aDelay;
}
//////////////////////////////////////////////////////////////////////////////
int OnX::BaseCyclic::iterations(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fCounter;
}
//////////////////////////////////////////////////////////////////////////////
int OnX::BaseCyclic::delay(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fDelay;
}
//////////////////////////////////////////////////////////////////////////////
void OnX::BaseCyclic::setScript(
 const std::string& aInterpreter
,const std::string& aScript
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fInterpreter = aInterpreter;
  fScript = aScript;
}
//////////////////////////////////////////////////////////////////////////////
void OnX::BaseCyclic::execute(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!fScriptManager) return;
  fScriptManager->executeScript(fInterpreter,fScript);
  fCounter++;
}
