// this :
#include <OnX/Core/Widget.h>

#include <Lib/Out.h>
#include <Lib/sout.h>
#include <Lib/Cast.h>

#include <Slash/UI/IWidgetClass.h>
#include <Slash/UI/IUI.h>

//////////////////////////////////////////////////////////////////////////////
OnX::Widget::Widget(
 Slash::UI::IUI& aUI
,Lib::ItemMLFactory& aFactory
,Lib::ItemML* aParent
,Slash::UI::IWidgetClass& aWidgetClass
)
:Lib::ItemML("widget",aFactory,aParent)
,fUI(aUI)
,fWidgetClass(aWidgetClass)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
OnX::Widget::~Widget(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(fUI.currentWidget()==this) fUI.setCurrentWidget(0);
}
//////////////////////////////////////////////////////////////////////////////
void* OnX::Widget::cast(
 const std::string& aClass
) const 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if_Lib_SCast(OnX::Widget)
  else if_Lib_SCast(Slash::UI::IWidget)
  else return Lib::ItemML::cast(aClass);
}
//////////////////////////////////////////////////////////////////////////////
std::string OnX::Widget::name(
) const 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
  std::string value;
  attributeValue("","name",value);
  return value;
}
//////////////////////////////////////////////////////////////////////////////
const Slash::UI::IWidgetClass& OnX::Widget::widgetClass(
) const 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
  return fWidgetClass;
}
//////////////////////////////////////////////////////////////////////////////
void* OnX::Widget::nativeWidget(
) const 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
  return getData1();
}
//////////////////////////////////////////////////////////////////////////////
bool OnX::Widget::size(
 unsigned int& aW
,unsigned int& aH
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fUI.size(*this,aW,aH); //FIXME : avoid passing by IUI.
}
//////////////////////////////////////////////////////////////////////////////
bool OnX::Widget::write(
 const std::string& aFile
,const std::string& aFormat
,const std::string& aOptions
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fUI.write(name(),aFormat,aFile,aOptions);
}
//////////////////////////////////////////////////////////////////////////////
bool OnX::Widget::setParameter(
 const std::string& aName
,const std::string& aValue
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  //FIXME : avoid passing by IUI.
  return fUI.setParameter(name()+"."+aName,aValue);
}
//////////////////////////////////////////////////////////////////////////////
bool OnX::Widget::parameterValue(
 const std::string& aName
,std::string& aValue
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  //FIXME : avoid passing by IUI.
  return fUI.parameterValue(name()+"."+aName,aValue);
}
#include <Lib/Element.h>
#include <OnX/Core/CallbackData.h>
//////////////////////////////////////////////////////////////////////////////
bool OnX::Widget::executeCallbacks(				  
 const std::string& aCallback
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::string name;
  attributeValue("","name",name);
  const std::list<Lib::Element*> props = properties();
  bool found = false;
  std::list<Lib::Element*>::const_iterator it;
  for(it=props.begin();it!=props.end();++it) {
    if(aCallback==(*it)->name()) {

      std::string sexec;
      (*it)->attributeValue("exec",sexec);

      fUI.setCallbackData(CallbackData(this,name,"","",0,0));
      fUI.executeScript(sexec,(*it)->value());
      fUI.setCallbackData(CallbackData());

      found = true;
    }
  }
  return found;
}
