// this :
#include <OnX/Gtk/GtkTools.h>

#ifdef HAS_GTK1

// GTK2 emulation :
extern "C" {
const gchar* gtk_window_get_title(GtkWindow* aWindow) { 
  return aWindow->title;
}
GList* gtk_container_get_children(GtkContainer* aContainer) {
  return gtk_container_children(aContainer);
}
GtkWidget* gtk_widget_get_parent(GtkWidget* aWidget){
  return aWidget->parent;
}
}

#endif

#include <Lib/smanip.h>
#include <Lib/fmanip.h>

#define NotFound (-1)

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
/*
//////////////////////////////////////////////////////////////////////////////
GtkWidget* OnX::gtk_widget_get_windowed_parent(
 GtkWidget* aWidget
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!GTK_WIDGET_NO_WINDOW(aWidget)) return aWidget; // has a window.
  //FIXME : loop on parent ?
  GtkWidget* parent = gtk_widget_get_parent(aWidget);
  if(GTK_WIDGET_NO_WINDOW(parent)) return 0; // parent has no window.
  return parent;
}*/
//////////////////////////////////////////////////////////////////////////////
bool OnX::gtk_widget_set_background(
 GtkWidget* aWidget
,const std::string& aValue
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  GdkColor color;
  gdk_color_parse(aValue.c_str(),&color);
#ifdef HAS_GTK1
  // Doesn't work properly because we change a "state"
  // that may change fg !
  GtkRcStyle* rc_style = gtk_rc_style_new ();
  rc_style->bg[GTK_STATE_NORMAL] = color;
  rc_style->base[GTK_STATE_NORMAL] = color;
  //REVISIT : GTL_RC_BASE
  rc_style->color_flags[GTK_STATE_NORMAL] =  
    (GtkRcFlags)(GTK_RC_BG | GTK_RC_BASE);
  //GtkStyle* style = gtk_widget_get_style(aWidget);
  //rc_style->fg[GTK_STATE_NORMAL] = style->fg[GTK_STATE_NORMAL];
  //rc_style->text[GTK_STATE_NORMAL] = style->text[GTK_STATE_NORMAL];
  gtk_widget_modify_style(aWidget, rc_style);
  gtk_rc_style_unref(rc_style);
#else
  gtk_widget_modify_bg (aWidget, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_base (aWidget, GTK_STATE_NORMAL, &color);
#endif

  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool OnX::gtk_widget_set_foreground(
 GtkWidget* aWidget
,const std::string& aValue
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(GTK_WIDGET_NO_WINDOW(aWidget)) return false; //REVISIT : needed ?
  GdkColor color;
  gdk_color_parse(aValue.c_str(),&color);
#ifdef HAS_GTK1
  GtkRcStyle* rc_style = gtk_rc_style_new ();
  rc_style->fg[GTK_STATE_NORMAL] = color;
  rc_style->text[GTK_STATE_NORMAL] = color;
  //REVISIT : GTK_RC_TEXT
  rc_style->color_flags[GTK_STATE_NORMAL] = 
    (GtkRcFlags)(GTK_RC_FG | GTK_RC_TEXT);
  gtk_widget_modify_style (aWidget, rc_style);
  gtk_rc_style_unref (rc_style);
#else
  gtk_widget_modify_fg (aWidget, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_text (aWidget, GTK_STATE_NORMAL, &color);
#endif  
  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool OnX::gtk_widget_set_background2(
 GtkWidget* aWidget
,const std::string& aValue
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(GTK_WIDGET_NO_WINDOW(aWidget)) return false;

  GdkColor color;
  gdk_color_parse(aValue.c_str(),&color);

  GdkColor* colorPale = gdk_color_copy(&color);
  colorPale->red = (int)(65535+2*color.red)/3;
  colorPale->green = (int)(65535+2*color.green)/3;
  colorPale->blue = (int)(65535+2*color.blue)/3;

  GdkColor* colorDark = gdk_color_copy(&color);
  colorDark->red = (int)(color.red/1.5);
  colorDark->green = (int)(color.green/1.5);
  colorDark->blue = (int)(color.blue/1.5);

#ifdef HAS_GTK1
  GtkRcStyle* rc_style = gtk_rc_style_new ();

  rc_style->bg[GTK_STATE_NORMAL] = color;
  rc_style->base[GTK_STATE_NORMAL] = color;
  rc_style->color_flags[GTK_STATE_NORMAL] = 
    (GtkRcFlags)(GTK_RC_BG | GTK_RC_BASE);

  rc_style->bg[GTK_STATE_PRELIGHT] = *colorPale;
  rc_style->base[GTK_STATE_PRELIGHT] = *colorPale;
  rc_style->color_flags[GTK_STATE_PRELIGHT] = 
    (GtkRcFlags)(GTK_RC_BG | GTK_RC_BASE);

  rc_style->bg[GTK_STATE_ACTIVE] = *colorDark;
  rc_style->base[GTK_STATE_ACTIVE] = *colorDark;
  rc_style->color_flags[GTK_STATE_ACTIVE] = 
    (GtkRcFlags)(GTK_RC_BG | GTK_RC_BASE);

  rc_style->bg[GTK_STATE_SELECTED] = *colorDark;
  rc_style->base[GTK_STATE_SELECTED] = *colorDark;
  rc_style->color_flags[GTK_STATE_SELECTED] = 
    (GtkRcFlags)(GTK_RC_BG | GTK_RC_BASE);

  rc_style->bg[GTK_STATE_INSENSITIVE] = *colorDark;
  rc_style->base[GTK_STATE_INSENSITIVE] = *colorDark;
  rc_style->color_flags[GTK_STATE_INSENSITIVE] = 
    (GtkRcFlags)(GTK_RC_BG | GTK_RC_BASE);

  gtk_widget_modify_style (aWidget, rc_style);
  gtk_rc_style_unref (rc_style);

#else
  gtk_widget_modify_bg (aWidget, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_base (aWidget, GTK_STATE_NORMAL, &color);

  gtk_widget_modify_bg (aWidget, GTK_STATE_PRELIGHT, colorPale);
  gtk_widget_modify_base (aWidget, GTK_STATE_PRELIGHT, colorPale);

  gtk_widget_modify_bg (aWidget, GTK_STATE_ACTIVE, colorDark);
  gtk_widget_modify_base (aWidget, GTK_STATE_ACTIVE, colorDark);

  gtk_widget_modify_bg (aWidget, GTK_STATE_SELECTED, colorDark);
  gtk_widget_modify_base (aWidget, GTK_STATE_SELECTED, colorDark);

  gtk_widget_modify_bg (aWidget, GTK_STATE_INSENSITIVE, colorDark);
  gtk_widget_modify_base (aWidget, GTK_STATE_INSENSITIVE, colorDark);
#endif
  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool OnX::gtk_widget_set_foreground2(
 GtkWidget* aWidget
,const std::string& aValue
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(GTK_WIDGET_NO_WINDOW(aWidget)) return false; //REVISIT : needed ?
  GdkColor color;
  gdk_color_parse(aValue.c_str(),&color);
#ifdef HAS_GTK1
  GtkRcStyle* rc_style = gtk_rc_style_new ();

  rc_style->fg[GTK_STATE_NORMAL] = color;
  rc_style->text[GTK_STATE_NORMAL] = color;
  rc_style->color_flags[GTK_STATE_NORMAL] = 
    (GtkRcFlags)(GTK_RC_FG | GTK_RC_TEXT);

  rc_style->fg[GTK_STATE_PRELIGHT] = color;
  rc_style->text[GTK_STATE_PRELIGHT] = color;
  rc_style->color_flags[GTK_STATE_PRELIGHT] = 
    (GtkRcFlags)(GTK_RC_FG | GTK_RC_TEXT);

  rc_style->fg[GTK_STATE_ACTIVE] = color;
  rc_style->text[GTK_STATE_ACTIVE] = color;
  rc_style->color_flags[GTK_STATE_ACTIVE] = 
    (GtkRcFlags)(GTK_RC_FG | GTK_RC_TEXT);

  rc_style->fg[GTK_STATE_SELECTED] = color;
  rc_style->text[GTK_STATE_SELECTED] = color;
  rc_style->color_flags[GTK_STATE_SELECTED] = 
    (GtkRcFlags)(GTK_RC_FG | GTK_RC_TEXT);

  rc_style->fg[GTK_STATE_INSENSITIVE] = color;
  rc_style->text[GTK_STATE_INSENSITIVE] = color;
  rc_style->color_flags[GTK_STATE_INSENSITIVE] = 
    (GtkRcFlags)(GTK_RC_FG | GTK_RC_TEXT);

  gtk_widget_modify_style (aWidget, rc_style);
  gtk_rc_style_unref (rc_style);
#else
  gtk_widget_modify_fg (aWidget, GTK_STATE_NORMAL, &color);
  gtk_widget_modify_text (aWidget, GTK_STATE_NORMAL, &color);

  gtk_widget_modify_fg (aWidget, GTK_STATE_PRELIGHT, &color);
  gtk_widget_modify_text (aWidget, GTK_STATE_PRELIGHT, &color);

  gtk_widget_modify_fg (aWidget, GTK_STATE_ACTIVE, &color);
  gtk_widget_modify_text (aWidget, GTK_STATE_ACTIVE, &color);

  gtk_widget_modify_fg (aWidget, GTK_STATE_SELECTED, &color);
  gtk_widget_modify_text (aWidget, GTK_STATE_SELECTED, &color);
#endif
  return true;
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
bool OnX::gtk_button_set_background(
 GtkButton* aWidget
,const std::string& aValue
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return gtk_widget_set_background2(GTK_WIDGET(aWidget),aValue);
} 
//////////////////////////////////////////////////////////////////////////////
bool OnX::gtk_button_set_foreground(
 GtkButton* aWidget
,const std::string& aValue
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return gtk_widget_set_foreground2(GTK_WIDGET(aWidget),aValue);
}
//////////////////////////////////////////////////////////////////////////////
bool OnX::gtk_menu_item_set_background(
 GtkMenuItem* aWidget
,const std::string& aValue
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return gtk_widget_set_background2(GTK_WIDGET(aWidget),aValue);
} 
//////////////////////////////////////////////////////////////////////////////
bool OnX::gtk_menu_item_set_foreground(
 GtkMenuItem* aWidget
,const std::string& aValue
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return gtk_widget_set_foreground2(GTK_WIDGET(aWidget),aValue);
}
//////////////////////////////////////////////////////////////////////////////
bool OnX::gtk_box_set_expand(
 GtkBox* aBox
,const std::string& aExpand
,GtkWidget* aContainer
)
//////////////////////////////////////////////////////////////////////////////
// @param aBox The box widget in wich we want to pack child
// @param aExpand The expand value for this parent widget : "first", "second" 
// or both. Anything else would be interpreted as "both"
// @param optional parameter to give a container to pack in the parent widget 
// if this parent hasn't already got two childs
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  GList* dlist = aBox->children;
  int number  = g_list_length(dlist);

  if (number == 0) { // this is the first widget to pack in
    if (aExpand=="first") { 
      gtk_box_pack_start(aBox,aContainer,TRUE,TRUE,0);
    } else if(aExpand == "second") {
      gtk_box_pack_start(aBox,aContainer,FALSE,TRUE,0);
    } else {
      gtk_box_pack_start(aBox,aContainer,TRUE,TRUE,0);
    }
  } else if (number == 1) { // this is the second widget to pack in
    if (aExpand=="first") {
      gtk_box_pack_start(aBox,aContainer,FALSE,TRUE,0);
    } else if(aExpand == "second") {
      gtk_box_pack_start(aBox,aContainer,TRUE,TRUE,0);
    } else {
      gtk_box_pack_start(aBox,aContainer,TRUE,TRUE,0);
    }
  } else if (number == 2) { // change expand value for these widgets
    if (!dlist) return false;
    GtkBoxChild* first = (GtkBoxChild*)(dlist->data);
    dlist = dlist->next;
    GtkBoxChild* second = (GtkBoxChild*)(dlist->data);

    if (aExpand == "first") {
      gtk_box_set_child_packing(aBox,
                                first->widget,
                                true,
                                first->fill,
                                first->padding,
                                (GtkPackType)first->pack);
      gtk_box_set_child_packing(aBox,
                                second->widget,
                                false,
                                second->fill,
                                second->padding,
                                (GtkPackType)second->pack);
    } else if (aExpand == "second") {
      gtk_box_set_child_packing(aBox,
                                first->widget,
                                false,
                                first->fill,
                                first->padding,
                                (GtkPackType)first->pack);
      gtk_box_set_child_packing(aBox,
                                second->widget,
                                true,
                                second->fill,
                                second->padding,
                                (GtkPackType)second->pack);
      
    } else {
      gtk_box_set_child_packing(aBox,
                                first->widget,
                                true,
                                first->fill,
                                first->padding,
                                (GtkPackType)first->pack);
      gtk_box_set_child_packing(aBox,
                                second->widget,
                                true,
                                second->fill,
                                second->padding,
                                (GtkPackType)second->pack);
      
    } 
  } else {
    return false;
  }
  return true;
}

//////////////////////////////////////////////////////////////////////////////
bool OnX::gtk_pixmap_set_from_file(
 GtkPixmap* aPixmap
,GdkWindow* aWindow
,const std::string& aFile
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::string fileName = Lib::fmanip::name(aFile);
  GdkColor color;
  GdkBitmap* mask = 0;
  GdkPixmap* pixmap = 
    gdk_pixmap_create_from_xpm(aWindow,
                               &mask,
                               &color,
                               fileName.c_str());
  if(!pixmap) return false;
  gtk_pixmap_set(aPixmap,pixmap,mask);
  gdk_pixmap_unref(pixmap);
  gdk_pixmap_unref(mask);
  return true;
}

//////////////////////////////////////////////////////////////////////////////
bool OnX::gtk_option_menu_initialize(
 GtkOptionMenu* aWidget
,const std::vector<std::string>& aItems
,const std::string& aDefault 
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  // Remove some existing menu :
  GtkWidget* menu = gtk_menu_new();
  gtk_option_menu_set_menu(aWidget,menu);
  menu = gtk_option_menu_get_menu(aWidget);
  if(!menu) return false;
  //Set aItems
  int found = NotFound;
  for(unsigned int index=0;index<aItems.size();index++) {
    GtkWidget* item = gtk_menu_item_new_with_label(aItems[index].c_str());
    gtk_menu_append(GTK_MENU(menu),item);
    gtk_widget_show(item);
    if(aItems[index]==aDefault) found = index;
  }
  gtk_option_menu_set_history(aWidget,(found==NotFound?0:found));
  return true;
}
//////////////////////////////////////////////////////////////////////////////
GList* OnX::gtk_option_menu_get_menu_items(
 GtkOptionMenu* aWidget
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  GtkWidget* menu = gtk_option_menu_get_menu(aWidget);
  if(!menu) return 0;
  GtkMenuShell* menu_shell = GTK_MENU_SHELL (menu);
  if(!menu_shell) return 0;
  return menu_shell->children;
}
//////////////////////////////////////////////////////////////////////////////
bool OnX::gtk_option_menu_set_default(
 GtkOptionMenu* aWidget
,const std::string& aDefault 
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  GList* items = gtk_option_menu_get_menu_items(aWidget);
  int index = 0;
  bool found = false;
  while (items) {
    GtkWidget* item = (GtkWidget*)items->data;
    // FIXME : the first item in the option menu 
    // is a GtkMenuItem but NOT a GtkLabel...
    if (GTK_BIN(item)) {
      GtkWidget* child = GTK_BIN(item)->child;
      if(GTK_IS_LABEL(child)) {
        char* str = 0;
        gtk_label_get(GTK_LABEL(child),&str);
        std::string label = str?str:"";
        if(label==aDefault) {
          gtk_option_menu_set_history(aWidget,index);
          found = true;
          break;
        }
      }
    }
    items = items->next;
    index++;
  }  
  if (!found) gtk_option_menu_set_history(aWidget,0);
  return found;
}
//////////////////////////////////////////////////////////////////////////////
bool OnX::gtk_option_menu_get_value(
 GtkOptionMenu* aWidget
,std::string& aValue
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  aValue = "";
  GtkWidget* menu = gtk_option_menu_get_menu(aWidget);
  if(!menu) return false;
  GtkWidget* active = gtk_menu_get_active(GTK_MENU(menu));
  if(!active) return false;
  if(GTK_IS_MENU_ITEM(active)==FALSE) return false;
  GtkWidget* child = GTK_BIN(GTK_MENU_ITEM(active))->child;
  if(child && GTK_IS_LABEL(child)) {
    gchar* s = 0;
    gtk_label_get(GTK_LABEL(child),&s);
    if(!s) return false;
    aValue = s;
    return true;
  } else { //REVISIT
    // this work to get the value of a ComboBox non focus 
    GtkWidget* child = GTK_BIN(GTK_BUTTON(aWidget))->child;
    if(child && GTK_IS_LABEL(child)) {
      gchar* s = 0;
      gtk_label_get(GTK_LABEL(child),&s);
      if(!s) return false;
      aValue = s;
      return true;
    }
  }
  return false;
}

#ifdef HAS_GTK1

//////////////////////////////////////////////////////////////////////////////
std::string OnX::gtk_tree_get_XML(
 GtkTree* aTree
,int depth
)
//////////////////////////////////////////////////////////////////////////////
//return a XML string representing this tree
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::string line;
  GtkLabel* label;
  GList* dlist = aTree->children;
  GtkTreeItem* item;
  std::string spaceItem = "";
  std::string spaceRoot = "";
  spaceItem.insert(0,depth*2,' ');
  spaceRoot.insert(0,(depth-1)*2,' ');
  
  while(dlist) {
    item = GTK_TREE_ITEM(dlist->data);
    if (!item) return "";
    line += spaceRoot + "<treeItem>\n";
    line += spaceItem + "<label>";

    label = GTK_LABEL(GTK_BIN(item)->child);
    gchar* s = 0;
    gtk_label_get(label,&s);
    std::string label = Lib::smanip::toxml(s);
    line.append(label);
    line += "</label>\n";
    line += spaceItem + "<opened>";
    if (item->expanded) line.append("true");
    else line.append("false");
    line += "</opened>\n";
    if (item->subtree) {
      line += gtk_tree_get_XML(GTK_TREE(item->subtree),depth+1);
    }    
    line += spaceRoot + "</treeItem>\n";
    dlist=dlist->next;
  }
  return line;
}
//////////////////////////////////////////////////////////////////////////////
std::string OnX::gtk_tree_item_get_path(
 GtkTreeItem* aItem
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::string path = "";
  GtkTreeItem* item = aItem;
  while(item) {
    if(!GTK_IS_LABEL(GTK_BIN(item)->child)) break;
    GtkLabel* label = GTK_LABEL(GTK_BIN(item)->child);
    gchar* s = 0;
    gtk_label_get(label,&s);
    std::string ss = s?s:"";
    std::string opath = path;
    path = "\n";
    path += ss;
    path += opath;
    GtkTree* tree = (GtkTree*)(GTK_WIDGET(item)->parent);
    if(!tree) break;
    if(!tree->tree_owner) break;
    item = GTK_TREE_ITEM(tree->tree_owner);
  }
  // Remove the leading \n
  if(path.size()) path = path.substr(1,path.size()-1);
  return path;
}

#else // GTK 2

class SearchTreeItem {
public:
  GtkTreeView* fView;
  std::string fLabel;
};

//////////////////////////////////////////////////////////////////////////////
static gboolean expandTreeModelItem(
 GtkTreeModel* aModel
,GtkTreePath* aPath
,GtkTreeIter* aIter
,gpointer aData
)
//////////////////////////////////////////////////////////////////////////////
// select the entrie with label equal data->txt and expand it if possible
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  gchar* txt = 0;
  SearchTreeItem* data = (SearchTreeItem*)aData;
  gtk_tree_model_get(aModel, aIter,GTK_TREE_COL_TEXT, &txt,-1);
  if (!txt) return FALSE;
  if (strcmp(data->fLabel.c_str(),txt)==0) {
    gtk_tree_view_expand_to_path(GTK_TREE_VIEW(data->fView),aPath);
    gtk_tree_selection_select_path(gtk_tree_view_get_selection(GTK_TREE_VIEW(data->fView)),aPath);
  }
  g_free(txt);
  return (strcmp(data->fLabel.c_str(),txt)==0);
}

//////////////////////////////////////////////////////////////////////////////
void OnX::gtk_tree_view_expand_item(
 GtkTreeView* aView
,const std::string& aLabel
)
//////////////////////////////////////////////////////////////////////////////
// loop on all tree and call the expandTreeModelItem to see 
// if search string==tree_item_label. If it matches, expand tree 
// to view this item
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if (gtk_tree_view_get_model(aView)) {
    SearchTreeItem search;
    search.fView = aView;
    search.fLabel = aLabel;
    gtk_tree_model_foreach(gtk_tree_view_get_model(aView),
                           expandTreeModelItem,&search);
  }
}

//////////////////////////////////////////////////////////////////////////////
std::string OnX::gtk_tree_model_get_XML(
 GtkTreeModel* aModel
,GtkTreeView* aView
,GtkTreeIter* aIter
)
//////////////////////////////////////////////////////////////////////////////
//return a XML string representing this tree
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::string line;
  std::string value;
  GtkTreePath* path = gtk_tree_model_get_path(aModel,aIter);
  gint depth = gtk_tree_path_get_depth(path);
  std::string spaceItem = "";
  std::string spaceRoot = "";
  spaceItem.insert(0,depth*2,' ');
  spaceRoot.insert(0,(depth-1)*2,' ');

  do  {
    GtkTreeIter child;
    gchar *label = 0;
    gtk_tree_model_get(aModel, aIter,GTK_TREE_COL_TEXT, &label,-1);
    gboolean expand = gtk_tree_view_row_expanded(aView,path);
    line += spaceRoot + "<treeItem>";
    line += spaceItem + "<label>";
    value = Lib::smanip::toxml(label);
    line.append(value);
    line += "</label>";
    line += spaceItem + "<opened>";
    if (expand) line.append("true");
    else line.append("false");
    line += "</opened>";
    if (gtk_tree_model_iter_children (aModel, &child, aIter)) {
      gtk_tree_path_down (path);
      line += gtk_tree_model_get_XML(aModel, aView,&child);
      gtk_tree_path_up (path);
    }    
    gtk_tree_path_next (path);
    line += spaceRoot + "</treeItem>";
    g_free(label);
  }
  while (gtk_tree_model_iter_next(aModel,aIter));
  gtk_tree_path_free (path);
  return line;
}
//////////////////////////////////////////////////////////////////////////////
std::string OnX::gtk_tree_selection_get_path(
 GtkTreeSelection* aSelection
)
//////////////////////////////////////////////////////////////////////////////
// This will only work in single or browse selection mode!
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  GtkTreeModel* model;
  GtkTreeIter child;
  std::string path ="";
  if(gtk_tree_selection_get_selected(aSelection, &model, &child)) {
    gchar* s = 0;
    gtk_tree_model_get (model, &child, GTK_TREE_COL_TEXT, &s, -1); 
    path = "\n";
    path += s?s:"";
    g_free(s);
    GtkTreeIter parent;
    while(gtk_tree_model_iter_parent (model,&parent,&child)) {
      gchar* s = 0;
      gtk_tree_model_get (model, &parent, GTK_TREE_COL_TEXT, &s, -1);
      std::string ss = s?s:"";
      g_free(s);
      std::string opath = path;
      path = "\n";
      path += ss;
      path += opath;
      child = parent;
    }
    // Remove the leading \n
    if(path.size()) path = path.substr(1,path.size()-1);
  }
  return path;
}

#endif // end of Gtk2 methods
