// this :
#include <OnX/NextStep/NextStepTk.h>

#import <AppKit/NSOpenPanel.h>
#import <AppKit/NSSavePanel.h>
#import <AppKit/NSOpenGL.h>
#import <AppKit/NSTableColumn.h>
#import <AppKit/NSColorPanel.h>
#import <AppKit/NSColor.h>

#import <Onx/NextStep/NSAction.h>

@implementation OnX_NSAction
- (id)init {
  if(self = [super init]) {
  }
  return self;
}
- (void)dealloc {  
  [super dealloc];
}
- (void)execute {
}
@end

@implementation OnX_NSButton
- (id)initWithFrame:(NSRect)aRect {
  fActivateActions = 0;
  if(self = [super initWithFrame:aRect]) {
    fActivateActions = [[NSMutableArray alloc] init];
    [self setTarget:self];
    [self setAction:@selector(action:)];
  }
  return self;
}
- (void)dealloc {
  [fActivateActions release];
  [super dealloc];
}
- (void)addActivateAction:(OnX_NSAction*)aAction {
  [fActivateActions addObject:aAction];
}
- (void)action:(id)aSender {
  int number = [fActivateActions count];
  int index;
  for(index=0;index<number;index++) {
    [(OnX_NSAction*)[fActivateActions objectAtIndex:index] execute];
  }
}
@end

@implementation OnX_NSToggleButton
- (id)initWithFrame:(NSRect)aRect {
  if(self = [super initWithFrame:aRect]) {
    [self setButtonType:NSOnOffButton];
  }
  return self;
}
- (void)dealloc {
  [super dealloc];
}
- (void)action:(id)aSender {
  [super action:aSender];
}
@end

@implementation OnX_NSMenuItem
- (id)initWithTitle:(NSString*)aString 
             action:(SEL)aSelector 
      keyEquivalent:(NSString*)aCharCode {
  fActivateActions = 0;
  if(self = [super initWithTitle:aString action:aSelector keyEquivalent:aCharCode]) {
    fActivateActions = [[NSMutableArray alloc] init];
    [self setTarget:self];
    [self setAction:@selector(action:)];
  }
  return self;
}
- (void)dealloc {
  [fActivateActions release];
  [super dealloc];
}
- (void)addActivateAction:(OnX_NSAction*)aAction {
  [fActivateActions addObject:aAction];
}
- (void)action:(id)aSender {
  int number = [fActivateActions count];
  int index;
  for(index=0;index<number;index++) {
    [(OnX_NSAction*)[fActivateActions objectAtIndex:index] execute];
  }
}
@end

@implementation OnX_NSToggleMenuItem
- (id)initWithTitle:(NSString*)aString 
             action:(SEL)aSelector 
      keyEquivalent:(NSString*)aCharCode {
  if(self = [super initWithTitle:aString action:aSelector keyEquivalent:aCharCode]) {
  }
  return self;
}
- (void)dealloc {
  [super dealloc];
}
- (void)action:(id)aSender {
  if([self state]==NSOffState) 
    [self setState:NSOnState];
  else if([self state]==NSOnState) 
    [self setState:NSOffState];
  [super action:aSender];
}
@end

@implementation OnX_NSPopUpButton
- (id)initWithFrame:(NSRect)aRect {
  fActivateActions = 0;
  if(self = [super initWithFrame:aRect]) {
    fActivateActions = [[NSMutableArray alloc] init];
    [self setTarget:self];
    [self setAction:@selector(action:)];
  }
  return self;
}
- (void)dealloc {
  [fActivateActions release];
  [super dealloc];
}
- (void)addActivateAction:(OnX_NSAction*)aAction {
  [fActivateActions addObject:aAction];
}
- (void)action:(id)aSender {
  int number = [fActivateActions count];
  int index;
  for(index=0;index<number;index++) {
    [(OnX_NSAction*)[fActivateActions objectAtIndex:index] execute];
  }
}
@end

@implementation OnX_NSTextField
- (id)initWithFrame:(NSRect)aRect {
  fActivateActions = 0;
  fCompleteActions = 0;
  if(self = [super initWithFrame:aRect]) {
    fActivateActions = [[NSMutableArray alloc] init];
    fCompleteActions = [[NSMutableArray alloc] init];
    [self setTarget:self];
    [self setAction:@selector(action:)];
  }
  return self;
}
- (void)dealloc {
  [fActivateActions release];
  [fCompleteActions release];
  [super dealloc];
}
- (void)addActivateAction:(OnX_NSAction*)aAction {
  [fActivateActions addObject:aAction];
}
- (void)addCompleteAction:(OnX_NSAction*)aAction {
  [fCompleteActions addObject:aAction];
}
- (void)action:(id)aSender {
  int number = [fActivateActions count];
  int index;
  for(index=0;index<number;index++) {
    [(OnX_NSAction*)[fActivateActions objectAtIndex:index] execute];
  }
  [self setStringValue:@""];
}
//FIXME : complete.
@end

@implementation OnX_NSSecureTextField
- (id)initWithFrame:(NSRect)aRect {
  fActivateActions = 0;
  if(self = [super initWithFrame:aRect]) {
    fActivateActions = [[NSMutableArray alloc] init];
    [self setTarget:self];
    [self setAction:@selector(action:)];
  }
  return self;
}
- (void)dealloc {
  [fActivateActions release];
  [super dealloc];
}
- (void)addActivateAction:(OnX_NSAction*)aAction {
  [fActivateActions addObject:aAction];
}
- (void)action:(id)aSender {
  int number = [fActivateActions count];
  int index;
  for(index=0;index<number;index++) {
    [(OnX_NSAction*)[fActivateActions objectAtIndex:index] execute];
  }
}
@end

@implementation OnX_NSComboBox
- (id)initWithFrame:(NSRect)aRect {
  fActivateActions = 0;
  if(self = [super initWithFrame:aRect]) {
    fActivateActions = [[NSMutableArray alloc] init];
    [self setTarget:self];
    [self setAction:@selector(action:)];
  }
  return self;
}
- (void)dealloc {
  [fActivateActions release];
  [super dealloc];
}
- (void)addActivateAction:(OnX_NSAction*)aAction {
  [fActivateActions addObject:aAction];
}
- (void)action:(id)aSender {
  int number = [fActivateActions count];
  int index;
  for(index=0;index<number;index++) {
    [(OnX_NSAction*)[fActivateActions objectAtIndex:index] execute];
  }
}
@end

@implementation OnX_NSToolbarItem
- (id)initWithItemIdentifier:(NSString*)aData {
  fActivateActions = 0;
  if(self = [super initWithItemIdentifier:aData]) {
    fActivateActions = [[NSMutableArray alloc] init];
    [self setTarget:self];
    [self setAction:@selector(action:)];
  }
  return self;
}
- (void)dealloc {
  [fActivateActions release];
  [super dealloc];
}
- (void)addActivateAction:(OnX_NSAction*)aAction {
  [fActivateActions addObject:aAction];
}
- (void)action:(id)aSender {
  int number = [fActivateActions count];
  int index;
  for(index=0;index<number;index++) {
    [(OnX_NSAction*)[fActivateActions objectAtIndex:index] execute];
  }
}
@end

@implementation OnX_NSToolbar
- (id)initWithIdentifier:(NSString*)aData {
  fItems = 0;
  if(self = [super initWithIdentifier:aData]) {
    fItems = [[NSMutableArray alloc] init];
    [self setDelegate:self];
  }
  return self;
}
- (void)dealloc {
  [fItems release];
  [super dealloc];
}
- (void)addToolbarItem:(NSToolbarItem*)aItem {
  [fItems addObject:aItem];
}
//NSToolbarDelegate
- (NSArray*)toolbarAllowedItemIdentifiers:(NSToolbar*)aToolBar {
  return [NSArray arrayWithObjects:nil];
}
- (NSArray*)toolbarDefaultItemIdentifiers:(NSToolbar*)aToolBar {
  return [NSArray arrayWithObjects:nil];
}
- (NSToolbarItem*) toolbar:(NSToolbar*)aToolBar
      itemForItemIdentifier:(NSString*)aItemIdentifier
  willBeInsertedIntoToolbar:(BOOL)aFlag
{
  int number = [fItems count];
  // NSToolbarItem factory :
  int index;
  for(index=0;index<number;index++) {
    NSToolbarItem* toolbarItem = [fItems objectAtIndex:index];
    NSString* identifier = [toolbarItem itemIdentifier];
    if ([aItemIdentifier isEqualToString:identifier]) {
      return toolbarItem;
    }
  }  
  return nil;
}
@end

// Expansion and split position policy :
// if expand FIRST
//   Second child height must not change.
//   If set (not -1), fSizeOfFixed is the height of the second child
//   else the current second child height is used.
// if expand SECOND (Default)
//   First child height must not change.
//   If set (not -1), fSizeOfFixed is the height of the first child
//   else the current first child height is used.
// if expand BOTH
//   The container height is equally divided between the two children.

@implementation OnX_NSVBox
- (id)initWithFrame:(NSRect)aRect {
  fExpand = OnX_SECOND;
  fSizeOfFixed = -1;
  if(self = [super initWithFrame:aRect]) {
  }
  return self;
}
- (void)dealloc {
  [super dealloc];
}
- (void)setExpand:(OnX_Expand)aExpand {
  fExpand = aExpand;
}
- (void)setSizeOfFixed:(int)aSize {
  fSizeOfFixed = aSize;
}
- (void)addView:(NSView*)aView {
  [self addSubview:aView];
  NSRect rect = [self frame];
  unsigned int mask = 0;
  if([[self subviews] count]==1) {
    // First entry, map to whole area :
    [aView setFrame:rect];
    mask = NSViewWidthSizable | NSViewHeightSizable; // What is changing :
    [aView setAutoresizingMask:mask];
    return;
  }
  // Second view, share the area with the first :
  NSView* firstView = [[self subviews] objectAtIndex:0]; 
  NSView* secondView = [[self subviews] objectAtIndex:1]; 
  if(fExpand==OnX_SECOND) { //Default
    // First view height must not change.
    // If set, fSizeOfFixed is the size of the first view.
    // First view :
    NSRect vrect;
    vrect.origin.x = 0;
    vrect.size.width = rect.size.width;
    double firstHeight = 
      fSizeOfFixed>=0 ? fSizeOfFixed : [firstView frame].size.height;
    vrect.origin.y = rect.size.height - firstHeight;
    vrect.size.height = firstHeight;
    [firstView setFrame:vrect];
    mask = NSViewWidthSizable | NSViewMinYMargin; // What is changing :
    [firstView setAutoresizingMask:mask];
    // Second view :
    vrect.origin.x = 0;
    vrect.size.width = rect.size.width;
    vrect.origin.y = 0;
    vrect.size.height = rect.size.height - firstHeight;
    [secondView setFrame:vrect];
    mask = NSViewWidthSizable | NSViewHeightSizable; // What is changing :
    [secondView setAutoresizingMask:mask];
  } else if(fExpand==OnX_FIRST) {
    // Second child height must not change.
    // If set, fSizeOfFixed is the size of the second child.
    // First view :
    NSRect vrect;
    vrect.origin.x = 0;
    vrect.size.width = rect.size.width;
    double secondHeight = 
      fSizeOfFixed>=0 ? fSizeOfFixed : [secondView frame].size.height;
    vrect.origin.y = secondHeight;
    vrect.size.height = rect.size.height - secondHeight;
    [firstView setFrame:vrect];
    mask = NSViewWidthSizable | NSViewHeightSizable; // What is changing :
    [firstView setAutoresizingMask:mask];
    // Second view :
    vrect.origin.x = 0;
    vrect.size.width = rect.size.width;
    vrect.origin.y = 0;
    vrect.size.height = secondHeight;
    [secondView setFrame:vrect];
    mask = NSViewWidthSizable | NSViewMaxYMargin; // What is changing :
    [secondView setAutoresizingMask:mask];
  } else if(fExpand==OnX_BOTH) {
    // First view :
    float width = rect.size.width;
    float height = rect.size.height / 2;
    NSRect vrect;
    vrect.origin.x = 0;
    vrect.origin.y = height; 
    vrect.size.width = width;
    vrect.size.height = height;
    [firstView setFrame:vrect];
    mask = NSViewWidthSizable | NSViewHeightSizable | NSViewMinYMargin;
    [firstView setAutoresizingMask:mask];
    // Second view :
    width = rect.size.width;
    height = rect.size.height / 2;
    vrect.origin.x = 0;
    vrect.origin.y = 0;
    vrect.size.width = width;
    vrect.size.height = height;
    [secondView setFrame:vrect];
    mask = NSViewWidthSizable | NSViewHeightSizable | NSViewMaxYMargin;
    [secondView setAutoresizingMask:mask];
  }
}
@end

// Expansion and split position policy :
// if expand FIRST
//   Second child width must not change.
//   If set (not -1), fSizeOfFixed is the width of the second child
//   else the current second child width is used.
// if expand SECOND (Default)
//   First child width must not change.
//   If set (not -1), fSizeOfFixed is the width of the first child
//   else the current first child width is used.
// if expand BOTH
//   The container width is equally divided between the two children.

@implementation OnX_NSHBox
- (id)initWithFrame:(NSRect)aRect {
  fExpand = OnX_SECOND;
  fSizeOfFixed = -1;
  if(self = [super initWithFrame:aRect]) {
  }
  return self;
}
- (void)dealloc {
  [super dealloc];
}
- (void)setExpand:(OnX_Expand)aExpand {
  fExpand = aExpand;
}
- (void)setSizeOfFixed:(int)aSize {
  fSizeOfFixed = aSize;
}
- (void)addView:(NSView*)aView {
  [self addSubview:aView];
  NSRect rect = [self frame];
  unsigned int mask = 0;
  if([[self subviews] count]==1) {
    // First entry, map to whole area :
    [aView setFrame:rect];
    mask = NSViewWidthSizable | NSViewHeightSizable; // What is changing :
    [aView setAutoresizingMask:mask];
    return;
  }
  // Second view, share the area with the first :
  NSView* firstView = [[self subviews] objectAtIndex:0]; 
  NSView* secondView = [[self subviews] objectAtIndex:1]; 
  if(fExpand==OnX_SECOND) {
    NSRect vrect;
    // First view :
    double firstWidth = 
      fSizeOfFixed>=0 ? fSizeOfFixed : [firstView frame].size.width;
    vrect.origin.x = 0;
    vrect.size.width = firstWidth;
    vrect.origin.y = 0;
    vrect.size.height = rect.size.height;
    [firstView setFrame:vrect];
    mask = NSViewHeightSizable | NSViewMaxXMargin;
    [firstView setAutoresizingMask:mask];
    // Second view :
    vrect.origin.x = firstWidth;
    vrect.size.width = rect.size.width - firstWidth;
    vrect.origin.y = 0;
    vrect.size.height = rect.size.height;
    [secondView setFrame:vrect];
    mask = NSViewWidthSizable | NSViewHeightSizable;
    [secondView setAutoresizingMask:mask];
  } else if(fExpand==OnX_FIRST) {
    NSRect vrect;
    // First view :
    double secondWidth = 
      fSizeOfFixed>=0 ? fSizeOfFixed : [secondView frame].size.width;
    vrect.origin.x = 0;
    vrect.size.width = rect.size.width - secondWidth;
    vrect.origin.y = 0;
    vrect.size.height = rect.size.height;
    [firstView setFrame:vrect];
    mask = NSViewWidthSizable | NSViewHeightSizable;
    [firstView setAutoresizingMask:mask];
    // Second view :
    vrect.origin.x = rect.size.width - secondWidth;
    vrect.size.width = secondWidth;
    vrect.origin.y = 0;
    vrect.size.height = rect.size.height;
    [secondView setFrame:vrect];
    mask = NSViewHeightSizable | NSViewMinXMargin;
    [secondView setAutoresizingMask:mask];
  } else if(fExpand==OnX_BOTH) {
    NSRect vrect;
    // First view :
    float width = rect.size.width / 2;
    float height = rect.size.height;
    vrect.origin.x = 0;
    vrect.origin.y = 0;
    vrect.size.width = width;
    vrect.size.height = height;
    [firstView setFrame:vrect];
    mask = NSViewWidthSizable | NSViewHeightSizable | NSViewMaxXMargin;
    [firstView setAutoresizingMask:mask];
    // Second view :
    width = rect.size.width / 2;
    height = rect.size.height;
    vrect.origin.x = width;
    vrect.origin.y = 0;
    vrect.size.width = width;
    vrect.size.height = height;
    [secondView setFrame:vrect];
    mask = NSViewWidthSizable | NSViewHeightSizable | NSViewMinXMargin;
    [secondView setAutoresizingMask:mask];
  }
}
@end

@implementation OnX_NSVContainer
- (id)init {
  if(self = [super init]) {
  }
  return self;
}
- (void)dealloc {
  [super dealloc];
}
- (void)addView:(NSView*)aView {
  [self addSubview:aView];
  NSRect rect = [self frame];
  // Share area between subviews :
  int number = [[self subviews] count];
  float height = rect.size.height / number;
  int index;
  for(index=0;index<number;index++) {
    NSView* view = [[self subviews] objectAtIndex:index];
    NSRect vrect;
    vrect.origin.x = 0;
    vrect.origin.y = (number - 1 - index) * height;
    vrect.size.width = rect.size.width;
    vrect.size.height = height;
    [view setFrame:vrect];
    unsigned int mask = 0;
    if(index==0) {
      mask = NSViewWidthSizable | NSViewHeightSizable | 
             NSViewMinYMargin;
    } else if(index==number-1) {
      mask = NSViewWidthSizable | NSViewHeightSizable | 
             NSViewMaxYMargin;
    } else {
      mask = NSViewWidthSizable | NSViewHeightSizable | 
             NSViewMinYMargin | NSViewMaxYMargin;
    }
    [view setAutoresizingMask:mask];
  }
}
@end

@implementation OnX_NSHContainer
- (id)init {
  if(self = [super init]) {
  }
  return self;
}
- (void)dealloc {
  [super dealloc];
}
- (void)addView:(NSView*)aView {
  [self addSubview:aView];
  NSRect rect = [self frame];
  // Share area between subviews :
  int number = [[self subviews] count];
  float width = rect.size.width / number;
  int index;
  for(index=0;index<number;index++) {
    NSView* view = [[self subviews] objectAtIndex:index];
    NSRect vrect;
    vrect.origin.x = index * width;
    vrect.origin.y = 0;
    vrect.size.width = width;
    vrect.size.height = rect.size.height;
    [view setFrame:vrect];
    unsigned int mask = 0;
    if(index==0) {
      mask = NSViewWidthSizable | NSViewHeightSizable | 
             NSViewMaxXMargin;
    } else if(index==number-1) {
      mask = NSViewWidthSizable | NSViewHeightSizable | 
             NSViewMinXMargin;
    } else {
      mask = NSViewWidthSizable | NSViewHeightSizable | 
             NSViewMaxXMargin | NSViewMinXMargin;
    }
    [view setAutoresizingMask:mask];
  }
}
@end

@implementation OnX_NSVPaned
- (id)initWithFrame:(NSRect)aRect {
  fSplitPosition = -1;
  if(self = [super initWithFrame:aRect]) {
    [self setIsPaneSplitter:YES];
  }
  return self;
}
- (void)dealloc {
  [super dealloc];
}
- (void)setSplitPosition:(int)aPosition {
  fSplitPosition = aPosition;
}
- (void)addView:(NSView*)aView {
  [self addSubview:aView];
  NSRect rect = [self frame];
  if([[self subviews] count]==1) {
    // First entry, map to whole area :
    [aView setFrame:rect];
    return;
  }
  // Second view, share the area with the first :
  NSView* firstView = [[self subviews] objectAtIndex:0]; 
  NSView* secondView = [[self subviews] objectAtIndex:1]; 
  NSRect vrect;
  vrect.origin.x = 0;
  vrect.size.width = rect.size.width;
  double firstHeight = 
    fSplitPosition>=0 ? fSplitPosition : [firstView frame].size.height;
  vrect.origin.y = rect.size.height - firstHeight;
  vrect.size.height = firstHeight;
  [firstView setFrame:vrect];
  // Second view :
  vrect.origin.x = 0;
  vrect.size.width = rect.size.width;
  vrect.origin.y = 0;
  vrect.size.height = rect.size.height - firstHeight;
  [secondView setFrame:vrect];
}
@end

@implementation OnX_NSHPaned
- (id)initWithFrame:(NSRect)aRect {
  fSplitPosition = -1;
  if(self = [super initWithFrame:aRect]) {
    [self setVertical:YES];
    [self setIsPaneSplitter:YES];
  }
  return self;
}
- (void)dealloc {
  [super dealloc];
}
- (void)setSplitPosition:(int)aPosition {
  fSplitPosition = aPosition;
}
- (void)addView:(NSView*)aView {
  [self addSubview:aView];
  NSRect rect = [self frame];
  if([[self subviews] count]==1) {
    // First entry, map to whole area :
    [aView setFrame:rect];
    return;
  }
  // Second view, share the area with the first :
  NSView* firstView = [[self subviews] objectAtIndex:0]; 
  NSView* secondView = [[self subviews] objectAtIndex:1]; 
  NSRect vrect;
  // First view :
  double firstWidth = 
    fSplitPosition>=0 ? fSplitPosition : [firstView frame].size.width;
  vrect.origin.x = 0;
  vrect.size.width = firstWidth;
  vrect.origin.y = 0;
  vrect.size.height = rect.size.height;
  [firstView setFrame:vrect];
  // Second view :
  vrect.origin.x = firstWidth;
  vrect.size.width = rect.size.width - firstWidth;
  vrect.origin.y = 0;
  vrect.size.height = rect.size.height;
  [secondView setFrame:vrect];
}
@end



@implementation OnX_NSOpenGLArea
- (id)initWithFrame:(NSRect)aRect {
  fPaintActions = 0;
  fEventActions = 0;
  fEventType = NSLeftMouseDown;
  NSOpenGLPixelFormat * pixelFormat;
  if ((pixelFormat = [self createPixelFormat:aRect]) != nil) {
    if (self = [super initWithFrame:aRect pixelFormat:pixelFormat]) {
      // flush buffer only during the vertical retrace of the monitor
      const long int vals[1] = {1};
      [[self openGLContext] setValues:vals forParameter:NSOpenGLCPSwapInterval];
      [[self openGLContext] makeCurrentContext];
      //other init should be put here.
      fPaintActions = [[NSMutableArray alloc] init];
      fEventActions = [[NSMutableArray alloc] init];
    }
    [pixelFormat release];
  } else {
    NSLog(@"OnX_NSOpenGLArea : can't create a pixel format.");
    //FIXME [[NSNotificationCenter defaultCenter]postNotificationName:SCCouldNotCreateValidPixelFormatNotification object:self];
    [self dealloc];
    self = nil;
  }
  return self;
}
- (void)dealloc {
  [fPaintActions release];
  [fEventActions release];
  [super dealloc];
}
- (void)addPaintAction:(OnX_NSAction*)aAction {
  [fPaintActions addObject:aAction];
}
- (void)addEventAction:(OnX_NSAction*)aAction {
  [fEventActions addObject:aAction];
}
- (NSEventType)eventType {
  return fEventType;
}
- (NSPoint)eventLocation {
  return fEventLocation;
}
- (void)drawRect:(NSRect)aRect {
  [self refresh];
}
- (void)refresh {
  [[self openGLContext] makeCurrentContext];
  int number = [fPaintActions count];
  int index;
  for(index=0;index<number;index++) {
    [(OnX_NSAction*)[fPaintActions objectAtIndex:index] execute];
  }
  [[self openGLContext] flushBuffer];
}
- (NSOpenGLPixelFormat*)createPixelFormat:(NSRect)aFrame {
  int colorbits = 32; // color depth
  int depthbits = 32; // z buffer resolution
  NSOpenGLPixelFormatAttribute att[16];
  int i = 0;
  att[i++] = NSOpenGLPFADoubleBuffer;
  att[i++] = NSOpenGLPFAAccelerated;
  att[i++] = NSOpenGLPFAAccumSize;
  att[i++] = (NSOpenGLPixelFormatAttribute)32;
  att[i++] = NSOpenGLPFAColorSize;
  att[i++] = (NSOpenGLPixelFormatAttribute)colorbits;
  att[i++] = NSOpenGLPFADepthSize;
  att[i++] = (NSOpenGLPixelFormatAttribute)depthbits;
  att[i++] = NSOpenGLPFAScreenMask;
  att[i++] = (NSOpenGLPixelFormatAttribute)
    CGDisplayIDToOpenGLDisplayMask(kCGDirectMainDisplay);
  att[i] = (NSOpenGLPixelFormatAttribute)0;
  NSOpenGLPixelFormat* pixelFormat = 
    [[NSOpenGLPixelFormat alloc] initWithAttributes:att];
  return pixelFormat;
}
- (void) mouseDown:(NSEvent*)aEvent {
  fEventType = NSLeftMouseDown;
  fEventLocation = [aEvent locationInWindow];
  int number = [fEventActions count];
  int index;
  for(index=0;index<number;index++) {
    [(OnX_NSAction*)[fEventActions objectAtIndex:index] execute];
  }
  //[[self nextResponder] mouseDown:aEvent];
}
- (void) mouseUp:(NSEvent*)aEvent {
  fEventType = NSLeftMouseUp;
  fEventLocation = [aEvent locationInWindow];
  int number = [fEventActions count];
  int index;
  for(index=0;index<number;index++) {
    [(OnX_NSAction*)[fEventActions objectAtIndex:index] execute];
  }
  //[[self nextResponder] mouseUp:aEvent];
}
- (void) mouseDragged:(NSEvent*)aEvent {
  fEventType = NSMouseMoved;
  fEventLocation = [aEvent locationInWindow];
  int number = [fEventActions count];
  int index;
  for(index=0;index<number;index++) {
    [(OnX_NSAction*)[fEventActions objectAtIndex:index] execute];
  }
  //[[self nextResponder] mouseDragged:aEvent];
}
@end

@implementation OnX_NSFileChooser
- (id)init {
  fModeOpen = true;
  fOpenPanel = 0;
  fSavePanel = 0;
  fOkActions = 0;
  fCancelActions = 0;
  fFileName = 0;
  if(self = [super init]) {
    fOpenPanel = [NSOpenPanel openPanel]; //We are not owner.
    fSavePanel = [NSSavePanel savePanel]; //We are not owner.
    fOkActions = [[NSMutableArray alloc] init];
    fCancelActions = [[NSMutableArray alloc] init];
    fFileName = [[NSString alloc] init];
  }
  return self;
}
- (void)dealloc {
  [fFileName release];
  [fOkActions release];
  [fCancelActions release];
  [super dealloc];
}
- (void)addOkAction:(OnX_NSAction*)aAction {
  [fOkActions addObject:aAction];
}
- (void)addCancelAction:(OnX_NSAction*)aAction {
  [fCancelActions addObject:aAction];
}
- (void)setModeOpen:(bool)aMode {
  fModeOpen = aMode;
}
- (void)show {
  if(fModeOpen) {
    [fOpenPanel beginForDirectory:nil
                             file:nil
                            types:nil
                 modelessDelegate:self
              didEndSelector:@selector(openPanelDidEnd:returnCode:contextInfo:)
                contextInfo:nil];
  } else { //Save
    int status = [fSavePanel runModal];
    if(status==NSFileHandlingPanelOKButton) {
      [fFileName release];
      fFileName = [[NSString alloc] initWithString:[fSavePanel filename]];
      int number = [fOkActions count];
      int index;
      for(index=0;index<number;index++) {
        [(OnX_NSAction*)[fOkActions objectAtIndex:index] execute];
      }
    } else if(status==NSFileHandlingPanelCancelButton) {
      [fFileName release];
      fFileName = 0;
      int number = [fCancelActions count];
      int index;
      for(index=0;index<number;index++) {
        [(OnX_NSAction*)[fCancelActions objectAtIndex:index] execute];
      }
    }
  }
}
- (NSString*)fileName {
  return fFileName;
}
- (void)openPanelDidEnd:(NSOpenPanel*)aPanel 
             returnCode:(int)aRC 
            contextInfo:(void*)aContext {
  if (aRC == NSOKButton) {
    [fFileName release];
    fFileName = [[NSString alloc] initWithString:[aPanel filename]];
    //printf("debug : file open \"%s\"\n",fFileName->c_str());
    int number = [fOkActions count];
    int index;
    for(index=0;index<number;index++) {
      [(OnX_NSAction*)[fOkActions objectAtIndex:index] execute];
    }
  } else if(aRC == NSCancelButton) {
    [fFileName release];
    fFileName = 0;
    int number = [fCancelActions count];
    int index;
    for(index=0;index<number;index++) {
      [(OnX_NSAction*)[fCancelActions objectAtIndex:index] execute];
    }
  }
}
@end

@implementation OnX_NSColorChooser
- (id)init {
  fColorPanel = 0;
  fOkActions = 0;
  fColor = 0;
  if(self = [super init]) {
    fColorPanel = [NSColorPanel sharedColorPanel]; //We are not owner.
    fOkActions = [[NSMutableArray alloc] init];
    fColor = [[NSString alloc] init];
    [fColorPanel setTarget:self];
    [fColorPanel setAction:@selector(changeColor:)];

  }
  return self;
}
- (void)dealloc {
  [fColor release];
  [fOkActions release];
  [super dealloc];
}
- (void)addOkAction:(OnX_NSAction*)aAction {
  [fOkActions addObject:aAction];
}
- (void)show:(id)aSender {
  if(fColorPanel) {
    [fColorPanel makeKeyAndOrderFront:aSender];
  }
}
- (void)hide {
  if(fColorPanel) {
    [fColorPanel close];
  }
}
- (NSString*)choosenColor {
  return fColor;
}
- (void)changeColor:(id)aSender {
  NSColor* color = [(NSColorPanel*)aSender color];
  float r = [color redComponent];
  float g = [color greenComponent];
  float b = [color blueComponent];
  [fColor release];
  fColor = [[NSString alloc] initWithFormat:@"%g %g %g",r,g,b];  
  int number = [fOkActions count];
  int index;
  for(index=0;index<number;index++) {
    [(OnX_NSAction*)[fOkActions objectAtIndex:index] execute];
  }
}
@end

@implementation OnX_NSTreeItem
- (id)initWithParent:(OnX_NSTreeItem*)aParent {  
  fParent = 0;
  fChildren = 0;
  fLabel = 0;
  if (self = [super init]) {
    fParent = aParent;
    fChildren = [[NSMutableArray alloc] init];
    fLabel = [[NSString alloc] init];
  }
  return self;
}
- (void)dealloc {
  [fChildren release];
  [fLabel release];
  [super dealloc];
}
- (void)addObject:(OnX_NSTreeItem*)aItem {
  [fChildren addObject:aItem];
}
- (int)numberOfChildren {
  return [fChildren count];
}
- (OnX_NSTreeItem*)childAtIndex:(int)aIndex {
  return [fChildren objectAtIndex:aIndex];
}
- (NSString*)label {
  return fLabel;
}
- (NSString*)path {
  if([fChildren count]) return 0; //Not a leaf.
  NSString* path = [[NSString alloc] init];
  OnX_NSTreeItem* item = self;
  while(item) {
    NSString* ss = item->fLabel?
                    [[NSString alloc] initWithString:item->fLabel] :
                    [[NSString alloc] init];
    NSString* opath = [[NSString alloc] initWithString:path];
    [path release];
    path = [[NSString alloc] initWithString:@"\n"];
    NSString* p1 = [path stringByAppendingString:ss];
    [ss release];
    NSString* p2 = [p1 stringByAppendingString:opath];
    [opath release];
    [path release];
    path = [[NSString alloc] initWithString:p2];
    item = item->fParent;
  }
  // Remove the leading \n (there are two because the root as an empty label)
  if([path length]>=2) {
    NSString* p = [path substringFromIndex:2];
    [path release];
    path = [[NSString alloc] initWithString:p];
  }
  return path; //released by the user.
}
- (void)setLabel:(NSString*)aLabel {
  if(aLabel!=fLabel) {
    [fLabel release];
    fLabel = [[NSString alloc] initWithString:aLabel];
  }
}
@end

@implementation OnX_NSTree
- (id)initWithFrame:(NSRect)aRect {
  fRootItem = 0;
  fSelectActions = 0;
  fSelectedPath = 0;
  if(self = [super initWithFrame:aRect]) {
    NSTableColumn* column = 
      [[NSTableColumn alloc] initWithIdentifier:@"NAME"];
    [self addTableColumn:column];
    [self setOutlineTableColumn:column];
    [column release];

    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(outlineViewSelectionDidChange:) name:NSOutlineViewSelectionDidChangeNotification object:self];

    fRootItem = [[OnX_NSTreeItem alloc] initWithParent:0];

    fSelectActions = [[NSMutableArray alloc] init];
    fSelectedPath = [[NSString alloc] init];
  }
  return self;
}
- (void)dealloc {
  [fSelectActions release];
  [fSelectedPath release];
  [fRootItem release];
  [[NSNotificationCenter defaultCenter] removeObserver:self];
  [super dealloc];
}
- (void)setRootItem:(OnX_NSTreeItem*)aItem {
  if(aItem!=fRootItem) {
    [fRootItem release];
    [aItem retain];
    fRootItem = aItem;
    // Trigger an update :
    [self setDataSource:nil];
    [self setDataSource:self];
  }
}
- (void)addSelectAction:(OnX_NSAction*)aAction {
  [fSelectActions addObject:aAction];
}
- (NSString*)selectedPath {
  return fSelectedPath;
}
// NSOutlineViewNotifications
- (void)outlineViewSelectionDidChange:(NSNotification*)aNotification {
  [fSelectedPath release];
  OnX_NSTree* tree = (OnX_NSTree*)[aNotification object];
  int row = [tree selectedRow];
  OnX_NSTreeItem* treeItem = (OnX_NSTreeItem*)[tree itemAtRow:row];
  fSelectedPath = [treeItem path];
  int number = [fSelectActions count];
  int index;
  for(index=0;index<number;index++) {
    [(OnX_NSAction*)[fSelectActions objectAtIndex:index] execute];
  }
}
// NSOutlineViewDataSource
- (int)outlineView:(NSOutlineView*)aView numberOfChildrenOfItem:(id)aItem {
  if(aItem==nil) {
    return [fRootItem numberOfChildren];
  } else {
    return [(OnX_NSTreeItem*)aItem numberOfChildren];
  }
}
- (id)outlineView:(NSOutlineView*)aView child:(int)aIndex ofItem:(id)aItem {
  if(aItem==nil) {
    return [fRootItem childAtIndex:aIndex];
  } else {
    return [(OnX_NSTreeItem*)aItem childAtIndex:aIndex];
  }
}
- (BOOL)outlineView:(NSOutlineView*)aView isItemExpandable:(id)aItem {
  if(aItem==nil) {
    return YES;
  } else {
    int n = [(OnX_NSTreeItem*)aItem numberOfChildren];
    return (n==0?NO:YES);
  }
}
- (id)outlineView:(NSOutlineView*)aView objectValueForTableColumn:(NSTableColumn*)aColumn byItem:(id)aItem {
  //if ([[aColumn identifier] isEqual: @"NAME"]){
  return [(OnX_NSTreeItem*)aItem label];
}
@end

@implementation OnX_NSList
- (id)initWithFrame:(NSRect)aRect {
  fRootItem = 0;
  fSelectActions = 0;
  fSelection = 0;
  if(self = [super initWithFrame:aRect]) {
    NSTableColumn* column = 
      [[NSTableColumn alloc] initWithIdentifier:@"NAME"];
    [self addTableColumn:column];
    [column release];

    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(tableViewSelectionDidChange:) name:NSTableViewSelectionDidChangeNotification object:self];

    fRootItem = [[OnX_NSTreeItem alloc] initWithParent:0];

    fSelectActions = [[NSMutableArray alloc] init];
    fSelection = [[NSString alloc] init];
  }
  return self;
}
- (void)dealloc {
  [fSelectActions release];
  [fSelection release];
  [fRootItem release];
  [[NSNotificationCenter defaultCenter] removeObserver:self];
  [super dealloc];
}
- (void)setRootItem:(OnX_NSTreeItem*)aItem {
  if(aItem!=fRootItem) {
    [fRootItem release];
    [aItem retain];
    fRootItem = aItem;
    // Trigger an update :
    [self setDataSource:nil];
    [self setDataSource:self];
  }
}
- (void)addSelectAction:(OnX_NSAction*)aAction {
  [fSelectActions addObject:aAction];
}
- (NSString*)selection {
  return fSelection;
}
// NSTableViewDataSource :
- (int)numberOfRowsInTableView:(NSTableView*)aTableView {
  return [fRootItem numberOfChildren];
}
- (id)tableView:(NSTableView*)aTableView objectValueForTableColumn:(NSTableColumn*)aTableColumn row:(int)aRow {
  return [[fRootItem childAtIndex:aRow] label];
}
// NSTableViewNotification :
- (void)tableViewSelectionDidChange:(NSNotification*)aNotification {
  [fSelection release];
  OnX_NSList* tree = (OnX_NSList*)[aNotification object];
  int row = [tree selectedRow];
  OnX_NSTreeItem* treeItem = [fRootItem childAtIndex:row];
  fSelection = [treeItem path];
  int number = [fSelectActions count];
  int index;
  for(index=0;index<number;index++) {
    [(OnX_NSAction*)[fSelectActions objectAtIndex:index] execute];
  }
}
@end

@implementation OnX_NSSlider
- (id)initWithFrame:(NSRect)aRect {
  fActivateActions = 0;
  if(self = [super initWithFrame:aRect]) {
    fActivateActions = [[NSMutableArray alloc] init];
    [self setTarget:self];
    [self setAction:@selector(action:)];
  }
  return self;
}
- (void)dealloc {
  [fActivateActions release];
  [super dealloc];
}
- (void)addActivateAction:(OnX_NSAction*)aAction {
  [fActivateActions addObject:aAction];
}
- (void)action:(id)aSender {
  int number = [fActivateActions count];
  int index;
  for(index=0;index<number;index++) {
    [(OnX_NSAction*)[fActivateActions objectAtIndex:index] execute];
  }
}
@end

@implementation OnX_NSScroller
- (id)initWithFrame:(NSRect)aRect {
  fActivateActions = 0;
  if(self = [super initWithFrame:aRect]) {
    fActivateActions = [[NSMutableArray alloc] init];
    [self setTarget:self];
    [self setAction:@selector(action:)];
  }
  return self;
}
- (void)dealloc {
  [fActivateActions release];
  [super dealloc];
}
- (void)addActivateAction:(OnX_NSAction*)aAction {
  [fActivateActions addObject:aAction];
}
- (void)action:(id)aSender {
  int number = [fActivateActions count];
  int index;
  for(index=0;index<number;index++) {
    [(OnX_NSAction*)[fActivateActions objectAtIndex:index] execute];
  }
}
@end

@implementation OnX_NSTabView
- (id)initWithFrame:(NSRect)aRect {
  fSelectActions = 0;
  if(self = [super initWithFrame:aRect]) {
    fSelectActions = [[NSMutableArray alloc] init];
    [self setDelegate:self];
  }
  return self;
}
- (void)dealloc {
  [fSelectActions release];
  [super dealloc];
}
- (void)addSelectAction:(OnX_NSAction*)aAction {
  [fSelectActions addObject:aAction];
}
// NSTabViewDelegate :
- (void)tabView:(NSTabView*)aTabView didSelectTabViewItem:(NSTabViewItem*)aTabViewItem {
  int number = [fSelectActions count];
  int index;
  for(index=0;index<number;index++) {
    [(OnX_NSAction*)[fSelectActions objectAtIndex:index] execute];
  }
}
@end

NSString* NSOnXMessageNotification = @"NSOnXMessage";

@interface OnX_NSMessage : NSObject {
  id fId;
}
- (id)initWithIdentifier:(id)aId;
- (void)dealloc;
- (id)identifier;
@end
@implementation OnX_NSMessage
- (id)initWithIdentifier:(id)aId {
  fId = 0;
  if(self = [super init]) {
    fId = aId;
  }
  return self;
}
- (void)dealloc {  
  [super dealloc];
}
- (id)identifier {
  return fId;
}
@end

@implementation OnX_NSDialog
- (id)initWithContentRect:(NSRect)aRect {
  unsigned int mask = NSResizableWindowMask | NSTitledWindowMask;
  if(self = [super initWithContentRect:aRect 
                             styleMask:mask
                               backing:NSBackingStoreBuffered 
                                 defer:NO]) {
    //[self setShowsResizeIndicator:YES];
    [self setReleasedWhenClosed:NO];
  }
  return self;
}
- (void)dealloc {
  [super dealloc];
}
@end
