package OnX;

import OnX.Native;

/**
 * Used in Script.java to debug.
 */

public class Detector {
  private long fSession = 0;
  public Detector(Long aSession) { 
    fSession = aSession.longValue();
    System.loadLibrary("OnXJavaSWIG");
  }
  public long getSession() { return fSession;}
  public void execute() {
    long ui = Native.Slash::Core::ISession_findManager(getSession(),"UI_Manager");
    // Get current SoPage :
    long s = Native.Slash::UI::IUI_currentViewer(ui);    
    long w = Native.Slash::UI::IUI_findWidget(ui,Native.std_string_c_str(s));
    if(w==0) return;
    long pageViewer = Native.Slash::UI::IWidget_to_Slash::UI::ISoPageViewer(w);
    if(pageViewer==0) return;
    long soPage = Native.Slash::UI::ISoPageViewer_soPage(pageViewer);
    if(soPage==0) return;
    Native.SoNode_set(soPage,"title \"Java/Detector\"");
    // Get current SoRegion :
    long soRegion = Native.SoCanvas_getHighlightedRegion(soPage);
    if(soRegion==0) return;
    if(Native.SoCanvas_isRootRegion(soPage,soRegion)==0) return;
    Native.SoNode_set(soRegion,"color 0.8 0.8 0.8");
    Native.SoRegion_clear(soRegion,Native.new_SbString(""));
    // Add something in the staticScene :
    long soDetector = Native.new_SoDetectorExample();
    long sbAddNode =
      Native.new_SbAddNode(soDetector,Native.new_SbString("staticScene"));
    Native.SoRegion_doIt(soRegion,sbAddNode);
    Native.delete_SbAddNode(sbAddNode);
    Native.Slash::UI::IUI_setParameter(ui,"viewer.view","all");
  }
}
