#include <OnX/Qt/QtUI.h>

// Lib :
#include <Slash/Core/ISession.h>
#include <Lib/smanip.h>
#include <Lib/Out.h>

// OnX :
#include <OnX/Qt/QtThread.h>

// Qt :
#include <qapplication.h>

extern "C" {

//////////////////////////////////////////////////////////////////////////////
Slash::UI::IUI* OnX_createQtUI(
 Slash::Core::ISession& aSession
,const std::string& aFile
,const std::vector<std::string>& aArgs
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::string value;
  bool ui_thread = false;
  if(aSession.parameterValue("UI_Manager.thread",value) &&(value!="")) {
    if(!Lib::smanip::tobool(value,ui_thread)) ui_thread = false;
  }
   
  if(ui_thread) {
#if QT_VERSION < 0x040000
    // From hippodraw.
    OnX::QtThread* thread = new OnX::QtThread();
    thread->start();
    while ( QApplication::startingUp () == true  ) {
      thread->wait ( 100 ); // wait for thread to run
    }
#ifdef WIN32
    // The folowing works under Windows, but under Linux leads to
    // occasional X Windows async errors
    //while ( qApp->currentCanvas () == 0 ) {
    //  thread->wait ( 100 ); // wait for thread to create first window
    //}
#else
    // The following seems to work better for Linux but not at all for
    // Windows ...
    while ( qApp->hasPendingEvents () == true ) {
      thread->wait ( 100 );
    }
#endif
    qApp->lock();
    Slash::UI::IUI* ui = new OnX::QtUI(aSession,aFile,aArgs);
    qApp->unlock();
    return ui;
#else
    Lib::Out out(aSession.printer());
    out << "OnX_createQtUI :"
        << " Qt threaded no yet supported with Qt4."
        << " Continue in a non-threaded mode."
        << Lib::endl;
    return new OnX::QtUI(aSession,aFile,aArgs);
#endif
  } else { 
    return new OnX::QtUI(aSession,aFile,aArgs);
  }
}

}
