
#include <OnX/Qt/QCommandLine.h>

#include <qevent.h> //Qt4 : to include QKeyEvent.

//////////////////////////////////////////////////////////////////////////////
OnX::QCommandLine::QCommandLine(
 QWidget* aParent
,const char* aName
)
:QLineEdit(aParent,aName)
,fHistoryPos(-1)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  QObject::connect(((QLineEdit*)this),SIGNAL(returnPressed()),
             this,SLOT(execute()));
}
//////////////////////////////////////////////////////////////////////////////
OnX::QCommandLine::~QCommandLine(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
const std::string& OnX::QCommandLine::getValue(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fValue;
}
//////////////////////////////////////////////////////////////////////////////
void OnX::QCommandLine::execute(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fValue = text().ascii();
  setText("");
  fHistory.push_back(fValue);
  fHistoryPos = -1;
}
//////////////////////////////////////////////////////////////////////////////
void OnX::QCommandLine::keyPressEvent(
 QKeyEvent* aKeyEvent
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(aKeyEvent->key()==Qt::Key_Up) {
    int n = fHistory.size(); 
    int pos = fHistoryPos == -1 ? n-1 : fHistoryPos-1;
    if((pos>=0)&&(pos<n)) {
      setText(fHistory[pos].c_str()); // Put cursor at eol.
      fHistoryPos = pos;
    }
  } else if(aKeyEvent->key()==Qt::Key_Down) {
    int n = fHistory.size(); 
    int pos = fHistoryPos == -1 ? n : fHistoryPos + 1;
    if((pos>=0)&&(pos<n)) {
      setText(fHistory[pos].c_str()); // Put cursor at eol.
      fHistoryPos = pos;
    } else if(pos>=n) {
      QLineEdit::setText("");
      fHistoryPos = -1;
    }
  } else if(aKeyEvent->key()==Qt::Key_Escape) {
    fValue = text().ascii();
    emit complete();
  } else {
    QLineEdit::keyPressEvent(aKeyEvent);
  }
}
