// this :
#include <OnX/Qt/QTk.h>

#include <Slash/Core/ISession.h>

#include <Lib/Debug.h>
#include <Lib/smanip.h>
#include <Lib/Out.h>
#include <Lib/Cast.h>

#include <OnX/Qt/QtTools.h>
#include <OnX/Qt/QCommandLine.h>
#include <OnX/Qt/QtUI.h> //FIXME

#include <qcolordialog.h>
#include <qcheckbox.h>
#include <qslider.h>
#include <qtabwidget.h>
#include <qcombobox.h>

#if QT_VERSION < 0x040000
#include <qpopupmenu.h>
#include <qlistbox.h>
#include <qlistview.h>
#include <qfiledialog.h>
#define S_QPopupMenu "QPopupMenu"
#define S_QListView "QListView"
#define S_QFileDialog  "QFileDialog"
#else
#include <q3popupmenu.h>
#include <q3listbox.h>
#include <q3valuelist.h>
#include <q3listview.h>
#include <qfiledialog.h>
#include <qevent.h>
#define QValueList Q3ValueList
#define QListView Q3ListView
#define QListViewItem Q3ListViewItem
#define QPopupMenu Q3PopupMenu
#define S_QPopupMenu "Q3PopupMenu"
#define S_QListView "Q3ListView"
#define S_QFileDialog  "OnX_QFileDialog"
#endif

#define S_QDialog      "QDialog"
#define S_QGLWidget    "QGLWidget"
#define S_QTabWidget   "QTabWidget"
#define S_QSlider      "QSlider"
#define S_QLineEdit    "QLineEdit"
#define S_QComboBox    "QComboBox"
#define S_QScrollBar   "QScrollBar"
#define S_QCheckBox    "QCheckBox"
#define S_QLabel       "QLabel"
#define S_QComboBox    "QComboBox"
#define S_QCheckBox    "QCheckBox"
#define S_QSplitter    "QSplitter"
#define S_QMenuBar     "QMenuBar"
#define S_QToolBar     "QToolBar"
#define S_QPushButton  "QPushButton"
#define S_QLineEdit    "QLineEdit"

#define S_OnX_QFileDialog     "OnX_QFileDialog"
#define S_OnX_QToggleMenuItem "OnX_QToggleMenuItem"
#define S_OnX_QMenuItem       "OnX_QMenuItem"
#define S_OnX_QMenu           "OnX_QMenu"
#define S_OnX_QColorDialog    "OnX_QColorDialog"
#define S_OnX_QOpenGLArea     "OnX_QOpenGLArea"
#define S_OnX_QSplitter       "OnX_QSplitter"

//FIXME : OnX_ -> OnX::

OnX_QOpenGLArea::OnX_QOpenGLArea(QWidget* aParent,const char* aName)
:QGLWidget(aParent,aName){
  Lib::Debug::increment(S_OnX_QOpenGLArea);
}
OnX_QOpenGLArea::~OnX_QOpenGLArea(){
  Lib::Debug::decrement(S_OnX_QOpenGLArea);
}
void OnX_QOpenGLArea::initialieGL() {}
void OnX_QOpenGLArea::resizeGL(int,int){}
void OnX_QOpenGLArea::paintGL() {
  QCallbackData data;
  emit paint(data);
}
void OnX_QOpenGLArea::mousePressEvent(QMouseEvent* aEvent) {
  QCallbackData data;
  data.event = "ButtonPress";
  data.x = aEvent->x();
  data.y = aEvent->y();
  emit eventHandler(data);
}
void OnX_QOpenGLArea::mouseReleaseEvent(QMouseEvent* aEvent) {
  QCallbackData data;
  data.event = "ButtonRelease";
  data.x = aEvent->x();
  data.y = aEvent->y();
  emit eventHandler(data);
}
void OnX_QOpenGLArea::mouseMoveEvent(QMouseEvent* aEvent) {
  QCallbackData data;
  data.event = "MotionNotify";
  data.x = aEvent->x();
  data.y = aEvent->y();
  emit eventHandler(data);
}

OnX_QSplitter::OnX_QSplitter(
 Qt::Orientation aOrientation
,QWidget* aParent
,const char* aName
):QSplitter(aOrientation,aParent,aName),fSplitPosition(0){
  Lib::Debug::increment(S_OnX_QSplitter);
}
OnX_QSplitter::~OnX_QSplitter(){
  Lib::Debug::decrement(S_OnX_QSplitter);
}
void OnX_QSplitter::setSplitPosition(int aPosition){
  fSplitPosition = aPosition;
}
void OnX_QSplitter::showEvent(QShowEvent* aEvent){
  QValueList<int> vals = sizes();
  if(vals.size()==2) {
    vals[0] = fSplitPosition;
    vals[1] = (orientation()==Qt::Vertical ? height() : width());
    vals[1] -= fSplitPosition;
    setSizes(vals);
  }
  QSplitter::showEvent(aEvent);
}

OnX_QColorDialog::OnX_QColorDialog(const char* aName):QWidget(0,aName){
  Lib::Debug::increment(S_OnX_QColorDialog);
}
OnX_QColorDialog::~OnX_QColorDialog(){
  Lib::Debug::decrement(S_OnX_QColorDialog);
}
#if QT_VERSION < 0x040000
void OnX_QColorDialog::hide(){}
void OnX_QColorDialog::show(){
#else
void OnX_QColorDialog::map(){
#endif
  fValue = "";
  QColor color = QColorDialog::getColor().rgb();
  if(!color.isValid()) return;
  Lib::smanip::printf(fValue,3*32,"%g %g %g",
  ((double)color.red())/255,
  ((double)color.green())/255,
  ((double)color.blue())/255);
  emit ok();
  fValue = "";
}
std::string OnX_QColorDialog::value() const {return fValue;}

OnX_QFileDialog::OnX_QFileDialog(const char* aName)
  //:QWidget(0,aName),fMode(AcceptOpen){
:QDialog(0,aName),fMode(AcceptOpen){
  Lib::Debug::increment(S_OnX_QFileDialog);
}
OnX_QFileDialog::~OnX_QFileDialog(){
  Lib::Debug::decrement(S_OnX_QFileDialog);
}
void OnX_QFileDialog::map(){
#if QT_VERSION < 0x040000
#else
  if(fMode==AcceptSave) {
    QString s = QFileDialog::getSaveFileName(0,
                      "Choose a filename to save under",
                      fDirectory.c_str(),fFilter.c_str());
    fValue = s.toStdString();
  } else { //AcceptOpen
    QString s = QFileDialog::getOpenFileName(0,
                      "Choose a filename to open",
                      fDirectory.c_str(),fFilter.c_str());
    fValue = s.toStdString();
  }
  emit ok();
  fValue = "";
#endif
}
void OnX_QFileDialog::setAcceptMode(AcceptMode aMode) {
  fMode = aMode;
}
void OnX_QFileDialog::setFilter(const std::string& aFilter) {
  fFilter = aFilter;
}
void OnX_QFileDialog::setDirectory(const std::string& aDirectory) {
  fDirectory = aDirectory;
}
std::string OnX_QFileDialog::value() const {
  return fValue;
}

OnX_QMenu::OnX_QMenu(const char* aName,QPopupMenu& aPopup)
:QWidget(0,aName),fPopup(aPopup){Lib::Debug::increment(S_OnX_QMenu);}
OnX_QMenu::~OnX_QMenu(){Lib::Debug::decrement(S_OnX_QMenu);}
QPopupMenu& OnX_QMenu::popupMenu() const{ return fPopup;}

OnX_QMenuItem::OnX_QMenuItem(
 const char* aName
,QPopupMenu& aPopup
,int aID)
:QWidget(0,aName),fPopup(aPopup),fID(aID){
  Lib::Debug::increment(S_OnX_QMenuItem);}
OnX_QMenuItem::~OnX_QMenuItem(){
  // fID = 0 is a separator.
  if(fID) fPopup.removeItem(fID);
  Lib::Debug::decrement(S_OnX_QMenuItem);
}
QPopupMenu& OnX_QMenuItem::popupMenu() const{ return fPopup;}

OnX_QToggleMenuItem::OnX_QToggleMenuItem(
 const char* aName
,QPopupMenu& aPopup
,int aID)
:OnX_QMenuItem(aName,aPopup,aID){}
OnX_QToggleMenuItem::~OnX_QToggleMenuItem(){}

QtCallback::QtCallback(OnX::Action& aAction)
:fAction(aAction)
{
  Lib::Debug::increment("QtCallback");
}
QtCallback::~QtCallback() {
  Lib::Debug::decrement("QtCallback");
}
OnX::Action& QtCallback::action() const{
  return fAction;
}
void QtCallback::destroy(){
}
void QtCallback::execute(){
  OnX::QtUI* ui = Lib_Cast(fAction.ui(),OnX::QtUI);
  if(!ui) return;
  std::string svalue;
  // Retreive "value" :
  QWidget* widget = (QWidget*)fAction.nativeWidget();
  //printf("debug : QtCallback::execute : %s\n",widget->className());
  //WARNING : have QCommandLine before QLineEdit.
  if(widget->inherits("OnX::QCommandLine")) {
    svalue = ((OnX::QCommandLine*)widget)->getValue();
  } else if(widget->inherits(S_QLineEdit)) {
    svalue = OnX::q2std(((QLineEdit*)widget)->text());
  } else if(widget->inherits(S_QFileDialog)) {
#if QT_VERSION < 0x040000
    svalue = OnX::q2std(((QFileDialog*)widget)->selectedFile());
#else
    svalue = ((OnX_QFileDialog*)widget)->value();
#endif
  } else if(widget->inherits(S_QCheckBox)) {
    svalue = ((QCheckBox*)widget)->isChecked()?"true":"false";
  } else if(widget->inherits(S_QListView)) {
    if (fAction.name()=="select") {
      QListViewItem* item = ((QListView*)widget)->selectedItem();
      if (!item) return;
      if (item->childCount()) return; //branch
      svalue = OnX::QListViewItemGetPath(item);
    } else if (fAction.name()=="selectBranch") {
      QListViewItem* item = ((QListView*)widget)->selectedItem();
      if (!item) return;
      if (!item->childCount()) return; //leaf
      svalue = OnX::QListViewItemGetPath(item);
    } else {
      return;
    }
  } else if(widget->inherits(S_QScrollBar)) {
    Lib::smanip::printf(svalue,64,"%d",((QScrollBar*)widget)->value());
  } else if(widget->inherits(S_QSlider)) {
    Lib::smanip::printf(svalue,64,"%d",((QSlider*)widget)->value());
  } else if(widget->inherits(S_QPopupMenu)) {
    int id = fAction.getID();
    if(id<10000) {
      ((QPopupMenu*)widget)->setItemChecked(id,
       !((QPopupMenu*)widget)->isItemChecked(id));
    }
    svalue = ((QPopupMenu*)widget)->isItemChecked(id)?"true":"false";
  } else if(widget->inherits(S_QComboBox)) {
    svalue = OnX::q2std(((QComboBox*)widget)->currentText());
  } else if(widget->inherits(S_OnX_QColorDialog)) {
    svalue = ((OnX_QColorDialog*)widget)->value();
  } else if(widget->inherits(S_QTabWidget)) {
    QTabWidget* w = (QTabWidget*)widget;
    if(w->currentPage()) {
      svalue = OnX::q2std(w->tabLabel(w->currentPage()));
    }
  }

  if(ui->session().verboseLevel()) {
    Lib::Out out(ui->session().printer());
    out << "OnX::QtCallback::execute :"
        << " value \"" << svalue << "\"." << Lib::endl;
  }
  ui->setCallbackData
    (OnX::CallbackData(fAction.widget(),widget->name(),svalue,"",0,0));
  // Execute script :
  fAction.execute(std::vector<std::string>());
  ui->setCallbackData(OnX::CallbackData());
}
void QtCallback::execute2(QCallbackData& aData){
  OnX::QtUI* ui = Lib_Cast(fAction.ui(),OnX::QtUI);
  if(!ui) return;
  QWidget* widget = (QWidget*)fAction.nativeWidget();
  std::string svalue = aData.value;

  if(ui->session().verboseLevel()) {
    Lib::Out out(ui->session().printer());
    out << "OnX::QtCallback::execute2 :"
        << " value \"" << svalue << "\"." << Lib::endl;
  }
  ui->setCallbackData(OnX::CallbackData
    (fAction.widget(),widget->name(),svalue,aData.event,aData.x,aData.y));
  // Execute script :
  fAction.execute(std::vector<std::string>());
  ui->setCallbackData(OnX::CallbackData());
}
void QtCallback::execute3(QListViewItem* aItem){
  //printf("debug : execute3 \"%s\"\n",fAction.name().c_str());
  std::string svalue = OnX::QListViewItemGetPath(aItem);
  if (fAction.name()=="open") {
    fAction.setBackground(true);
  } else if (fAction.name()=="close") {
    fAction.setBackground(true);
  } else {
    return;
  }

  OnX::QtUI* ui = Lib_Cast(fAction.ui(),OnX::QtUI);
  if(!ui) return;
  QWidget* widget = (QWidget*)fAction.nativeWidget();

  if(ui->session().verboseLevel()) {
    Lib::Out out(ui->session().printer());
    out << "OnX::QtCallback::execute3 :"
        << " value \"" << svalue << "\"." << Lib::endl;
  }
  ui->setCallbackData
    (OnX::CallbackData(fAction.widget(),widget->name(),svalue,"",0,0));
  // Execute script :
  fAction.execute(std::vector<std::string>());
  ui->setCallbackData(OnX::CallbackData());
}

#if QT_VERSION < 0x040000

OnX::QtMessage::QtMessage(QtUI& aUI,Slash::Core::IMessage* aMess)
:fUI(aUI),fMessage(aMess){
  Lib::Debug::increment("OnX::QtMessage");
}
OnX::QtMessage::~QtMessage() {
  Lib::Debug::decrement("OnX::QtMessage");
}
void OnX_QMessageWidget::customEvent(QCustomEvent* aEvent) {
  OnX::QtMessage* guiMessage = (OnX::QtMessage*)aEvent->data();
  OnX::QtUI& This = guiMessage->fUI;
  Slash::Core::IMessage* message = guiMessage->fMessage;
  delete guiMessage;
  This.notification(message);
}
#else

OnX::QCustomEvent::QCustomEvent(QtUI& aUI,Slash::Core::IMessage* aMess)
:QEvent(QEvent::User)
,fUI(aUI)
,fMessage(aMess){
  Lib::Debug::increment("OnX::QCustomEvent");
}
OnX::QCustomEvent::~QCustomEvent() {
  Lib::Debug::decrement("OnX::QCustomEvent");
}
void OnX_QMessageWidget::customEvent(QEvent* aEvent) {
  OnX::QCustomEvent* event = dynamic_cast<OnX::QCustomEvent*>(aEvent);
  if(!event) return;
  OnX::QtUI& This = event->fUI;
  Slash::Core::IMessage* message = event->fMessage;
  //delete guiMessage;
  This.notification(message);
}

#endif
