// this :
#include <OnX/Qt/QtCyclic.h>

#include <Slash/Core/ISession.h>

#include <qwidget.h>

namespace OnX {
class Timer : public QObject {
public:
  Timer(QtCyclic& aCyclic):fCyclic(aCyclic){}
  virtual ~Timer(){}
protected:
  void timerEvent(QTimerEvent*) {
    fCyclic.execute();
  }
private:
  QtCyclic& fCyclic;
};
}

//////////////////////////////////////////////////////////////////////////////
OnX::QtCyclic::QtCyclic(
 Slash::Core::ISession& aSession
,const std::string& aName
,int aDelay
,const std::string& aInterpreter
,const std::string& aScript
)
:BaseCyclic(aSession,aName,aDelay,aInterpreter,aScript)
,fTimer(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
OnX::QtCyclic::~QtCyclic(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  stop();
}
//////////////////////////////////////////////////////////////////////////////
void OnX::QtCyclic::stop(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  delete fTimer;
  fTimer = 0;
}
//////////////////////////////////////////////////////////////////////////////
void OnX::QtCyclic::start(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  stop();
  fTimer = new Timer(*this);
  fTimer->startTimer(fDelay);
}
//////////////////////////////////////////////////////////////////////////////
bool OnX::QtCyclic::started(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fTimer?true:false;
}
