// this :
#import <OnX/SDL/NS.h>

#include <SDL.h>

// Slash :
//#include <Slash/Core/ISession.h>

// NextStep :

#import <Foundation/NSObject.h>
#import <Foundation/NSAutoReleasePool.h>
#import <AppKit/NSApplication.h>

#include <Inventor/SDL/SoSDL.h>

@interface OnX_NSApplicationDelegate : NSObject {
  //Slash::Core::ISession* fSession;
}
- (id)initWithSession//:(Slash::Core::ISession*)aSession
;
- (void)dealloc;
- (NSApplicationTerminateReply)applicationShouldTerminate:(NSApplication*)aSender;
@end
@implementation OnX_NSApplicationDelegate
- (id)initWithSession//:(Slash::Core::ISession*)aSession
 {
  //fSession = 0;
  if(self = [super init]) {
    //fSession = aSession;
  }
  return self;
}
- (void)dealloc {
  [super dealloc];
}
- (NSApplicationTerminateReply)applicationShouldTerminate:(NSApplication*)aSender {
  //NSLog(@"debug : delegate terminate\n");
  // Remove .log_tmp, .err, .out files :
  return NSTerminateNow;
}
- (void) applicationDidFinishLaunching: (NSNotification *) note
{
  //NSLog(@"debug : applicationDidFinishLaunching\n");
  SoSDL::mainLoop();    
  //FIXME :
  // if clicking the opt Exit button with the gamepad,
  // we do not exit of [fPrivate->fApplication run];
  // as long as some other event is send to the desktop !
  // Do a "hard" ::exit here... 
  SoSDL::clear();  
  ::exit(0); //FIXME
}
@end

namespace OnX {
class NS_private {
public:
  NSAutoreleasePool* fAutoreleasePool;
  NSApplication* fApplication;
  OnX_NSApplicationDelegate* fAppDelegate;
};
}

//////////////////////////////////////////////////////////////////////////////
OnX::NS::NS(
 //Slash::Core::ISession& aSession
)
:fPrivate(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fPrivate = new NS_private();
  fPrivate->fAutoreleasePool = 0;
  fPrivate->fApplication = 0;
  fPrivate->fAppDelegate = 0;

  //printf("debug : ================================== : 100\n");
  // Initialize NS (NextStep) :

  fPrivate->fAutoreleasePool = [[NSAutoreleasePool alloc] init];
  fPrivate->fApplication = [NSApplication sharedApplication];  
  // fApplication is created with a class factory.
  // According NextStep conventions, it is then autoreleased, 
  // we do not have to release it at the end ; this will be done   
  // by the pool.

  //fPrivate->fAppDelegate = 
  //  [[OnX_NSApplicationDelegate alloc] initWithSession:&aSession];

  fPrivate->fAppDelegate = [[OnX_NSApplicationDelegate alloc] initWithSession];
  [fPrivate->fApplication setDelegate:fPrivate->fAppDelegate];
}
//////////////////////////////////////////////////////////////////////////////
OnX::NS::~NS(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
  [fPrivate->fApplication setDelegate:nil];
  [fPrivate->fAppDelegate release];
  //FIXME : the below crash if we exit the NS::steer with NS::exit.
  //FIXME [fPrivate->fAutoreleasePool release]; //delete the fApplication.
  delete fPrivate;
}
//////////////////////////////////////////////////////////////////////////////
void OnX::NS::steer(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!fPrivate->fApplication) return;
  [fPrivate->fApplication run];
}
//////////////////////////////////////////////////////////////////////////////
void OnX::NS::exit(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!fPrivate->fApplication) return;
  [fPrivate->fApplication stop:nil];
}
