// this :
#include <OnX/SDL/SDL_Cyclic.h>

#include <Slash/Core/ISession.h>

//////////////////////////////////////////////////////////////////////////////
OnX::SDL_Cyclic::SDL_Cyclic(
 Slash::Core::ISession& aSession
,const std::string& aName
,int aDelay
,const std::string& aInterpreter
,const std::string& aScript
)
:BaseCyclic(aSession,aName,aDelay,aInterpreter,aScript)
,fTimerID(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
OnX::SDL_Cyclic::~SDL_Cyclic(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  stop();
}
//////////////////////////////////////////////////////////////////////////////
void OnX::SDL_Cyclic::stop(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!fTimerID) return;
  SDL_RemoveTimer(fTimerID);
  fTimerID = 0;
}
//////////////////////////////////////////////////////////////////////////////
void OnX::SDL_Cyclic::start(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  stop();
  if(fDelay<=0) return;
  fTimerID = SDL_AddTimer(fDelay,timerCB,this);
}
//////////////////////////////////////////////////////////////////////////////
bool OnX::SDL_Cyclic::started(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fTimerID?true:false;
}
//////////////////////////////////////////////////////////////////////////////
Uint32 OnX::SDL_Cyclic::timerCB(
 Uint32 aInterval
,void* aData
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!![!!!!!!!!!!!!!!!//
{
  OnX::SDL_Cyclic* This = (OnX::SDL_Cyclic*)aData;
  This->execute();
  return aInterval; //continue. (Returning 0 would stop the timer).
}
