//////////////////////////////////////////////////////////////////////////////
/// Pre SWIG /////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

%rename(pck) Slash::UI::IInterpreter::package; //package is a java keyword.

%ignore Slash::Data::IArray::vector();
// Avoid a clash with a finalize() produced by SWIG :
%ignore Slash::UI::IUI::finalize();

#ifdef SWIGPYTHON
// FIXME : lxplus 64 bits. The code generated has a call to :
//   set(std::vector<unsigned int,std::allocator<unsigned int > > const &,
//    std::vector<unsigned long long,std::allocator<Slash::uint64 > > const &);
// and NOT : 
//   set(std::vector<unsigned int,std::allocator<unsigned int > > const &,
//    std::vector<Slash::uint64,std::allocator<Slash::uint64 > > const &);
// and then does not compile.

%ignore Slash::Core::IValue::set(const std::vector<unsigned int>&,
                                 const std::vector<Slash::uint64>&);
%ignore Slash::Core::IValue::set(const std::vector<unsigned int>&,
                                 const std::vector<Slash::int64>&);
#endif
//////////////////////////////////////////////////////////////////////////////
/// Code to wrap /////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

//FIXME %include <Slash/All.h>

// Meta :
//#include <Slash/Meta/IClass.h>
//#include <Slash/Meta/IDictionary.h>
//#include <Slash/Meta/IObject.h>

// Core :
%include <Slash/Core/IReader.h>
%include <Slash/Core/IWriter.h>

%include <Slash/Core/IManager.h>
%include <Slash/Core/ISession.h>

%include <Slash/Core/ILibrary.h>
%include <Slash/Core/ILibraryManager.h>

%include <Slash/Core/IRelation.h>
%include <Slash/Core/IRelationVisitor.h>
%include <Slash/Core/IRelationManager.h>

%include <Slash/Core/IDirectoryVisitor.h>
%include <Slash/Core/IAction.h>
%include <Slash/Core/IMessage.h>

#include <Slash/Core/IFileGetter.h>
#include <Slash/Core/IValue.h>
#include <Slash/Core/IOpaqueManager.h>

// UI :
%include <Slash/UI/IInterpreter.h>
%include <Slash/UI/IScriptManager.h>

%include <Slash/UI/IStyleManager.h>

%include <Slash/UI/ICallbackData.h>
%include <Slash/UI/IWidgetFactory.h>
%include <Slash/UI/IWidgetClass.h>
%include <Slash/UI/IWidget.h>
%include <Slash/UI/IUI.h>
%include <Slash/UI/IUI_Manager.h>

%include <Slash/UI/ICyclic.h>

%include <Slash/UI/ISoViewer.h>

// Data :
%include <Slash/Data/IAccessor.h>
%include <Slash/Data/IHandler.h>
%include <Slash/Data/IHandlersIterator.h>
%include <Slash/Data/IIterator.h>
%include <Slash/Data/IProcessor.h>
%include <Slash/Data/IProperty.h>
%include <Slash/Data/IVisualizer.h>
%include <Slash/Data/IFunction.h>
%include <Slash/Data/IFunctionManager.h>
%include <Slash/Data/IArray.h>
%include <Slash/Data/IArrayFactory.h>

// Store :
%include <Slash/Store/IObject.h>
%include <Slash/Store/ITree.h>
%include <Slash/Store/IFolder.h>
%include <Slash/Store/IFolderIterator.h>
%include <Slash/Store/IFolderVisitor.h>
%include <Slash/Store/IObjectIterator.h>
%include <Slash/Store/IStoreManager.h>

//////////////////////////////////////////////////////////////
/// Post SWIG ////////////////////////////////////////////////
//////////////////////////////////////////////////////////////

// Put helpers as extensions :

%extend Slash::Core::IManager {
  Slash::Data::IProcessor* cast_Lib_IProcessor() {
    return Lib_Cast(*self,Slash::Data::IProcessor);
  }
}

%extend Slash::Core::ISession {
  std::string parameterValue(const std::string& aKey) {
    std::string s;
    self->parameterValue(aKey,s);
    return s;
  }
}

%extend Slash::Data::IProcessor {
/*void types() {
    data_collect(*self,"Lib_Type");
    data_dump(*self);
  }*/
  void collect(const std::string& aWhat,
                           const std::string& aCuts = "") {
    data_collect(*self,aWhat,aCuts);
  }
  void visualize() {
    data_visualize(*self);
  }
  int number() {
    return data_number(*self);
  }
  std::vector<std::string> values(const std::string& aWhat) {
    return data_values(*self,aWhat);
  }
  void dump(const std::string& aMode = "table") {
    data_dump(*self,aMode);
  }
  void filter(const std::string& aWhat,
                          const std::string& aFilter = "") {
    data_filter(*self,aWhat,aFilter);
  }
  void set(const std::string& aWhat,
                       const std::string& aValue) {
    data_set(*self,aWhat,aValue);
  }
  void destroy() {
    data_destroy(*self);
  }
}

%define LIB_CAST(aClass)
  aClass* cast_##aClass () {
    return Lib_Cast(*self,aClass);
  }
%enddef

%extend Slash::Core::IManager {
  LIB_CAST(Slash::UI::IUI);
  LIB_CAST(Slash::UI::IScriptManager);
}

%extend Slash::Core::ISession {
  void setColor(double aR,double aG,double aB) {
    std::string s;
    Lib::smanip::printf(s,128,"%g %g %g",aR,aG,aB);
    self->setParameter("modeling.color",s);
  }
  void setColor(const std::string& aColor) {
    self->setParameter("modeling.color",aColor);
  }
  Slash::Data::IProcessor* accessorManager() {
    return Lib_findManager(*self,"AccessorManager",Slash::Data::IProcessor);
  }
  Slash::UI::IScriptManager* scriptManager() {
    return Lib_findManager(*self,"ScriptManager",Slash::UI::IScriptManager);
  }
  Slash::UI::IUI* ui() {
    return Lib_findUI(*self);
  }
}

%extend Slash::UI::IUI {
  std::string parameterValue(const std::string& aKey) {
    std::string s;
    self->parameterValue(aKey,s);
    return s;
  }
  bool setTreeItems(const std::string& aTreeWidget,const std::string& aFile) {
    std::vector<std::string> lines;
    if(!Lib::fmanip::read(aFile,lines)) return false;
    self->setParameter(aTreeWidget+".items",Lib::smanip::tostring(lines,"\n"));
    return true;
  }
  void showHelp(const std::string& aFile) {
    ui_help_text(*self,aFile);
  }
  void showDialog(const std::string& aFile,
                  const std::string& aDialog) {
    ui_show_dialog(*self,aFile,aDialog);
  } 
}
