// this :
#include <OnX/Win/SoExaminerViewer.h>

#include <windows.h>
#include <windowsx.h>
//#include <wingdi.h>

//////////////////////////////////////////////////////////////////////////////
WinTk::SoExaminerViewer::SoExaminerViewer(
 Component& aParent
,const std::string& aName
)
:Component("SoExaminerViewer",aParent)
,fViewer(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!fParent) return;
  HWND parent = fParent->nativeWindow();
  if(!parent) return;

  static char sSoExaminerViewerClassName[] = "WinTk::SoExaminerViewer";
  static bool done = false;
  if(!done) {
    WNDCLASS         wc;
    wc.style         = CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc   = (WNDPROC)WinTk::SoExaminerViewer::proc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = 0;
    wc.hInstance     = GetWindowInstance(parent),
    wc.hIcon         = LoadIcon(NULL,IDI_APPLICATION);
    wc.hCursor       = LoadCursor(NULL,IDC_ARROW);
    wc.hbrBackground = GetSysColorBrush(COLOR_BTNFACE);
    wc.lpszMenuName  = sSoExaminerViewerClassName;
    wc.lpszClassName = sSoExaminerViewerClassName;
    ::RegisterClass(&wc);
    done = true;
  }
  
  // The WS_BORDER is needed. Else probleme of size at startup.
  RECT rect;
  ::GetClientRect(parent,&rect);
  fWindow = ::CreateWindow(sSoExaminerViewerClassName,
                           NULL,
                           WS_CHILD | WS_VISIBLE | WS_BORDER,
                           0,0,
                           rect.right-rect.left,
                           rect.bottom-rect.top,
                           parent,NULL,
                           GetWindowInstance(parent),
                           NULL);
  if(!fWindow) return;
  ::SetWindowLong(fWindow,GWL_USERDATA,LONG(this));

  fViewer = new ::SoWinExaminerViewer(fWindow,aName.c_str(),TRUE);
}
//////////////////////////////////////////////////////////////////////////////
WinTk::SoExaminerViewer::~SoExaminerViewer(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
  delete fViewer;
  if(fWindow) {
    ::SetWindowLong(fWindow,GWL_USERDATA,LONG(NULL));
    ::DestroyWindow(fWindow);
    fWindow = 0;
  }
}
//////////////////////////////////////////////////////////////////////////////
void WinTk::SoExaminerViewer::show(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
  //if(!fViewer) return;
  //fViewer->show();
}
//////////////////////////////////////////////////////////////////////////////
LRESULT CALLBACK WinTk::SoExaminerViewer::proc( 
 HWND   aWindow
,UINT   aMessage
,WPARAM aWParam
,LPARAM aLParam
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  switch(aMessage) { 
  case WM_DESTROY:{
    SoExaminerViewer* This = 
      (SoExaminerViewer*)::GetWindowLong(aWindow,GWL_USERDATA);
    if(This) {
      This->fWindow = 0;
      ::SetWindowLong(aWindow,GWL_USERDATA,LONG(NULL));
    }
  }return 0;
  }
  return (DefWindowProc(aWindow,aMessage,aWParam,aLParam));
}
