
// Lib :
#include <Slash/Core/ISession.h>
#include <Lib/smanip.h>
#include <Lib/Out.h>

// OnX :
#include <OnX/Xt/XtUI.h>

// X11 :
#include <X11/Xlib.h>

extern "C" {

//////////////////////////////////////////////////////////////////////////////
Slash::UI::IUI* OnX_createXtUI(
 Slash::Core::ISession& aSession
,const std::string& aFile
,const std::vector<std::string>& aArgs
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::string value;
  bool ui_thread = false;
  if(aSession.parameterValue("UI_Manager.thread",value) &&(value!="")) {
    if(!Lib::smanip::tobool(value,ui_thread)) ui_thread = false;
  }
   
  if(ui_thread) {
    if(!XInitThreads()) {
      Lib::Out out(aSession.printer());
      out << "OnX_createXtUI :"
          << " XInitThreads() failed." 
          << Lib::endl;
      return 0;
    } else {
      if(aSession.verboseLevel()) {
        Lib::Out out(aSession.printer());
        out << "OnX_createXtUI :"
            << " XInitThreads() done."
            << Lib::endl;
      }
    }
  }

  return new OnX::XtUI(aSession,aFile,aArgs);
}

}
