@ECHO OFF
SETLOCAL

SET bin=.\

FOR /F "usebackq delims=;" %%s IN (`onx-config --incs`) DO SET onx_incs=%%s
FOR /F "usebackq delims=;" %%s IN (`onx-config --py_incs`) DO SET onx_py_incs=%%s
FOR /F "usebackq delims=;" %%s IN (`onx-config --libs`) DO SET onx_libs=%%s
FOR /F "usebackq delims=;" %%s IN (`onx-config --py_libs`) DO SET onx_py_libs=%%s

REM # /GR to enable RTTI and dynamic cast.
REM # /GX to enable exception handling (for STL).
REM # /O2 optimize
REM # /W3 warmings
SET cppflags=/nologo /DWIN32 /MD /GX /GR /O2 /W3 /I. /I.. 
cl.exe /c %cppflags% %onx_incs% /Fo%bin%Hello.obj /Tp..\source\Hello.cxx

cl.exe /c %cppflags% %onx_incs% %onx_py_incs% /Fo%bin%PythonSWIG.obj /Tp..\source\Python\PythonSWIG.cxx

REM # Build the archive lib :
lib.exe /nologo /machine:ix86 /out:%bin%OnXTemplateTwo.arc %bin%Hello.obj %bin%PythonSWIG.obj

REM # Build the win32def.exe utility program :
cl.exe %cppflags% /Fe%bin%win32def.exe /Tpwin32def.c

REM # Building the .def file :
dumpbin /out:%bin%tmp /symbols %bin%OnXTemplateTwo.arc
%bin%win32def.exe OnXTemplateTwo < %bin%tmp > %bin%OnXTemplateTwo.def

REM # Build the DLL :
lib.exe /nologo /machine:ix86 /def:%bin%OnXTemplateTwo.def /out:%bin%OnXTemplateTwo.lib
IF EXIST %bin%OnXTemplateTwo.dll DEL %bin%OnXTemplateTwo.dll
link.exe /nologo /dll /out:%bin%OnXTemplateTwo.dll %bin%OnXTemplateTwo.exp %bin%OnXTemplateTwo.arc %onx_py_libs% %onx_libs%

del %bin%tmp
del %bin%Hello.obj
del %bin%PythonSWIG.obj

ENDLOCAL
@ECHO ON
