#!/bin/sh -f

if test -z $ONXROOT ;
then
  echo "OnX setup not executed."
  exit
fi

packroot=${ONXROOT}
app=OnX_oqt

# Get binary :
cd ${packroot}/${PLATFORMBIN}/${app}.app/Contents
/bin/rm -R -f MacOS
mkdir MacOS
cd MacOS
cp ${packroot}/${PLATFORMBIN}/${app}.exe ${app}

# Get libraries :
dir_lib=Frameworks
cd ${packroot}/${PLATFORMBIN}/${app}.app/Contents
/bin/rm -R -f ${dir_lib}
mkdir ${dir_lib}
cd ${dir_lib}
cp /Developer/qt/lib/libqt-mt.3.dylib .
cp ${COINGLROOT}/${PLATFORMBIN}/libCoin.dylib .
cp ${COINQTROOT}/${PLATFORMBIN}/libCoinQt.dylib .
cp /sw/lib/libfreetype.6.dylib .
cp /sw/lib/libexpat.0.dylib .
cp ${GL2PSROOT}/${PLATFORMBIN}/libosc_gl2ps.dylib .
cp ${JPEGROOT}/${PLATFORMBIN}/libosc_jpeg.dylib .
cp ${DVI2BITMAPROOT}/${PLATFORMBIN}/libosc_dvi2bitmap.dylib .
cp ${HEPVISROOT}/${PLATFORMBIN}/libHEPVisGUI.dylib .
cp ${HEPVISROOT}/${PLATFORMBIN}/libHEPVisPlotter.dylib .
cp ${HEPVISROOT}/${PLATFORMBIN}/libHEPVisDetector.dylib .
cp ${HEPVISROOT}/${PLATFORMBIN}/libHEPVisGeometry.dylib .
cp ${HEPVISROOT}/${PLATFORMBIN}/libHEPVisUtils.dylib .
cp /Developer/qt/lib/libqt-mt.3.dylib .
cp ${ONXROOT}/${PLATFORMBIN}/libOnXQt.dylib .
cp ${ONXROOT}/${PLATFORMBIN}/libOnXInventor.dylib .
cp ${ONXROOT}/${PLATFORMBIN}/libOnXCore.dylib .
cp ${LIBROOT}/${PLATFORMBIN}/libLibXML.dylib .
cp ${LIBROOT}/${PLATFORMBIN}/libLibZip.dylib .
cp ${LIBROOT}/${PLATFORMBIN}/libLibUtils.dylib .

dylibs='libosc_gl2ps.dylib libosc_dvi2bitmap.dylib libosc_jpeg.dylib libCoin.dylib libCoinQt.dylib libHEPVisGUI.dylib libHEPVisPlotter.dylib libHEPVisDetector.dylib libHEPVisGeometry.dylib libHEPVisUtils.dylib libqt-mt.3.dylib libOnXQt.dylib libOnXInventor.dylib libOnXCore.dylib libLibXML.dylib libLibZip.dylib libLibUtils.dylib'

# Instrument the binary :
cd ${packroot}/${PLATFORMBIN}/${app}.app/Contents/MacOS
binary=OnX_oqt
for dylibi in $dylibs
do 
  install_name_tool -change ${dylibi} @executable_path/../${dir_lib}/${dylibi} ${binary}
done

# Instrument the libraries :
cd ${packroot}/${PLATFORMBIN}/${app}.app/Contents/${dir_lib}
for dylibi in $dylibs
do 
  install_name_tool -id @executable_path/../${dir_lib}/${dylibi} ${dylibi}
  for dylibj in $dylibs
  do 
    install_name_tool -change ${dylibj} @executable_path/../${dir_lib}/${dylibj} ${dylibi}
  done
done
