
#include <Lib/Arguments.h>
#include <Lib/Printer.h>
#include <Lib/argZero.h>

#include <OnX/Core/Main.h>
#include <OnX/Core/Environment.h>

#include <OnXLab/Core/Environment.h>

//////////////////////////////////////////////////////////////////////////////
int main (
 int aArgc
,char** aArgv
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(aArgc<=0) return Lib::System::exitFailure();

 {std::string arg0(aArgv[0]);
  bool is_Mac_app = false;
  if(!Lib::argZero::startMacApp(arg0,"OnXLab",is_Mac_app)) return 1;
  Lib::Printer printer;
  if(!check_ONXROOT(arg0,printer,0,true)) {
    return Lib::System::exitFailure();
  }
  if(!check_ONXLABROOT(arg0,printer)) {
    return Lib::System::exitFailure();
  }}

 {Lib::Arguments args(aArgc,aArgv);
  std::string file;
  if(args.file(file)) {
    args.add("-data_file",file);
    args.remove(file);
  }
  args.add("-onx_file","$ONXLABROOT/scripts/OnX/OnXLab.onx");

  std::vector<std::string> opts = OnX::Main::defaultKnownOptions();
  opts.push_back("-data_file");
  opts.push_back("-file_type");

  OnX::Main onxMain(true,true,args.tovector(),opts);
  if(!onxMain.isValid()) return Lib::System::exitFailure();
  onxMain.steer();}

  // Some libraries (for exa Coin, gtk) may have declared 
  // C functions with ::atexit. To ease debugging we call
  // explicitly ::exit here.
  Lib::System::exit();

  return Lib::System::exitSuccess();
}
