@ECHO OFF
SETLOCAL

REM #
REM # File produced by the obuild tool version 1.0
REM # for the package OnXLab with version v1r2p0.
REM #

REM #////////////////////////////////////////////////
REM # Usage :
REM #   DOS> CD some_path\pack\version\obuild
REM #   DOS> DOS\run
REM # or :
REM #   DOS> call DOS\run.bat
REM #
REM #////////////////////////////////////////////////

REM #////////////////////////////////////////////////
REM #/// Get path of this file :
REM #////////////////////////////////////////////////
SET obuild_OnXLab_path=%~dp0
REM # Remove ending \obuild\DOS\
SET obuild_OnXLab_path=%obuild_OnXLab_path:~0,-12%

SET obuild_verbose=no
SET obuild_set_x=no
SET obuild_do_mains=yes
SET obuild_group=main

REM #////////////////////////////////////////////////
REM #/// Treat arguments :
REM #////////////////////////////////////////////////

:next_arg
IF "%1%" == "" GOTO end_args

IF NOT "%1%" == "-h" GOTO end_if_h
  ECHO Usage :
  ECHO   DOS\run [Options]
  ECHO Options :
  ECHO   -v : verbose.
  ECHO   -x : execute with ECHO ON"
  ECHO   -nm : build the not-main components.
  ECHO   -group group : build the given group of components.
  GOTO obuild_return
:end_if_h

IF NOT "%1%" == "-v" GOTO end_if_v
  SET obuild_verbose=yes
  SHIFT
  GOTO next_arg
:end_if_v

IF NOT "%1%" == "-x" GOTO end_if_x
  SET obuild_set_x=yes
  SHIFT
  GOTO next_arg
:end_if_x

IF NOT "%1%" == "-nm" GOTO end_if_nm
  SET obuild_do_mains=no
  SHIFT
  GOTO next_arg
:end_if_nm

IF NOT "%1%" == "-group" GOTO end_if_group
  SHIFT
  SET obuild_group=%1%
  SHIFT
  GOTO next_arg
:end_if_group

:end_args

REM #////////////////////////////////////////////////
REM #/// End arguments.
REM #////////////////////////////////////////////////

IF %obuild_set_x% == yes ECHO ON

IF "%OBUILD_DIR_BIN%" == "" (
  SET obuild_dir_bin=bin_obuild
) ELSE (
  SET obuild_dir_bin=%OBUILD_DIR_BIN%
)

IF "%obuild_dir_bin%" == "" (
  ECHO obuild_dir_bin variable not defined.
  GOTO obuild_return
)

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OnXLab_0=%%d
IF NOT %obuild_group% == main GOTO end_if_group_0
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%" MKDIR "%obuild_OnXLab_path%\%obuild_dir_bin%"
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\obuild_platform.exe" (
  cl.exe /nologo /DWIN32 /MD /O2 /W3  /GX /GR /Fe"%obuild_OnXLab_path%\%obuild_dir_bin%\obuild_platform.exe" "%obuild_OnXLab_path%\obuild\cpp\obuild_platform.cpp" 1> cl_exe_error
  IF ERRORLEVEL 1 TYPE cl_exe_error
  IF NOT ERRORLEVEL 1 DEL cl_exe_error 
  IF EXIST obuild_platform.obj DEL obuild_platform.obj
)

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OnXLab_1=%%d
cd "%obuild_OnXLab_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OnXLab_1%"
SET obuild_pwd_OnXLab_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_0
@IF %obuild_verbose% == yes @ECHO ON 
    CALL DOS\run_check_aida_config.bat "%obuild_OnXLab_path%\examples\cpp\OnXLab_exa_config.cxx"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_platform_0
SET obuild_platform_result=
:end_if_group_0
IF NOT %obuild_group% == main GOTO end_if_group_1
  IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_onx.exe"  GOTO end_if_run_2
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_onx.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_2
:end_if_group_1
IF NOT %obuild_group% == Python GOTO end_if_group_2
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnXLab_path%/examples/Python/OnXLab_exa_aida_0.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_2
IF NOT %obuild_group% == Python GOTO end_if_group_3
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnXLab_path%/examples/Python/OnXLab_exa_aida_1.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_3
IF NOT %obuild_group% == Python GOTO end_if_group_4
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnXLab_path%/examples/Python/OnXLab_exa_aida_2.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_4
IF NOT %obuild_group% == Python GOTO end_if_group_5
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnXLab_path%/examples/Python/OnXLab_exa_aida_3.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_5
IF NOT %obuild_group% == Python GOTO end_if_group_6
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnXLab_path%/examples/Python/OnXLab_exa_aida_4.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_6
IF NOT %obuild_group% == Python GOTO end_if_group_7
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnXLab_path%/examples/Python/OnXLab_exa_aida_5.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_7
IF NOT %obuild_group% == Python GOTO end_if_group_8
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnXLab_path%/examples/Python/OnXLab_exa_aida_6.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_8
IF NOT %obuild_group% == Python GOTO end_if_group_9
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnXLab_path%/examples/Python/OnXLab_exa_aida_7.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_9
IF NOT %obuild_group% == Python GOTO end_if_group_10
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnXLab_path%/examples/Python/OnXLab_exa_aida_8.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_10
IF NOT %obuild_group% == Python GOTO end_if_group_11
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnXLab_path%/examples/Python/OnXLab_exa_aida_9.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_11
IF NOT %obuild_group% == Python GOTO end_if_group_12
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnXLab_path%/examples/Python/OnXLab_exa_aida_10.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_12
IF NOT %obuild_group% == Python GOTO end_if_group_13
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnXLab_path%/examples/Python/OnXLab_exa_aida_11.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_13
IF NOT %obuild_group% == Python GOTO end_if_group_14
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnXLab_path%/examples/Python/OnXLab_exa_aida_12.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_14
IF NOT %obuild_group% == Python GOTO end_if_group_15
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnXLab_path%/examples/Python/OnXLab_exa_aida_13.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_15
IF NOT %obuild_group% == Python GOTO end_if_group_16
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnXLab_path%/examples/Python/OnXLab_exa_aida_14.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_16
IF NOT %obuild_group% == Python GOTO end_if_group_17
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnXLab_path%/examples/Python/OnXLab_exa_quite_aida_0.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_17
IF NOT %obuild_group% == Python GOTO end_if_group_18
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnXLab_path%/examples/Python/OnXLab_exa_quite_aida_1.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_18
IF NOT %obuild_group% == Python GOTO end_if_group_19
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnXLab_path%/examples/Python/OnXLab_exa_quite_aida_3.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_19
IF NOT %obuild_group% == Python GOTO end_if_group_20
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnXLab_path%/examples/Python/OnXLab_exa_quite_aida_4.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_20
IF NOT %obuild_group% == Python GOTO end_if_group_21
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnXLab_path%/examples/Python/OnXLab_exa_quite_aida_5.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_21
IF NOT %obuild_group% == Python GOTO end_if_group_22
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnXLab_path%/examples/Python/OnXLab_exa_quite_aida_6.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_22
IF NOT %obuild_group% == Python GOTO end_if_group_23
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnXLab_path%/examples/Python/OnXLab_exa_quite_aida_7.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_23
IF NOT %obuild_group% == Python GOTO end_if_group_24
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnXLab_path%/examples/Python/OnXLab_exa_aida_OnX_0.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_24
IF NOT %obuild_group% == Python GOTO end_if_group_25
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnXLab_path%/examples/Python/OnXLab_exa_aida_OnX_1.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_25
IF NOT %obuild_group% == Python GOTO end_if_group_26
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnXLab_path%/examples/Python/OnXLab_exa_aida_OnX_2.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_26
IF NOT %obuild_group% == Python GOTO end_if_group_27
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnXLab_path%/examples/Python/OnXLab_exa_aida_OnX_3.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_27
IF NOT %obuild_group% == Python GOTO end_if_group_28
@IF %obuild_verbose% == yes @ECHO ON 
    python "%obuild_OnXLab_path%/examples/Python/OnXLab_exa_update.py"
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_28
IF NOT %obuild_group% == Java GOTO end_if_group_29
@IF %obuild_verbose% == yes @ECHO ON 
    java -classpath "%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab.jar;%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab_exa_Java_aida_0.jar" OnXLab_exa_Java_aida_0
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_29
IF NOT %obuild_group% == Java GOTO end_if_group_30
@IF %obuild_verbose% == yes @ECHO ON 
    java -classpath "%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab.jar;%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab_exa_Java_aida_13.jar" OnXLab_exa_Java_aida_13
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_30
IF NOT %obuild_group% == Java GOTO end_if_group_31
@IF %obuild_verbose% == yes @ECHO ON 
    java -classpath "%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab.jar;%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab_exa_Java_SLAC_Chi2FitToHistogram.jar" OnXLab_exa_Java_SLAC_Chi2FitToHistogram
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_31
IF NOT %obuild_group% == Java GOTO end_if_group_32
@IF %obuild_verbose% == yes @ECHO ON 
    java -classpath "%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab.jar;%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab_exa_Java_SLAC_Cloud.jar" OnXLab_exa_Java_SLAC_Cloud
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_32
IF NOT %obuild_group% == Java GOTO end_if_group_33
@IF %obuild_verbose% == yes @ECHO ON 
    java -classpath "%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab.jar;%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab_exa_Java_SLAC_CloudCreate.jar" OnXLab_exa_Java_SLAC_CloudCreate
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_33
IF NOT %obuild_group% == Java GOTO end_if_group_34
@IF %obuild_verbose% == yes @ECHO ON 
    java -classpath "%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab.jar;%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab_exa_Java_SLAC_ComplexFit.jar" OnXLab_exa_Java_SLAC_ComplexFit
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_34
IF NOT %obuild_group% == Java GOTO end_if_group_35
@IF %obuild_verbose% == yes @ECHO ON 
    java -classpath "%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab.jar;%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab_exa_Java_SLAC_CreateAndFitDataPointSet.jar" OnXLab_exa_Java_SLAC_CreateAndFitDataPointSet
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_35
IF NOT %obuild_group% == Java GOTO end_if_group_36
@IF %obuild_verbose% == yes @ECHO ON 
    java -classpath "%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab.jar;%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab_exa_Java_SLAC_DataPointSetCreateAndFill.jar" OnXLab_exa_Java_SLAC_DataPointSetCreateAndFill
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_36
IF NOT %obuild_group% == Java GOTO end_if_group_37
@IF %obuild_verbose% == yes @ECHO ON 
    java -classpath "%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab.jar;%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab_exa_Java_SLAC_DataPointSetCreateFromData.jar" OnXLab_exa_Java_SLAC_DataPointSetCreateFromData
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_37
IF NOT %obuild_group% == Java GOTO end_if_group_38
@IF %obuild_verbose% == yes @ECHO ON 
    java -classpath "%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab.jar;%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab_exa_Java_SLAC_FilterAndEvaluator.jar" OnXLab_exa_Java_SLAC_FilterAndEvaluator
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_38
IF NOT %obuild_group% == Java GOTO end_if_group_39
@IF %obuild_verbose% == yes @ECHO ON 
    java -classpath "%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab.jar;%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab_exa_Java_SLAC_Fit.jar" OnXLab_exa_Java_SLAC_Fit
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_39
IF NOT %obuild_group% == Java GOTO end_if_group_40
@IF %obuild_verbose% == yes @ECHO ON 
    java -classpath "%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab.jar;%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab_exa_Java_SLAC_Histogram.jar" OnXLab_exa_Java_SLAC_Histogram
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_40
IF NOT %obuild_group% == Java GOTO end_if_group_41
@IF %obuild_verbose% == yes @ECHO ON 
    java -classpath "%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab.jar;%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab_exa_Java_SLAC_HistogramArithmetic.jar" OnXLab_exa_Java_SLAC_HistogramArithmetic
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_41
IF NOT %obuild_group% == Java GOTO end_if_group_42
@IF %obuild_verbose% == yes @ECHO ON 
    java -classpath "%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab.jar;%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab_exa_Java_SLAC_Plot.jar" OnXLab_exa_Java_SLAC_Plot
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_42
IF NOT %obuild_group% == Java GOTO end_if_group_43
@IF %obuild_verbose% == yes @ECHO ON 
    java -classpath "%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab.jar;%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab_exa_Java_SLAC_ProfileCreate.jar" OnXLab_exa_Java_SLAC_ProfileCreate
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_43
IF NOT %obuild_group% == Java GOTO end_if_group_44
@IF %obuild_verbose% == yes @ECHO ON 
    java -classpath "%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab.jar;%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab_exa_Java_SLAC_ProfileFill.jar" OnXLab_exa_Java_SLAC_ProfileFill
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_44
IF NOT %obuild_group% == Java GOTO end_if_group_45
@IF %obuild_verbose% == yes @ECHO ON 
    java -classpath "%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab.jar;%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab_exa_Java_SLAC_ProfileFitAndPlot.jar" OnXLab_exa_Java_SLAC_ProfileFitAndPlot
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_45
IF NOT %obuild_group% == Java GOTO end_if_group_46
@IF %obuild_verbose% == yes @ECHO ON 
    java -classpath "%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab.jar;%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab_exa_Java_SLAC_Restore.jar" OnXLab_exa_Java_SLAC_Restore
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_46
IF NOT %obuild_group% == Java GOTO end_if_group_47
@IF %obuild_verbose% == yes @ECHO ON 
    java -classpath "%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab.jar;%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab_exa_Java_SLAC_ScanAndContour.jar" OnXLab_exa_Java_SLAC_ScanAndContour
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_47
IF NOT %obuild_group% == Java GOTO end_if_group_48
@IF %obuild_verbose% == yes @ECHO ON 
    java -classpath "%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab.jar;%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab_exa_Java_SLAC_SimpleFit.jar" OnXLab_exa_Java_SLAC_SimpleFit
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_48
IF NOT %obuild_group% == Java GOTO end_if_group_49
@IF %obuild_verbose% == yes @ECHO ON 
    java -classpath "%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab.jar;%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab_exa_Java_SLAC_Store.jar" OnXLab_exa_Java_SLAC_Store
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_49
IF NOT %obuild_group% == Java GOTO end_if_group_50
@IF %obuild_verbose% == yes @ECHO ON 
    java -classpath "%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab.jar;%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab_exa_Java_SLAC_Tree.jar" OnXLab_exa_Java_SLAC_Tree
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_50
IF NOT %obuild_group% == Java GOTO end_if_group_51
@IF %obuild_verbose% == yes @ECHO ON 
    java -classpath "%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab.jar;%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab_exa_Java_SLAC_Tuple.jar" OnXLab_exa_Java_SLAC_Tuple
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_51
IF NOT %obuild_group% == Java GOTO end_if_group_52
@IF %obuild_verbose% == yes @ECHO ON 
    java -classpath "%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab.jar;%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab_exa_Java_SLAC_TupleCreate.jar" OnXLab_exa_Java_SLAC_TupleCreate
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_52
IF NOT %obuild_group% == Java GOTO end_if_group_53
@IF %obuild_verbose% == yes @ECHO ON 
    java -classpath "%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab.jar;%obuild_OnXLab_path%\%obuild_dir_bin%/OnXLab_exa_Java_SLAC_createAndFillTupleWithComplexStructure.jar" OnXLab_exa_Java_SLAC_createAndFillTupleWithComplexStructure
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_group_53


cd "%obuild_pwd_OnXLab_0%"
SET obuild_pwd_OnXLab_0=
:obuild_return
ENDLOCAL
@ECHO ON
