#!/bin/csh -f

#
# File produced by the obuild tool version 1.0
# for the package OnXLab with version v1r2p0.
#

#////////////////////////////////////////////////
# Usage :
#   csh> source setup.csh
#////////////////////////////////////////////////

#set verbose  # uncomment this line to have full verbosity.

#////////////////////////////////////////////////
# Set the absolute path of this package.
# If in the below line there is the keyword :
#
#     @@absolute_dir@@
#
# then the package had not been installed.
#
#  Someone has to replace @@absolute_dir@@
# by the absolute path of the package.
# By "absolute path of the package", we mean that
# if the obuild directory of the package is 
# found under :
#    some_path/pack/vers/obuild
# then the "absolute path of the package" is :
#    some_path/pack/vers
#
#  This replacement can be done on the setup
# scripts of the package by using the sh/build 
# with the -i option.
#
#  This replacement can be done recursively
# on the setups of the used packages by using 
# the sh/build script with the -bci option 
# ("bci" for broadcast install).
#
#////////////////////////////////////////////////

set obuild_OnXLab_path="@@absolute_dir@@"


if ( "${obuild_OnXLab_path}" == '@@absolute_dir@@' ) then
  echo '  The package OnXLab had not been installed.'
  echo ''
  echo ' In the file :'
  echo '    OnXLab/<vers>/obuild/setup.csh'
  echo ' someone has to replace '
  echo '    @@absolute_dir@@'
  echo ' by the absolute path of the package.'
  echo '  By "absolute path of the package", we mean that'
  echo ' if the obuild directory of the package is found under :'
  echo '    some_path/pack/vers/obuild'
  echo ' then the "absolute path of the package" is :'
  echo '    some_path/pack/vers'
  echo ''
  echo '  If having the write access, this replacement can be done'
  echo ' on the setup scripts of the package by using the sh/build'
  echo ' with the -i option. This replacement can be done recursively'
  echo ' on the setups of the used packages by using the sh/build script'
  echo ' with the -bci option ("bci" for broadcast install).'
  echo ''
  exit
endif

if ( $?OBUILD_DIR_BIN ) then
  if (  "${OBUILD_DIR_BIN}" == "" ) then
    set obuild_dir_bin=bin_obuild
  else
    set obuild_dir_bin=${OBUILD_DIR_BIN}
  endif
else
  set obuild_dir_bin=bin_obuild
endif

if ( "${obuild_dir_bin}" == "" ) then
  echo "obuild_dir_bin variable not defined."
  exit
endif

/bin/mkdir -p "${obuild_OnXLab_path}/${obuild_dir_bin}"
if ( ! -e "${obuild_OnXLab_path}/${obuild_dir_bin}/obuild_platform" ) then
  if ( ! -e "${obuild_OnXLab_path}/obuild/cpp/obuild_platform.cpp" ) then
    echo "Program source obuild_platform.cpp not found."
    exit
  endif
  if ( $?obuild_cxx_command ) then
    if ( "${obuild_cxx_command}" == "" ) then
      if (  $?OBUILD_CXX ) then
        set obuild_platform_compiler=${OBUILD_CXX}
      else
        set obuild_platform_compiler=c++
      endif
    else
      set obuild_platform_compiler=${obuild_cxx_command}
    endif
  else
    set obuild_platform_compiler=c++
  endif
  ${obuild_platform_compiler} -o "${obuild_OnXLab_path}/${obuild_dir_bin}/obuild_platform" "${obuild_OnXLab_path}/obuild/cpp/obuild_platform.cpp"
  unset obuild_platform_compiler
  if ( ! -e "${obuild_OnXLab_path}/${obuild_dir_bin}/obuild_platform" ) then
    echo "Program obuild_platform not found."
    exit
  endif
endif
set obuild_platform_exe="${obuild_OnXLab_path}/${obuild_dir_bin}/obuild_platform"
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if ( ${obuild_platform_result} == yes ) then
set Python_home="/Library/Frameworks/Python.framework"
endif
unset obuild_platform_result
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Python_home="/usr/local/Python/2.5.1"
endif
unset obuild_platform_result
if ( $?OBUILD_SITE ) then
if ( "${OBUILD_SITE}" == "lxplus_slc4_ia32_gcc34" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Python_home="/afs/cern.ch/sw/lcg/external/Python/2.5/slc4_ia32_gcc34"
endif
unset obuild_platform_result
endif
endif
if ( $?OBUILD_SITE ) then
if ( "${OBUILD_SITE}" == "lxplus_slc4_amd64_gcc34" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Python_home="/afs/cern.ch/sw/lcg/external/Python/2.5/slc4_amd64_gcc34"
endif
unset obuild_platform_result
endif
endif
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Python_vers="2.5"
endif
unset obuild_platform_result
if ( $?OBUILD_SITE ) then
if ( "${OBUILD_SITE}" == "lxplus_slc4_ia32_gcc34" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Python_vers="2.5"
endif
unset obuild_platform_result
endif
endif
if ( $?OBUILD_SITE ) then
if ( "${OBUILD_SITE}" == "lxplus_slc4_amd64_gcc34" ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set Python_vers="2.5"
endif
unset obuild_platform_result
endif
endif
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'OSF1'`
if ( ${obuild_platform_result} == yes ) then
set Python_home="/usr/local/Python/2.3.4"
endif
unset obuild_platform_result
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if ( ${obuild_platform_result} == yes ) then
set JavaVM_home="/System/Library/Frameworks/JavaVM.framework"
endif
unset obuild_platform_result
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
set JavaVM_home="/opt/jdk1.5.0_07"
endif
unset obuild_platform_result
/bin/mkdir -p "${obuild_OnXLab_path}/${obuild_dir_bin}"
if ( ! -e "${obuild_OnXLab_path}/${obuild_dir_bin}/obuild_find" ) then
  if ( ! -e "${obuild_OnXLab_path}/obuild/cpp/obuild_find.cpp" ) then
    echo "Program source obuild_find.cpp not found."
    exit
  endif
  if ( $?obuild_cxx_command ) then
    if ( "${obuild_cxx_command}" == "" ) then
      if (  $?OBUILD_CXX ) then
        set obuild_find_compiler=${OBUILD_CXX}
      else
        set obuild_find_compiler=c++
      endif
    else
      set obuild_find_compiler=${obuild_cxx_command}
    endif
  else
    set obuild_find_compiler=c++
  endif
  ${obuild_find_compiler} -o "${obuild_OnXLab_path}/${obuild_dir_bin}/obuild_find" "${obuild_OnXLab_path}/obuild/cpp/obuild_find.cpp"
  unset obuild_find_compiler
  if ( ! -e "${obuild_OnXLab_path}/${obuild_dir_bin}/obuild_find" ) then
    echo "Program obuild_find not found."
    exit
  endif
endif
set obuild_find_exe="${obuild_OnXLab_path}/${obuild_dir_bin}/obuild_find"
if ( "${obuild_find_exe}" == "" ) then
  echo "Variable obuild_find_exe not defined."
  exit
endif
set obuild_AIDA_path=`"${obuild_find_exe}" AIDA 'v3r2p1'`

if ( "${obuild_find_exe}" == "" ) then
  echo "Variable obuild_find_exe not defined."
  exit
endif
set obuild_OnX_path=`"${obuild_find_exe}" OnX 'v17r*'`
if ( "${obuild_find_exe}" == "" ) then
  echo "Variable obuild_find_exe not defined."
  exit
endif
set obuild_BatchLab_path=`"${obuild_find_exe}" BatchLab 'v1r*'`

# Execute setup of used packages :
source "${obuild_OnX_path}/obuild/setup.csh"

source "${obuild_BatchLab_path}/obuild/setup.csh"

# Set environment variables of this package :
setenv ONXLABROOT "${obuild_OnXLab_path}"

  if (  $?PYTHONPATH ) then
    setenv PYTHONPATH "${PYTHONPATH}:${obuild_OnXLab_path}/scripts/Python"
  else
    setenv PYTHONPATH "${obuild_OnXLab_path}/scripts/Python"
  endif

  if (  $?PYTHONPATH ) then
    setenv PYTHONPATH "${PYTHONPATH}:${obuild_OnXLab_path}/${obuild_dir_bin}"
  else
    setenv PYTHONPATH "${obuild_OnXLab_path}/${obuild_dir_bin}"
  endif

  if (  $?CLASSPATH ) then
    setenv CLASSPATH "${CLASSPATH}:${obuild_OnXLab_path}/${obuild_dir_bin}/OnXLab.jar"
  else
    setenv CLASSPATH "${obuild_OnXLab_path}/${obuild_dir_bin}/OnXLab.jar"
  endif

if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if ( ${obuild_platform_result} == yes ) then
  if (  $?DYLD_LIBRARY_PATH ) then
    setenv DYLD_LIBRARY_PATH "${DYLD_LIBRARY_PATH}:${obuild_OnXLab_path}/${obuild_dir_bin}"
  else
    setenv DYLD_LIBRARY_PATH "${obuild_OnXLab_path}/${obuild_dir_bin}"
  endif
else
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'CYGWIN'`
if ( ${obuild_platform_result} == yes ) then
if (  $?PATH ) then
  setenv PATH "${PATH}:${obuild_OnXLab_path}/${obuild_dir_bin}"
else
  setenv PATH "${obuild_OnXLab_path}/${obuild_dir_bin}"
endif

else
  if (  $?LD_LIBRARY_PATH ) then
    setenv LD_LIBRARY_PATH "${LD_LIBRARY_PATH}:${obuild_OnXLab_path}/${obuild_dir_bin}"
  else
    setenv LD_LIBRARY_PATH "${obuild_OnXLab_path}/${obuild_dir_bin}"
  endif
endif
unset obuild_platform_result
endif
unset obuild_platform_result

if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if ( ${obuild_platform_result} == yes ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
  if (  $?DYLD_LIBRARY_PATH ) then
    setenv DYLD_LIBRARY_PATH "${DYLD_LIBRARY_PATH}:${JavaVM_home}/jre/lib/i386"
  else
    setenv DYLD_LIBRARY_PATH "${JavaVM_home}/jre/lib/i386"
  endif
endif
unset obuild_platform_result
else
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'CYGWIN'`
if ( ${obuild_platform_result} == yes ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
if (  $?PATH ) then
  setenv PATH "${PATH}:${JavaVM_home}/jre/lib/i386"
else
  setenv PATH "${JavaVM_home}/jre/lib/i386"
endif

endif
unset obuild_platform_result
else
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
  if (  $?LD_LIBRARY_PATH ) then
    setenv LD_LIBRARY_PATH "${LD_LIBRARY_PATH}:${JavaVM_home}/jre/lib/i386"
  else
    setenv LD_LIBRARY_PATH "${JavaVM_home}/jre/lib/i386"
  endif
endif
unset obuild_platform_result
endif
unset obuild_platform_result
endif
unset obuild_platform_result

if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if ( ${obuild_platform_result} == yes ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
  if (  $?DYLD_LIBRARY_PATH ) then
    setenv DYLD_LIBRARY_PATH "${DYLD_LIBRARY_PATH}:${JavaVM_home}/jre/lib/i386/client"
  else
    setenv DYLD_LIBRARY_PATH "${JavaVM_home}/jre/lib/i386/client"
  endif
endif
unset obuild_platform_result
else
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'CYGWIN'`
if ( ${obuild_platform_result} == yes ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
if (  $?PATH ) then
  setenv PATH "${PATH}:${JavaVM_home}/jre/lib/i386/client"
else
  setenv PATH "${JavaVM_home}/jre/lib/i386/client"
endif

endif
unset obuild_platform_result
else
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
  if (  $?LD_LIBRARY_PATH ) then
    setenv LD_LIBRARY_PATH "${LD_LIBRARY_PATH}:${JavaVM_home}/jre/lib/i386/client"
  else
    setenv LD_LIBRARY_PATH "${JavaVM_home}/jre/lib/i386/client"
  endif
endif
unset obuild_platform_result
endif
unset obuild_platform_result
endif
unset obuild_platform_result

if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Darwin'`
if ( ${obuild_platform_result} == yes ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
  if (  $?DYLD_LIBRARY_PATH ) then
    setenv DYLD_LIBRARY_PATH "${DYLD_LIBRARY_PATH}:${JavaVM_home}/jre/lib/i386/native_threads"
  else
    setenv DYLD_LIBRARY_PATH "${JavaVM_home}/jre/lib/i386/native_threads"
  endif
endif
unset obuild_platform_result
else
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'CYGWIN'`
if ( ${obuild_platform_result} == yes ) then
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
if (  $?PATH ) then
  setenv PATH "${PATH}:${JavaVM_home}/jre/lib/i386/native_threads"
else
  setenv PATH "${JavaVM_home}/jre/lib/i386/native_threads"
endif

endif
unset obuild_platform_result
else
if ( "${obuild_platform_exe}" == "" ) then
  echo "Variable obuild_platform_exe not defined."
  exit
endif
set obuild_platform_result=`"${obuild_platform_exe}" 'Linux'`
if ( ${obuild_platform_result} == yes ) then
  if (  $?LD_LIBRARY_PATH ) then
    setenv LD_LIBRARY_PATH "${LD_LIBRARY_PATH}:${JavaVM_home}/jre/lib/i386/native_threads"
  else
    setenv LD_LIBRARY_PATH "${JavaVM_home}/jre/lib/i386/native_threads"
  endif
endif
unset obuild_platform_result
endif
unset obuild_platform_result
endif
unset obuild_platform_result

if (  $?PATH ) then
  setenv PATH "${PATH}:${obuild_OnXLab_path}/${obuild_dir_bin}"
else
  setenv PATH "${obuild_OnXLab_path}/${obuild_dir_bin}"
endif

unset obuild_OnXLab_path

#FIXME unset obuild_dir_bin
