#ifndef OnXLab_Accessors_h
#define OnXLab_Accessors_h

// Inheritance :
#include <Lib/BaseAccessor.h>
#include <Slash/Data/IVisualizer.h>

namespace Slash {namespace Core {class ISession;}}

namespace OnXLab {

class Bin1D_Accessor : public Lib::BaseAccessor {
public:
  Bin1D_Accessor(Slash::Core::ISession&);
  virtual ~Bin1D_Accessor();
public: //Slash::Data::IAccessor
  virtual std::string name() const;
  virtual Slash::Data::IIterator* iterator();
  virtual Slash::Core::IValue* findValue(Slash::Data::IAccessor::Data,const std::string&,void*);
private:
  Slash::Core::ISession& fSession;
  std::string fName;
};

class Bin2D_Accessor : public Lib::BaseAccessor {
public:
  Bin2D_Accessor(Slash::Core::ISession&);
  virtual ~Bin2D_Accessor();
public: //Slash::Data::IAccessor
  virtual std::string name() const;
  virtual Slash::Data::IIterator* iterator();
  virtual Slash::Core::IValue* findValue(Slash::Data::IAccessor::Data,const std::string&,void*);
private:
  Slash::Core::ISession& fSession;
  std::string fName;
};

class ManagedObjectAccessor
:public Lib::BaseAccessor
,public virtual Slash::Data::IVisualizer {
public:
  ManagedObjectAccessor(Slash::Core::ISession&);
  virtual ~ManagedObjectAccessor();
public: //Slash::Data::IAccessor
  virtual std::string name() const;
  virtual Slash::Data::IIterator* iterator();
  virtual Slash::Core::IValue* findValue(Slash::Data::IAccessor::Data,const std::string&,void*);
public: //Slash::Data::IVisualizer
  virtual void beginVisualize();
  virtual void visualize(Slash::Data::IAccessor::Data,void*);
  virtual void endVisualize();
private:
  Slash::Core::ISession& fSession;
  std::string fName;
};

class FunctionAccessor
:public Lib::BaseAccessor
,public virtual Slash::Data::IVisualizer {
public:
  FunctionAccessor(Slash::Core::ISession&);
  virtual ~FunctionAccessor();
public: //Slash::Data::IAccessor
  virtual std::string name() const;
  virtual Slash::Data::IIterator* iterator();
  virtual Slash::Core::IValue* findValue(Slash::Data::IAccessor::Data,const std::string&,void*);
public: //Slash::Data::IVisualizer
  virtual void beginVisualize();
  virtual void visualize(Slash::Data::IAccessor::Data,void*);
  virtual void endVisualize();
private:
  Slash::Core::ISession& fSession;
  std::string fName;
};

}

#endif
