
#include <OnXLab/Core/Main.h>

extern "C" {

//////////////////////////////////////////////////////////////////////////////
AIDA::IAnalysisFactory* AIDA_createAnalysisFactory(
#if (AIDA_VERSION_MAJOR<=3) && (AIDA_VERSION_MINOR<=2) 
#else
 const std::string& //aOptions
#endif
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  //We do not create the UI now. Delegated to the plotter factory.
  OnXLab::Main* aida = new OnXLab::Main(false,false);
  if(!aida->isValid()) {
    delete aida;
    return 0;
  }
  return aida;
}

}

#include <OnXLab/Core/PlotterMain.h>

extern "C" {

//////////////////////////////////////////////////////////////////////////////
AIDA::IPlotterFactory* AIDA_createPlotterFactory(
 int aArgc
,char** aArgv
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  OnXLab::PlotterMain* pf = new OnXLab::PlotterMain(aArgc,aArgv);
  if(!pf->isValid()) {
    delete pf;
    return 0;
  }
  return pf;
}
// Backward compatibility :
//////////////////////////////////////////////////////////////////////////////
AIDA::IPlotterFactory* OnXLab_createPlotterFactory(
 int aArgc
,char** aArgv
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return AIDA_createPlotterFactory(aArgc,aArgv);
}

}


