// this :
#include <OnXLab/Core/AnalysisFactory.h>

// Lib :
#include <Lib/Debug.h>
#include <Lib/Cast.h>

// AIDA :
#include <AIDA/IPlotterFactory.h>

// OnXLab :
#include <OnXLab/Core/TreeFactory.h>
#include <OnXLab/Core/PlotterFactory.h>

//////////////////////////////////////////////////////////////////////////////
OnXLab::AnalysisFactory::AnalysisFactory(
 Slash::Core::ISession& aSession
)
:BatchLab::AnalysisFactory(aSession)
//,fName("AnalysisFactory")
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Debug::increment("OnXLab::AnalysisFactory");
}
//////////////////////////////////////////////////////////////////////////////
OnXLab::AnalysisFactory::~AnalysisFactory(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Debug::decrement("OnXLab::AnalysisFactory");
}
//////////////////////////////////////////////////////////////////////////////
void* OnXLab::AnalysisFactory::cast(
 const std::string& aClass
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if_Lib_SCast(OnXLab::AnalysisFactory)
  else return BatchLab::AnalysisFactory::cast(aClass);
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
AIDA::ITreeFactory* OnXLab::AnalysisFactory::createTreeFactory(
#if (AIDA_VERSION_MAJOR<=3) && (AIDA_VERSION_MINOR<=2) 
#else
 const std::string& //aOptions
#endif
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return new OnXLab::TreeFactory(fSession);
}
//////////////////////////////////////////////////////////////////////////////
AIDA::IPlotterFactory* OnXLab::AnalysisFactory::createPlotterFactory(
 int aArgc
,char** aArgv
,const std::string& aImplementation
,const std::string& aLibrary
#if (AIDA_VERSION_MAJOR<=3) && (AIDA_VERSION_MINOR<=2) 
#else
,const std::string& //aOptions
#endif
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if( (aImplementation!="") && (aLibrary!="") ) {
    return BatchLab::AnalysisFactory::createPlotterFactory
             (aArgc,aArgv,aImplementation,aLibrary);
  } else {
    return new OnXLab::PlotterFactory
      (fSession,aImplementation,aLibrary,aArgc,aArgv);
  }
}
