// this :
#include <OnXLab/Core/PlotterMain.h>

#include <OnXLab/Core/Main.h>

//////////////////////////////////////////////////////////////////////////////
OnXLab::PlotterMain::PlotterMain(
 int aArgc
,char** aArgv
)
:fAIDA(0)
,fPlotterFactory(0) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::vector<std::string> args;
  for(int index=0;index<aArgc;index++) args.push_back(aArgv[index]);
  fAIDA = new OnXLab::Main(false,false,args);
  if(!fAIDA->isValid()) {
    delete fAIDA;
    fAIDA = 0;
    return;
  }
/*
  if(!fAIDA->createUI()) { //Will load from ONXLABPLOTTER env variable.
    delete fAIDA;
    fAIDA = 0;
    return;
  }
*/
  fPlotterFactory = fAIDA->createPlotterFactory(aArgc,aArgv,"","");
  if(!fPlotterFactory) {
    delete fAIDA;
    fAIDA = 0;
    return;
  }
}
//////////////////////////////////////////////////////////////////////////////
OnXLab::PlotterMain::~PlotterMain(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  delete fPlotterFactory;
  delete fAIDA;
}
//////////////////////////////////////////////////////////////////////////////
bool OnXLab::PlotterMain::isValid(
) const 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
  return (fPlotterFactory?true:false);
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
AIDA::IPlotter* OnXLab::PlotterMain::create(
 const std::string& aName
#if (AIDA_VERSION_MAJOR<=3) && (AIDA_VERSION_MINOR<=2) 
#else
,const std::string& //aOptions
#endif
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!fPlotterFactory) return 0;
  return fPlotterFactory->create(aName);
}
//////////////////////////////////////////////////////////////////////////////
AIDA::IMarkerStyle* OnXLab::PlotterMain::createMarkerStyle(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!fPlotterFactory) return 0;
  return fPlotterFactory->createMarkerStyle();
}
//////////////////////////////////////////////////////////////////////////////
AIDA::ITextStyle* OnXLab::PlotterMain::createTextStyle(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!fPlotterFactory) return 0;
  return fPlotterFactory->createTextStyle();
}
//////////////////////////////////////////////////////////////////////////////
AIDA::ILineStyle* OnXLab::PlotterMain::createLineStyle(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!fPlotterFactory) return 0;
  return fPlotterFactory->createLineStyle();
}
//////////////////////////////////////////////////////////////////////////////
AIDA::IFillStyle* OnXLab::PlotterMain::createFillStyle(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!fPlotterFactory) return 0;
  return fPlotterFactory->createFillStyle();
}
//////////////////////////////////////////////////////////////////////////////
AIDA::IDataStyle* OnXLab::PlotterMain::createDataStyle(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!fPlotterFactory) return 0;
  return fPlotterFactory->createDataStyle();
}
//////////////////////////////////////////////////////////////////////////////
AIDA::IAxisStyle* OnXLab::PlotterMain::createAxisStyle(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!fPlotterFactory) return 0;
  return fPlotterFactory->createAxisStyle();
}
//////////////////////////////////////////////////////////////////////////////
AIDA::ITitleStyle* OnXLab::PlotterMain::createTitleStyle(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!fPlotterFactory) return 0;
  return fPlotterFactory->createTitleStyle();
}
//////////////////////////////////////////////////////////////////////////////
AIDA::IPlotterStyle* OnXLab::PlotterMain::createPlotterStyle(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!fPlotterFactory) return 0;
  return fPlotterFactory->createPlotterStyle();
}
