#ifndef Random_h
#define Random_h 1

#include <cstdlib>
#include <ctime>

#ifdef WIN32
typedef unsigned __int64 ulonglong;
typedef __int64 longlong;
#else
typedef unsigned long long ulonglong;
typedef long long longlong;
#endif

class Random {

    private:
        ulonglong seed;
        const ulonglong multiplier;
        const ulonglong addend;
        const ulonglong mask;
        const int BITS_PER_BYTE;
        const int BYTES_PER_INT;
        double nextNextGaussian;
        bool haveNextNextGaussian;

    protected:
        int next(int bits);

    public:
        Random(ulonglong seed = time(NULL));
        void setSeed(ulonglong seed);
        void nextBytes(unsigned char bytes[], int length);
        int nextInt();
        int nextInt(int n);
        longlong nextLong();
        bool nextBoolean();
        float nextFloat();
        double nextDouble();
        double nextGaussian();
};

#endif
