extern "C" {
  void hisdef_();
  void fundef_();
  void ntudef_();
  void gradef_();
  void picdef_();
  void obsdef_();
  void zebdef_();
  void fordef_();
  void netdef_();
  void pvedef_();

  // VECTOR :
  void vecdef_();
  int vector_create_C(void*);
  int vector_delete_C(void*);
  int vector_read_C(void*);
  int vector_write_C(void*);
  int vector_input_C(void*);
  int vector_list_C(void*);
  int vector_operation_C(void*);
  int vector_print_C(void*);
  int vector_find_C(const char*,void*);
  int vector_value_C(const char*,double*,void*);

  //SIGMA :
  extern "C" {
    int sigma_C(const char*,void*);
  }

  //dummies :
  void bugreprt_(void*);
  void mergin_(void*);
  void pafeyn_(void*);
  void pahfit_(void*);
  void palint_(void*);
  void paobs_(void*);
  void papiaf_(void*);
  void pavercmd_(void*);
  void pawork_(void*);
  void pawuwf_(void*);
  void pazdz_(void*);
  void pazfz_(void*);
  void pchain_(void*);
  void pvmem_(void*);
  void qpflags_(void*);
  void rlogin_(void*);
  void rshell_(void*);
  void pahelp_(void*);
}

#include <kuip/ksys.h>
#include <kuip/kfor.h>
#include <kuip/kuser.h>
#include <kuip/klink.h>

extern "C" {
  void Kufdef(const char*,const char*,const char*,const char*,
              SUBRPTR,int,int,int,int);
}

#include <Slash/Core/ISession.h>
#include <Slash/Core/IWriter.h>

#include <Lib/Out.h>
#include <Lib/Manager.h>
#include <Lib/smanip.h>
#include <Lib/sout.h>
#include <Lib/Cast.h>
#include <Lib/FString.h>
#include <Lib/Arguments.h>

#include <OnX/Helpers/OnX.h>
#include <OnX/Helpers/UI.h>
#include <OnX/Helpers/Inventor.h>
#include <OnX/Version.h>

#include <BatchLab/Helpers/AIDA.h>

#include <OnXLab/Version.h> //Sole compilation relationship to OnXLab !

#include <OpenPAW/Version.h>
#include <OpenPAW/PAW_Manager.h>

extern "C" {
  void HBOOK_Initialize(Slash::Core::ISession&);
  void HBOOK_Finalize(Slash::Core::ISession&);
}

extern "C" {
  void OpenPAWInitialize(Slash::Core::ISession&);
  void OpenPAWFinalize(Slash::Core::ISession&);
}

//////////////////////////////////////////////////////////////////////////////
static void HPLQSE(
 void* aCHOPT
,float* aR
,int aLenCHOPT
,void* aSession
) 
//////////////////////////////////////////////////////////////////////////////
// Fortran signature is :
//      SUBROUTINE HPLQSE(CHOPT,R)
//      CHARACTER*(*) CHOPT
//      CHARACTER*8   CHOPTN
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Slash::Core::ISession* session = (Slash::Core::ISession*)aSession;
  OpenPAW::PAW_Manager* pawManager = find_PAW(*session);
  if(!pawManager) return;
  ATTs_type& atts = pawManager->atts();

  Lib::FString CHOPT(aCHOPT,aLenCHOPT);
  std::string sCHOPT = CHOPT.std_string();
  if(!sCHOPT.size()) return;
  Lib::smanip::strip(sCHOPT);
  if(sCHOPT[0]=='?') {
    *aR = (float)atts.value(sCHOPT.substr(1,sCHOPT.size()-1)); 
  } else {
    atts.setValue(sCHOPT,(double)*aR);
  }
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
void OpenPAWInitialize(
 Slash::Core::ISession& aSession
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  OpenPAW::PAW_Manager* pawManager = 
    Lib_findManager(aSession,"PAW_Manager",OpenPAW::PAW_Manager);
  if(!pawManager) {
    pawManager = new OpenPAW::PAW_Manager(aSession);
    aSession.addManager(pawManager);
  }

  Slash::Core::IWriter& printer = aSession.printer();

  hisdef_();
  fundef_();
  ntudef_();
  gradef_();
  picdef_();
  obsdef_();
  zebdef_();
  fordef_();
  netdef_();
  pvedef_();

  // VECTOR :
  vecdef_();
  ku_xvcreate(vector_create_C); 
  ku_xvdelete(vector_delete_C); 
  ku_xvread(vector_read_C); 
  ku_xvwrite(vector_write_C); 
  ku_xvinput(vector_input_C); 
  ku_xvlist(vector_list_C); 
  ku_xvoperation(vector_operation_C); 
  ku_xvprint(vector_print_C); 
  ku_xvfind(vector_find_C); 
  ku_xvvalue(vector_value_C); 

  //SIGMA 
  ku_sigm(sigma_C);

  //PAW KUFDEFs found in CERNLIB/src/pawlib/paw/code/pawdef.F.
  std::string arg1 = "$GRAFINFO('attr')";
  std::string arg2 = "HPLOT/HIGZ attributes (see HELP SET for valid names)";
  std::string arg3 = "x=$GRAFINFO(u)";
  std::string arg4 = "-=HPLQSE(u,x)";
  Kufdef(arg1.c_str(),arg2.c_str(),arg3.c_str(),arg4.c_str(),
         (SUBRPTR)HPLQSE,
         arg1.size(),arg2.size(),arg3.size(),arg4.size());

  Lib::Out out(printer);
 
  std::string line_version("Version ");
  line_version += std::string(OPENPAW_VERSION);
  Lib::smanip::justify(line_version,52,Lib::smanip::middle);
  //        0        1         2         3         4         5   
  //        1234567890123456789012345678901234567890123456789012
  out << " ******************************************************"<<Lib::endl;
  out << " *                                                    *"<<Lib::endl;
  out << " *    W E L C O M E  to  O p e n P A W                *"<<Lib::endl;
  out << " *                                                    *"<<Lib::endl;
  out << " *" << line_version                              << "*"<<Lib::endl;
  out << " *                                                    *"<<Lib::endl;
  out << " ******************************************************"<<Lib::endl;
  out << " Version " << ONXLAB_VERSION << " of OnXLab started" << Lib::endl;
  out << " Version " << ONX_VERSION << " of OnX started" << Lib::endl;

  //FIXME : have to do the below with AIDA.
  Slash::UI::IUI* ui = Lib_findUI(aSession);
  if(ui) {
    Slash::UI::ISoViewer* soViewer = ui_SoViewer(*ui);
    if(soViewer) {
      soViewer->setDecoration(false);
      soViewer->setViewing(false);
    }
    // Add KUIP in the console interpreters.
    ui_add_prompt(*ui,"KUIP",false);
    // Do the below here, so that a -kumac_file can override
    // the global title.
    ui->executeScript("DLD","OnX page_setParameter title OpenPAW");
  }

  AIDA::IAnalysisFactory* aida = find_aida(aSession);
  if(!aida) return;

  AIDA::IPlotter* plotter = create_plotter(*aida);
  if(plotter) {
    plotter->setTitle("");
    pawManager->setPlotterZONE(*plotter);
    delete plotter;
  }

  HBOOK_Initialize(aSession);

  // Execute, if any, .kumac passed in argument :
  // Example :
  //   OS> opaw my.kumac
 {Lib::Arguments args(aSession.arguments());
  std::string file;
  if(args.find("-kumac_file",file) && file.size()) {
    // Execute with ui (and not directly with the ScriptManager) 
    // in order to have the "bg". It is needed to have the
    // PS production from a -kumac_file working.
    if(ui) {
      ui->executeScript("KUIP bg",file);
    }
  /*Slash::UI::IScriptManager* sm = 
      Lib_findManager(aSession,"ScriptManager",Slash::UI::IScriptManager);
    if(!sm) {
      out << "OpenPAWInitialize :"
          << " ScriptManager not found." 
          << " can't execute " << Lib::sout(file)
          << Lib::endl;
    } else {
      sm->executeScript("KUIP",file);
    }*/
  }}

}
//////////////////////////////////////////////////////////////////////////////
void OpenPAWFinalize(
 Slash::Core::ISession& aSession
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Slash::Core::IWriter& printer = aSession.printer();
  Lib::Out out(printer);

  out << " Exiting from OpenPAW." << Lib::endl;

  HBOOK_Finalize(aSession);

  aSession.destroyManager("PAW_Manager");
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
void dummy(
 const std::string& aFunction
,void* aSession
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Slash::Core::ISession* session = (Slash::Core::ISession*)aSession;

  Slash::Core::IWriter& printer = session->printer();
  Lib::Out out(printer);

  std::string cmd_path = ku_path() ? ku_path() : "";
  //std::string cmd_name = ku_name();

  out << aFunction << " :" 
      << " " << cmd_path << " : dummy." << Lib::endl;
}
void bugreprt_(void* aSession) { dummy("bugreprt",aSession);}
void mergin_(void* aSession) { dummy("mergin",aSession);}
void pafeyn_(void* aSession) { dummy("pafeyn",aSession);}
void pahfit_(void* aSession) { dummy("pahfit",aSession);}
void palint_(void* aSession) { dummy("palint",aSession);}
void paobs_(void* aSession) { dummy("paobs",aSession);}
void papiaf_(void* aSession) { dummy("papiaf",aSession);}
void pavercmd_(void* aSession) { dummy("pavercmd",aSession);}
void pawork_(void* aSession) { dummy("pawork",aSession);}
void pawuwf_(void* aSession) { dummy("pawuwf",aSession);}
void pazdz_(void* aSession) { dummy("pazdz",aSession);}
void pazfz_(void* aSession) { dummy("pazfz",aSession);}
void pchain_(void* aSession) { dummy("pchain",aSession);}
void pvmem_(void* aSession) { dummy("pvmem",aSession);}
void qpflags_(void* aSession) { dummy("qpflags",aSession);}
void rlogin_(void* aSession) { dummy("rlogin",aSession);}
void rshell_(void* aSession) { dummy("rshell",aSession);}
void pahelp_(void* aSession) { dummy("pahelp",aSession);}
