extern "C" {
  void pancut_(void*);
}

#include <kuip/ksys.h>
#include <kuip/kfor.h>
#include <kuip/kuser.h>
#include <kuip/klink.h>

#include <Slash/Core/ISession.h>
#include <Slash/Core/IWriter.h>
#include <Lib/Out.h>
#include <Lib/sout.h>
#include <Lib/smanip.h>
#include <Lib/Manager.h>

#include <BatchLab/Helpers/AIDA.h>

#include <OpenPAW/PAW_Manager.h>

//////////////////////////////////////////////////////////////////////////////
void pancut_(
 void* aSession
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
  Slash::Core::ISession* session = (Slash::Core::ISession*)aSession;

  Slash::Core::IWriter& printer = session->printer();
  Lib::Out out(printer);

  std::string cmd_path = ku_path() ? ku_path() : "";
  //std::string cmd_name = ku_name();
  if(session->verboseLevel()) {
    out << "pancut :" 
        << " execute " << Lib::sout(cmd_path) 
        << Lib::endl;
  }

  OpenPAW::PAW_Manager* pawManager = find_PAW(*session);
  if(!pawManager) return;

  AIDA::IAnalysisFactory* aida = find_aida(*session);
  if(!aida) return;

  AIDA::ITree* memoryTree = find_memoryTree(*aida);
  if(!memoryTree) return;

  Lib::Parameters<int,std::string>& cuts = pawManager->cuts();

  if(cmd_path=="/NTUPLE/CUTS") {

    std::string CUTID = ku_gets();
    std::string OPTION = ku_gets();
    /*std::string FNAME = */ku_gets();
    /*int WKID = */ku_geti();

    if(!CUTID.size()) return;
    std::string scutid = CUTID;
    if(CUTID[0]=='$') {
      scutid = CUTID.substr(1,CUTID.size()-1);
    }
    int cutid;
    if(!Lib::smanip::toint(scutid,cutid)) { //Syntax error.
      out << "pancut :" 
          << " Syntax error in " << Lib::sout(CUTID) 
          << Lib::endl;
      return;
    }

    std::string CHOPT = OPTION;
    Lib::smanip::touppercase(CHOPT);
    if(CHOPT=="P") {
      out << "pancut :" 
          << " /NTUPLE/CUTS :"
          << " P is a valid option, but not yet supported in OpenPAW." 
          << Lib::endl;
    } else if(CHOPT=="-") {
      out << "pancut :" 
          << " /NTUPLE/CUTS :"
          << " - is a valid option, but not yet supported in OpenPAW." 
          << Lib::endl;
    } else if(CHOPT=="R") {
      out << "pancut :" 
          << " /NTUPLE/CUTS :"
          << " R is a valid option, but not yet supported in OpenPAW." 
          << Lib::endl;
    } else if(CHOPT=="W") {
      out << "pancut :" 
          << " /NTUPLE/CUTS :"
          << " W is a valid option, but not yet supported in OpenPAW." 
          << Lib::endl;
    } else if(CHOPT=="D") {
      out << "pancut :" 
          << " /NTUPLE/CUTS :"
          << " D is a valid option, but not yet supported in OpenPAW." 
          << Lib::endl;
    } else {

      if(cuts.isKey(cutid)) {
        out << "pancut :" 
            << " CUTID " << CUTID << " already in used by OpenPAW." 
            << Lib::endl;
        return;
      }

      cuts.add(cutid,"",OPTION,"","");

    }

  } else {
    out << "pancut :" 
        << " " << cmd_path << " : dummy." << Lib::endl;

  }
}
