@ECHO OFF
SETLOCAL

REM #
REM # File produced by the obuild tool version 1.0
REM # for the package OpenPAW with version v3r2p0.
REM #

REM #////////////////////////////////////////////////
REM # Usage :
REM #   DOS> CD some_path\pack\version\obuild
REM #   DOS> DOS\run
REM # or :
REM #   DOS> call DOS\run.bat
REM #
REM #////////////////////////////////////////////////

REM #////////////////////////////////////////////////
REM #/// Get path of this file :
REM #////////////////////////////////////////////////
SET obuild_OpenPAW_path=%~dp0
REM # Remove ending \obuild\DOS\
SET obuild_OpenPAW_path=%obuild_OpenPAW_path:~0,-12%

SET obuild_verbose=no
SET obuild_set_x=no
SET obuild_do_mains=yes
SET obuild_group=main

REM #////////////////////////////////////////////////
REM #/// Treat arguments :
REM #////////////////////////////////////////////////

:next_arg
IF "%1%" == "" GOTO end_args

IF NOT "%1%" == "-h" GOTO end_if_h
  ECHO Usage :
  ECHO   DOS\run [Options]
  ECHO Options :
  ECHO   -v : verbose.
  ECHO   -x : execute with ECHO ON"
  ECHO   -nm : build the not-main components.
  ECHO   -group group : build the given group of components.
  GOTO obuild_return
:end_if_h

IF NOT "%1%" == "-v" GOTO end_if_v
  SET obuild_verbose=yes
  SHIFT
  GOTO next_arg
:end_if_v

IF NOT "%1%" == "-x" GOTO end_if_x
  SET obuild_set_x=yes
  SHIFT
  GOTO next_arg
:end_if_x

IF NOT "%1%" == "-nm" GOTO end_if_nm
  SET obuild_do_mains=no
  SHIFT
  GOTO next_arg
:end_if_nm

IF NOT "%1%" == "-group" GOTO end_if_group
  SHIFT
  SET obuild_group=%1%
  SHIFT
  GOTO next_arg
:end_if_group

:end_args

REM #////////////////////////////////////////////////
REM #/// End arguments.
REM #////////////////////////////////////////////////

IF %obuild_set_x% == yes ECHO ON

IF "%OBUILD_DIR_BIN%" == "" (
  SET obuild_dir_bin=bin_obuild
) ELSE (
  SET obuild_dir_bin=%OBUILD_DIR_BIN%
)

IF "%obuild_dir_bin%" == "" (
  ECHO obuild_dir_bin variable not defined.
  GOTO obuild_return
)

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenPAW_0=%%d
IF NOT %obuild_group% == main GOTO end_if_group_0
  IF NOT EXIST "%obuild_OpenPAW_path%\%obuild_dir_bin%\OpenPAW_opaw.exe"  GOTO end_if_run_1
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_OpenPAW_path%\%obuild_dir_bin%\OpenPAW_opaw.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_1
:end_if_group_0


cd "%obuild_pwd_OpenPAW_0%"
SET obuild_pwd_OpenPAW_0=
:obuild_return
ENDLOCAL
@ECHO ON
