extern "C" {
  void pagksa_(void*);
}

#include <kuip/ksys.h>
#include <kuip/kfor.h>
#include <kuip/kuser.h>
#include <kuip/klink.h>

#include <Slash/Core/ISession.h>
#include <Slash/Core/IWriter.h>
#include <Lib/Out.h>
#include <Lib/sout.h>
#include <Lib/colormanip.h>
#include <Lib/Manager.h>

#include <OpenPAW/PAW_Manager.h>

//////////////////////////////////////////////////////////////////////////////
void pagksa_(
 void* aSession
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
  Slash::Core::ISession* session = (Slash::Core::ISession*)aSession;

  Slash::Core::IWriter& printer = session->printer();
  Lib::Out out(printer);
  std::string cmd_path = ku_path() ? ku_path() : "";
  //std::string cmd_name = ku_name();
  if(session->verboseLevel()) {
    out << "pagksa :" 
        << " execute " << Lib::sout(cmd_path) 
        << Lib::endl;
  }

  OpenPAW::PAW_Manager* pawManager = find_PAW(*session);
  if(!pawManager) return;

  //OPTs_type& opts = pawManager->opts();
  ATTs_type& atts = pawManager->atts();

  //AIDA::IAnalysisFactory* aida = find_aida(*session);
  //if(!aida) return;

  if(cmd_path=="/GRAPHICS/ATTRIBUTES/COLOR_TABLE") {

    int ICOL = ku_geti();
    double RED = ku_getr();
    double GREEN = ku_getr();
    double BLUE = ku_getr();

    pawManager->setColor(ICOL,RED,GREEN,BLUE);

  } else if(cmd_path=="/GRAPHICS/ATTRIBUTES/PALETTE") {

    int PALNB = ku_geti();
    int NEL = ku_geti();
    std::vector<int> LIST;   
   {for(int index=0;index<NEL;index++) {
      LIST.push_back(ku_geti());
    }}

    if(session->verboseLevel()) {
      out << "pagksa :" 
          << " " << cmd_path
          << " PALNB= " << PALNB
          << " NEL= " << NEL
          << " LIST= ";
      for(unsigned int index=0;index<LIST.size();index++) {
        out << LIST[index] << " ";
      }
      out << Lib::endl;
    }

    //CERN/PAW : PALNB is in [1,50] :
    if(PALNB<=0) PALNB = 1;
    if(PALNB>=51) PALNB = 50;

    int NCOL = (int)atts.value("NCOL");

    if(NEL<=0) {
      // If NCOL<=8 elements from the color table in :
      if(NCOL<=8) {
        std::vector<int> pal;
        pal.push_back(0);
        pal.push_back(5);
        pal.push_back(7);
        pal.push_back(3);
        pal.push_back(6);
        pal.push_back(2);
        pal.push_back(4);
        pal.push_back(1);
        pal.resize(NCOL);
        pawManager->setPalette(PALNB,OpenPAW::Palette(pal));
      } else {
        std::vector<int> pal;
        // Fill color_table elements [8,NCOL] with 
        // a blue to red scale (from blue to black) :
        int ncol = NCOL-8;
        if(ncol==1) {
          pawManager->setColor(9,1,1,1);
          pal.push_back(9);
        } else {
          // Use the hsv colorwheel. We start from
          // blue (240,255,1) and turn around by using h 
          // to reach red (0,255,1) by passing by green (120,255,1)
          for(int index=0;index<ncol;index++) {
            // index 0  -> h =240
            // index ncol-1 -> h = 0
            int h = int(240 * (1 - ((float)index)/((float)(ncol-1))));
            int s = 255;
            int v = 255;
            int r,g,b;
            Lib::colormanip::hsv2rgb(h,s,v,r,g,b);
            pawManager->setColor(8+index,
                                 ((float)r)/255,((float)g)/255,((float)b)/255);
            pal.push_back(8+index);
          }
        }
        pawManager->setPalette(PALNB,OpenPAW::Palette(pal));
      }
    } else {
      for(unsigned int index=0;index<LIST.size();index++) {
        pawManager->createColor(LIST[index]);
      }
      pawManager->setPalette(PALNB,OpenPAW::Palette(LIST));
    }

  } else {
    out << "pagksa :" 
        << " " << cmd_path << " : dummy." << Lib::endl;
  }
}

