extern "C" {
  void pahvec_(void*);
}

#include <kuip/ksys.h>
#include <kuip/kfor.h>
#include <kuip/kuser.h>
#include <kuip/klink.h>

#include <BatchLab/Core/amanip.h>
#include "ArrayHelpers.h" //FIXME : not AIDA.

#include "KuipHelpers.h"
#include "FindHelpers.h"

//////////////////////////////////////////////////////////////////////////////
void pahvec_(
 void* aSession
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
  Slash::Core::ISession* session = (Slash::Core::ISession*)aSession;

  Slash::Core::IWriter& printer = session->printer();
  Lib::Out out(printer);

  //std::string cmd_name = ku_name();
  std::string cmd_path = ku_path() ? ku_path() : "";
  if(session->verboseLevel()) {
    out << "pahvec :" 
        << " execute " << Lib::sout(cmd_path) 
        << Lib::endl;
  }

  AIDA::IAnalysisFactory* aida = find_aida(*session);
  if(!aida) return;

  AIDA::ITree* memoryTree = find_memoryTree(*aida);
  if(!memoryTree) return;


  if(cmd_path=="/HISTOGRAM/PUT_VECT/CONTENTS") {

    std::string ID = ku_gets();
    std::string VNAME = ku_gets();

    AIDA::IBaseHistogram* histogram = baseHistogram_find(*session,ID);
    if(!histogram) {
      out << "pahvec :" 
          << " can't find histogram " << Lib::sout(ID) 
          << Lib::endl;
      return;
    }

    std::string NAME;
    std::vector< std::pair<int,int> > dims;
    if(!OpenPAW::PAW_Manager::parseName(VNAME,NAME,dims,printer)) return;
    Lib::smanip::touppercase(NAME);
    Slash::Data::IArray* vector = find_vector(*memoryTree,NAME);
    if(!vector) {
      out << "pahvec :" 
          << " can't find vector " << Lib::sout(NAME) << Lib::endl;
      return;
    } 
    std::vector< std::pair<unsigned int,unsigned int> > cut;
    if(!vector_get_cut(*vector,dims,cut)) {
      out << "pahvec :" 
            << " mismatch dimension in " << Lib::sout(VNAME) 
          << Lib::endl;
      return;
    }

    if(histogram->dimension()!=1) {
      out << "pahvec :" 
          << " histogram of dimension " << histogram->dimension()
          << " not yet supported."
          << Lib::endl;
      return;
    }
    
    AIDA::IHistogram1D* histogram1D = Lib_Cast(*histogram,AIDA::IHistogram1D);

    histogram1D->reset();

    const std::vector<double>& v = vector->vector();
    //unsigned int vsize = v.size();

    int binn = histogram1D->axis().bins();
    for(int bini = 0;bini<binn;bini++) {
      int index = bini;
      if(vector->accept(index,cut)) {
        double x = histogram1D->axis().binLowerEdge(bini);
        histogram1D->fill(x,v[index]);
      }
    }

  } else {
    out << "pahvec :" 
        << " " << cmd_path << " : dummy." << Lib::endl;

  }
}
