#ifndef Rio_BaseClass_h
#define Rio_BaseClass_h

#include <Rio/Interfaces/IClass.h>

namespace Rio {

class IPrinter;

class BaseClass : public virtual IClass {
public: //Rio::IClass:
  virtual const std::string& name() const;
  virtual const std::string& inStoreName() const;
  virtual short version() const;
  virtual bool writeBuffer(IBuffer&,void*) const;
  virtual bool readBuffer(IBuffer&,void*) const;
  virtual void* createOpaque(const Arguments& aArgs);
public:
  BaseClass(const std::string&,const std::string&,short);
  BaseClass(const BaseClass&);
  virtual ~BaseClass();
  BaseClass& operator=(const BaseClass&);
private:
  std::string fName;
  std::string fInStoreName;
  short fVersion;
};

}

#endif
