#ifndef Rio_Out_h
#define Rio_Out_h

#include <string>
#include <Rio/Interfaces/typedefs.h>

namespace Rio {

class IPrinter;
              
class Out;
typedef Out& (*OutFunc)(Out&);

class Out {
public:
  Out& operator<<(const char*);
  Out& operator<<(const std::string&);
  Out& operator<<(bool);
  Out& operator<<(int);
  Out& operator<<(int64);
  Out& operator<<(double);
  Out& operator<<(float);
  Out& operator<<(unsigned int);
  Out& operator<<(uint64);
  Out& operator<<(const void*);
  Out& operator<<(OutFunc);
public:
  Out(IPrinter&);
  virtual ~Out();
private:
  IPrinter& fPrinter;
};

Out& endl(Out&);
Out& tab(Out&);

std::string char_p_tos(const char*); //For tobuf.
std::string long_tos(const long); //For Rio::Map

}


#endif
