// this :
#include <Rio/Core/Out.h>

#include <Rio/Interfaces/IPrinter.h>

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
Rio::Out& Rio::endl(
 Out& aOut
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return aOut << "\n";
}
//////////////////////////////////////////////////////////////////////////////
Rio::Out& Rio::tab(
 Out& aOut
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return aOut << "\t";
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
Rio::Out::Out(
 IPrinter& aPrinter
)
:fPrinter(aPrinter)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
Rio::Out::~Out(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
Rio::Out& Rio::Out::operator<<(
 const char* aValue
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fPrinter.write(aValue);
  return *this;
}
//////////////////////////////////////////////////////////////////////////////
Rio::Out& Rio::Out::operator<<(
 const std::string& aValue
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fPrinter.write(aValue.c_str());
  return *this;
}
//////////////////////////////////////////////////////////////////////////////
Rio::Out& Rio::Out::operator<<(
 OutFunc aFunc
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return aFunc(*this);
}
//////////////////////////////////////////////////////////////////////////////
Rio::Out& Rio::Out::operator<<(
 bool aValue
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(aValue) 
    fPrinter.write("true");
  else 
    fPrinter.write("false");
  return *this;
}
#include <stdio.h>
//////////////////////////////////////////////////////////////////////////////
Rio::Out& Rio::Out::operator<<(
 int aValue
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  char s[32];
  ::sprintf(s,"%d",aValue);
  fPrinter.write(s);
  return *this;
}
//////////////////////////////////////////////////////////////////////////////
Rio::Out& Rio::Out::operator<<(
 int64 aValue
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  char s[32];
  ::sprintf(s,RIO_INT64_FORMAT,aValue);
  fPrinter.write(s);
  return *this;
}
//////////////////////////////////////////////////////////////////////////////
Rio::Out& Rio::Out::operator<<(
 float aValue
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  char s[32];
  ::sprintf(s,"%f",aValue);
  fPrinter.write(s);
  return *this;
}
//////////////////////////////////////////////////////////////////////////////
Rio::Out& Rio::Out::operator<<(
 double aValue
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  char s[32];
  ::sprintf(s,"%g",aValue);
  fPrinter.write(s);
  return *this;
}
//////////////////////////////////////////////////////////////////////////////
Rio::Out& Rio::Out::operator<<(
 unsigned int aValue
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  char s[32];
  ::sprintf(s,"%d",aValue);
  fPrinter.write(s);
  return *this;
}
//////////////////////////////////////////////////////////////////////////////
Rio::Out& Rio::Out::operator<<(
 uint64 aValue
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  char s[32];
  ::sprintf(s,RIO_UINT64_FORMAT,aValue);
  fPrinter.write(s);
  return *this;
}
//////////////////////////////////////////////////////////////////////////////
Rio::Out& Rio::Out::operator<<(
 const void* aValue
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  char s[32];
  ::sprintf(s,"%lx",(unsigned long)aValue);
  fPrinter.write(s);
  return *this;
}

// for tobuf :
std::string Rio::char_p_tos(const char* aValue) {
  char s[32];
  ::sprintf(s,"%lu",(unsigned long)aValue);
  return std::string(s);
}

// for Map :
std::string Rio::long_tos(const long aValue) {
  char s[32];
  ::sprintf(s,"%ld",aValue);
  return std::string(s);
}
