#!/bin/sh -f

#
# File produced by the obuild tool version 1.0
# for the package Slash with version v1r0p0.
#

#////////////////////////////////////////////////
# Usage :
# ( UNIX> chmod a+x build.sh )
#   UNIX> ./build.sh
#
#////////////////////////////////////////////////

#obuild_args="$*"

obuild_verbose_build=no
obuild_debug=no
obuild_set_x=no
obuild_erase_dir_bin=no
obuild_do_mains=yes

obuild_args=""
while test $# -ge 1 ; do
  case $1 in
    -h) 
        echo "Usage :"
        echo "  UNIX>./build.sh [Options] [Target]"
        echo "Options :"
        echo "  -v : verbose."
        echo "  -g : build in debug mode."
        echo "  -i : install setup scripts."
        echo "  -bci : broadacst install setup scripts."
        echo "  -e : erase binary directory."
        echo "  -x : execute with set -x."
        echo "  -l : link only, do not (re)compile."
        echo "  -k : do not erase result of compilations (.o, .obj)."
        echo "  -nm : build the not-main components."
        echo "Target :"
        echo "  If no option is specify and a ending"
        echo " string is given ; this string is given"
        echo " to a find command of the form :"
        echo '    find ./sh -name "*target*" -exec {} \;'
        echo " in order to execute selected scripts under"
        echo " the sh directory."
        echo "Examples :"
        echo "  UNIX>./build.sh app"
        echo "  UNIX>./build.sh -v _lib"
        echo "  UNIX>./build.sh -v -g dll_"
        echo ""
        exit ;;
    -v) obuild_verbose_build=yes;obuild_args="${obuild_args} $1" ;;
    -g) obuild_debug=yes;obuild_args="${obuild_args} $1" ;;
    -i) ./sh/install.sh; exit ;;
    -bci) if test ! -e ./sh/broadcast_install.sh ; then 
            echo "Nothing to do for this package." 
            exit
          fi
          ./sh/broadcast_install.sh ${obuild_args}; 
          exit ;;
    -x) obuild_set_x=yes;obuild_args="${obuild_args} $1" ;;
    -l) obuild_args="${obuild_args} $1" ;;
    -k) obuild_args="${obuild_args} $1" ;;
    -e) obuild_erase_dir_bin=yes ;;
    -nm) obuild_do_mains=no ;;
    -*) echo "unknwon option : $1" ; exit ;;
     *) if [ $# = 1 ] ; then
          find ./sh -name "*$1*" -exec {} ${obuild_args} \;
        else         
          echo "unknwon option : $1" ;
        fi
        exit ;;
  esac
  shift
done

if [ ${obuild_set_x} = yes ] ; then
  set -x
fi

if [ ${obuild_erase_dir_bin} = "yes" ] ; then
  if [  "${OBUILD_PLATFORM}" = "" ] ; then
    obuild_platform=`uname`
  else
    obuild_platform=${OBUILD_PLATFORM}
  fi
  if [ "${obuild_platform}" = "" ] ; then
    echo "platform variable not defined."
    exit
  fi
  obuild_Slash_path=..
  /bin/rm -R -f ${obuild_Slash_path}/${obuild_platform}_obuild
  exit  
fi

# Check foreign packages / resources :
if test -e './sh/check_foreigns.sh' ; then
  ./sh/check_foreigns.sh
  obuild_status=$?;if test ${obuild_status} != 0 ; then exit ${obuild_status};fi
fi

if test -e './sh/install.sh' ; then
  ./sh/install.sh
fi

