//  Mai/2007 : G.Barrand : creation.

// this :
#include <Inventor/SDL/SoSDL.h>
   
// Inventor :
#include <Inventor/SoDB.h>
#include <Inventor/SbTime.h>
#include <Inventor/SoInteraction.h>
#include <Inventor/nodekits/SoNodeKit.h>

#include <Inventor/SDL/viewers/SoSDL_Viewer.h> //FIXME

SDL_Surface* SoSDL::fScreen = 0;
SoSDL_Widget* SoSDL::fWidget = 0;
std::vector<SoSDL_AudioSample*>* SoSDL::fAudioSamples = 0;
SDL_TimerID SoSDL::fMainTimerID = 0;
//SDL_TimerID SoSDL::fTimerSensorID = 0;
//SDL_TimerID SoSDL::fDelaySensorID = 0;
std::vector<SDL_Joystick*>* SoSDL::fJoySticks = 0;

SbBool SoSDL::fViewer_render = TRUE;
SbBool SoSDL::fToQuit = FALSE;

//////////////////////////////////////////////////////////////////////////////
SoSDL_Widget::SoSDL_Widget(
) 
:fViewer(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
SoSDL_Widget::~SoSDL_Widget(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
void SoSDL_Widget::setViewer(
 SoSDL_Viewer* aViewer
) 
//////////////////////////////////////////////////////////////////////////////
// FIXME : at end, have to rm this method.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fViewer = aViewer;
}
//////////////////////////////////////////////////////////////////////////////
SoSDL_Viewer* SoSDL_Widget::getViewer(
) const
//////////////////////////////////////////////////////////////////////////////
// FIXME : at end have to rm this method.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fViewer;
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
SoSDL_Widget* SoSDL::init(
 int a_video_width
,int a_video_height
,Uint32 aFlags
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if (SDL_Init(SDL_INIT_VIDEO|SDL_INIT_TIMER|SDL_INIT_JOYSTICK)<0) { 
    ::fprintf
      (stderr,"SoSDL::init : couldn't initialize SDL: %s\n",SDL_GetError());
    return 0;
  }

  SDL_GL_SetAttribute(SDL_GL_DEPTH_SIZE,16);
  SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER,1);
    
  Uint32 flags = SDL_OPENGL;
  flags |= aFlags;

  fScreen = SDL_SetVideoMode(a_video_width,a_video_height,0,flags);

  if (fScreen == NULL) {
    ::fprintf
      (stderr,"SoSDL::init : couldn't set video mode with %d x %d : %s\n",
         a_video_width,a_video_height,SDL_GetError());
    SDL_Quit();
    return 0;
  }

  SDL_EnableUNICODE(1);

  //SDL_EnableKeyRepeat(0,0); //to disable key repeat.
  //SDL_DEFAULT_REPEAT_DELAY is 500
  //SDL_DEFAULT_REPEAT_INTERVAL is 30
  //NOTE : we must arrange to have key repeat 
  //       at the same rythm than the gamepad.
  //       If changing the below see SoSDL_Viewer::startMoveTimer.
  SDL_EnableKeyRepeat(200,10);

  //SDL_WM_SetCaption("Hello",NULL); //does nothing !

  SDL_ShowCursor(0);

  if(!SoDB::isInitialized()) SoDB::init();
  SoNodeKit::init();
  SoInteraction::init();

  //SoDB::getSensorManager()->setChangedCallback(sensorQueueChanged,NULL);

  SoSDL::initJoysticks();
  SoSDL::initAudio();

  while(true) {
    SDL_Event event;
    if(SDL_PollEvent(&event)==0) break;
  }
  
  fMainTimerID = SDL_AddTimer(50,SoSDL::mainTimerCB,0);

  fWidget = new SoSDL_Widget();
  return fWidget;
}
//////////////////////////////////////////////////////////////////////////////
void SoSDL::show(
 SoSDL_Widget*
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
void SoSDL::clear(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(fMainTimerID) {
    SDL_RemoveTimer(fMainTimerID);
    fMainTimerID = 0;
  }
  //if(fTimerSensorID) {
  //  SDL_RemoveTimer(fTimerSensorID);
  //  fTimerSensorID = 0;
  //}
  //if(fDelaySensorID) {
  //  SDL_RemoveTimer(fDelaySensorID);
  //  fDelaySensorID = 0;
  //}
 
  SoSDL::clearJoysticks();
  SoSDL::clearAudio();
  SDL_Quit();
  delete fWidget;
  fWidget = 0;
}
//////////////////////////////////////////////////////////////////////////////
SDL_Surface* SoSDL::screen(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fScreen;
}
//////////////////////////////////////////////////////////////////////////////
void SoSDL::mainLoop(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  SoSensorManager* sensorManager = SoDB::getSensorManager();
  if(!sensorManager) return;

  if(!fWidget) return;

  //FIXME : at end, the below should disappear :
  SoSDL_Viewer* viewer = fWidget->getViewer();
  if(!viewer) return;

  bool appVisible = true;
  Uint32 lastCount = SDL_GetTicks();
  float maxFPS = 10000.0F;
  //float maxFPS = 500.0F;

  //FIXME : at startup we receive some SDL_JOYAXISMOTION !
  //bool enable_joyaxis = false;

  bool joy_rotate = true;
  bool joy_forback = true;
 
  while(fToQuit==FALSE) {

    SDL_Event event;
    if(SDL_PollEvent(&event)) {

      //dumpEvent(event);

      if(viewer->processEvent(event,fViewer_render)==TRUE) {
      } else {
        // various way to quit :
        switch (event.type) {
        case SDL_JOYBUTTONDOWN:
          if(event.jbutton.button==8) {
            fToQuit = TRUE;
            break;
          }
          break;
        case SDL_KEYDOWN:
          if( (event.key.keysym.sym==SDLK_q) ||
              (event.key.keysym.sym==SDLK_ESCAPE) ) {
            fToQuit = TRUE;
            break;
          }
          break;
        case SDL_QUIT: //close window in non-fullscreen mode.
          fToQuit = TRUE;
          break;
        case SDL_USEREVENT:
          if(event.user.code==SoSDL_USEREVENT_RENDER) {
            fViewer_render = TRUE;
          } else if
            (event.user.code==SoSDL_USEREVENT_PROCESS_DELAY_QUEUE_IDLE) {
            if (sensorManager->isDelaySensorPending()) {
              sensorManager->processDelayQueue(TRUE);
              fViewer_render = TRUE;
            }
          } else if
            (event.user.code==SoSDL_USEREVENT_PROCESS_DELAY_QUEUE_NOT_IDLE) {
            if (sensorManager->isDelaySensorPending()) {
              sensorManager->processDelayQueue(FALSE);
              fViewer_render = TRUE;
            }
          } else if(event.user.code==SoSDL_USEREVENT_PROCESS_TIMER_QUEUE) {
            SbTime timevalue;
            if(sensorManager->isTimerSensorPending(timevalue)) {
              sensorManager->processTimerQueue();
              fViewer_render = TRUE;
            }
          }
          //
          break;
        default:
          break;			
        }
      }

   } else { //SDL_PollEvent

      // If the application is not visible
      if(!appVisible) {
        // Leave the CPU alone, don't waste time, simply wait for an event
        SDL_WaitEvent(NULL);
      } else {

        Uint32 tickCount = SDL_GetTicks(); // Get present ticks

        //printf("debug : no event : tickCount %u %u\n",
        //  lastCount,tickCount);        

        // G.Barrand : stellarium logic...
        // This is used to constraint the maximum FPS rate
        if((tickCount-lastCount) < 1000.0F/maxFPS) {
          Uint32 delay = (unsigned int)(1000.0F/maxFPS)-(tickCount-lastCount);
          //printf("debug : delay %u\n",delay);
          SDL_Delay(delay);
	}
        tickCount = SDL_GetTicks();
  
        if(fViewer_render==TRUE) { //render if needed.
          //printf("debug : viewer render...\n");
          //FIXME : use SoSceneManager::scheduleRedraw ?
          //FIXME : viewer->scheduleRedraw() ?
          viewer->render(); //it calls sensorQueueChanged
          SDL_GL_SwapBuffers();
          fViewer_render = FALSE;
        }

        lastCount = tickCount; // Save the present tick probing
      }
    }    
  }
}
//////////////////////////////////////////////////////////////////////////////
bool SoSDL::isShiftDown() 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  bool shiftDown = false;
  SDLMod state = SDL_GetModState();
  if((state & KMOD_LSHIFT) == KMOD_LSHIFT) shiftDown = true;
  if((state & KMOD_RSHIFT) == KMOD_RSHIFT) shiftDown = true;
  return shiftDown;
}
//////////////////////////////////////////////////////////////////////////////
/// joysticks ////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
void SoSDL::initJoysticks()
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  int numJoystick = SDL_NumJoysticks();
  //printf("debug : joysticks found : %d\n",numJoystick);
  for(int index=0;index<numJoystick;index++)  {
    //printf("debug : joystick name : %i : %s\n",
    //  index,SDL_JoystickName(index));
    SDL_Joystick* joyStick = SDL_JoystickOpen(index);
    if(joyStick) {
      //printf("debug : num axes : %d\n",SDL_JoystickNumAxes(joyStick));
      //printf("debug : num buttons : %d\n",SDL_JoystickNumButtons(joyStick));
      if(!fJoySticks) {
        fJoySticks = new std::vector<SDL_Joystick*>();
      }
      fJoySticks->push_back(joyStick);
    } else {
      //printf("debug : can't open joystick\n");
    }
  }
}
//////////////////////////////////////////////////////////////////////////////
void SoSDL::clearJoysticks() 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!fJoySticks) return;
  std::vector<SDL_Joystick*>::iterator it;
  for(it=fJoySticks->begin();it!=fJoySticks->end();++it) {
    SDL_JoystickClose(*it);
  }
  fJoySticks->clear();
  delete fJoySticks;
  fJoySticks = 0;
}
//////////////////////////////////////////////////////////////////////////////
/// Audio ////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
class SoSDL_AudioSample {
public:
  SoSDL_AudioSample(const SbString& aFile)
  :fData(0),fPos(0),fLen(0){
    // Load the sound file and convert it to 16-bit stereo at 22kHz :
    SDL_AudioSpec wave;
    Uint8* data;
    Uint32 dlen;
    if(SDL_LoadWAV(aFile.getString(),&wave,&data,&dlen)==NULL) {
      ::fprintf(stderr,"Couldn't load %s: %s\n",
        aFile.getString(),SDL_GetError());
      return;
    }
    SDL_AudioCVT cvt;
    SDL_BuildAudioCVT
      (&cvt,wave.format,wave.channels,wave.freq,AUDIO_S16,2,22050);
    cvt.buf = (Uint8*)::malloc(dlen*cvt.len_mult);
    ::memcpy(cvt.buf,data,dlen);
    cvt.len = dlen;
    SDL_ConvertAudio(&cvt);
    SDL_FreeWAV(data);

    SDL_LockAudio();
    fData = cvt.buf;
    fLen = cvt.len_cvt;
    fPos = 0;
    SDL_UnlockAudio();
  }
  virtual ~SoSDL_AudioSample(){
    if(fData) ::free(fData);
  }
public:
  Uint8* fData;
  Uint32 fPos;
  Uint32 fLen;
};

//////////////////////////////////////////////////////////////////////////////
void SoSDL::playAudioFile(
 const SbString& aFile
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  SoSDL_AudioSample* sample = new SoSDL_AudioSample(aFile);
  if(!sample) return;
  if(!fAudioSamples) fAudioSamples = new std::vector<SoSDL_AudioSample*>();
  fAudioSamples->push_back(sample);
  SoSDL::playAudio(*sample);
  //delete sample;
}

//////////////////////////////////////////////////////////////////////////////
void mixaudio(
 void* aUserData
,Uint8* aStream
,int aLength
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  SoSDL_AudioSample* sample = (SoSDL_AudioSample*)aUserData;
  if(sample->fPos>=sample->fLen){
    sample->fPos = sample->fLen; //Enforce end.
    return;
  }
  Uint32 amount = sample->fLen - sample->fPos;
  if(amount>(Uint8)aLength) amount = aLength;
  SDL_MixAudio(aStream,
               sample->fData+sample->fPos,
               amount,
               SDL_MIX_MAXVOLUME);
  sample->fPos += amount;
}
//////////////////////////////////////////////////////////////////////////////
void SoSDL::initAudio() 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
void SoSDL::clearAudio() 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(fAudioSamples) {
    unsigned int number = fAudioSamples->size();
    for(unsigned int index=0;index<number;++index) 
      delete (*fAudioSamples)[index];
    fAudioSamples->clear();
  }
  SDL_CloseAudio();
}
//////////////////////////////////////////////////////////////////////////////
void SoSDL::playAudio(
 SoSDL_AudioSample& aSample
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  // Set 16-bit stereo audio at 22Khz.
  SDL_AudioSpec fmt;
  fmt.freq = 22050;
  fmt.format = AUDIO_S16;
  fmt.channels = 2;
  fmt.samples = 512;        // A good value for games.
  fmt.callback = mixaudio;
  fmt.userdata = &aSample; //Received as aUserData in mixaudio.

  // Open the audio device and start playing sound!
  if(SDL_OpenAudio(&fmt,NULL)<0) {
    ::fprintf(stderr,"SoSDL::playAudio : unable to open audio: %s\n",
      SDL_GetError());
    return;
  }
  SDL_PauseAudio(0);

  //SDL_CloseAudio();

}
//////////////////////////////////////////////////////////////////////////////
Uint32 SoSDL::mainTimerCB(
 Uint32 aInterval
,void* //aTag
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  //printf("debug : SoSDL::mainTimerCB\n");

  //NOTE : avoid to call Inventor code here because
  //       SDL will execute it in an another thread
  //       that the mainLoop thread. And we observed
  //       crashes when doing that. (For example
  //       in case of clearing the scene whilst
  //       caching is active).

  SoSensorManager* sensorManager = SoDB::getSensorManager();
  if(sensorManager) {
    sendMessage(SoSDL_USEREVENT_PROCESS_DELAY_QUEUE_IDLE);
    sendMessage(SoSDL_USEREVENT_PROCESS_TIMER_QUEUE);
  }

  return aInterval; //respawn.
}

/*
//////////////////////////////////////////////////////////////////////////////
void SoSDL::sensorQueueChanged(
 void*
)
//////////////////////////////////////////////////////////////////////////////
// This callback handles events from sensors in the scene graph,
// needed to deal with scene interaction.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  SoSensorManager* sensorManager = SoDB::getSensorManager();

  SbTime timevalue;
  if (sensorManager->isTimerSensorPending(timevalue)) {

    SbTime sbInterval = timevalue - SbTime::getTimeOfDay();
    if(sbInterval.getValue()<0.0) { // Follow the SoXt logic...
      sbInterval.setValue(0.0); 
    }
    Uint32 interval = sbInterval.getMsecValue();

    if(fTimerSensorID) SDL_RemoveTimer(fTimerSensorID);
    fTimerSensorID = SDL_AddTimer(interval,SoSDL::timerSensorCB,0);

  } else if(fTimerSensorID) {
    SDL_RemoveTimer(fTimerSensorID);
    fTimerSensorID = 0;
  }

  if (sensorManager->isDelaySensorPending()) {
    Uint32 interval = SoDB::getDelaySensorTimeout().getMsecValue();

    if(fDelaySensorID) SDL_RemoveTimer(fDelaySensorID);
    fDelaySensorID = SDL_AddTimer(interval,SoSDL::delaySensorCB,0);
  } else if(fDelaySensorID) {
    SDL_RemoveTimer(fDelaySensorID);
    fDelaySensorID = 0;
  }
}
//////////////////////////////////////////////////////////////////////////////
Uint32 SoSDL::timerSensorCB(
Uint32 //aInterval
,void*
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  //NOTE : avoid to call Inventor code here because
  //       SDL will execute it in an another thread
  //       that the mainLoop thread. And we observed
  //       crashes when doing that. (For example
  //       in case of clearing the scene whilst
  //       caching is active).

  sendMessage(SoSDL_USEREVENT_PROCESS_TIMER_QUEUE);
  
  return 0; //Stop the timer. (Returning aInterval would continue the timer).
}
//////////////////////////////////////////////////////////////////////////////
Uint32 SoSDL::delaySensorCB(
Uint32 //aInterval
,void*
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  //NOTE : avoid to call Inventor code here because
  //       SDL will execute it in an another thread
  //       that the mainLoop thread. And we observed
  //       crashes when doing that. (For example
  //       in case of clearing the scene whilst
  //       caching is active).

  sendMessage(SoSDL_USEREVENT_PROCESS_DELAY_QUEUE_NOT_IDLE);

  return 0;
}
*/

//////////////////////////////////////////////////////////////////////////////
void SoSDL::setViewerRender(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fViewer_render = TRUE;
}

//////////////////////////////////////////////////////////////////////////////
void SoSDL::toQuit(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fToQuit = TRUE;
}
//////////////////////////////////////////////////////////////////////////////
void SoSDL::sendMessage(
 int aMessage
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  SDL_Event event;
  event.type = SDL_USEREVENT;
  event.user.code = aMessage;
  SDL_PushEvent(&event);
}
//////////////////////////////////////////////////////////////////////////////
void SoSDL::sendRender(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  sendMessage(SoSDL_USEREVENT_RENDER);
}

#include <stdio.h> //printf
void SoSDL::dumpEvent(SDL_Event& aEvent) {
  printf("debug : event.type : %d\n",aEvent.type);        
  switch (aEvent.type) {
  case SDL_MOUSEMOTION:
    printf("debug : SDL_MOUSEMOTION : which %d, state %d, x %d, y %d, xrel %d, yrel %d\n",aEvent.motion.which,aEvent.motion.state,aEvent.motion.x,aEvent.motion.y,aEvent.motion.xrel,aEvent.motion.yrel);        
    break;
  case SDL_MOUSEBUTTONDOWN: //treated in viewer->processAEvent.
  case SDL_MOUSEBUTTONUP: //treated in viewer->processAEvent.
    printf("debug : SDL_MOUSEBUTTONDOWN : which %d, button %d, state %d, x %d, y %d\n",aEvent.button.which,aEvent.button.button,aEvent.button.state,aEvent.button.x,aEvent.button.y);        
    break;
  case SDL_JOYAXISMOTION: //treated in viewer->processAEvent.
    printf("debug : SDL_JOYAXISMOTION : which %d, axis %d, value %d\n",aEvent.jaxis.which,aEvent.jaxis.axis,aEvent.jaxis.value);        
    break;
  case SDL_JOYBALLMOTION:
    printf("debug : SDL_JOYBALLMOTION : which %d, ball %d, xrel %d, yrel %d\n",aEvent.jball.which,aEvent.jball.ball,aEvent.jball.xrel,aEvent.jball.yrel);        
    break;
  case SDL_JOYHATMOTION:
    printf("debug : SDL_JOYHATMOTION : which %d, hat %d, value %d\n",
      aEvent.jhat.which,aEvent.jhat.hat,aEvent.jhat.value);        
    break;
  case SDL_JOYBUTTONUP:
    break;
  case SDL_JOYBUTTONDOWN: //treated in viewer->processAEvent.
    printf("debug : SDL_JOYBUTTON : which %d, button %d, state %d\n",aEvent.jbutton.which,aEvent.jbutton.button,aEvent.jbutton.state);        
    break;
  case SDL_KEYDOWN:
    printf("debug : SDL_KEYDOWN : which %d, state %d, keysym %d\n",aEvent.key.which,aEvent.key.state,aEvent.key.keysym.sym);        
    break;
  case SDL_QUIT:
    break;
  default:
    break;			
  }
}
/* Trash area :
  SDL_WM_ToggleFullScreen(Screen); // Try fullscreen
 */

