
// C++ conversion of the java/DataPointSetCreateFromData.java example.

#include <AIDA/AIDA.h>

using namespace AIDA;

#include <stdlib.h>

int main(int argc,char* argv[]) {

  IAnalysisFactory* af = AIDA_createAnalysisFactory();
  if(!af) return EXIT_FAILURE;

  ITreeFactory* trf = af->createTreeFactory();
  if(!trf) return EXIT_FAILURE;
  // Create a tree loading the AIDA objects stored in an AIDA file.
  ITree* tree = trf->create("aidaStore.aida");
  delete trf;
  if(!tree) return EXIT_FAILURE;

  IManagedObject* mo = tree->find("h1");
  if(!mo) return EXIT_FAILURE;
  IHistogram1D* h1 = dynamic_cast<IHistogram1D*>(mo);
  if(!h1) return EXIT_FAILURE;

  mo = tree->find("p2");
  if(!mo) return EXIT_FAILURE;
  IProfile2D* p2 = dynamic_cast<IProfile2D*>(mo);
  if(!p2) return EXIT_FAILURE;

  mo = tree->find("c3");
  if(!mo) return EXIT_FAILURE;
  ICloud3D* c3 = dynamic_cast<ICloud3D*>(mo);
  if(!c3) return EXIT_FAILURE;
        
  IDataPointSetFactory* dpsf = af->createDataPointSetFactory(*tree);
  if(!dpsf) return EXIT_FAILURE;

  // Create IDataPointSets from the the above AIDA objects.
  dpsf->create("dps1DFromHist",*h1);
  dpsf->create("dps2DFromProf",*p2);
  dpsf->create("dps2DFromCloud",*c3);

  delete dpsf;

  delete af;

  return EXIT_SUCCESS;
}
