@ECHO OFF
SETLOCAL

REM #
REM # File produced by the obuild tool version 1.0
REM # for the package VisAIDA with version v1r0p4.
REM #

REM #////////////////////////////////////////////////
REM # Usage :
REM #   DOS> CD some_path\pack\version\obuild
REM #   DOS> DOS\build
REM # or :
REM #   DOS> call DOS\build.bat
REM #
REM #////////////////////////////////////////////////

REM #////////////////////////////////////////////////
REM #/// Get path of this file :
REM #////////////////////////////////////////////////
SET obuild_VisAIDA_path=%~dp0
REM # Remove ending \obuild\DOS\
SET obuild_VisAIDA_path=%obuild_VisAIDA_path:~0,-12%

REM #////////////////////////////////////////////////
REM #/// Treat arguments :
REM #////////////////////////////////////////////////

SET obuild_verbose=no
SET obuild_debug=no
SET obuild_do_mains=yes
SET obuild_group=main

SET obuild_args=

:next_arg
IF "%1%" == "" GOTO end_args

IF NOT "%1%" == "-h" GOTO end_if_h
  ECHO Usage :
  ECHO   build [Options] [Target]
  ECHO Options :
  ECHO   -v : verbose.
  ECHO   -g : build in debug mode.
  ECHO   -e : erase binary directory.
  ECHO   -x : execute with ECHO ON"
  ECHO   -nm : build the not-main components.
  ECHO   -group group : build the given group of components.
  ECHO Target :
  ECHO   If no option is specify and a ending
  ECHO  string is given ; this string is given
  ECHO  to a find command in order to execute 
  ECHO  selected scripts under the DOS directory.
  ECHO Examples :
  ECHO   build app
  ECHO   build -v _lib
  ECHO   build -v -g dll_
  GOTO obuild_return
:end_if_h

IF NOT "%1%" == "-v" GOTO end_if_v
  SET obuild_verbose=yes
  SET obuild_args=%obuild_args% -v
  SHIFT
  GOTO next_arg
:end_if_v

IF NOT "%1%" == "-g" GOTO end_if_g
  SET obuild_debug=yes
  SET obuild_args=%obuild_args% -g
  SHIFT
  GOTO next_arg
:end_if_g

IF NOT "%1%" == "-e" GOTO end_if_e

  IF "%OBUILD_DIR_BIN%" == "" (
    SET obuild_dir_bin=bin_obuild
  ) ELSE (
    SET obuild_dir_bin=%OBUILD_DIR_BIN%
  )

  IF "%obuild_dir_bin%" == "" (
    ECHO obuild_dir_bin variable not defined.
    GOTO obuild_return
  )

  IF EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%" RMDIR /S /Q "%obuild_VisAIDA_path%\%obuild_dir_bin%"

  GOTO obuild_return

:end_if_e

IF NOT "%1%" == "-x" GOTO end_if_x
  SET obuild_args=%obuild_args% -x
  SHIFT
  GOTO next_arg
:end_if_x

IF NOT "%1%" == "-nm" GOTO end_if_nm
  SET obuild_do_mains=no
  SHIFT
  GOTO next_arg
:end_if_nm

IF NOT "%1%" == "-group" GOTO end_if_group
  SHIFT
  SET obuild_group=%1%
  SHIFT
  GOTO next_arg
:end_if_group

REM # Argument without a leading "-" is assumed to 
REM # be the last one and then to be a pattern 
REM # to find and execute command files under 
REM # the DOS directory.
SET obuild_arg=%1%
SET obuild_arg1=%1:~0,1%
IF "%obuild_arg1%" == "-" GOTO obuild_return

  FOR %%f IN (DOS\*%obuild_arg%*) DO %%f %obuild_args%

  GOTO obuild_return

:end_args

REM #////////////////////////////////////////////////
REM #/// End arguments.
REM #////////////////////////////////////////////////


IF NOT %obuild_group% == main GOTO end_if_group_0
IF NOT %obuild_do_mains% == yes GOTO end_if_main_0
  IF NOT EXIST .\DOS\build_app_AIDA_example_ChainedAndFilteredTuplesExample_vis.bat  GOTO end_if_build_0
    CALL .\DOS\build_app_AIDA_example_ChainedAndFilteredTuplesExample_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_0
:end_if_main_0
:end_if_group_0
IF NOT %obuild_group% == main GOTO end_if_group_1
IF NOT %obuild_do_mains% == yes GOTO end_if_main_1
  IF NOT EXIST .\DOS\build_app_AIDA_example_Cloud_vis.bat  GOTO end_if_build_1
    CALL .\DOS\build_app_AIDA_example_Cloud_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_1
:end_if_main_1
:end_if_group_1
IF NOT %obuild_group% == main GOTO end_if_group_2
IF NOT %obuild_do_mains% == yes GOTO end_if_main_2
  IF NOT EXIST .\DOS\build_app_AIDA_example_CloudCreate_vis.bat  GOTO end_if_build_2
    CALL .\DOS\build_app_AIDA_example_CloudCreate_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_2
:end_if_main_2
:end_if_group_2
IF NOT %obuild_group% == main GOTO end_if_group_3
IF NOT %obuild_do_mains% == yes GOTO end_if_main_3
  IF NOT EXIST .\DOS\build_app_AIDA_example_DataPointSetCreateAndFill_vis.bat  GOTO end_if_build_3
    CALL .\DOS\build_app_AIDA_example_DataPointSetCreateAndFill_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_3
:end_if_main_3
:end_if_group_3
IF NOT %obuild_group% == main GOTO end_if_group_4
IF NOT %obuild_do_mains% == yes GOTO end_if_main_4
  IF NOT EXIST .\DOS\build_app_AIDA_example_FilterAndEvaluatorExample_vis.bat  GOTO end_if_build_4
    CALL .\DOS\build_app_AIDA_example_FilterAndEvaluatorExample_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_4
:end_if_main_4
:end_if_group_4
IF NOT %obuild_group% == main GOTO end_if_group_5
IF NOT %obuild_do_mains% == yes GOTO end_if_main_5
  IF NOT EXIST .\DOS\build_app_AIDA_example_Histogram_vis.bat  GOTO end_if_build_5
    CALL .\DOS\build_app_AIDA_example_Histogram_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_5
:end_if_main_5
:end_if_group_5
IF NOT %obuild_group% == main GOTO end_if_group_6
IF NOT %obuild_do_mains% == yes GOTO end_if_main_6
  IF NOT EXIST .\DOS\build_app_AIDA_example_HistogramArithmetic_vis.bat  GOTO end_if_build_6
    CALL .\DOS\build_app_AIDA_example_HistogramArithmetic_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_6
:end_if_main_6
:end_if_group_6
IF NOT %obuild_group% == main GOTO end_if_group_7
IF NOT %obuild_do_mains% == yes GOTO end_if_main_7
  IF NOT EXIST .\DOS\build_app_AIDA_example_PlotExample_vis.bat  GOTO end_if_build_7
    CALL .\DOS\build_app_AIDA_example_PlotExample_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_7
:end_if_main_7
:end_if_group_7
IF NOT %obuild_group% == main GOTO end_if_group_8
IF NOT %obuild_do_mains% == yes GOTO end_if_main_8
  IF NOT EXIST .\DOS\build_app_AIDA_example_PlotWithStyles_vis.bat  GOTO end_if_build_8
    CALL .\DOS\build_app_AIDA_example_PlotWithStyles_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_8
:end_if_main_8
:end_if_group_8
IF NOT %obuild_group% == main GOTO end_if_group_9
IF NOT %obuild_do_mains% == yes GOTO end_if_main_9
  IF NOT EXIST .\DOS\build_app_AIDA_example_ProfileCreate_vis.bat  GOTO end_if_build_9
    CALL .\DOS\build_app_AIDA_example_ProfileCreate_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_9
:end_if_main_9
:end_if_group_9
IF NOT %obuild_group% == main GOTO end_if_group_10
IF NOT %obuild_do_mains% == yes GOTO end_if_main_10
  IF NOT EXIST .\DOS\build_app_AIDA_example_ProfileFill_vis.bat  GOTO end_if_build_10
    CALL .\DOS\build_app_AIDA_example_ProfileFill_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_10
:end_if_main_10
:end_if_group_10
IF NOT %obuild_group% == main GOTO end_if_group_11
IF NOT %obuild_do_mains% == yes GOTO end_if_main_11
  IF NOT EXIST .\DOS\build_app_AIDA_example_Tree_vis.bat  GOTO end_if_build_11
    CALL .\DOS\build_app_AIDA_example_Tree_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_11
:end_if_main_11
:end_if_group_11
IF NOT %obuild_group% == main GOTO end_if_group_12
IF NOT %obuild_do_mains% == yes GOTO end_if_main_12
  IF NOT EXIST .\DOS\build_app_AIDA_example_Tuple_vis.bat  GOTO end_if_build_12
    CALL .\DOS\build_app_AIDA_example_Tuple_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_12
:end_if_main_12
:end_if_group_12
IF NOT %obuild_group% == main GOTO end_if_group_13
IF NOT %obuild_do_mains% == yes GOTO end_if_main_13
  IF NOT EXIST .\DOS\build_app_AIDA_example_TupleCreate_vis.bat  GOTO end_if_build_13
    CALL .\DOS\build_app_AIDA_example_TupleCreate_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_13
:end_if_main_13
:end_if_group_13
IF NOT %obuild_group% == main GOTO end_if_group_14
IF NOT %obuild_do_mains% == yes GOTO end_if_main_14
  IF NOT EXIST .\DOS\build_app_AIDA_example_createAndFillTupleWithComplexStructure_vis.bat  GOTO end_if_build_14
    CALL .\DOS\build_app_AIDA_example_createAndFillTupleWithComplexStructure_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_14
:end_if_main_14
:end_if_group_14
IF NOT %obuild_group% == main GOTO end_if_group_15
IF NOT %obuild_do_mains% == yes GOTO end_if_main_15
  IF NOT EXIST .\DOS\build_app_AIDA_example_DataPointSetCreateFromData_vis.bat  GOTO end_if_build_15
    CALL .\DOS\build_app_AIDA_example_DataPointSetCreateFromData_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_15
:end_if_main_15
:end_if_group_15
IF NOT %obuild_group% == main GOTO end_if_group_16
IF NOT %obuild_do_mains% == yes GOTO end_if_main_16
  IF NOT EXIST .\DOS\build_app_AIDA_example_Store_vis.bat  GOTO end_if_build_16
    CALL .\DOS\build_app_AIDA_example_Store_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_16
:end_if_main_16
:end_if_group_16
IF NOT %obuild_group% == main GOTO end_if_group_17
IF NOT %obuild_do_mains% == yes GOTO end_if_main_17
  IF NOT EXIST .\DOS\build_app_AIDA_example_Restore_vis.bat  GOTO end_if_build_17
    CALL .\DOS\build_app_AIDA_example_Restore_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_17
:end_if_main_17
:end_if_group_17
IF NOT %obuild_group% == main GOTO end_if_group_18
IF NOT %obuild_do_mains% == yes GOTO end_if_main_18
  IF NOT EXIST .\DOS\build_app_AIDA_example_Chi2FitToHistogram_vis.bat  GOTO end_if_build_18
    CALL .\DOS\build_app_AIDA_example_Chi2FitToHistogram_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_18
:end_if_main_18
:end_if_group_18
IF NOT %obuild_group% == main GOTO end_if_group_19
IF NOT %obuild_do_mains% == yes GOTO end_if_main_19
  IF NOT EXIST .\DOS\build_app_AIDA_example_ComplexFit_vis.bat  GOTO end_if_build_19
    CALL .\DOS\build_app_AIDA_example_ComplexFit_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_19
:end_if_main_19
:end_if_group_19
IF NOT %obuild_group% == main GOTO end_if_group_20
IF NOT %obuild_do_mains% == yes GOTO end_if_main_20
  IF NOT EXIST .\DOS\build_app_AIDA_example_CreateAndFitDataPointSet_vis.bat  GOTO end_if_build_20
    CALL .\DOS\build_app_AIDA_example_CreateAndFitDataPointSet_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_20
:end_if_main_20
:end_if_group_20
IF NOT %obuild_group% == main GOTO end_if_group_21
IF NOT %obuild_do_mains% == yes GOTO end_if_main_21
  IF NOT EXIST .\DOS\build_app_AIDA_example_FitExample_vis.bat  GOTO end_if_build_21
    CALL .\DOS\build_app_AIDA_example_FitExample_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_21
:end_if_main_21
:end_if_group_21
IF NOT %obuild_group% == main GOTO end_if_group_22
IF NOT %obuild_do_mains% == yes GOTO end_if_main_22
  IF NOT EXIST .\DOS\build_app_AIDA_example_ProfileFitAndPlot_vis.bat  GOTO end_if_build_22
    CALL .\DOS\build_app_AIDA_example_ProfileFitAndPlot_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_22
:end_if_main_22
:end_if_group_22
IF NOT %obuild_group% == main GOTO end_if_group_23
IF NOT %obuild_do_mains% == yes GOTO end_if_main_23
  IF NOT EXIST .\DOS\build_app_AIDA_example_ScanAndContour_vis.bat  GOTO end_if_build_23
    CALL .\DOS\build_app_AIDA_example_ScanAndContour_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_23
:end_if_main_23
:end_if_group_23
IF NOT %obuild_group% == main GOTO end_if_group_24
IF NOT %obuild_do_mains% == yes GOTO end_if_main_24
  IF NOT EXIST .\DOS\build_app_AIDA_example_SimpleFit_vis.bat  GOTO end_if_build_24
    CALL .\DOS\build_app_AIDA_example_SimpleFit_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_24
:end_if_main_24
:end_if_group_24
IF NOT %obuild_group% == main GOTO end_if_group_25
IF NOT %obuild_do_mains% == yes GOTO end_if_main_25
  IF NOT EXIST .\DOS\build_app_AIDA_example_anaphe_b1_vis.bat  GOTO end_if_build_25
    CALL .\DOS\build_app_AIDA_example_anaphe_b1_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_25
:end_if_main_25
:end_if_group_25
IF NOT %obuild_group% == main GOTO end_if_group_26
IF NOT %obuild_do_mains% == yes GOTO end_if_main_26
  IF NOT EXIST .\DOS\build_app_AIDA_example_anaphe_b2_vis.bat  GOTO end_if_build_26
    CALL .\DOS\build_app_AIDA_example_anaphe_b2_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_26
:end_if_main_26
:end_if_group_26
IF NOT %obuild_group% == main GOTO end_if_group_27
IF NOT %obuild_do_mains% == yes GOTO end_if_main_27
  IF NOT EXIST .\DOS\build_app_AIDA_example_anaphe_b3_vis.bat  GOTO end_if_build_27
    CALL .\DOS\build_app_AIDA_example_anaphe_b3_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_27
:end_if_main_27
:end_if_group_27
IF NOT %obuild_group% == main GOTO end_if_group_28
IF NOT %obuild_do_mains% == yes GOTO end_if_main_28
  IF NOT EXIST .\DOS\build_app_AIDA_example_anaphe_b4_vis.bat  GOTO end_if_build_28
    CALL .\DOS\build_app_AIDA_example_anaphe_b4_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_28
:end_if_main_28
:end_if_group_28
IF NOT %obuild_group% == main GOTO end_if_group_29
IF NOT %obuild_do_mains% == yes GOTO end_if_main_29
  IF NOT EXIST .\DOS\build_app_AIDA_example_anaphe_b5_vis.bat  GOTO end_if_build_29
    CALL .\DOS\build_app_AIDA_example_anaphe_b5_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_29
:end_if_main_29
:end_if_group_29
IF NOT %obuild_group% == main GOTO end_if_group_30
IF NOT %obuild_do_mains% == yes GOTO end_if_main_30
  IF NOT EXIST .\DOS\build_app_AIDA_example_anaphe_b6_vis.bat  GOTO end_if_build_30
    CALL .\DOS\build_app_AIDA_example_anaphe_b6_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_30
:end_if_main_30
:end_if_group_30
IF NOT %obuild_group% == main GOTO end_if_group_31
IF NOT %obuild_do_mains% == yes GOTO end_if_main_31
  IF NOT EXIST .\DOS\build_app_AIDA_example_anaphe_b7_vis.bat  GOTO end_if_build_31
    CALL .\DOS\build_app_AIDA_example_anaphe_b7_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_31
:end_if_main_31
:end_if_group_31
IF NOT %obuild_group% == main GOTO end_if_group_32
IF NOT %obuild_do_mains% == yes GOTO end_if_main_32
  IF NOT EXIST .\DOS\build_app_AIDA_example_anaphe_b8_vis.bat  GOTO end_if_build_32
    CALL .\DOS\build_app_AIDA_example_anaphe_b8_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_32
:end_if_main_32
:end_if_group_32
IF NOT %obuild_group% == main GOTO end_if_group_33
IF NOT %obuild_do_mains% == yes GOTO end_if_main_33
  IF NOT EXIST .\DOS\build_app_AIDA_example_anaphe_b11_vis.bat  GOTO end_if_build_33
    CALL .\DOS\build_app_AIDA_example_anaphe_b11_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_33
:end_if_main_33
:end_if_group_33
IF NOT %obuild_group% == main GOTO end_if_group_34
IF NOT %obuild_do_mains% == yes GOTO end_if_main_34
  IF NOT EXIST .\DOS\build_app_AIDA_example_jec_vis.bat  GOTO end_if_build_34
    CALL .\DOS\build_app_AIDA_example_jec_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_34
:end_if_main_34
:end_if_group_34
IF NOT %obuild_group% == main GOTO end_if_group_35
IF NOT %obuild_do_mains% == yes GOTO end_if_main_35
  IF NOT EXIST .\DOS\build_app_AIDA_example_rmason_vis.bat  GOTO end_if_build_35
    CALL .\DOS\build_app_AIDA_example_rmason_vis.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_35
:end_if_main_35
:end_if_group_35

:obuild_return
ENDLOCAL
@ECHO ON
