@ECHO OFF
SETLOCAL

REM #
REM # File produced by the obuild tool version 1.0
REM # for the package VisAIDA with version v1r0p4.
REM #

REM #////////////////////////////////////////////////
REM # Usage :
REM #   DOS> CD some_path\pack\version\obuild
REM #   DOS> DOS\run
REM # or :
REM #   DOS> call DOS\run.bat
REM #
REM #////////////////////////////////////////////////

REM #////////////////////////////////////////////////
REM #/// Get path of this file :
REM #////////////////////////////////////////////////
SET obuild_VisAIDA_path=%~dp0
REM # Remove ending \obuild\DOS\
SET obuild_VisAIDA_path=%obuild_VisAIDA_path:~0,-12%

SET obuild_verbose=no
SET obuild_set_x=no
SET obuild_do_mains=yes
SET obuild_group=main

REM #////////////////////////////////////////////////
REM #/// Treat arguments :
REM #////////////////////////////////////////////////

:next_arg
IF "%1%" == "" GOTO end_args

IF NOT "%1%" == "-h" GOTO end_if_h
  ECHO Usage :
  ECHO   DOS\run [Options]
  ECHO Options :
  ECHO   -v : verbose.
  ECHO   -x : execute with ECHO ON"
  ECHO   -nm : build the not-main components.
  ECHO   -group group : build the given group of components.
  GOTO obuild_return
:end_if_h

IF NOT "%1%" == "-v" GOTO end_if_v
  SET obuild_verbose=yes
  SHIFT
  GOTO next_arg
:end_if_v

IF NOT "%1%" == "-x" GOTO end_if_x
  SET obuild_set_x=yes
  SHIFT
  GOTO next_arg
:end_if_x

IF NOT "%1%" == "-nm" GOTO end_if_nm
  SET obuild_do_mains=no
  SHIFT
  GOTO next_arg
:end_if_nm

IF NOT "%1%" == "-group" GOTO end_if_group
  SHIFT
  SET obuild_group=%1%
  SHIFT
  GOTO next_arg
:end_if_group

:end_args

REM #////////////////////////////////////////////////
REM #/// End arguments.
REM #////////////////////////////////////////////////

IF %obuild_set_x% == yes ECHO ON

IF "%OBUILD_DIR_BIN%" == "" (
  SET obuild_dir_bin=bin_obuild
) ELSE (
  SET obuild_dir_bin=%OBUILD_DIR_BIN%
)

IF "%obuild_dir_bin%" == "" (
  ECHO obuild_dir_bin variable not defined.
  GOTO obuild_return
)

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_VisAIDA_0=%%d
IF NOT %obuild_group% == main GOTO end_if_group_0
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_ChainedAndFilteredTuplesExample_vis.exe"  GOTO end_if_run_1
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_ChainedAndFilteredTuplesExample_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_1
:end_if_group_0
IF NOT %obuild_group% == main GOTO end_if_group_1
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_Cloud_vis.exe"  GOTO end_if_run_3
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_Cloud_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_3
:end_if_group_1
IF NOT %obuild_group% == main GOTO end_if_group_2
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_CloudCreate_vis.exe"  GOTO end_if_run_5
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_CloudCreate_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_5
:end_if_group_2
IF NOT %obuild_group% == main GOTO end_if_group_3
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_DataPointSetCreateAndFill_vis.exe"  GOTO end_if_run_7
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_DataPointSetCreateAndFill_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_7
:end_if_group_3
IF NOT %obuild_group% == main GOTO end_if_group_4
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_FilterAndEvaluatorExample_vis.exe"  GOTO end_if_run_9
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_FilterAndEvaluatorExample_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_9
:end_if_group_4
IF NOT %obuild_group% == main GOTO end_if_group_5
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_Histogram_vis.exe"  GOTO end_if_run_11
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_Histogram_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_11
:end_if_group_5
IF NOT %obuild_group% == main GOTO end_if_group_6
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_HistogramArithmetic_vis.exe"  GOTO end_if_run_13
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_HistogramArithmetic_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_13
:end_if_group_6
IF NOT %obuild_group% == main GOTO end_if_group_7
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_PlotExample_vis.exe"  GOTO end_if_run_15
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_PlotExample_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_15
:end_if_group_7
IF NOT %obuild_group% == main GOTO end_if_group_8
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_PlotWithStyles_vis.exe"  GOTO end_if_run_17
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_PlotWithStyles_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_17
:end_if_group_8
IF NOT %obuild_group% == main GOTO end_if_group_9
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_ProfileCreate_vis.exe"  GOTO end_if_run_19
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_ProfileCreate_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_19
:end_if_group_9
IF NOT %obuild_group% == main GOTO end_if_group_10
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_ProfileFill_vis.exe"  GOTO end_if_run_21
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_ProfileFill_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_21
:end_if_group_10
IF NOT %obuild_group% == main GOTO end_if_group_11
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_Tree_vis.exe"  GOTO end_if_run_23
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_Tree_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_23
:end_if_group_11
IF NOT %obuild_group% == main GOTO end_if_group_12
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_Tuple_vis.exe"  GOTO end_if_run_25
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_Tuple_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_25
:end_if_group_12
IF NOT %obuild_group% == main GOTO end_if_group_13
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_TupleCreate_vis.exe"  GOTO end_if_run_27
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_TupleCreate_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_27
:end_if_group_13
IF NOT %obuild_group% == main GOTO end_if_group_14
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_createAndFillTupleWithComplexStructure_vis.exe"  GOTO end_if_run_29
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_createAndFillTupleWithComplexStructure_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_29
:end_if_group_14
IF NOT %obuild_group% == main GOTO end_if_group_15
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_DataPointSetCreateFromData_vis.exe"  GOTO end_if_run_31
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_DataPointSetCreateFromData_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_31
:end_if_group_15
IF NOT %obuild_group% == main GOTO end_if_group_16
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_Store_vis.exe"  GOTO end_if_run_33
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_Store_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_33
:end_if_group_16
IF NOT %obuild_group% == main GOTO end_if_group_17
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_Restore_vis.exe"  GOTO end_if_run_35
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_Restore_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_35
:end_if_group_17
IF NOT %obuild_group% == main GOTO end_if_group_18
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_Chi2FitToHistogram_vis.exe"  GOTO end_if_run_37
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_Chi2FitToHistogram_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_37
:end_if_group_18
IF NOT %obuild_group% == main GOTO end_if_group_19
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_ComplexFit_vis.exe"  GOTO end_if_run_39
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_ComplexFit_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_39
:end_if_group_19
IF NOT %obuild_group% == main GOTO end_if_group_20
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_CreateAndFitDataPointSet_vis.exe"  GOTO end_if_run_41
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_CreateAndFitDataPointSet_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_41
:end_if_group_20
IF NOT %obuild_group% == main GOTO end_if_group_21
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_FitExample_vis.exe"  GOTO end_if_run_43
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_FitExample_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_43
:end_if_group_21
IF NOT %obuild_group% == main GOTO end_if_group_22
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_ProfileFitAndPlot_vis.exe"  GOTO end_if_run_45
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_ProfileFitAndPlot_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_45
:end_if_group_22
IF NOT %obuild_group% == main GOTO end_if_group_23
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_ScanAndContour_vis.exe"  GOTO end_if_run_47
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_ScanAndContour_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_47
:end_if_group_23
IF NOT %obuild_group% == main GOTO end_if_group_24
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_SimpleFit_vis.exe"  GOTO end_if_run_49
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_SimpleFit_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_49
:end_if_group_24
IF NOT %obuild_group% == main GOTO end_if_group_25
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b1_vis.exe"  GOTO end_if_run_51
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b1_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_51
:end_if_group_25
IF NOT %obuild_group% == main GOTO end_if_group_26
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b2_vis.exe"  GOTO end_if_run_53
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b2_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_53
:end_if_group_26
IF NOT %obuild_group% == main GOTO end_if_group_27
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b3_vis.exe"  GOTO end_if_run_55
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b3_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_55
:end_if_group_27
IF NOT %obuild_group% == main GOTO end_if_group_28
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b4_vis.exe"  GOTO end_if_run_57
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b4_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_57
:end_if_group_28
IF NOT %obuild_group% == main GOTO end_if_group_29
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b5_vis.exe"  GOTO end_if_run_59
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b5_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_59
:end_if_group_29
IF NOT %obuild_group% == main GOTO end_if_group_30
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b6_vis.exe"  GOTO end_if_run_61
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b6_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_61
:end_if_group_30
IF NOT %obuild_group% == main GOTO end_if_group_31
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b7_vis.exe"  GOTO end_if_run_63
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b7_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_63
:end_if_group_31
IF NOT %obuild_group% == main GOTO end_if_group_32
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b8_vis.exe"  GOTO end_if_run_65
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b8_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_65
:end_if_group_32
IF NOT %obuild_group% == main GOTO end_if_group_33
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b11_vis.exe"  GOTO end_if_run_67
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b11_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_67
:end_if_group_33
IF NOT %obuild_group% == main GOTO end_if_group_34
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_jec_vis.exe"  GOTO end_if_run_69
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_jec_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_69
:end_if_group_34
IF NOT %obuild_group% == main GOTO end_if_group_35
  IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_rmason_vis.exe"  GOTO end_if_run_71
@IF %obuild_verbose% == yes @ECHO ON 
    "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_rmason_vis.exe"
    @IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 
:end_if_run_71
:end_if_group_35


cd "%obuild_pwd_VisAIDA_0%"
SET obuild_pwd_VisAIDA_0=
:obuild_return
ENDLOCAL
@ECHO ON
