// LAL : Laurent Garnier.
#ifdef WIN32
//FIXME : do the Windows version !
int main() {return 0;}
#else

#include <config.h>

#include <vector>
#include <iostream>
#include <string>
#include <stdio.h>
#include <stdlib.h>
#include "stringstream.h"


#include "PipeStream.h"
string& substitute_font_string (const string fmt,
					const string mode,
					const string fontname,
					const int dpi,
					const int basedpi,
					const double magnification);

int main (int argc, char **argv)
{
  //////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////

string fontgenCommandTemplate_ = string(FONT_GEN_TEMPLATE)
  + " --destdir "
  + string(getenv(FONT_ENV_VARIABLE))
  + FONT_SEARCH_PATH
  + FSPATH_SEP +" "
  + FONT_GEN_OPTIONS;

  char *texmfcnf = getenv ("TEXMFCNF");
  if (texmfcnf == NULL) {
#ifdef DEFAULT_TEXMFCNF
    texmfcnf = DEFAULT_TEXMFCNF;
#else
    texmfcnf = "";
#endif
  }


  int dpi[14];
  dpi[0] = 110;
  dpi[1] = 125;
  dpi[2] = 150;
  dpi[3] = 180;
  dpi[4] = 220;
  dpi[5] = 252;
  dpi[6] = 288;
  dpi[7] = 324;
  dpi[8] = 360;
  dpi[9] = 394;
  dpi[11] = 432;
  dpi[12] = 518;
  dpi[13] = 622;

  string fname[63];
  fname[0] = "cmb";
  fname[1] = "cmbsy";
  fname[2] = "cmbx";
  fname[3] = "cmbxsl";
  fname[4] = "cmbxti";
  fname[5] = "cmcsc";
  fname[6] = "cmdunh";
  fname[7] = "cmex";
  fname[8] = "cmff";
  fname[9] = "cmfib";
  fname[10] = "cminch";
  fname[11] = "cmitt";
  fname[12] = "cmmi";
  fname[13] = "cmr";
  fname[14] = "cmsl";
  fname[15] = "cmsltt";
  fname[16] = "cmss";
  fname[17] = "cmssbx";
  fname[18] = "cmssdc";
  fname[19] = "cmssi";
  fname[20] = "cmssqi";
  fname[21] = "cmsy";
  fname[22] = "cmtcsc";
  fname[23] = "cmtex";
  fname[24] = "cmti";
  fname[25] = "cmtt";
  fname[26] = "cmu";
  fname[27] = "cmvtt";
  fname[28] = "lasy";
  fname[29] = "lasyb";
  fname[43] = "euex";
  fname[44] = "eufb";
  fname[30] = "eufm";
  fname[31] = "eurb";
  fname[32] = "eurm";
  fname[33] = "eusb";
  fname[34] = "eusm";
  fname[35] = "icmex";
  fname[36] = "icmmi";
  fname[37] = "icmsy";
  fname[38] = "icmtt";
  fname[39] = "ilasy";
  fname[40] = "ilcmss";
  fname[41] = "ilcmssb";
  fname[42] = "ilcmssi";
  //  fname[45] = "lcircle";
  //  fname[46] = "lcirclew";
  fname[47] = "lcmss";
  fname[48] = "lcmssb";
  fname[49] = "lcmssi";
  //  fname[50] = "line";
  //  fname[51] = "linew";
  fname[52] = "msam";
  fname[53] = "msbm";
  fname[54] = "wncyb";
  fname[55] = "wncyi";
  fname[56] = "wncyr";
  fname[57] = "wycysc";
  fname[58] = "wycyss";
  fname[59] = "ecbx";
  fname[60] = "eccc";
  fname[61] = "ecrm";
  fname[62] = "ecss";
  fname[50] = "ecti";
  fname[51] = "ectt";
  fname[45] = "wasy";
  fname[46] = "wasyb";
 
  float mag;
  int res = 110;
  string resMode = "ibmvga";

  for (int s=5;s<12;s++) {
    char size[2];
    sprintf(size,"%d",s);

    for (unsigned int d=0;d<14;d++) {
      if (dpi[d] <180) {
        res = 110;
        resMode = "ibmvga";
      } else if (dpi[d] <300) {
        res = 180;
        resMode = "lqlores";
      } else if (dpi[d] <360) {
        res = 300;
        resMode = "cx";
      } else {
        res = 360;
        resMode = "lqhires";
      }
      for (unsigned int n=0;n<30;n++) {
        mag = (float)dpi[d]/res;
        string cmd = substitute_font_string (fontgenCommandTemplate_,
                                             resMode,fname[n]+string(size),
                                             dpi[d],res,
                                             mag);
        
        printf("run:%s\n",cmd.c_str());
        PipeStream *PS = new PipeStream(cmd,texmfcnf);
      }
    }
  }
  
  //////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////
}

string& substitute_font_string (const string fmt,
					const string mode,
					const string fontname,
					const int dpi,
					const int basedpi,
					const double magnification)
{
    static string retval;
    SSTREAM newstring;


    for (const char *p = fmt.c_str(); *p != '\0'; p++)
    {
	if (*p == '%')
	    switch (*++p)
	    {
	      case 'M':
		newstring << mode;
		break;
	      case 'm':
	        newstring << magnification;
	        break;
	      case 'f':
		newstring << fontname;
		break;
	      case 'd':
		newstring << dpi;
		break;
	      case 'b':
		newstring << basedpi;
		break;
	      case '%':
		newstring << '%';
		break;
	      default:
		{
		}
		/* NOTREACHED */
	    }
	else
	    newstring << *p;
    }
    retval = SS_STRING(newstring);

    return retval;
}
#endif
