#ifndef obuild_Shell_h
#define obuild_Shell_h

#include <string>
#include <vector>

namespace Slash {namespace Core {class IWriter;}}

namespace Lib {class FileWriter;}

namespace obuild {

class Shell {
public:
  Shell(Slash::Core::IWriter&);
  virtual ~Shell();
public:
  bool setup(const std::vector<std::string>& reps,
             const std::vector<std::string>& pvs);
  bool setupFromFile(const std::string&);
  bool start();
private:
  void dispatch(const std::string&);
  void process_packages(const std::string& = "");
  void removeOut();
  bool openOut();
  bool closeOut();
  bool get_cvs_version(const std::string&,std::string&);
  bool get_cmt_version(const std::string&,std::string&);
  bool check_versions(const std::string&);
  bool has_changed(const std::string&,const std::string&,bool&);
  bool check_obuild_setups(const std::string&);
  bool p_v(const std::string&,std::string&,std::string&);
  bool release();
private:
  static void del(const std::string&);
  static std::string sep();
  static std::string cmd_and();
  static std::string cmd_redirect();
  static std::string cmd_to_log();
  static std::string cmd_build(const std::string& = "");
  static std::string cmd_run(const std::string& = "");
  static std::string quote(const std::string&);
private:
  Slash::Core::IWriter& fPrinter;
  std::vector<std::string> fPackages;
  std::vector<std::string> fRepositories;
  std::vector<std::string> fHistory;
  bool fShowTime;
  Lib::FileWriter* fOut;
};

}

#endif
