// this :
#include <Lib/FileReader.h>

#include <Lib/Out.h>
#include <Lib/Debug.h>

#include <stdio.h>

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
Lib::FileReader::FileReader(
 const std::string& aFileName
,Slash::Core::IWriter& aPrinter
)
:fPrinter(aPrinter)
,fFileName(aFileName)
,fFILE(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Debug::increment("Lib::FileReader");
  fFILE = ::fopen(aFileName.c_str(),"rb");
}
//////////////////////////////////////////////////////////////////////////////
Lib::FileReader::~FileReader(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(fFILE) ::fclose((FILE*)fFILE);
  Lib::Debug::decrement("Lib::FileReader");
}
//////////////////////////////////////////////////////////////////////////////
void Lib::FileReader::disable(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!fFILE) return; // Already closed.
  ::fclose((FILE*)fFILE);
  fFILE = 0;
}
//////////////////////////////////////////////////////////////////////////////
void Lib::FileReader::enable(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(fFILE) return; // Already open.
  fFILE = ::fopen(fFileName.c_str(),"rb");
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::FileReader::enabled(
) const 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fFILE ? true : false;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::FileReader::read(
 void* aBuffer
,unsigned int aLength
,int& aReadLength
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  aReadLength = 0;
  if(!fFILE) return false;
  size_t len = ::fread(aBuffer,1,aLength,(FILE*)fFILE);
  aReadLength = (size_t)len;
  return true;
}
