#!/bin/sh -f

#
# File produced by the obuild tool version @@obuild_version@@
# for the package @@package@@ with version @@version@@.
#

#////////////////////////////////////////////////
# Usage :
#   UNIX> cd some_path/pack/version/obuild
# ( UNIX> chmod a+x sh/run )
#   UNIX> sh/run
#
#////////////////////////////////////////////////

#obuild_args="$*"

obuild_verbose=no
obuild_set_x=no
obuild_do_mains=yes
obuild_group=main

while test $# -ge 1 ; do
  case $1 in
    -h) 
        echo "Usage :"
        echo "  UNIX> sh/run [Options]"
        echo "Options :"
        echo "  -v : verbose."
        echo "  -x : execute with set -x."
        echo "  -nm : build the not-main components."
        echo "  -group group : build the given group of components."
        echo ""
        exit ;;
    -v) obuild_verbose=yes ;;
    -x) obuild_set_x=yes ;;
    -nm) obuild_do_mains=no ;;
    -group) shift
        if [ $# != 0 ] ; then
          obuild_group=$1 
        else         
          echo "give a group name after the -group option."
          exit 
        fi ;;
    -*) echo "unknwon option : $1" ; exit ;;
  esac
  shift
done

if [ ${obuild_set_x} = yes ] ; then
  set -x
fi

if [  "${OBUILD_DIR_BIN}" = "" ] ; then
  @@dir_bin_variable@@=bin_obuild
else
  @@dir_bin_variable@@=${OBUILD_DIR_BIN}
fi

if [ "${@@dir_bin_variable@@}" = "" ] ; then
  echo "@@dir_bin_variable@@ variable not defined."
  exit
fi

obuild_pwd=`pwd`
@@path_variable@@=`dirname "${obuild_pwd}"`
unset obuild_pwd


