@ECHO OFF
SETLOCAL

REM # SSH :
SET PATH=%PATH%;C:\Program Files\SSH Communications Security\SSH Secure Shell

SET old_PATH=%PATH%
REM # zip.exe, unzip.exe, wget.exe :
SET PATH=%PATH%;C:\CYGWIN\bin

SET TEMP=C:\barrand\temp

REM #
REM # At this point wget.exe, unzip.exe and 
REM # scp2.exe, ssh2.exe should be in the PATH.
REM #

REM # //////////////////////////////////////////////////////////////////
REM # // args //////////////////////////////////////////////////////////
REM # //////////////////////////////////////////////////////////////////

SET osc_wget_build_what=
SET osc_wget_build_version=
SET osc_wget_build_clean=yes

:next_arg
IF "%1%" == "" GOTO end_args

IF NOT "%1%" == "-h" GOTO end_if_h
  ECHO Arguments :
  ECHO  -what : [osc_batch,osc_vis,...].
  ECHO  -version : version to build.
  ECHO  -no_clean : do not remove the build area when finished.
  ECHO
  ECHO Examples :
  ECHO   osc_wget_build -what osc_vis -version v16r3
  GOTO osc_wget_build_return
:end_if_h

IF NOT "%1%" == "-what" GOTO end_if_what
  SHIFT
  SET osc_wget_build_what=%1%
  SHIFT
  GOTO next_arg
:end_if_what

IF NOT "%1%" == "-version" GOTO end_if_version
  SHIFT
  SET osc_wget_build_version=%1%
  SHIFT
  GOTO next_arg
:end_if_version

IF NOT "%1%" == "-no_clean" GOTO end_if_no_clean
  SET osc_wget_build_clean=no
  SHIFT
  GOTO next_arg
:end_if_no_clean

:end_args

REM # //////////////////////////////////////////////////////////////////
REM # //////////////////////////////////////////////////////////////////
REM # //////////////////////////////////////////////////////////////////

IF NOT "%osc_wget_build_what%" == "" GOTO end_if_check_what
  ECHO No target given
  GOTO osc_wget_build_return
:end_if_check_what

IF NOT "%osc_wget_build_version%" == "" GOTO end_if_check_version
  ECHO No version given
  GOTO osc_wget_build_return
:end_if_check_version

SET file_src=%osc_wget_build_what%
SET build_Zebra=no
SET build_Python=no
SET build_Qt=no
SET build_gtk=no
SET build_SDL=no
SET build_Geant4=no
IF NOT %osc_wget_build_what% == osc_batch GOTO osc_wget_build_end_if_osc_batch
  SET build_Zebra=yes
:osc_wget_build_end_if_osc_batch

IF NOT %osc_wget_build_what% == osc_vis GOTO osc_wget_build_end_if_osc_vis
  SET file_src=osc
  SET build_Zebra=yes
  SET build_Python=yes
  SET build_Qt=yes
REM  SET build_gtk=yes
  SET build_SDL=yes
  SET build_Geant4=yes
:osc_wget_build_end_if_osc_vis

IF NOT %osc_wget_build_what% == osc_g4 GOTO osc_wget_build_end_if_osc_g4
  SET file_src=osc
  SET build_Zebra=yes
  SET build_Python=yes
  SET build_Qt=yes
REM  SET build_gtk=yes
  SET build_SDL=yes
  SET build_Geant4=yes
:osc_wget_build_end_if_osc_g4

SET build_dir=OpenScientist\build_%osc_wget_build_what%_%osc_wget_build_version%
IF EXIST %build_dir% RMDIR /S /Q %build_dir%
IF NOT EXIST %build_dir% MKDIR %build_dir%
CD %build_dir%

SET file=%file_src%_source_%osc_wget_build_version%.zip
SET url=http://OpenScientist.lal.in2p3.fr/download/tmpup/%file%

REM SET web_getter=curl.exe -s -O
SET web_getter=wget.exe -q

%web_getter% %url%
IF ERRORLEVEL 1 ECHO Unable to get %file% && GOTO osc_wget_build_return

IF NOT EXIST %file% ECHO Unable to get %file% && GOTO osc_wget_build_return

unzip -q %file%
CD OpenScientist\%osc_wget_build_version%\%osc_wget_build_what%\%osc_wget_build_version%\obuild
REM # Avoid clash with programs in C:\CYGWIN\bin :
SET PATH=%old_PATH%
CALL setup.bat
@ECHO OFF
CALL DOS\build.bat
@ECHO OFF
IF NOT %build_Zebra% == yes GOTO osc_wget_build_end_if_build_Zebra
  REM # Set DF98 FORTRAN :
  SET PATH=%PATH%;C:\Program Files\Microsoft Visual Studio\DF98\BIN
  SET LIB=%LIB%;C:\Program Files\Microsoft Visual Studio\DF98\LIB
  SET INCLUDE=%INCLUDE%;C:\Program Files\Microsoft Visual Studio\DF98\INCLUDE
  ECHO ////////////////////
  ECHO build group Zebra...
  ECHO ////////////////////
  CALL DOS\build.bat -group Zebra
  @ECHO OFF
:osc_wget_build_end_if_build_Zebra

IF NOT %build_Python% == yes GOTO osc_wget_build_end_if_build_Python
  ECHO ////////////////////
  ECHO build group Python...
  ECHO ////////////////////
  CALL DOS\build -group Python
  @ECHO OFF
:osc_wget_build_end_if_build_Python

IF NOT %build_Qt% == yes GOTO osc_wget_build_end_if_build_Qt
  ECHO ////////////////////
  ECHO build group Qt...
  ECHO ////////////////////
  CALL DOS\build -group Qt
  @ECHO OFF
:osc_wget_build_end_if_build_Qt

IF NOT %build_gtk% == yes GOTO osc_wget_build_end_if_build_gtk
  ECHO ////////////////////
  ECHO build group gtk...
  ECHO ////////////////////
  CALL DOS\build -group gtk
  @ECHO OFF
:osc_wget_build_end_if_build_gtk

IF NOT %build_SDL% == yes GOTO osc_wget_build_end_if_build_SDL
  ECHO ////////////////////
  ECHO build group SDL...
  ECHO ////////////////////
  CALL DOS\build -group SDL
  @ECHO OFF
:osc_wget_build_end_if_build_SDL

IF NOT %build_Geant4% == yes GOTO osc_wget_build_end_if_build_Geant4
  ECHO ////////////////////
  ECHO build group Geant4...
  ECHO ////////////////////
  CALL DOS\build -group Geant4
  @ECHO OFF
:osc_wget_build_end_if_build_Geant4

REM # to have zip.exe :
SET PATH=%PATH%;C:\CYGWIN\bin
ECHO ////////////////////
ECHO build release...
ECHO ////////////////////
CALL DOS\build_release
@ECHO OFF

IF NOT EXIST ..\bin_obuild ECHO ../bin_obuild directory not found. && GOTO osc_wget_build_return

CD ..\bin_obuild

FOR %%d IN (*.zip) DO SET zip_file=%%d

IF "%zip_file%" == "" ECHO zip file not found. && GOTO osc_wget_build_return

FOR %%d IN (%zip_file%) DO SET sz_local=%%~zd
REM ECHO %sz_local%

SET remote=barrand@lx2.lal.in2p3.fr
scp2 %zip_file% %remote%:tmpup/%zip_file%
SET command=ssh2 %remote% "ls -al tmpup/%zip_file% | awk '{print $5;}'"
FOR /F "usebackq" %%d IN (`%command%`) DO SET sz_remote=%%d

REM ECHO %sz_remote%
IF "%sz_local%" NEQ "%sz_remote%" ECHO uploaded zip file mismatch. && GOTO osc_wget_build_return

IF "%osc_wget_build_clean%" == "yes" RMDIR /S /Q %build_dir%

:osc_wget_build_return
ENDLOCAL
@ECHO ON
