@ECHO OFF
SETLOCAL

REM #
REM # File produced by the obuild tool version 1.0
REM # for the package OpenScientist with version v16r5.
REM #

REM #////////////////////////////////////////////////
REM # Usage :
REM #   DOS> CD some_path\pack\version\obuild
REM #   DOS> DOS\build
REM # or :
REM #   DOS> call DOS\build.bat
REM #
REM #////////////////////////////////////////////////

REM #////////////////////////////////////////////////
REM #/// Get path of this file :
REM #////////////////////////////////////////////////
SET obuild_OpenScientist_path=%~dp0
REM # Remove ending \obuild\DOS\
SET obuild_OpenScientist_path=%obuild_OpenScientist_path:~0,-12%

REM #////////////////////////////////////////////////
REM #/// Treat arguments :
REM #////////////////////////////////////////////////

SET obuild_verbose=no

SET obuild_args=

:next_arg
IF "%1%" == "" GOTO end_args

IF NOT "%1%" == "-h" GOTO end_if_h
  ECHO Usage :
  ECHO   build [Options]
  ECHO Options :
  ECHO   -v : verbose.
  ECHO   -x : execute with ECHO ON"
  ECHO   -* : passed to packages build script.
  ECHO
  GOTO obuild_return
:end_if_h

IF NOT "%1%" == "-v" GOTO end_if_v
  SET obuild_verbose=yes
  SET obuild_args=%obuild_args% -v
  SHIFT
  GOTO next_arg
:end_if_v

IF NOT "%1%" == "-x" GOTO end_if_x
  ECHO ON
  SET obuild_args=%obuild_args% -x
  SHIFT
  GOTO next_arg
:end_if_x

SET obuild_args=%obuild_args% %1%
SHIFT
GOTO next_arg

:end_args

REM #////////////////////////////////////////////////
REM #/// End arguments.
REM #////////////////////////////////////////////////


FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_0=%%d

IF NOT EXIST "%obuild_OpenScientist_path%\%obuild_dir_bin%" MKDIR "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST "%obuild_OpenScientist_path%\%obuild_dir_bin%\obuild_find.exe" (
  cl.exe /nologo /DWIN32 /MD /O2 /W3 /GX /GR /Fe"%obuild_OpenScientist_path%\%obuild_dir_bin%\obuild_find.exe" "%obuild_OpenScientist_path%\obuild\cpp\obuild_find.cpp" 1> cl_exe_error
  IF ERRORLEVEL 1 TYPE cl_exe_error
  IF NOT ERRORLEVEL 1 DEL cl_exe_error 
  IF EXIST obuild_find.obj DEL obuild_find.obj
)
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  obuild v1r4p0`) DO SET obuild_obuild_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_obuild_path  ECHO Can't find obuild package.  && GOTO obuild_return

cd "%obuild_obuild_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build obuild/v1r4p0 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  foreign v1r4p0`) DO SET obuild_foreign_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_foreign_path  ECHO Can't find foreign package.  && GOTO obuild_return

cd "%obuild_foreign_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build foreign/v1r4p0 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  zlib v1r114p6`) DO SET obuild_zlib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_zlib_path  ECHO Can't find zlib package.  && GOTO obuild_return

cd "%obuild_zlib_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build zlib/v1r114p6 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  zip v1r101p0`) DO SET obuild_zip_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_zip_path  ECHO Can't find zip package.  && GOTO obuild_return

cd "%obuild_zip_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build zip/v1r101p0 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  expat v1r11p8`) DO SET obuild_expat_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_expat_path  ECHO Can't find expat package.  && GOTO obuild_return

cd "%obuild_expat_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build expat/v1r11p8 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Slash v1r2p0`) DO SET obuild_Slash_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Slash_path  ECHO Can't find Slash package.  && GOTO obuild_return

cd "%obuild_Slash_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build Slash/v1r2p0 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

cd "%obuild_Lib_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build Lib/v8r3p0 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HCL v7r0p2`) DO SET obuild_HCL_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HCL_path  ECHO Can't find HCL package.  && GOTO obuild_return

cd "%obuild_HCL_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build HCL/v7r0p2 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Midnight v4r0p2`) DO SET obuild_Midnight_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Midnight_path  ECHO Can't find Midnight package.  && GOTO obuild_return

cd "%obuild_Midnight_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build Midnight/v4r0p2 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Minuit v1r140p6`) DO SET obuild_Minuit_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Minuit_path  ECHO Can't find Minuit package.  && GOTO obuild_return

cd "%obuild_Minuit_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build Minuit/v1r140p6 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Rio v9r0p0`) DO SET obuild_Rio_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Rio_path  ECHO Can't find Rio package.  && GOTO obuild_return

cd "%obuild_Rio_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build Rio/v9r0p0 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HDF5 v1r165p5`) DO SET obuild_HDF5_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HDF5_path  ECHO Can't find HDF5 package.  && GOTO obuild_return

cd "%obuild_HDF5_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build HDF5/v1r165p5 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  BatchLab v1r3p0`) DO SET obuild_BatchLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_BatchLab_path  ECHO Can't find BatchLab package.  && GOTO obuild_return

cd "%obuild_BatchLab_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build BatchLab/v1r3p0 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

cd "%obuild_UseAIDA_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build UseAIDA/v1r0p5 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  osc_source v16r5`) DO SET obuild_osc_source_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_osc_source_path  ECHO Can't find osc_source package.  && GOTO obuild_return

cd "%obuild_osc_source_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build osc_source/v16r5 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  png v1r1216p3`) DO SET obuild_png_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_png_path  ECHO Can't find png package.  && GOTO obuild_return

cd "%obuild_png_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build png/v1r1216p3 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  jpeg v1r62p3`) DO SET obuild_jpeg_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_jpeg_path  ECHO Can't find jpeg package.  && GOTO obuild_return

cd "%obuild_jpeg_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build jpeg/v1r62p3 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  dvi2bitmap v1r0132p3`) DO SET obuild_dvi2bitmap_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_dvi2bitmap_path  ECHO Can't find dvi2bitmap package.  && GOTO obuild_return

cd "%obuild_dvi2bitmap_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build dvi2bitmap/v1r0132p3 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  freetype2 v1r219p2`) DO SET obuild_freetype2_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_freetype2_path  ECHO Can't find freetype2 package.  && GOTO obuild_return

cd "%obuild_freetype2_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build freetype2/v1r219p2 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinGL v1r250p0`) DO SET obuild_CoinGL_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_CoinGL_path  ECHO Can't find CoinGL package.  && GOTO obuild_return

cd "%obuild_CoinGL_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build CoinGL/v1r250p0 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinXt v1r122p2`) DO SET obuild_CoinXt_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_CoinXt_path  ECHO Can't find CoinXt package.  && GOTO obuild_return

cd "%obuild_CoinXt_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build CoinXt/v1r122p2 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinWin v1r50p7`) DO SET obuild_CoinWin_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_CoinWin_path  ECHO Can't find CoinWin package.  && GOTO obuild_return

cd "%obuild_CoinWin_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build CoinWin/v1r50p7 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinQt v1r130p2`) DO SET obuild_CoinQt_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_CoinQt_path  ECHO Can't find CoinQt package.  && GOTO obuild_return

cd "%obuild_CoinQt_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build CoinQt/v1r130p2 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinGtk v1r50p4`) DO SET obuild_CoinGtk_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_CoinGtk_path  ECHO Can't find CoinGtk package.  && GOTO obuild_return

cd "%obuild_CoinGtk_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build CoinGtk/v1r50p4 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinPython v1r0p2`) DO SET obuild_CoinPython_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_CoinPython_path  ECHO Can't find CoinPython package.  && GOTO obuild_return

cd "%obuild_CoinPython_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build CoinPython/v1r0p2 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  SoSDL v1r1p0`) DO SET obuild_SoSDL_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_SoSDL_path  ECHO Can't find SoSDL package.  && GOTO obuild_return

cd "%obuild_SoSDL_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build SoSDL/v1r1p0 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

cd "%obuild_HEPVis_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build HEPVis/v6r10p0 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  KUIP v1r950303p18`) DO SET obuild_KUIP_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_KUIP_path  ECHO Can't find KUIP package.  && GOTO obuild_return

cd "%obuild_KUIP_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build KUIP/v1r950303p18 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

cd "%obuild_OnX_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build OnX/v17r5p0 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

cd "%obuild_OnXLab_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build OnXLab/v1r2p0 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

cd "%obuild_VisAIDA_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build VisAIDA/v1r0p4 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OpenPAW v3r2p0`) DO SET obuild_OpenPAW_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OpenPAW_path  ECHO Can't find OpenPAW package.  && GOTO obuild_return

cd "%obuild_OpenPAW_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build OpenPAW/v3r2p0 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  G4Lab v8r3p0`) DO SET obuild_G4Lab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_G4Lab_path  ECHO Can't find G4Lab package.  && GOTO obuild_return

cd "%obuild_G4Lab_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build G4Lab/v8r3p0 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  G4Simple v2r2p0`) DO SET obuild_G4Simple_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_G4Simple_path  ECHO Can't find G4Simple package.  && GOTO obuild_return

cd "%obuild_G4Simple_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build G4Simple/v2r2p0 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  G4Examples v1r2p0`) DO SET obuild_G4Examples_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_G4Examples_path  ECHO Can't find G4Examples package.  && GOTO obuild_return

cd "%obuild_G4Examples_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build G4Examples/v1r2p0 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 

cd "%obuild_pwd_OpenScientist_0%"
SET obuild_pwd_OpenScientist_0=
:obuild_return
ENDLOCAL
@ECHO ON
