@ECHO OFF
SETLOCAL

REM #
REM # File produced by the obuild tool version 1.0
REM # for the package OpenScientist with version v16r5.
REM #

REM #////////////////////////////////////////////////
REM # Usage :
REM #   DOS> CD some_path\project\version\obuild
REM #   DOS> DOS\build_release
REM # or :
REM #   DOS> call DOS\build_release.bat
REM #
REM #////////////////////////////////////////////////

REM #////////////////////////////////////////////////
REM #/// Get path of this file :
REM #////////////////////////////////////////////////
SET obuild_OpenScientist_path=%~dp0
REM # Remove ending \obuild\DOS\
SET obuild_OpenScientist_path=%obuild_OpenScientist_path:~0,-12%

SET obuild_verbose=no
SET obuild_set_x=no
SET obuild_erase_dir_bin=no

REM #////////////////////////////////////////////////
REM #/// Treat arguments :
REM #////////////////////////////////////////////////

:next_arg
IF "%1%" == "" GOTO end_args

IF NOT "%1%" == "-h" GOTO end_if_h
  ECHO Usage :
  ECHO   DOS\run [Options]
  ECHO Options :
  ECHO   -v : verbose.
  ECHO   -x : execute with ECHO ON"
  ECHO   -e : erase binary directory.
  GOTO obuild_return
:end_if_h

IF NOT "%1%" == "-v" GOTO end_if_v
  SET obuild_verbose=yes
  SHIFT
  GOTO next_arg
:end_if_v

IF NOT "%1%" == "-x" GOTO end_if_x
  SET obuild_set_x=yes
  SHIFT
  GOTO next_arg
:end_if_x

IF NOT "%1%" == "-e" GOTO end_if_e
  SET obuild_erase_dir_bin=yes
  SHIFT
  GOTO next_arg
:end_if_e

:end_args

REM #////////////////////////////////////////////////
REM #/// End arguments.
REM #////////////////////////////////////////////////

IF %obuild_set_x% == yes ECHO ON

IF "%OBUILD_DIR_BIN%" == "" (
  SET obuild_dir_bin=bin_obuild
) ELSE (
  SET obuild_dir_bin=%OBUILD_DIR_BIN%
)

IF "%obuild_dir_bin%" == "" (
  ECHO obuild_dir_bin variable not defined.
  GOTO obuild_return
)

IF "%obuild_erase_dir_bin%" == "yes" (
  IF EXIST "%obuild_OpenScientist_path%\%obuild_dir_bin%" RMDIR /S /Q "%obuild_OpenScientist_path%\%obuild_dir_bin%"
  GOTO obuild_return
)

IF NOT EXIST "%obuild_OpenScientist_path%\%obuild_dir_bin%" MKDIR "%obuild_OpenScientist_path%\%obuild_dir_bin%"

IF NOT EXIST "%obuild_OpenScientist_path%\%obuild_dir_bin%" MKDIR "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST "%obuild_OpenScientist_path%\%obuild_dir_bin%\obuild_platform.exe" (
  cl.exe /nologo /DWIN32 /MD /O2 /W3  /GX /GR /Fe"%obuild_OpenScientist_path%\%obuild_dir_bin%\obuild_platform.exe" "%obuild_OpenScientist_path%\obuild\cpp\obuild_platform.cpp" 1> cl_exe_error
  IF ERRORLEVEL 1 TYPE cl_exe_error
  IF NOT ERRORLEVEL 1 DEL cl_exe_error 
  IF EXIST obuild_platform.obj DEL obuild_platform.obj
)

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_0=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OpenScientist_0%"
SET obuild_pwd_OpenScientist_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_1
SET CERNLIB_home=C:\cern\pro
:end_if_platform_1
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_0=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OpenScientist_0%"
SET obuild_pwd_OpenScientist_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_3
SET Qt_home=C:\usr\local\Qt\4.1.1
:end_if_platform_3
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_0=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OpenScientist_0%"
SET obuild_pwd_OpenScientist_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_5
SET Python_home=C:\usr\local\Python\2.5
:end_if_platform_5
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_0=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OpenScientist_0%"
SET obuild_pwd_OpenScientist_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_7
SET Python_version=25
:end_if_platform_7
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_0=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OpenScientist_0%"
SET obuild_pwd_OpenScientist_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_9
SET SDL_home=C:\usr\local\SDL\1.2.11
:end_if_platform_9
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_0=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OpenScientist_0%"
SET obuild_pwd_OpenScientist_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_11
SET curl_home=C:\usr\local\curl\7.15.1
:end_if_platform_11
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_0=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OpenScientist_0%"
SET obuild_pwd_OpenScientist_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_13
SET JavaVM_home=C:\usr\local\j2sdk1.4.1
:end_if_platform_13
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_0=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OpenScientist_0%"
SET obuild_pwd_OpenScientist_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_15
SET CLHEP_home=C:\cygwin\usr\local\CLHEP\2.0.3.2
:end_if_platform_15
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_0=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OpenScientist_0%"
SET obuild_pwd_OpenScientist_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_17
SET Geant4_system=WIN32-VC
:end_if_platform_17
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_0=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OpenScientist_0%"
SET obuild_pwd_OpenScientist_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_19
SET Geant4_home=C:\cygwin\usr\local\geant4\geant4-09-01-patch-01
:end_if_platform_19
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_0=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF EXIST OpenScientist RMDIR /S /Q OpenScientist
IF NOT EXIST OpenScientist MKDIR OpenScientist
cd OpenScientist
IF NOT EXIST v16r5 MKDIR v16r5
cd v16r5
IF NOT EXIST lib MKDIR lib
IF NOT EXIST bin MKDIR bin
IF NOT EXIST Resources MKDIR Resources
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_dir_project=%%d

IF EXIST "%obuild_dir_project%\Versions" DEL "%obuild_dir_project%\Versions"
ECHO package foreign v1r4p0   >> "%obuild_dir_project%\Versions"
ECHO package expat v1r11p8   >> "%obuild_dir_project%\Versions"
ECHO package Slash v1r2p0   >> "%obuild_dir_project%\Versions"
ECHO package Lib v8r3p0   >> "%obuild_dir_project%\Versions"
ECHO package BatchLab v1r3p0   >> "%obuild_dir_project%\Versions"
ECHO package UseAIDA v1r0p5   >> "%obuild_dir_project%\Versions"
ECHO package osc_source v16r5   >> "%obuild_dir_project%\Versions"
ECHO package CoinGL v1r250p0   >> "%obuild_dir_project%\Versions"
ECHO package CoinXt v1r122p2   >> "%obuild_dir_project%\Versions"
ECHO package CoinQt v1r130p2   >> "%obuild_dir_project%\Versions"
ECHO package CoinGtk v1r50p4   >> "%obuild_dir_project%\Versions"
ECHO package CoinPython v1r0p2   >> "%obuild_dir_project%\Versions"
ECHO package SoSDL v1r1p0   >> "%obuild_dir_project%\Versions"
ECHO package HEPVis v6r10p0   >> "%obuild_dir_project%\Versions"
ECHO package OnX v17r5p0   >> "%obuild_dir_project%\Versions"
ECHO package OnXLab v1r2p0   >> "%obuild_dir_project%\Versions"
ECHO package OpenPAW v3r2p0   >> "%obuild_dir_project%\Versions"
ECHO package G4Lab v8r3p0   >> "%obuild_dir_project%\Versions"
ECHO package G4Simple v2r2p0   >> "%obuild_dir_project%\Versions"
ECHO package G4Examples v1r2p0   >> "%obuild_dir_project%\Versions"
ECHO foreign CERNLIB 2003   >> "%obuild_dir_project%\Versions"
ECHO foreign Motif 2.2   >> "%obuild_dir_project%\Versions"
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_22
ECHO foreign Qt 4.1.1   >> "%obuild_dir_project%\Versions"
:end_if_platform_22
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_23
ECHO foreign Python 2.5   >> "%obuild_dir_project%\Versions"
:end_if_platform_23
SET obuild_platform_result=
ECHO foreign SDL 1.2.11   >> "%obuild_dir_project%\Versions"
ECHO foreign curl 3   >> "%obuild_dir_project%\Versions"
ECHO foreign CLHEP 2.0.3.2   >> "%obuild_dir_project%\Versions"
ECHO foreign Geant4 9.1.p01   >> "%obuild_dir_project%\Versions"

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_28
IF NOT EXIST "%Qt_home%\bin\moc.exe"  ECHO WARNING : File %Qt_home%\bin\moc.exe not found.  && GOTO end_if_release_29
IF NOT EXIST "%obuild_dir_project%\bin" MKDIR "%obuild_dir_project%\bin"
COPY "%Qt_home%\bin\moc.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
@IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_release_29
:end_if_platform_28
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_30
IF NOT EXIST "%Qt_home%\bin"  ECHO WARNING : Directory %Qt_home%\bin not found.  && GOTO end_if_release_31
IF NOT EXIST "%obuild_dir_project%\bin\." MKDIR "%obuild_dir_project%\bin\."
XCOPY /E /Q "%Qt_home%\bin"\Qt*.dll "%obuild_dir_project%\bin\." 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_31
:end_if_platform_30
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_32
IF NOT EXIST "%SDL_home%\lib"  ECHO WARNING : Directory %SDL_home%\lib not found.  && GOTO end_if_release_33
IF NOT EXIST "%obuild_dir_project%\bin\." MKDIR "%obuild_dir_project%\bin\."
XCOPY /E /Q "%SDL_home%\lib"\SDL.dll "%obuild_dir_project%\bin\." 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_33
:end_if_platform_32
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_34
IF NOT EXIST "%curl_home%"  ECHO WARNING : Directory %curl_home% not found.  && GOTO end_if_release_35
IF NOT EXIST "%obuild_dir_project%\bin\." MKDIR "%obuild_dir_project%\bin\."
XCOPY /E /Q "%curl_home%"\libcurl.dll "%obuild_dir_project%\bin\." 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_35
:end_if_platform_34
SET obuild_platform_result=

IF NOT EXIST "%obuild_OpenScientist_path%\%obuild_dir_bin%" MKDIR "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST "%obuild_OpenScientist_path%\%obuild_dir_bin%\obuild_find.exe" (
  cl.exe /nologo /DWIN32 /MD /O2 /W3 /GX /GR /Fe"%obuild_OpenScientist_path%\%obuild_dir_bin%\obuild_find.exe" "%obuild_OpenScientist_path%\obuild\cpp\obuild_find.cpp" 1> cl_exe_error
  IF ERRORLEVEL 1 TYPE cl_exe_error
  IF NOT ERRORLEVEL 1 DEL cl_exe_error 
  IF EXIST obuild_find.obj DEL obuild_find.obj
)
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  foreign v1r4p0`) DO SET obuild_foreign_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_foreign_path  ECHO Can't find foreign package.  && GOTO obuild_return

IF NOT EXIST "%obuild_foreign_path%\..\v1r4p0"  ECHO WARNING : Directory %obuild_foreign_path%\..\v1r4p0 not found.  && GOTO end_if_release_37
IF NOT EXIST "%obuild_dir_project%\Resources\foreign\.\v1r4p0" MKDIR "%obuild_dir_project%\Resources\foreign\.\v1r4p0"
XCOPY /E /Q "%obuild_foreign_path%\..\v1r4p0" "%obuild_dir_project%\Resources\foreign\.\v1r4p0" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_37
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  expat v1r11p8`) DO SET obuild_expat_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_expat_path  ECHO Can't find expat package.  && GOTO obuild_return

IF NOT EXIST "%obuild_expat_path%\include"  ECHO WARNING : Directory %obuild_expat_path%\include not found.  && GOTO end_if_release_39
IF NOT EXIST "%obuild_dir_project%\Resources\expat\.\include" MKDIR "%obuild_dir_project%\Resources\expat\.\include"
XCOPY /E /Q "%obuild_expat_path%\include" "%obuild_dir_project%\Resources\expat\.\include" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_39
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Slash v1r2p0`) DO SET obuild_Slash_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Slash_path  ECHO Can't find Slash package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Slash_path%\Slash"  ECHO WARNING : Directory %obuild_Slash_path%\Slash not found.  && GOTO end_if_release_41
IF NOT EXIST "%obuild_dir_project%\Resources\Slash\.\Slash" MKDIR "%obuild_dir_project%\Resources\Slash\.\Slash"
XCOPY /E /Q "%obuild_Slash_path%\Slash" "%obuild_dir_project%\Resources\Slash\.\Slash" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_41
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\include"  ECHO WARNING : Directory %obuild_Lib_path%\include not found.  && GOTO end_if_release_43
IF NOT EXIST "%obuild_dir_project%\Resources\Lib\.\include" MKDIR "%obuild_dir_project%\Resources\Lib\.\include"
XCOPY /E /Q "%obuild_Lib_path%\include" "%obuild_dir_project%\Resources\Lib\.\include" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_43
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  BatchLab v1r3p0`) DO SET obuild_BatchLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_BatchLab_path  ECHO Can't find BatchLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_BatchLab_path%\scripts"  ECHO WARNING : Directory %obuild_BatchLab_path%\scripts not found.  && GOTO end_if_release_45
IF NOT EXIST "%obuild_dir_project%\Resources\BatchLab\.\scripts" MKDIR "%obuild_dir_project%\Resources\BatchLab\.\scripts"
XCOPY /E /Q "%obuild_BatchLab_path%\scripts" "%obuild_dir_project%\Resources\BatchLab\.\scripts" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_45
IF NOT EXIST "%obuild_BatchLab_path%\examples"  ECHO WARNING : Directory %obuild_BatchLab_path%\examples not found.  && GOTO end_if_release_47
IF NOT EXIST "%obuild_dir_project%\Resources\BatchLab\.\examples" MKDIR "%obuild_dir_project%\Resources\BatchLab\.\examples"
XCOPY /E /Q "%obuild_BatchLab_path%\examples" "%obuild_dir_project%\Resources\BatchLab\.\examples" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_47
IF NOT EXIST "%obuild_BatchLab_path%\BatchLab"  ECHO WARNING : Directory %obuild_BatchLab_path%\BatchLab not found.  && GOTO end_if_release_49
IF NOT EXIST "%obuild_dir_project%\Resources\BatchLab\.\BatchLab" MKDIR "%obuild_dir_project%\Resources\BatchLab\.\BatchLab"
XCOPY /E /Q "%obuild_BatchLab_path%\BatchLab" "%obuild_dir_project%\Resources\BatchLab\.\BatchLab" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_49
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\examples"  ECHO WARNING : Directory %obuild_UseAIDA_path%\examples not found.  && GOTO end_if_release_51
IF NOT EXIST "%obuild_dir_project%\Resources\AIDA\.\examples" MKDIR "%obuild_dir_project%\Resources\AIDA\.\examples"
XCOPY /E /Q "%obuild_UseAIDA_path%\examples" "%obuild_dir_project%\Resources\AIDA\.\examples" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_51
IF NOT EXIST "%obuild_UseAIDA_path%\scripts\sh"  ECHO WARNING : Directory %obuild_UseAIDA_path%\scripts\sh not found.  && GOTO end_if_release_53
IF NOT EXIST "%obuild_dir_project%\Resources\AIDA\scripts\.\sh" MKDIR "%obuild_dir_project%\Resources\AIDA\scripts\.\sh"
XCOPY /E /Q "%obuild_UseAIDA_path%\scripts\sh" "%obuild_dir_project%\Resources\AIDA\scripts\.\sh" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_53
IF NOT EXIST "%obuild_UseAIDA_path%\scripts\DOS"  ECHO WARNING : Directory %obuild_UseAIDA_path%\scripts\DOS not found.  && GOTO end_if_release_55
IF NOT EXIST "%obuild_dir_project%\Resources\AIDA\scripts\.\DOS" MKDIR "%obuild_dir_project%\Resources\AIDA\scripts\.\DOS"
XCOPY /E /Q "%obuild_UseAIDA_path%\scripts\DOS" "%obuild_dir_project%\Resources\AIDA\scripts\.\DOS" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_55
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  osc_source v16r5`) DO SET obuild_osc_source_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_osc_source_path  ECHO Can't find osc_source package.  && GOTO obuild_return

IF NOT EXIST "%obuild_osc_source_path%\release\License"  ECHO WARNING : File %obuild_osc_source_path%\release\License not found.  && GOTO end_if_release_57
IF NOT EXIST "%obuild_dir_project%" MKDIR "%obuild_dir_project%"
COPY "%obuild_osc_source_path%\release\License" "%obuild_dir_project%\." 1> copy_exe_error
@IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_release_57
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_58
IF NOT EXIST "%obuild_osc_source_path%\release\Windows_NT\setup.bat"  ECHO WARNING : File %obuild_osc_source_path%\release\Windows_NT\setup.bat not found.  && GOTO end_if_release_59
IF NOT EXIST "%obuild_dir_project%" MKDIR "%obuild_dir_project%"
COPY "%obuild_osc_source_path%\release\Windows_NT\setup.bat" "%obuild_dir_project%\." 1> copy_exe_error
@IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_release_59
:end_if_platform_58
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_60
IF NOT EXIST "%obuild_osc_source_path%\release\Windows_NT\aida-setup.bat"  ECHO WARNING : File %obuild_osc_source_path%\release\Windows_NT\aida-setup.bat not found.  && GOTO end_if_release_61
IF NOT EXIST "%obuild_dir_project%" MKDIR "%obuild_dir_project%"
COPY "%obuild_osc_source_path%\release\Windows_NT\aida-setup.bat" "%obuild_dir_project%\." 1> copy_exe_error
@IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_release_61
:end_if_platform_60
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_62
IF NOT EXIST "%obuild_osc_source_path%\release\Windows_NT\README"  ECHO WARNING : File %obuild_osc_source_path%\release\Windows_NT\README not found.  && GOTO end_if_release_63
IF NOT EXIST "%obuild_dir_project%" MKDIR "%obuild_dir_project%"
COPY "%obuild_osc_source_path%\release\Windows_NT\README" "%obuild_dir_project%\." 1> copy_exe_error
@IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_release_63
:end_if_platform_62
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_64
IF NOT EXIST "%obuild_osc_source_path%\release\Windows_NT\py-setup.bat"  ECHO WARNING : File %obuild_osc_source_path%\release\Windows_NT\py-setup.bat not found.  && GOTO end_if_release_65
IF NOT EXIST "%obuild_dir_project%" MKDIR "%obuild_dir_project%"
COPY "%obuild_osc_source_path%\release\Windows_NT\py-setup.bat" "%obuild_dir_project%\." 1> copy_exe_error
@IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_release_65
:end_if_platform_64
SET obuild_platform_result=
IF NOT EXIST "%obuild_osc_source_path%\..\..\AIDA\v3r2p1\src\cpp\AIDA"  ECHO WARNING : Directory %obuild_osc_source_path%\..\..\AIDA\v3r2p1\src\cpp\AIDA not found.  && GOTO end_if_release_67
IF NOT EXIST "%obuild_dir_project%\Resources\AIDA\src\cpp\.\AIDA" MKDIR "%obuild_dir_project%\Resources\AIDA\src\cpp\.\AIDA"
XCOPY /E /Q "%obuild_osc_source_path%\..\..\AIDA\v3r2p1\src\cpp\AIDA" "%obuild_dir_project%\Resources\AIDA\src\cpp\.\AIDA" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_67
IF NOT EXIST "%obuild_osc_source_path%\..\..\Interfaces"  ECHO WARNING : Directory %obuild_osc_source_path%\..\..\Interfaces not found.  && GOTO end_if_release_69
IF NOT EXIST "%obuild_dir_project%\Resources\CMT\.\Interfaces" MKDIR "%obuild_dir_project%\Resources\CMT\.\Interfaces"
XCOPY /E /Q "%obuild_osc_source_path%\..\..\Interfaces" "%obuild_dir_project%\Resources\CMT\.\Interfaces" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_69
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinGL v1r250p0`) DO SET obuild_CoinGL_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_CoinGL_path  ECHO Can't find CoinGL package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinGL_path%\include"  ECHO WARNING : Directory %obuild_CoinGL_path%\include not found.  && GOTO end_if_release_71
IF NOT EXIST "%obuild_dir_project%\Resources\CoinGL\.\include" MKDIR "%obuild_dir_project%\Resources\CoinGL\.\include"
XCOPY /E /Q "%obuild_CoinGL_path%\include" "%obuild_dir_project%\Resources\CoinGL\.\include" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_71
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinXt v1r122p2`) DO SET obuild_CoinXt_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_CoinXt_path  ECHO Can't find CoinXt package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinXt_path%\include"  ECHO WARNING : Directory %obuild_CoinXt_path%\include not found.  && GOTO end_if_release_73
IF NOT EXIST "%obuild_dir_project%\Resources\CoinXt\.\include" MKDIR "%obuild_dir_project%\Resources\CoinXt\.\include"
XCOPY /E /Q "%obuild_CoinXt_path%\include" "%obuild_dir_project%\Resources\CoinXt\.\include" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_73
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinQt v1r130p2`) DO SET obuild_CoinQt_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_CoinQt_path  ECHO Can't find CoinQt package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinQt_path%\include"  ECHO WARNING : Directory %obuild_CoinQt_path%\include not found.  && GOTO end_if_release_75
IF NOT EXIST "%obuild_dir_project%\Resources\CoinQt\.\include" MKDIR "%obuild_dir_project%\Resources\CoinQt\.\include"
XCOPY /E /Q "%obuild_CoinQt_path%\include" "%obuild_dir_project%\Resources\CoinQt\.\include" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_75
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinGtk v1r50p4`) DO SET obuild_CoinGtk_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_CoinGtk_path  ECHO Can't find CoinGtk package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinGtk_path%\include"  ECHO WARNING : Directory %obuild_CoinGtk_path%\include not found.  && GOTO end_if_release_77
IF NOT EXIST "%obuild_dir_project%\Resources\CoinGtk\.\include" MKDIR "%obuild_dir_project%\Resources\CoinGtk\.\include"
XCOPY /E /Q "%obuild_CoinGtk_path%\include" "%obuild_dir_project%\Resources\CoinGtk\.\include" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_77
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinPython v1r0p2`) DO SET obuild_CoinPython_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_CoinPython_path  ECHO Can't find CoinPython package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinPython_path%\scripts"  ECHO WARNING : Directory %obuild_CoinPython_path%\scripts not found.  && GOTO end_if_release_79
IF NOT EXIST "%obuild_dir_project%\Resources\CoinPython\.\scripts" MKDIR "%obuild_dir_project%\Resources\CoinPython\.\scripts"
XCOPY /E /Q "%obuild_CoinPython_path%\scripts" "%obuild_dir_project%\Resources\CoinPython\.\scripts" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_79
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  SoSDL v1r1p0`) DO SET obuild_SoSDL_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_SoSDL_path  ECHO Can't find SoSDL package.  && GOTO obuild_return

IF NOT EXIST "%obuild_SoSDL_path%\include"  ECHO WARNING : Directory %obuild_SoSDL_path%\include not found.  && GOTO end_if_release_81
IF NOT EXIST "%obuild_dir_project%\Resources\SoSDL\.\include" MKDIR "%obuild_dir_project%\Resources\SoSDL\.\include"
XCOPY /E /Q "%obuild_SoSDL_path%\include" "%obuild_dir_project%\Resources\SoSDL\.\include" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_81
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\scripts"  ECHO WARNING : Directory %obuild_HEPVis_path%\scripts not found.  && GOTO end_if_release_83
IF NOT EXIST "%obuild_dir_project%\Resources\HEPVis\.\scripts" MKDIR "%obuild_dir_project%\Resources\HEPVis\.\scripts"
XCOPY /E /Q "%obuild_HEPVis_path%\scripts" "%obuild_dir_project%\Resources\HEPVis\.\scripts" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_83
IF NOT EXIST "%obuild_HEPVis_path%\fonts"  ECHO WARNING : Directory %obuild_HEPVis_path%\fonts not found.  && GOTO end_if_release_85
IF NOT EXIST "%obuild_dir_project%\Resources\HEPVis\.\fonts" MKDIR "%obuild_dir_project%\Resources\HEPVis\.\fonts"
XCOPY /E /Q "%obuild_HEPVis_path%\fonts" "%obuild_dir_project%\Resources\HEPVis\.\fonts" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_85
IF NOT EXIST "%obuild_HEPVis_path%\include"  ECHO WARNING : Directory %obuild_HEPVis_path%\include not found.  && GOTO end_if_release_87
IF NOT EXIST "%obuild_dir_project%\Resources\HEPVis\.\include" MKDIR "%obuild_dir_project%\Resources\HEPVis\.\include"
XCOPY /E /Q "%obuild_HEPVis_path%\include" "%obuild_dir_project%\Resources\HEPVis\.\include" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_87
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\scripts"  ECHO WARNING : Directory %obuild_OnX_path%\scripts not found.  && GOTO end_if_release_89
IF NOT EXIST "%obuild_dir_project%\Resources\OnX\.\scripts" MKDIR "%obuild_dir_project%\Resources\OnX\.\scripts"
XCOPY /E /Q "%obuild_OnX_path%\scripts" "%obuild_dir_project%\Resources\OnX\.\scripts" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_89
IF NOT EXIST "%obuild_OnX_path%\examples"  ECHO WARNING : Directory %obuild_OnX_path%\examples not found.  && GOTO end_if_release_91
IF NOT EXIST "%obuild_dir_project%\Resources\OnX\.\examples" MKDIR "%obuild_dir_project%\Resources\OnX\.\examples"
XCOPY /E /Q "%obuild_OnX_path%\examples" "%obuild_dir_project%\Resources\OnX\.\examples" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_91
IF NOT EXIST "%obuild_OnX_path%\include"  ECHO WARNING : Directory %obuild_OnX_path%\include not found.  && GOTO end_if_release_93
IF NOT EXIST "%obuild_dir_project%\Resources\OnX\.\include" MKDIR "%obuild_dir_project%\Resources\OnX\.\include"
XCOPY /E /Q "%obuild_OnX_path%\include" "%obuild_dir_project%\Resources\OnX\.\include" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_93
IF NOT EXIST "%obuild_OnX_path%\templates"  ECHO WARNING : Directory %obuild_OnX_path%\templates not found.  && GOTO end_if_release_95
IF NOT EXIST "%obuild_dir_project%\Resources\OnX\.\templates" MKDIR "%obuild_dir_project%\Resources\OnX\.\templates"
XCOPY /E /Q "%obuild_OnX_path%\templates" "%obuild_dir_project%\Resources\OnX\.\templates" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_95
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\scripts"  ECHO WARNING : Directory %obuild_OnXLab_path%\scripts not found.  && GOTO end_if_release_97
IF NOT EXIST "%obuild_dir_project%\Resources\OnXLab\.\scripts" MKDIR "%obuild_dir_project%\Resources\OnXLab\.\scripts"
XCOPY /E /Q "%obuild_OnXLab_path%\scripts" "%obuild_dir_project%\Resources\OnXLab\.\scripts" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_97
IF NOT EXIST "%obuild_OnXLab_path%\examples"  ECHO WARNING : Directory %obuild_OnXLab_path%\examples not found.  && GOTO end_if_release_99
IF NOT EXIST "%obuild_dir_project%\Resources\OnXLab\.\examples" MKDIR "%obuild_dir_project%\Resources\OnXLab\.\examples"
XCOPY /E /Q "%obuild_OnXLab_path%\examples" "%obuild_dir_project%\Resources\OnXLab\.\examples" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_99
IF NOT EXIST "%obuild_OnXLab_path%\OnXLab"  ECHO WARNING : Directory %obuild_OnXLab_path%\OnXLab not found.  && GOTO end_if_release_101
IF NOT EXIST "%obuild_dir_project%\Resources\OnXLab\.\OnXLab" MKDIR "%obuild_dir_project%\Resources\OnXLab\.\OnXLab"
XCOPY /E /Q "%obuild_OnXLab_path%\OnXLab" "%obuild_dir_project%\Resources\OnXLab\.\OnXLab" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_101
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OpenPAW v3r2p0`) DO SET obuild_OpenPAW_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OpenPAW_path  ECHO Can't find OpenPAW package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OpenPAW_path%\scripts"  ECHO WARNING : Directory %obuild_OpenPAW_path%\scripts not found.  && GOTO end_if_release_103
IF NOT EXIST "%obuild_dir_project%\Resources\OpenPAW\.\scripts" MKDIR "%obuild_dir_project%\Resources\OpenPAW\.\scripts"
XCOPY /E /Q "%obuild_OpenPAW_path%\scripts" "%obuild_dir_project%\Resources\OpenPAW\.\scripts" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_103
IF NOT EXIST "%obuild_OpenPAW_path%\examples"  ECHO WARNING : Directory %obuild_OpenPAW_path%\examples not found.  && GOTO end_if_release_105
IF NOT EXIST "%obuild_dir_project%\Resources\OpenPAW\.\examples" MKDIR "%obuild_dir_project%\Resources\OpenPAW\.\examples"
XCOPY /E /Q "%obuild_OpenPAW_path%\examples" "%obuild_dir_project%\Resources\OpenPAW\.\examples" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_105
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  G4Lab v8r3p0`) DO SET obuild_G4Lab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_G4Lab_path  ECHO Can't find G4Lab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_G4Lab_path%\scripts"  ECHO WARNING : Directory %obuild_G4Lab_path%\scripts not found.  && GOTO end_if_release_107
IF NOT EXIST "%obuild_dir_project%\Resources\G4Lab\.\scripts" MKDIR "%obuild_dir_project%\Resources\G4Lab\.\scripts"
XCOPY /E /Q "%obuild_G4Lab_path%\scripts" "%obuild_dir_project%\Resources\G4Lab\.\scripts" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_107
IF NOT EXIST "%obuild_G4Lab_path%\include"  ECHO WARNING : Directory %obuild_G4Lab_path%\include not found.  && GOTO end_if_release_109
IF NOT EXIST "%obuild_dir_project%\Resources\G4Lab\.\include" MKDIR "%obuild_dir_project%\Resources\G4Lab\.\include"
XCOPY /E /Q "%obuild_G4Lab_path%\include" "%obuild_dir_project%\Resources\G4Lab\.\include" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_109
IF NOT EXIST "%obuild_G4Lab_path%\templates"  ECHO WARNING : Directory %obuild_G4Lab_path%\templates not found.  && GOTO end_if_release_111
IF NOT EXIST "%obuild_dir_project%\Resources\G4Lab\.\templates" MKDIR "%obuild_dir_project%\Resources\G4Lab\.\templates"
XCOPY /E /Q "%obuild_G4Lab_path%\templates" "%obuild_dir_project%\Resources\G4Lab\.\templates" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_111
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  G4Simple v2r2p0`) DO SET obuild_G4Simple_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_G4Simple_path  ECHO Can't find G4Simple package.  && GOTO obuild_return

IF NOT EXIST "%obuild_G4Simple_path%\scripts"  ECHO WARNING : Directory %obuild_G4Simple_path%\scripts not found.  && GOTO end_if_release_113
IF NOT EXIST "%obuild_dir_project%\Resources\G4Simple\.\scripts" MKDIR "%obuild_dir_project%\Resources\G4Simple\.\scripts"
XCOPY /E /Q "%obuild_G4Simple_path%\scripts" "%obuild_dir_project%\Resources\G4Simple\.\scripts" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_113
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  G4Examples v1r2p0`) DO SET obuild_G4Examples_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_G4Examples_path  ECHO Can't find G4Examples package.  && GOTO obuild_return

IF NOT EXIST "%obuild_G4Examples_path%\scripts"  ECHO WARNING : Directory %obuild_G4Examples_path%\scripts not found.  && GOTO end_if_release_115
IF NOT EXIST "%obuild_dir_project%\Resources\G4Examples\.\scripts" MKDIR "%obuild_dir_project%\Resources\G4Examples\.\scripts"
XCOPY /E /Q "%obuild_G4Examples_path%\scripts" "%obuild_dir_project%\Resources\G4Examples\.\scripts" 1> xcopy_exe_error
@IF ERRORLEVEL 1 @TYPE xcopy_exe_error && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL xcopy_exe_error
:end_if_release_115

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  zlib v1r114p6`) DO SET obuild_zlib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_zlib_path  ECHO Can't find zlib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_zlib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_zlib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_116
IF NOT EXIST "%obuild_zlib_path%\%obuild_dir_bin%\osc_zlib.lib" GOTO end_if_copy_117
  COPY "%obuild_zlib_path%\%obuild_dir_bin%\osc_zlib.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_117
IF NOT EXIST "%obuild_zlib_path%\%obuild_dir_bin%\osc_zlib.dll" GOTO end_if_copy_118
  COPY "%obuild_zlib_path%\%obuild_dir_bin%\osc_zlib.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_118
:end_if_release_116
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  zip v1r101p0`) DO SET obuild_zip_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_zip_path  ECHO Can't find zip package.  && GOTO obuild_return

IF NOT EXIST "%obuild_zip_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_zip_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_119
IF NOT EXIST "%obuild_zip_path%\%obuild_dir_bin%\osc_zip.lib" GOTO end_if_copy_120
  COPY "%obuild_zip_path%\%obuild_dir_bin%\osc_zip.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_120
IF NOT EXIST "%obuild_zip_path%\%obuild_dir_bin%\osc_zip.dll" GOTO end_if_copy_121
  COPY "%obuild_zip_path%\%obuild_dir_bin%\osc_zip.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_121
:end_if_release_119
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  expat v1r11p8`) DO SET obuild_expat_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_expat_path  ECHO Can't find expat package.  && GOTO obuild_return

IF NOT EXIST "%obuild_expat_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_expat_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_122
IF NOT EXIST "%obuild_expat_path%\%obuild_dir_bin%\osc_expat.lib" GOTO end_if_copy_123
  COPY "%obuild_expat_path%\%obuild_dir_bin%\osc_expat.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_123
IF NOT EXIST "%obuild_expat_path%\%obuild_dir_bin%\osc_expat.dll" GOTO end_if_copy_124
  COPY "%obuild_expat_path%\%obuild_dir_bin%\osc_expat.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_124
:end_if_release_122
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_125
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\LibUtils.lib" GOTO end_if_copy_126
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\LibUtils.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_126
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\LibUtils.dll" GOTO end_if_copy_127
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\LibUtils.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_127
:end_if_release_125
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_128
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\LibZip.lib" GOTO end_if_copy_129
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\LibZip.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_129
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\LibZip.dll" GOTO end_if_copy_130
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\LibZip.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_130
:end_if_release_128
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_131
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\LibXML.lib" GOTO end_if_copy_132
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\LibXML.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_132
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\LibXML.dll" GOTO end_if_copy_133
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\LibXML.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_133
:end_if_release_131
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_134
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\LibSocket.lib" GOTO end_if_copy_135
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\LibSocket.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_135
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\LibSocket.dll" GOTO end_if_copy_136
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\LibSocket.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_136
:end_if_release_134
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HCL v7r0p2`) DO SET obuild_HCL_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HCL_path  ECHO Can't find HCL package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HCL_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HCL_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_137
IF NOT EXIST "%obuild_HCL_path%\%obuild_dir_bin%\HCL.lib" GOTO end_if_copy_138
  COPY "%obuild_HCL_path%\%obuild_dir_bin%\HCL.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_138
IF NOT EXIST "%obuild_HCL_path%\%obuild_dir_bin%\HCL.dll" GOTO end_if_copy_139
  COPY "%obuild_HCL_path%\%obuild_dir_bin%\HCL.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_139
:end_if_release_137
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Midnight v4r0p2`) DO SET obuild_Midnight_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Midnight_path  ECHO Can't find Midnight package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Midnight_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Midnight_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_140
IF NOT EXIST "%obuild_Midnight_path%\%obuild_dir_bin%\Midnight.lib" GOTO end_if_copy_141
  COPY "%obuild_Midnight_path%\%obuild_dir_bin%\Midnight.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_141
IF NOT EXIST "%obuild_Midnight_path%\%obuild_dir_bin%\Midnight.dll" GOTO end_if_copy_142
  COPY "%obuild_Midnight_path%\%obuild_dir_bin%\Midnight.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_142
:end_if_release_140
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Minuit v1r140p6`) DO SET obuild_Minuit_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Minuit_path  ECHO Can't find Minuit package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Minuit_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Minuit_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_143
IF NOT EXIST "%obuild_Minuit_path%\%obuild_dir_bin%\osc_Minuit.lib" GOTO end_if_copy_144
  COPY "%obuild_Minuit_path%\%obuild_dir_bin%\osc_Minuit.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_144
IF NOT EXIST "%obuild_Minuit_path%\%obuild_dir_bin%\osc_Minuit.dll" GOTO end_if_copy_145
  COPY "%obuild_Minuit_path%\%obuild_dir_bin%\osc_Minuit.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_145
:end_if_release_143
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Rio v9r0p0`) DO SET obuild_Rio_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Rio_path  ECHO Can't find Rio package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Rio_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Rio_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_146
IF NOT EXIST "%obuild_Rio_path%\%obuild_dir_bin%\osc_Rio.lib" GOTO end_if_copy_147
  COPY "%obuild_Rio_path%\%obuild_dir_bin%\osc_Rio.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_147
IF NOT EXIST "%obuild_Rio_path%\%obuild_dir_bin%\osc_Rio.dll" GOTO end_if_copy_148
  COPY "%obuild_Rio_path%\%obuild_dir_bin%\osc_Rio.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_148
:end_if_release_146
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HDF5 v1r165p5`) DO SET obuild_HDF5_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HDF5_path  ECHO Can't find HDF5 package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HDF5_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HDF5_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_149
IF NOT EXIST "%obuild_HDF5_path%\%obuild_dir_bin%\osc_HDF5.lib" GOTO end_if_copy_150
  COPY "%obuild_HDF5_path%\%obuild_dir_bin%\osc_HDF5.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_150
IF NOT EXIST "%obuild_HDF5_path%\%obuild_dir_bin%\osc_HDF5.dll" GOTO end_if_copy_151
  COPY "%obuild_HDF5_path%\%obuild_dir_bin%\osc_HDF5.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_151
:end_if_release_149
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  BatchLab v1r3p0`) DO SET obuild_BatchLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_BatchLab_path  ECHO Can't find BatchLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_BatchLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_152
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabCore.lib" GOTO end_if_copy_153
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabCore.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_153
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabCore.dll" GOTO end_if_copy_154
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabCore.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_154
:end_if_release_152
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  BatchLab v1r3p0`) DO SET obuild_BatchLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_BatchLab_path  ECHO Can't find BatchLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_BatchLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_155
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabAIDA.lib" GOTO end_if_copy_156
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabAIDA.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_156
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabAIDA.dll" GOTO end_if_copy_157
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabAIDA.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_157
:end_if_release_155
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  BatchLab v1r3p0`) DO SET obuild_BatchLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_BatchLab_path  ECHO Can't find BatchLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_BatchLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_158
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabXMLCore.lib" GOTO end_if_copy_159
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabXMLCore.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_159
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabXMLCore.dll" GOTO end_if_copy_160
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabXMLCore.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_160
:end_if_release_158
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  BatchLab v1r3p0`) DO SET obuild_BatchLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_BatchLab_path  ECHO Can't find BatchLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_BatchLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_161
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabHBOOK.lib" GOTO end_if_copy_162
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabHBOOK.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_162
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabHBOOK.dll" GOTO end_if_copy_163
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabHBOOK.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_163
:end_if_release_161
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  png v1r1216p3`) DO SET obuild_png_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_png_path  ECHO Can't find png package.  && GOTO obuild_return

IF NOT EXIST "%obuild_png_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_png_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_164
IF NOT EXIST "%obuild_png_path%\%obuild_dir_bin%\osc_png.lib" GOTO end_if_copy_165
  COPY "%obuild_png_path%\%obuild_dir_bin%\osc_png.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_165
IF NOT EXIST "%obuild_png_path%\%obuild_dir_bin%\osc_png.dll" GOTO end_if_copy_166
  COPY "%obuild_png_path%\%obuild_dir_bin%\osc_png.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_166
:end_if_release_164
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  jpeg v1r62p3`) DO SET obuild_jpeg_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_jpeg_path  ECHO Can't find jpeg package.  && GOTO obuild_return

IF NOT EXIST "%obuild_jpeg_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_jpeg_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_167
IF NOT EXIST "%obuild_jpeg_path%\%obuild_dir_bin%\osc_jpeg.lib" GOTO end_if_copy_168
  COPY "%obuild_jpeg_path%\%obuild_dir_bin%\osc_jpeg.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_168
IF NOT EXIST "%obuild_jpeg_path%\%obuild_dir_bin%\osc_jpeg.dll" GOTO end_if_copy_169
  COPY "%obuild_jpeg_path%\%obuild_dir_bin%\osc_jpeg.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_169
:end_if_release_167
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  dvi2bitmap v1r0132p3`) DO SET obuild_dvi2bitmap_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_dvi2bitmap_path  ECHO Can't find dvi2bitmap package.  && GOTO obuild_return

IF NOT EXIST "%obuild_dvi2bitmap_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_dvi2bitmap_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_170
IF NOT EXIST "%obuild_dvi2bitmap_path%\%obuild_dir_bin%\osc_dvi2bitmap.lib" GOTO end_if_copy_171
  COPY "%obuild_dvi2bitmap_path%\%obuild_dir_bin%\osc_dvi2bitmap.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_171
IF NOT EXIST "%obuild_dvi2bitmap_path%\%obuild_dir_bin%\osc_dvi2bitmap.dll" GOTO end_if_copy_172
  COPY "%obuild_dvi2bitmap_path%\%obuild_dir_bin%\osc_dvi2bitmap.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_172
:end_if_release_170
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  freetype2 v1r219p2`) DO SET obuild_freetype2_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_freetype2_path  ECHO Can't find freetype2 package.  && GOTO obuild_return

IF NOT EXIST "%obuild_freetype2_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_freetype2_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_173
IF NOT EXIST "%obuild_freetype2_path%\%obuild_dir_bin%\osc_freetype2.lib" GOTO end_if_copy_174
  COPY "%obuild_freetype2_path%\%obuild_dir_bin%\osc_freetype2.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_174
IF NOT EXIST "%obuild_freetype2_path%\%obuild_dir_bin%\osc_freetype2.dll" GOTO end_if_copy_175
  COPY "%obuild_freetype2_path%\%obuild_dir_bin%\osc_freetype2.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_175
:end_if_release_173
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinGL v1r250p0`) DO SET obuild_CoinGL_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_CoinGL_path  ECHO Can't find CoinGL package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinGL_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_CoinGL_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_176
IF NOT EXIST "%obuild_CoinGL_path%\%obuild_dir_bin%\osc_Coin.lib" GOTO end_if_copy_177
  COPY "%obuild_CoinGL_path%\%obuild_dir_bin%\osc_Coin.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_177
IF NOT EXIST "%obuild_CoinGL_path%\%obuild_dir_bin%\osc_Coin.dll" GOTO end_if_copy_178
  COPY "%obuild_CoinGL_path%\%obuild_dir_bin%\osc_Coin.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_178
:end_if_release_176
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinWin v1r50p7`) DO SET obuild_CoinWin_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_CoinWin_path  ECHO Can't find CoinWin package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinWin_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_CoinWin_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_179
IF NOT EXIST "%obuild_CoinWin_path%\%obuild_dir_bin%\CoinWin.lib" GOTO end_if_copy_180
  COPY "%obuild_CoinWin_path%\%obuild_dir_bin%\CoinWin.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_180
IF NOT EXIST "%obuild_CoinWin_path%\%obuild_dir_bin%\CoinWin.dll" GOTO end_if_copy_181
  COPY "%obuild_CoinWin_path%\%obuild_dir_bin%\CoinWin.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_181
:end_if_release_179
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinQt v1r130p2`) DO SET obuild_CoinQt_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_CoinQt_path  ECHO Can't find CoinQt package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinQt_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_CoinQt_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_182
IF NOT EXIST "%obuild_CoinQt_path%\%obuild_dir_bin%\CoinQt.lib" GOTO end_if_copy_183
  COPY "%obuild_CoinQt_path%\%obuild_dir_bin%\CoinQt.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_183
IF NOT EXIST "%obuild_CoinQt_path%\%obuild_dir_bin%\CoinQt.dll" GOTO end_if_copy_184
  COPY "%obuild_CoinQt_path%\%obuild_dir_bin%\CoinQt.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_184
:end_if_release_182
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinGtk v1r50p4`) DO SET obuild_CoinGtk_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_CoinGtk_path  ECHO Can't find CoinGtk package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_CoinGtk_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_185
IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%\CoinGtk.lib" GOTO end_if_copy_186
  COPY "%obuild_CoinGtk_path%\%obuild_dir_bin%\CoinGtk.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_186
IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%\CoinGtk.dll" GOTO end_if_copy_187
  COPY "%obuild_CoinGtk_path%\%obuild_dir_bin%\CoinGtk.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_187
:end_if_release_185
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  SoSDL v1r1p0`) DO SET obuild_SoSDL_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_SoSDL_path  ECHO Can't find SoSDL package.  && GOTO obuild_return

IF NOT EXIST "%obuild_SoSDL_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_SoSDL_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_188
IF NOT EXIST "%obuild_SoSDL_path%\%obuild_dir_bin%\SoSDL.lib" GOTO end_if_copy_189
  COPY "%obuild_SoSDL_path%\%obuild_dir_bin%\SoSDL.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_189
IF NOT EXIST "%obuild_SoSDL_path%\%obuild_dir_bin%\SoSDL.dll" GOTO end_if_copy_190
  COPY "%obuild_SoSDL_path%\%obuild_dir_bin%\SoSDL.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_190
:end_if_release_188
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_191
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisUtils.lib" GOTO end_if_copy_192
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisUtils.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_192
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisUtils.dll" GOTO end_if_copy_193
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisUtils.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_193
:end_if_release_191
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_194
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGeometry.lib" GOTO end_if_copy_195
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGeometry.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_195
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGeometry.dll" GOTO end_if_copy_196
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGeometry.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_196
:end_if_release_194
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_197
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisDetector.lib" GOTO end_if_copy_198
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisDetector.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_198
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisDetector.dll" GOTO end_if_copy_199
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisDetector.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_199
:end_if_release_197
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_200
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGUI.lib" GOTO end_if_copy_201
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGUI.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_201
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGUI.dll" GOTO end_if_copy_202
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGUI.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_202
:end_if_release_200
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_203
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisPlotter.lib" GOTO end_if_copy_204
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisPlotter.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_204
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisPlotter.dll" GOTO end_if_copy_205
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisPlotter.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_205
:end_if_release_203
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_206
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisWin.lib" GOTO end_if_copy_207
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisWin.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_207
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisWin.dll" GOTO end_if_copy_208
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisWin.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_208
:end_if_release_206
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_209
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisQt.lib" GOTO end_if_copy_210
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisQt.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_210
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisQt.dll" GOTO end_if_copy_211
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisQt.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_211
:end_if_release_209
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_212
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisSDL.lib" GOTO end_if_copy_213
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisSDL.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_213
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisSDL.dll" GOTO end_if_copy_214
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisSDL.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_214
:end_if_release_212
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_215
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGtk.lib" GOTO end_if_copy_216
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGtk.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_216
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGtk.dll" GOTO end_if_copy_217
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisGtk.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_217
:end_if_release_215
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  KUIP v1r950303p18`) DO SET obuild_KUIP_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_KUIP_path  ECHO Can't find KUIP package.  && GOTO obuild_return

IF NOT EXIST "%obuild_KUIP_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_KUIP_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_218
IF NOT EXIST "%obuild_KUIP_path%\%obuild_dir_bin%\KUIP.lib" GOTO end_if_copy_219
  COPY "%obuild_KUIP_path%\%obuild_dir_bin%\KUIP.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_219
IF NOT EXIST "%obuild_KUIP_path%\%obuild_dir_bin%\KUIP.dll" GOTO end_if_copy_220
  COPY "%obuild_KUIP_path%\%obuild_dir_bin%\KUIP.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_220
:end_if_release_218
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_221
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnXCore.lib" GOTO end_if_copy_222
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnXCore.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_222
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnXCore.dll" GOTO end_if_copy_223
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnXCore.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_223
:end_if_release_221
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_224
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnXInventor.lib" GOTO end_if_copy_225
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnXInventor.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_225
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnXInventor.dll" GOTO end_if_copy_226
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnXInventor.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_226
:end_if_release_224
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_227
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnXWinCore.lib" GOTO end_if_copy_228
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnXWinCore.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_228
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnXWinCore.dll" GOTO end_if_copy_229
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnXWinCore.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_229
:end_if_release_227
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_230
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnXQtCore.lib" GOTO end_if_copy_231
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnXQtCore.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_231
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnXQtCore.dll" GOTO end_if_copy_232
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnXQtCore.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_232
:end_if_release_230
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_233
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnXGtkCore.lib" GOTO end_if_copy_234
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnXGtkCore.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_234
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnXGtkCore.dll" GOTO end_if_copy_235
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnXGtkCore.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_235
:end_if_release_233
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_236
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnXSDL_Core.lib" GOTO end_if_copy_237
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnXSDL_Core.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_237
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnXSDL_Core.dll" GOTO end_if_copy_238
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnXSDL_Core.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_238
:end_if_release_236
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_239
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_SWIG_Java_jar.lib" GOTO end_if_copy_240
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_SWIG_Java_jar.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_240
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_SWIG_Java_jar.dll" GOTO end_if_copy_241
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_SWIG_Java_jar.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_241
:end_if_release_239
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_242
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLabCore.lib" GOTO end_if_copy_243
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLabCore.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_243
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLabCore.dll" GOTO end_if_copy_244
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLabCore.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_244
:end_if_release_242
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_245
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLabAIDA.lib" GOTO end_if_copy_246
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLabAIDA.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_246
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLabAIDA.dll" GOTO end_if_copy_247
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLabAIDA.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_247
:end_if_release_245
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_248
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_SWIG_Java_jar.lib" GOTO end_if_copy_249
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_SWIG_Java_jar.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_249
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_SWIG_Java_jar.dll" GOTO end_if_copy_250
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_SWIG_Java_jar.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_250
:end_if_release_248
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  G4Lab v8r3p0`) DO SET obuild_G4Lab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_G4Lab_path  ECHO Can't find G4Lab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_G4Lab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_251
IF NOT EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%\G4LabCore.lib" GOTO end_if_copy_252
  COPY "%obuild_G4Lab_path%\%obuild_dir_bin%\G4LabCore.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_252
IF NOT EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%\G4LabCore.dll" GOTO end_if_copy_253
  COPY "%obuild_G4Lab_path%\%obuild_dir_bin%\G4LabCore.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_253
:end_if_release_251
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  G4Lab v8r3p0`) DO SET obuild_G4Lab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_G4Lab_path  ECHO Can't find G4Lab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_G4Lab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_254
IF NOT EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%\G4LabUIOnX.lib" GOTO end_if_copy_255
  COPY "%obuild_G4Lab_path%\%obuild_dir_bin%\G4LabUIOnX.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_255
IF NOT EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%\G4LabUIOnX.dll" GOTO end_if_copy_256
  COPY "%obuild_G4Lab_path%\%obuild_dir_bin%\G4LabUIOnX.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_256
:end_if_release_254
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  G4Simple v2r2p0`) DO SET obuild_G4Simple_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_G4Simple_path  ECHO Can't find G4Simple package.  && GOTO obuild_return

IF NOT EXIST "%obuild_G4Simple_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_G4Simple_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_257
IF NOT EXIST "%obuild_G4Simple_path%\%obuild_dir_bin%\G4SimpleCore.lib" GOTO end_if_copy_258
  COPY "%obuild_G4Simple_path%\%obuild_dir_bin%\G4SimpleCore.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_258
IF NOT EXIST "%obuild_G4Simple_path%\%obuild_dir_bin%\G4SimpleCore.dll" GOTO end_if_copy_259
  COPY "%obuild_G4Simple_path%\%obuild_dir_bin%\G4SimpleCore.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_259
:end_if_release_257

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_260
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\LibTest.lib" GOTO end_if_copy_261
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\LibTest.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_261
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\LibTest.dll" GOTO end_if_copy_262
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\LibTest.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_262
:end_if_release_260
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  BatchLab v1r3p0`) DO SET obuild_BatchLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_BatchLab_path  ECHO Can't find BatchLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_BatchLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_263
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabLoadAIDA.lib" GOTO end_if_copy_264
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabLoadAIDA.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_264
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabLoadAIDA.dll" GOTO end_if_copy_265
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabLoadAIDA.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_265
:end_if_release_263
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  BatchLab v1r3p0`) DO SET obuild_BatchLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_BatchLab_path  ECHO Can't find BatchLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_BatchLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_266
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabRio.lib" GOTO end_if_copy_267
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabRio.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_267
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabRio.dll" GOTO end_if_copy_268
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabRio.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_268
:end_if_release_266
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  BatchLab v1r3p0`) DO SET obuild_BatchLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_BatchLab_path  ECHO Can't find BatchLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_BatchLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_269
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabXML.lib" GOTO end_if_copy_270
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabXML.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_270
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabXML.dll" GOTO end_if_copy_271
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabXML.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_271
:end_if_release_269
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  BatchLab v1r3p0`) DO SET obuild_BatchLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_BatchLab_path  ECHO Can't find BatchLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_BatchLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_272
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabHDF5.lib" GOTO end_if_copy_273
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabHDF5.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_273
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabHDF5.dll" GOTO end_if_copy_274
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabHDF5.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_274
:end_if_release_272
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  BatchLab v1r3p0`) DO SET obuild_BatchLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_BatchLab_path  ECHO Can't find BatchLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_BatchLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_275
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabZebra.lib" GOTO end_if_copy_276
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabZebra.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_276
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabZebra.dll" GOTO end_if_copy_277
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabZebra.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_277
:end_if_release_275
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  BatchLab v1r3p0`) DO SET obuild_BatchLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_BatchLab_path  ECHO Can't find BatchLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_BatchLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_278
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabZip.lib" GOTO end_if_copy_279
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabZip.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_279
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabZip.dll" GOTO end_if_copy_280
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabZip.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_280
:end_if_release_278
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  BatchLab v1r3p0`) DO SET obuild_BatchLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_BatchLab_path  ECHO Can't find BatchLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_BatchLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_281
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabFS.lib" GOTO end_if_copy_282
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabFS.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_282
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabFS.dll" GOTO end_if_copy_283
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLabFS.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_283
:end_if_release_281
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinPython v1r0p2`) DO SET obuild_CoinPython_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_CoinPython_path  ECHO Can't find CoinPython package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinPython_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_CoinPython_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_284
IF NOT EXIST "%obuild_CoinPython_path%\%obuild_dir_bin%\CoinPython.lib" GOTO end_if_copy_285
  COPY "%obuild_CoinPython_path%\%obuild_dir_bin%\CoinPython.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_285
IF NOT EXIST "%obuild_CoinPython_path%\%obuild_dir_bin%\CoinPython.dll" GOTO end_if_copy_286
  COPY "%obuild_CoinPython_path%\%obuild_dir_bin%\CoinPython.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_286
IF NOT EXIST "%obuild_CoinPython_path%\%obuild_dir_bin%\_CoinPython.pyd" GOTO end_if_copy_287
  COPY "%obuild_CoinPython_path%\%obuild_dir_bin%\_CoinPython.pyd" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_287
:end_if_release_284
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_288
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_SWIG_Python.lib" GOTO end_if_copy_289
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_SWIG_Python.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_289
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_SWIG_Python.dll" GOTO end_if_copy_290
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_SWIG_Python.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_290
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_SWIG_Python.pyd" GOTO end_if_copy_291
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_SWIG_Python.pyd" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_291
:end_if_release_288
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_292
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnXSession.lib" GOTO end_if_copy_293
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnXSession.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_293
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnXSession.dll" GOTO end_if_copy_294
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnXSession.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_294
:end_if_release_292
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_295
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnXTestDLD.lib" GOTO end_if_copy_296
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnXTestDLD.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_296
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnXTestDLD.dll" GOTO end_if_copy_297
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnXTestDLD.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_297
:end_if_release_295
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_298
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnXWin.lib" GOTO end_if_copy_299
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnXWin.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_299
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnXWin.dll" GOTO end_if_copy_300
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnXWin.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_300
:end_if_release_298
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_301
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnXQt.lib" GOTO end_if_copy_302
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnXQt.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_302
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnXQt.dll" GOTO end_if_copy_303
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnXQt.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_303
:end_if_release_301
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_304
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnXGtk.lib" GOTO end_if_copy_305
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnXGtk.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_305
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnXGtk.dll" GOTO end_if_copy_306
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnXGtk.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_306
:end_if_release_304
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_307
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnXSDL.lib" GOTO end_if_copy_308
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnXSDL.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_308
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnXSDL.dll" GOTO end_if_copy_309
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnXSDL.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_309
:end_if_release_307
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_310
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX.lib" GOTO end_if_copy_311
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_311
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX.dll" GOTO end_if_copy_312
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_312
:end_if_release_310
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_313
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_config_Lib.lib" GOTO end_if_copy_314
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_config_Lib.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_314
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_config_Lib.dll" GOTO end_if_copy_315
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_config_Lib.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_315
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_config_Lib.save" GOTO end_if_copy_316
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_config_Lib.save" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_316
:end_if_release_313
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_317
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_config_OpenGL.lib" GOTO end_if_copy_318
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_config_OpenGL.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_318
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_config_OpenGL.dll" GOTO end_if_copy_319
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_config_OpenGL.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_319
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_config_OpenGL.save" GOTO end_if_copy_320
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_config_OpenGL.save" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_320
:end_if_release_317
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_321
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_config_Inventor.lib" GOTO end_if_copy_322
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_config_Inventor.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_322
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_config_Inventor.dll" GOTO end_if_copy_323
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_config_Inventor.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_323
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_config_Inventor.save" GOTO end_if_copy_324
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_config_Inventor.save" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_324
:end_if_release_321
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_325
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnXKUIP.lib" GOTO end_if_copy_326
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnXKUIP.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_326
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnXKUIP.dll" GOTO end_if_copy_327
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnXKUIP.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_327
:end_if_release_325
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_328
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnXPython.lib" GOTO end_if_copy_329
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnXPython.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_329
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnXPython.dll" GOTO end_if_copy_330
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnXPython.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_330
:end_if_release_328
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_331
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_SWIG_Python.lib" GOTO end_if_copy_332
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_SWIG_Python.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_332
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_SWIG_Python.dll" GOTO end_if_copy_333
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_SWIG_Python.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_333
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_SWIG_Python.pyd" GOTO end_if_copy_334
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_SWIG_Python.pyd" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_334
:end_if_release_331
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_335
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_config_Python.lib" GOTO end_if_copy_336
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_config_Python.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_336
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_config_Python.dll" GOTO end_if_copy_337
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_config_Python.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_337
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_config_Python.save" GOTO end_if_copy_338
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_config_Python.save" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_338
:end_if_release_335
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_339
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnXJava.lib" GOTO end_if_copy_340
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnXJava.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_340
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnXJava.dll" GOTO end_if_copy_341
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnXJava.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_341
:end_if_release_339
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_342
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_SWIG_Java.lib" GOTO end_if_copy_343
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_SWIG_Java.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_343
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_SWIG_Java.dll" GOTO end_if_copy_344
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_SWIG_Java.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_344
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\libOnX_SWIG_Java.jnilib.dll" GOTO end_if_copy_345
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\libOnX_SWIG_Java.jnilib.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_345
:end_if_release_342
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_346
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLabInventor.lib" GOTO end_if_copy_347
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLabInventor.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_347
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLabInventor.dll" GOTO end_if_copy_348
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLabInventor.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_348
:end_if_release_346
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_349
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLabLoadAIDA.lib" GOTO end_if_copy_350
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLabLoadAIDA.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_350
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLabLoadAIDA.dll" GOTO end_if_copy_351
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLabLoadAIDA.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_351
:end_if_release_349
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_352
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab.lib" GOTO end_if_copy_353
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_353
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab.dll" GOTO end_if_copy_354
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_354
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\Lab.dll" GOTO end_if_copy_355
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\Lab.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_355
:end_if_release_352
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_356
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLabKUIP.lib" GOTO end_if_copy_357
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLabKUIP.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_357
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLabKUIP.dll" GOTO end_if_copy_358
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLabKUIP.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_358
:end_if_release_356
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_359
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_SWIG_Python.lib" GOTO end_if_copy_360
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_SWIG_Python.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_360
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_SWIG_Python.dll" GOTO end_if_copy_361
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_SWIG_Python.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_361
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_SWIG_Python.pyd" GOTO end_if_copy_362
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_SWIG_Python.pyd" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_362
:end_if_release_359
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_363
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_SWIG_Java.lib" GOTO end_if_copy_364
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_SWIG_Java.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_364
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_SWIG_Java.dll" GOTO end_if_copy_365
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_SWIG_Java.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_365
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\libOnXLab_SWIG_Java.jnilib.dll" GOTO end_if_copy_366
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\libOnXLab_SWIG_Java.jnilib.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_366
:end_if_release_363
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OpenPAW v3r2p0`) DO SET obuild_OpenPAW_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OpenPAW_path  ECHO Can't find OpenPAW package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OpenPAW_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OpenPAW_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_367
IF NOT EXIST "%obuild_OpenPAW_path%\%obuild_dir_bin%\OpenPAW.lib" GOTO end_if_copy_368
  COPY "%obuild_OpenPAW_path%\%obuild_dir_bin%\OpenPAW.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_368
IF NOT EXIST "%obuild_OpenPAW_path%\%obuild_dir_bin%\OpenPAW.dll" GOTO end_if_copy_369
  COPY "%obuild_OpenPAW_path%\%obuild_dir_bin%\OpenPAW.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_369
:end_if_release_367
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  G4Lab v8r3p0`) DO SET obuild_G4Lab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_G4Lab_path  ECHO Can't find G4Lab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_G4Lab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_370
IF NOT EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%\G4Lab.lib" GOTO end_if_copy_371
  COPY "%obuild_G4Lab_path%\%obuild_dir_bin%\G4Lab.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_371
IF NOT EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%\G4Lab.dll" GOTO end_if_copy_372
  COPY "%obuild_G4Lab_path%\%obuild_dir_bin%\G4Lab.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_372
:end_if_release_370
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  G4Lab v8r3p0`) DO SET obuild_G4Lab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_G4Lab_path  ECHO Can't find G4Lab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_G4Lab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_373
IF NOT EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%\G4LabDefault.lib" GOTO end_if_copy_374
  COPY "%obuild_G4Lab_path%\%obuild_dir_bin%\G4LabDefault.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_374
IF NOT EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%\G4LabDefault.dll" GOTO end_if_copy_375
  COPY "%obuild_G4Lab_path%\%obuild_dir_bin%\G4LabDefault.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_375
:end_if_release_373
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  G4Lab v8r3p0`) DO SET obuild_G4Lab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_G4Lab_path  ECHO Can't find G4Lab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_G4Lab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_376
IF NOT EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%\G4Lab_config_Geant4.lib" GOTO end_if_copy_377
  COPY "%obuild_G4Lab_path%\%obuild_dir_bin%\G4Lab_config_Geant4.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_377
IF NOT EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%\G4Lab_config_Geant4.dll" GOTO end_if_copy_378
  COPY "%obuild_G4Lab_path%\%obuild_dir_bin%\G4Lab_config_Geant4.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_378
IF NOT EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%\G4Lab_config_Geant4.save" GOTO end_if_copy_379
  COPY "%obuild_G4Lab_path%\%obuild_dir_bin%\G4Lab_config_Geant4.save" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_379
:end_if_release_376
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  G4Lab v8r3p0`) DO SET obuild_G4Lab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_G4Lab_path  ECHO Can't find G4Lab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_G4Lab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_380
IF NOT EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%\G4Lab_config_physics_lists.lib" GOTO end_if_copy_381
  COPY "%obuild_G4Lab_path%\%obuild_dir_bin%\G4Lab_config_physics_lists.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_381
IF NOT EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%\G4Lab_config_physics_lists.dll" GOTO end_if_copy_382
  COPY "%obuild_G4Lab_path%\%obuild_dir_bin%\G4Lab_config_physics_lists.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_382
IF NOT EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%\G4Lab_config_physics_lists.save" GOTO end_if_copy_383
  COPY "%obuild_G4Lab_path%\%obuild_dir_bin%\G4Lab_config_physics_lists.save" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_383
:end_if_release_380
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  G4Lab v8r3p0`) DO SET obuild_G4Lab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_G4Lab_path  ECHO Can't find G4Lab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_G4Lab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_384
IF NOT EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%\G4Lab_config.lib" GOTO end_if_copy_385
  COPY "%obuild_G4Lab_path%\%obuild_dir_bin%\G4Lab_config.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_385
IF NOT EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%\G4Lab_config.dll" GOTO end_if_copy_386
  COPY "%obuild_G4Lab_path%\%obuild_dir_bin%\G4Lab_config.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_386
IF NOT EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%\G4Lab_config.save" GOTO end_if_copy_387
  COPY "%obuild_G4Lab_path%\%obuild_dir_bin%\G4Lab_config.save" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_387
:end_if_release_384
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  G4Simple v2r2p0`) DO SET obuild_G4Simple_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_G4Simple_path  ECHO Can't find G4Simple package.  && GOTO obuild_return

IF NOT EXIST "%obuild_G4Simple_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_G4Simple_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_388
IF NOT EXIST "%obuild_G4Simple_path%\%obuild_dir_bin%\G4SimpleOnX.lib" GOTO end_if_copy_389
  COPY "%obuild_G4Simple_path%\%obuild_dir_bin%\G4SimpleOnX.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_389
IF NOT EXIST "%obuild_G4Simple_path%\%obuild_dir_bin%\G4SimpleOnX.dll" GOTO end_if_copy_390
  COPY "%obuild_G4Simple_path%\%obuild_dir_bin%\G4SimpleOnX.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_390
:end_if_release_388
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  G4Simple v2r2p0`) DO SET obuild_G4Simple_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_G4Simple_path  ECHO Can't find G4Simple package.  && GOTO obuild_return

IF NOT EXIST "%obuild_G4Simple_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_G4Simple_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_391
IF NOT EXIST "%obuild_G4Simple_path%\%obuild_dir_bin%\G4Simple.lib" GOTO end_if_copy_392
  COPY "%obuild_G4Simple_path%\%obuild_dir_bin%\G4Simple.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_392
IF NOT EXIST "%obuild_G4Simple_path%\%obuild_dir_bin%\G4Simple.dll" GOTO end_if_copy_393
  COPY "%obuild_G4Simple_path%\%obuild_dir_bin%\G4Simple.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_393
:end_if_release_391
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  G4Examples v1r2p0`) DO SET obuild_G4Examples_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_G4Examples_path  ECHO Can't find G4Examples package.  && GOTO obuild_return

IF NOT EXIST "%obuild_G4Examples_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_G4Examples_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_394
IF NOT EXIST "%obuild_G4Examples_path%\%obuild_dir_bin%\G4Examples.lib" GOTO end_if_copy_395
  COPY "%obuild_G4Examples_path%\%obuild_dir_bin%\G4Examples.lib" "%obuild_dir_project%\lib\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_395
IF NOT EXIST "%obuild_G4Examples_path%\%obuild_dir_bin%\G4Examples.dll" GOTO end_if_copy_396
  COPY "%obuild_G4Examples_path%\%obuild_dir_bin%\G4Examples.dll" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_396
:end_if_release_394

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  obuild v1r4p0`) DO SET obuild_obuild_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_obuild_path  ECHO Can't find obuild package.  && GOTO obuild_return

IF NOT EXIST "%obuild_obuild_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_obuild_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_397
IF NOT EXIST "%obuild_obuild_path%\%obuild_dir_bin%\owrap.exe" GOTO end_if_copy_398
  COPY "%obuild_obuild_path%\%obuild_dir_bin%\owrap.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_398
:end_if_release_397
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  obuild v1r4p0`) DO SET obuild_obuild_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_obuild_path  ECHO Can't find obuild package.  && GOTO obuild_return

IF NOT EXIST "%obuild_obuild_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_obuild_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_399
IF NOT EXIST "%obuild_obuild_path%\%obuild_dir_bin%\obuild.exe" GOTO end_if_copy_400
  COPY "%obuild_obuild_path%\%obuild_dir_bin%\obuild.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_400
:end_if_release_399
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  zlib v1r114p6`) DO SET obuild_zlib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_zlib_path  ECHO Can't find zlib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_zlib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_zlib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_401
IF NOT EXIST "%obuild_zlib_path%\%obuild_dir_bin%\zlib_example.exe" GOTO end_if_copy_402
  COPY "%obuild_zlib_path%\%obuild_dir_bin%\zlib_example.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_402
:end_if_release_401
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  zlib v1r114p6`) DO SET obuild_zlib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_zlib_path  ECHO Can't find zlib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_zlib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_zlib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_403
IF NOT EXIST "%obuild_zlib_path%\%obuild_dir_bin%\zlib_minigzip.exe" GOTO end_if_copy_404
  COPY "%obuild_zlib_path%\%obuild_dir_bin%\zlib_minigzip.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_404
:end_if_release_403
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  zip v1r101p0`) DO SET obuild_zip_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_zip_path  ECHO Can't find zip package.  && GOTO obuild_return

IF NOT EXIST "%obuild_zip_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_zip_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_405
IF NOT EXIST "%obuild_zip_path%\%obuild_dir_bin%\zip_minizip.exe" GOTO end_if_copy_406
  COPY "%obuild_zip_path%\%obuild_dir_bin%\zip_minizip.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_406
:end_if_release_405
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  zip v1r101p0`) DO SET obuild_zip_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_zip_path  ECHO Can't find zip package.  && GOTO obuild_return

IF NOT EXIST "%obuild_zip_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_zip_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_407
IF NOT EXIST "%obuild_zip_path%\%obuild_dir_bin%\zip_miniuzip.exe" GOTO end_if_copy_408
  COPY "%obuild_zip_path%\%obuild_dir_bin%\zip_miniuzip.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_408
:end_if_release_407
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  expat v1r11p8`) DO SET obuild_expat_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_expat_path  ECHO Can't find expat package.  && GOTO obuild_return

IF NOT EXIST "%obuild_expat_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_expat_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_409
IF NOT EXIST "%obuild_expat_path%\%obuild_dir_bin%\expat_example.exe" GOTO end_if_copy_410
  COPY "%obuild_expat_path%\%obuild_dir_bin%\expat_example.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_410
:end_if_release_409
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_411
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_tab.exe" GOTO end_if_copy_412
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_tab.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_412
:end_if_release_411
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_413
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_sizeof.exe" GOTO end_if_copy_414
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_sizeof.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_414
:end_if_release_413
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_415
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_endian.exe" GOTO end_if_copy_416
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_endian.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_416
:end_if_release_415
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_417
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_whereami.exe" GOTO end_if_copy_418
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_whereami.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_418
:end_if_release_417
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_419
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_subs.exe" GOTO end_if_copy_420
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_subs.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_420
:end_if_release_419
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_421
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_run.exe" GOTO end_if_copy_422
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_run.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_422
:end_if_release_421
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_423
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_clone.exe" GOTO end_if_copy_424
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_clone.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_424
:end_if_release_423
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_425
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_upgrade.exe" GOTO end_if_copy_426
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_upgrade.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_426
:end_if_release_425
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_427
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_find.exe" GOTO end_if_copy_428
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_find.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_428
:end_if_release_427
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_429
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_wrap.exe" GOTO end_if_copy_430
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_wrap.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_430
:end_if_release_429
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_431
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_dld.exe" GOTO end_if_copy_432
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_dld.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_432
:end_if_release_431
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_433
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_file_header.exe" GOTO end_if_copy_434
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_file_header.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_434
:end_if_release_433
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_435
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_cxx.exe" GOTO end_if_copy_436
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_cxx.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_436
:end_if_release_435
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_437
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_f77.exe" GOTO end_if_copy_438
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_f77.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_438
:end_if_release_437
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_439
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_STL.exe" GOTO end_if_copy_440
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_STL.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_440
:end_if_release_439
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_441
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_accessorManager.exe" GOTO end_if_copy_442
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_accessorManager.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_442
:end_if_release_441
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_443
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_array.exe" GOTO end_if_copy_444
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_array.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_444
:end_if_release_443
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_445
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_colormanip.exe" GOTO end_if_copy_446
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_colormanip.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_446
:end_if_release_445
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_447
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_columns.exe" GOTO end_if_copy_448
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_columns.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_448
:end_if_release_447
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_449
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_contour.exe" GOTO end_if_copy_450
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_contour.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_450
:end_if_release_449
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_451
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_debug.exe" GOTO end_if_copy_452
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_debug.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_452
:end_if_release_451
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_453
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_dirmanip.exe" GOTO end_if_copy_454
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_dirmanip.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_454
:end_if_release_453
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_455
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_extern.exe" GOTO end_if_copy_456
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_extern.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_456
:end_if_release_455
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_457
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_fortran_format.exe" GOTO end_if_copy_458
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_fortran_format.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_458
:end_if_release_457
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_459
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_functionManager.exe" GOTO end_if_copy_460
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_functionManager.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_460
:end_if_release_459
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_461
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_functions.exe" GOTO end_if_copy_462
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_functions.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_462
:end_if_release_461
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_463
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_home.exe" GOTO end_if_copy_464
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_home.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_464
:end_if_release_463
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_465
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_parameters.exe" GOTO end_if_copy_466
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_parameters.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_466
:end_if_release_465
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_467
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_paw_set_opt.exe" GOTO end_if_copy_468
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_paw_set_opt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_468
:end_if_release_467
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_469
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_prime.exe" GOTO end_if_copy_470
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_prime.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_470
:end_if_release_469
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_471
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_processor.exe" GOTO end_if_copy_472
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_processor.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_472
:end_if_release_471
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_473
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_rio_sinfo.exe" GOTO end_if_copy_474
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_rio_sinfo.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_474
:end_if_release_473
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_475
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_smanip.exe" GOTO end_if_copy_476
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_smanip.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_476
:end_if_release_475
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_477
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_symbolic.exe" GOTO end_if_copy_478
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_symbolic.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_478
:end_if_release_477
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_479
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_args.exe" GOTO end_if_copy_480
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_args.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_480
:end_if_release_479
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_481
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_algebra.exe" GOTO end_if_copy_482
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_algebra.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_482
:end_if_release_481
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_483
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_phys.exe" GOTO end_if_copy_484
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_phys.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_484
:end_if_release_483
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_485
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_baker_hausdorf.exe" GOTO end_if_copy_486
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_baker_hausdorf.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_486
:end_if_release_485
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_487
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_objectML.exe" GOTO end_if_copy_488
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_objectML.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_488
:end_if_release_487
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_489
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_xml.exe" GOTO end_if_copy_490
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_xml.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_490
:end_if_release_489
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_491
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_gzip.exe" GOTO end_if_copy_492
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_gzip.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_492
:end_if_release_491
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_493
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_zip.exe" GOTO end_if_copy_494
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_zip.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_494
:end_if_release_493
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_495
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_client.exe" GOTO end_if_copy_496
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_client.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_496
:end_if_release_495
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r3p0`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Lib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_497
IF NOT EXIST "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_server.exe" GOTO end_if_copy_498
  COPY "%obuild_Lib_path%\%obuild_dir_bin%\Lib_test_server.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_498
:end_if_release_497
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HCL v7r0p2`) DO SET obuild_HCL_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HCL_path  ECHO Can't find HCL package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HCL_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HCL_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_499
IF NOT EXIST "%obuild_HCL_path%\%obuild_dir_bin%\HCL_example.exe" GOTO end_if_copy_500
  COPY "%obuild_HCL_path%\%obuild_dir_bin%\HCL_example.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_500
:end_if_release_499
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Midnight v4r0p2`) DO SET obuild_Midnight_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Midnight_path  ECHO Can't find Midnight package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Midnight_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Midnight_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_501
IF NOT EXIST "%obuild_Midnight_path%\%obuild_dir_bin%\Midnight_example.exe" GOTO end_if_copy_502
  COPY "%obuild_Midnight_path%\%obuild_dir_bin%\Midnight_example.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_502
:end_if_release_501
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Minuit v1r140p6`) DO SET obuild_Minuit_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Minuit_path  ECHO Can't find Minuit package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Minuit_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Minuit_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_503
IF NOT EXIST "%obuild_Minuit_path%\%obuild_dir_bin%\Minuit_test_DemoGaussSim.exe" GOTO end_if_copy_504
  COPY "%obuild_Minuit_path%\%obuild_dir_bin%\Minuit_test_DemoGaussSim.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_504
:end_if_release_503
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Minuit v1r140p6`) DO SET obuild_Minuit_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Minuit_path  ECHO Can't find Minuit package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Minuit_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Minuit_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_505
IF NOT EXIST "%obuild_Minuit_path%\%obuild_dir_bin%\Minuit_test_PaulTest.exe" GOTO end_if_copy_506
  COPY "%obuild_Minuit_path%\%obuild_dir_bin%\Minuit_test_PaulTest.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_506
:end_if_release_505
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Minuit v1r140p6`) DO SET obuild_Minuit_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Minuit_path  ECHO Can't find Minuit package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Minuit_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Minuit_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_507
IF NOT EXIST "%obuild_Minuit_path%\%obuild_dir_bin%\Minuit_test_PaulTest2.exe" GOTO end_if_copy_508
  COPY "%obuild_Minuit_path%\%obuild_dir_bin%\Minuit_test_PaulTest2.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_508
:end_if_release_507
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Minuit v1r140p6`) DO SET obuild_Minuit_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Minuit_path  ECHO Can't find Minuit package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Minuit_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Minuit_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_509
IF NOT EXIST "%obuild_Minuit_path%\%obuild_dir_bin%\Minuit_test_PaulTest3.exe" GOTO end_if_copy_510
  COPY "%obuild_Minuit_path%\%obuild_dir_bin%\Minuit_test_PaulTest3.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_510
:end_if_release_509
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Minuit v1r140p6`) DO SET obuild_Minuit_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Minuit_path  ECHO Can't find Minuit package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Minuit_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Minuit_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_511
IF NOT EXIST "%obuild_Minuit_path%\%obuild_dir_bin%\Minuit_test_PaulTest4.exe" GOTO end_if_copy_512
  COPY "%obuild_Minuit_path%\%obuild_dir_bin%\Minuit_test_PaulTest4.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_512
:end_if_release_511
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Minuit v1r140p6`) DO SET obuild_Minuit_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Minuit_path  ECHO Can't find Minuit package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Minuit_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Minuit_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_513
IF NOT EXIST "%obuild_Minuit_path%\%obuild_dir_bin%\Minuit_test_ReneTest.exe" GOTO end_if_copy_514
  COPY "%obuild_Minuit_path%\%obuild_dir_bin%\Minuit_test_ReneTest.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_514
:end_if_release_513
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Minuit v1r140p6`) DO SET obuild_Minuit_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Minuit_path  ECHO Can't find Minuit package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Minuit_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Minuit_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_515
IF NOT EXIST "%obuild_Minuit_path%\%obuild_dir_bin%\Minuit_test_Quad1FMain.exe" GOTO end_if_copy_516
  COPY "%obuild_Minuit_path%\%obuild_dir_bin%\Minuit_test_Quad1FMain.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_516
:end_if_release_515
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Minuit v1r140p6`) DO SET obuild_Minuit_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Minuit_path  ECHO Can't find Minuit package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Minuit_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Minuit_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_517
IF NOT EXIST "%obuild_Minuit_path%\%obuild_dir_bin%\Minuit_test_Quad2FMain.exe" GOTO end_if_copy_518
  COPY "%obuild_Minuit_path%\%obuild_dir_bin%\Minuit_test_Quad2FMain.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_518
:end_if_release_517
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Minuit v1r140p6`) DO SET obuild_Minuit_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Minuit_path  ECHO Can't find Minuit package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Minuit_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Minuit_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_519
IF NOT EXIST "%obuild_Minuit_path%\%obuild_dir_bin%\Minuit_test_Quad3FMain.exe" GOTO end_if_copy_520
  COPY "%obuild_Minuit_path%\%obuild_dir_bin%\Minuit_test_Quad3FMain.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_520
:end_if_release_519
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Minuit v1r140p6`) DO SET obuild_Minuit_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Minuit_path  ECHO Can't find Minuit package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Minuit_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Minuit_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_521
IF NOT EXIST "%obuild_Minuit_path%\%obuild_dir_bin%\Minuit_test_Quad4FMain.exe" GOTO end_if_copy_522
  COPY "%obuild_Minuit_path%\%obuild_dir_bin%\Minuit_test_Quad4FMain.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_522
:end_if_release_521
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Minuit v1r140p6`) DO SET obuild_Minuit_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Minuit_path  ECHO Can't find Minuit package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Minuit_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Minuit_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_523
IF NOT EXIST "%obuild_Minuit_path%\%obuild_dir_bin%\Minuit_test_Quad8FMain.exe" GOTO end_if_copy_524
  COPY "%obuild_Minuit_path%\%obuild_dir_bin%\Minuit_test_Quad8FMain.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_524
:end_if_release_523
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Minuit v1r140p6`) DO SET obuild_Minuit_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Minuit_path  ECHO Can't find Minuit package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Minuit_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Minuit_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_525
IF NOT EXIST "%obuild_Minuit_path%\%obuild_dir_bin%\Minuit_test_Quad12FMain.exe" GOTO end_if_copy_526
  COPY "%obuild_Minuit_path%\%obuild_dir_bin%\Minuit_test_Quad12FMain.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_526
:end_if_release_525
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Rio v9r0p0`) DO SET obuild_Rio_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Rio_path  ECHO Can't find Rio package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Rio_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Rio_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_527
IF NOT EXIST "%obuild_Rio_path%\%obuild_dir_bin%\Rio_rio.exe" GOTO end_if_copy_528
  COPY "%obuild_Rio_path%\%obuild_dir_bin%\Rio_rio.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_528
IF NOT EXIST "%obuild_Rio_path%\%obuild_dir_bin%\rio.exe" GOTO end_if_copy_529
  COPY "%obuild_Rio_path%\%obuild_dir_bin%\rio.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_529
:end_if_release_527
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Rio v9r0p0`) DO SET obuild_Rio_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Rio_path  ECHO Can't find Rio package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Rio_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Rio_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_530
IF NOT EXIST "%obuild_Rio_path%\%obuild_dir_bin%\Rio_test.exe" GOTO end_if_copy_531
  COPY "%obuild_Rio_path%\%obuild_dir_bin%\Rio_test.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_531
:end_if_release_530
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Rio v9r0p0`) DO SET obuild_Rio_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Rio_path  ECHO Can't find Rio package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Rio_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Rio_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_532
IF NOT EXIST "%obuild_Rio_path%\%obuild_dir_bin%\Rio_test_jec.exe" GOTO end_if_copy_533
  COPY "%obuild_Rio_path%\%obuild_dir_bin%\Rio_test_jec.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_533
:end_if_release_532
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Rio v9r0p0`) DO SET obuild_Rio_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Rio_path  ECHO Can't find Rio package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Rio_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Rio_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_534
IF NOT EXIST "%obuild_Rio_path%\%obuild_dir_bin%\Rio_test_jec_read.exe" GOTO end_if_copy_535
  COPY "%obuild_Rio_path%\%obuild_dir_bin%\Rio_test_jec_read.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_535
:end_if_release_534
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Rio v9r0p0`) DO SET obuild_Rio_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_Rio_path  ECHO Can't find Rio package.  && GOTO obuild_return

IF NOT EXIST "%obuild_Rio_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_Rio_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_536
IF NOT EXIST "%obuild_Rio_path%\%obuild_dir_bin%\Rio_test_stl.exe" GOTO end_if_copy_537
  COPY "%obuild_Rio_path%\%obuild_dir_bin%\Rio_test_stl.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_537
:end_if_release_536
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HDF5 v1r165p5`) DO SET obuild_HDF5_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HDF5_path  ECHO Can't find HDF5 package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HDF5_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HDF5_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_538
IF NOT EXIST "%obuild_HDF5_path%\%obuild_dir_bin%\h5_array_compound.exe" GOTO end_if_copy_539
  COPY "%obuild_HDF5_path%\%obuild_dir_bin%\h5_array_compound.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_539
:end_if_release_538
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  BatchLab v1r3p0`) DO SET obuild_BatchLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_BatchLab_path  ECHO Can't find BatchLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_BatchLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_540
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_aida_config.exe" GOTO end_if_copy_541
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_aida_config.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_541
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\aida-config.exe" GOTO end_if_copy_542
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\aida-config.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_542
:end_if_release_540
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  BatchLab v1r3p0`) DO SET obuild_BatchLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_BatchLab_path  ECHO Can't find BatchLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_BatchLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_543
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_exa_config.exe" GOTO end_if_copy_544
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_exa_config.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_544
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_exa_config.save" GOTO end_if_copy_545
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_exa_config.save" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_545
:end_if_release_543
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  BatchLab v1r3p0`) DO SET obuild_BatchLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_BatchLab_path  ECHO Can't find BatchLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_BatchLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_546
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_xml.exe" GOTO end_if_copy_547
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_xml.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_547
:end_if_release_546
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  BatchLab v1r3p0`) DO SET obuild_BatchLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_BatchLab_path  ECHO Can't find BatchLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_BatchLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_548
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_xml2fs.exe" GOTO end_if_copy_549
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_xml2fs.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_549
:end_if_release_548
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  BatchLab v1r3p0`) DO SET obuild_BatchLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_BatchLab_path  ECHO Can't find BatchLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_BatchLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_550
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_exa_store.exe" GOTO end_if_copy_551
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_exa_store.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_551
:end_if_release_550
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  BatchLab v1r3p0`) DO SET obuild_BatchLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_BatchLab_path  ECHO Can't find BatchLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_BatchLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_552
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_exa_functions.exe" GOTO end_if_copy_553
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_exa_functions.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_553
:end_if_release_552
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  BatchLab v1r3p0`) DO SET obuild_BatchLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_BatchLab_path  ECHO Can't find BatchLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_BatchLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_554
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_exa_analysis.exe" GOTO end_if_copy_555
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_exa_analysis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_555
:end_if_release_554
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  BatchLab v1r3p0`) DO SET obuild_BatchLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_BatchLab_path  ECHO Can't find BatchLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_BatchLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_556
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_exa_b1.exe" GOTO end_if_copy_557
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_exa_b1.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_557
:end_if_release_556
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  BatchLab v1r3p0`) DO SET obuild_BatchLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_BatchLab_path  ECHO Can't find BatchLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_BatchLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_558
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_exa_hippo.exe" GOTO end_if_copy_559
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_exa_hippo.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_559
:end_if_release_558
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  BatchLab v1r3p0`) DO SET obuild_BatchLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_BatchLab_path  ECHO Can't find BatchLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_BatchLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_560
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_exa_jec.exe" GOTO end_if_copy_561
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_exa_jec.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_561
:end_if_release_560
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  BatchLab v1r3p0`) DO SET obuild_BatchLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_BatchLab_path  ECHO Can't find BatchLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_BatchLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_562
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_exa_cloud.exe" GOTO end_if_copy_563
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_exa_cloud.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_563
:end_if_release_562
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  BatchLab v1r3p0`) DO SET obuild_BatchLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_BatchLab_path  ECHO Can't find BatchLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_BatchLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_564
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_exa_shahrokh_write.exe" GOTO end_if_copy_565
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_exa_shahrokh_write.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_565
:end_if_release_564
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  BatchLab v1r3p0`) DO SET obuild_BatchLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_BatchLab_path  ECHO Can't find BatchLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_BatchLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_566
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_exa_shahrokh_read.exe" GOTO end_if_copy_567
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_exa_shahrokh_read.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_567
:end_if_release_566
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  BatchLab v1r3p0`) DO SET obuild_BatchLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_BatchLab_path  ECHO Can't find BatchLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_BatchLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_568
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_exa_columns.exe" GOTO end_if_copy_569
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_exa_columns.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_569
:end_if_release_568
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  BatchLab v1r3p0`) DO SET obuild_BatchLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_BatchLab_path  ECHO Can't find BatchLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_BatchLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_570
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_test_tuple.exe" GOTO end_if_copy_571
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_test_tuple.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_571
:end_if_release_570
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  BatchLab v1r3p0`) DO SET obuild_BatchLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_BatchLab_path  ECHO Can't find BatchLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_BatchLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_572
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_Rio.exe" GOTO end_if_copy_573
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_Rio.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_573
:end_if_release_572
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  BatchLab v1r3p0`) DO SET obuild_BatchLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_BatchLab_path  ECHO Can't find BatchLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_BatchLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_574
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_test_HDF5.exe" GOTO end_if_copy_575
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_test_HDF5.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_575
:end_if_release_574
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  BatchLab v1r3p0`) DO SET obuild_BatchLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_BatchLab_path  ECHO Can't find BatchLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_BatchLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_576
IF NOT EXIST "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_test_hbook.exe" GOTO end_if_copy_577
  COPY "%obuild_BatchLab_path%\%obuild_dir_bin%\BatchLab_test_hbook.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_577
:end_if_release_576
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_578
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_ChainedAndFilteredTuplesExample.exe" GOTO end_if_copy_579
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_ChainedAndFilteredTuplesExample.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_579
:end_if_release_578
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_580
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_Cloud.exe" GOTO end_if_copy_581
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_Cloud.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_581
:end_if_release_580
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_582
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_CloudCreate.exe" GOTO end_if_copy_583
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_CloudCreate.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_583
:end_if_release_582
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_584
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_DataPointSetCreateAndFill.exe" GOTO end_if_copy_585
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_DataPointSetCreateAndFill.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_585
:end_if_release_584
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_586
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_FilterAndEvaluatorExample.exe" GOTO end_if_copy_587
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_FilterAndEvaluatorExample.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_587
:end_if_release_586
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_588
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_Histogram.exe" GOTO end_if_copy_589
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_Histogram.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_589
:end_if_release_588
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_590
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_HistogramArithmetic.exe" GOTO end_if_copy_591
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_HistogramArithmetic.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_591
:end_if_release_590
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_592
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_PlotExample.exe" GOTO end_if_copy_593
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_PlotExample.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_593
:end_if_release_592
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_594
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_PlotWithStyles.exe" GOTO end_if_copy_595
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_PlotWithStyles.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_595
:end_if_release_594
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_596
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_ProfileCreate.exe" GOTO end_if_copy_597
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_ProfileCreate.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_597
:end_if_release_596
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_598
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_ProfileFill.exe" GOTO end_if_copy_599
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_ProfileFill.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_599
:end_if_release_598
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_600
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_Tree.exe" GOTO end_if_copy_601
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_Tree.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_601
:end_if_release_600
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_602
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_Tuple.exe" GOTO end_if_copy_603
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_Tuple.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_603
:end_if_release_602
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_604
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_TupleCreate.exe" GOTO end_if_copy_605
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_TupleCreate.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_605
:end_if_release_604
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_606
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_createAndFillTupleWithComplexStructure.exe" GOTO end_if_copy_607
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_createAndFillTupleWithComplexStructure.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_607
:end_if_release_606
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_608
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_DataPointSetCreateFromData.exe" GOTO end_if_copy_609
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_DataPointSetCreateFromData.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_609
:end_if_release_608
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_610
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_Store.exe" GOTO end_if_copy_611
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_Store.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_611
:end_if_release_610
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_612
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_Restore.exe" GOTO end_if_copy_613
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_Restore.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_613
:end_if_release_612
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_614
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_Chi2FitToHistogram.exe" GOTO end_if_copy_615
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_Chi2FitToHistogram.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_615
:end_if_release_614
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_616
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_ComplexFit.exe" GOTO end_if_copy_617
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_ComplexFit.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_617
:end_if_release_616
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_618
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_CreateAndFitDataPointSet.exe" GOTO end_if_copy_619
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_CreateAndFitDataPointSet.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_619
:end_if_release_618
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_620
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_FitExample.exe" GOTO end_if_copy_621
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_FitExample.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_621
:end_if_release_620
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_622
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_ProfileFitAndPlot.exe" GOTO end_if_copy_623
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_ProfileFitAndPlot.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_623
:end_if_release_622
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_624
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_ScanAndContour.exe" GOTO end_if_copy_625
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_ScanAndContour.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_625
:end_if_release_624
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_626
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_SimpleFit.exe" GOTO end_if_copy_627
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_SimpleFit.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_627
:end_if_release_626
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_628
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b1.exe" GOTO end_if_copy_629
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b1.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_629
:end_if_release_628
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_630
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b2.exe" GOTO end_if_copy_631
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b2.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_631
:end_if_release_630
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_632
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b3.exe" GOTO end_if_copy_633
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b3.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_633
:end_if_release_632
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_634
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b4.exe" GOTO end_if_copy_635
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b4.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_635
:end_if_release_634
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_636
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b5.exe" GOTO end_if_copy_637
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b5.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_637
:end_if_release_636
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_638
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b6.exe" GOTO end_if_copy_639
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b6.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_639
:end_if_release_638
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_640
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b7.exe" GOTO end_if_copy_641
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b7.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_641
:end_if_release_640
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_642
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b8.exe" GOTO end_if_copy_643
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b8.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_643
:end_if_release_642
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_644
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b11.exe" GOTO end_if_copy_645
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b11.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_645
:end_if_release_644
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_646
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_jec.exe" GOTO end_if_copy_647
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_jec.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_647
:end_if_release_646
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_648
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_rmason.exe" GOTO end_if_copy_649
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_rmason.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_649
:end_if_release_648
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r0p5`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_UseAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_650
IF NOT EXIST "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_DynamicLoad.exe" GOTO end_if_copy_651
  COPY "%obuild_UseAIDA_path%\%obuild_dir_bin%\AIDA_example_DynamicLoad.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_651
:end_if_release_650
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  dvi2bitmap v1r0132p3`) DO SET obuild_dvi2bitmap_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_dvi2bitmap_path  ECHO Can't find dvi2bitmap package.  && GOTO obuild_return

IF NOT EXIST "%obuild_dvi2bitmap_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_dvi2bitmap_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_652
IF NOT EXIST "%obuild_dvi2bitmap_path%\%obuild_dir_bin%\dvireport.exe" GOTO end_if_copy_653
  COPY "%obuild_dvi2bitmap_path%\%obuild_dir_bin%\dvireport.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_653
:end_if_release_652
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  dvi2bitmap v1r0132p3`) DO SET obuild_dvi2bitmap_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_dvi2bitmap_path  ECHO Can't find dvi2bitmap package.  && GOTO obuild_return

IF NOT EXIST "%obuild_dvi2bitmap_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_dvi2bitmap_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_654
IF NOT EXIST "%obuild_dvi2bitmap_path%\%obuild_dir_bin%\dvi2bitmap.exe" GOTO end_if_copy_655
  COPY "%obuild_dvi2bitmap_path%\%obuild_dir_bin%\dvi2bitmap.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_655
:end_if_release_654
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  dvi2bitmap v1r0132p3`) DO SET obuild_dvi2bitmap_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_dvi2bitmap_path  ECHO Can't find dvi2bitmap package.  && GOTO obuild_return

IF NOT EXIST "%obuild_dvi2bitmap_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_dvi2bitmap_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_656
IF NOT EXIST "%obuild_dvi2bitmap_path%\%obuild_dir_bin%\fontGeneration.exe" GOTO end_if_copy_657
  COPY "%obuild_dvi2bitmap_path%\%obuild_dir_bin%\fontGeneration.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_657
:end_if_release_656
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  freetype2 v1r219p2`) DO SET obuild_freetype2_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_freetype2_path  ECHO Can't find freetype2 package.  && GOTO obuild_return

IF NOT EXIST "%obuild_freetype2_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_freetype2_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_658
IF NOT EXIST "%obuild_freetype2_path%\%obuild_dir_bin%\freetypes_test_gb_0.exe" GOTO end_if_copy_659
  COPY "%obuild_freetype2_path%\%obuild_dir_bin%\freetypes_test_gb_0.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_659
:end_if_release_658
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinGL v1r250p0`) DO SET obuild_CoinGL_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_CoinGL_path  ECHO Can't find CoinGL package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinGL_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_CoinGL_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_660
IF NOT EXIST "%obuild_CoinGL_path%\%obuild_dir_bin%\CoinGL_coin_config.exe" GOTO end_if_copy_661
  COPY "%obuild_CoinGL_path%\%obuild_dir_bin%\CoinGL_coin_config.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_661
IF NOT EXIST "%obuild_CoinGL_path%\%obuild_dir_bin%\coin-config.exe" GOTO end_if_copy_662
  COPY "%obuild_CoinGL_path%\%obuild_dir_bin%\coin-config.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_662
:end_if_release_660
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinGL v1r250p0`) DO SET obuild_CoinGL_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_CoinGL_path  ECHO Can't find CoinGL package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinGL_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_CoinGL_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_663
IF NOT EXIST "%obuild_CoinGL_path%\%obuild_dir_bin%\CoinGL_config_save.exe" GOTO end_if_copy_664
  COPY "%obuild_CoinGL_path%\%obuild_dir_bin%\CoinGL_config_save.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_664
IF NOT EXIST "%obuild_CoinGL_path%\%obuild_dir_bin%\CoinGL_config_save.save" GOTO end_if_copy_665
  COPY "%obuild_CoinGL_path%\%obuild_dir_bin%\CoinGL_config_save.save" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_665
:end_if_release_663
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinWin v1r50p7`) DO SET obuild_CoinWin_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_CoinWin_path  ECHO Can't find CoinWin package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinWin_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_CoinWin_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_666
IF NOT EXIST "%obuild_CoinWin_path%\%obuild_dir_bin%\CoinWin_test_cube.exe" GOTO end_if_copy_667
  COPY "%obuild_CoinWin_path%\%obuild_dir_bin%\CoinWin_test_cube.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_667
:end_if_release_666
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinWin v1r50p7`) DO SET obuild_CoinWin_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_CoinWin_path  ECHO Can't find CoinWin package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinWin_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_CoinWin_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_668
IF NOT EXIST "%obuild_CoinWin_path%\%obuild_dir_bin%\CoinWin_test_cube2.exe" GOTO end_if_copy_669
  COPY "%obuild_CoinWin_path%\%obuild_dir_bin%\CoinWin_test_cube2.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_669
:end_if_release_668
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinQt v1r130p2`) DO SET obuild_CoinQt_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_CoinQt_path  ECHO Can't find CoinQt package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinQt_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_CoinQt_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_670
IF NOT EXIST "%obuild_CoinQt_path%\%obuild_dir_bin%\CoinQt_test_cube.exe" GOTO end_if_copy_671
  COPY "%obuild_CoinQt_path%\%obuild_dir_bin%\CoinQt_test_cube.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_671
:end_if_release_670
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinQt v1r130p2`) DO SET obuild_CoinQt_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_CoinQt_path  ECHO Can't find CoinQt package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinQt_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_CoinQt_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_672
IF NOT EXIST "%obuild_CoinQt_path%\%obuild_dir_bin%\CoinQt_test_gui.exe" GOTO end_if_copy_673
  COPY "%obuild_CoinQt_path%\%obuild_dir_bin%\CoinQt_test_gui.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_673
:end_if_release_672
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinQt v1r130p2`) DO SET obuild_CoinQt_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_CoinQt_path  ECHO Can't find CoinQt package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinQt_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_CoinQt_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_674
IF NOT EXIST "%obuild_CoinQt_path%\%obuild_dir_bin%\CoinQt_coin_config.exe" GOTO end_if_copy_675
  COPY "%obuild_CoinQt_path%\%obuild_dir_bin%\CoinQt_coin_config.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_675
IF NOT EXIST "%obuild_CoinQt_path%\%obuild_dir_bin%\soqt-config.exe" GOTO end_if_copy_676
  COPY "%obuild_CoinQt_path%\%obuild_dir_bin%\soqt-config.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_676
:end_if_release_674
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinQt v1r130p2`) DO SET obuild_CoinQt_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_CoinQt_path  ECHO Can't find CoinQt package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinQt_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_CoinQt_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_677
IF NOT EXIST "%obuild_CoinQt_path%\%obuild_dir_bin%\CoinQt_config_save.exe" GOTO end_if_copy_678
  COPY "%obuild_CoinQt_path%\%obuild_dir_bin%\CoinQt_config_save.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_678
IF NOT EXIST "%obuild_CoinQt_path%\%obuild_dir_bin%\CoinQt_config_save.save" GOTO end_if_copy_679
  COPY "%obuild_CoinQt_path%\%obuild_dir_bin%\CoinQt_config_save.save" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_679
:end_if_release_677
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinGtk v1r50p4`) DO SET obuild_CoinGtk_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_CoinGtk_path  ECHO Can't find CoinGtk package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_CoinGtk_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_680
IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%\CoinGtk_test_cube.exe" GOTO end_if_copy_681
  COPY "%obuild_CoinGtk_path%\%obuild_dir_bin%\CoinGtk_test_cube.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_681
:end_if_release_680
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinGtk v1r50p4`) DO SET obuild_CoinGtk_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_CoinGtk_path  ECHO Can't find CoinGtk package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_CoinGtk_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_682
IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%\CoinGtk_test_gui.exe" GOTO end_if_copy_683
  COPY "%obuild_CoinGtk_path%\%obuild_dir_bin%\CoinGtk_test_gui.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_683
:end_if_release_682
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinGtk v1r50p4`) DO SET obuild_CoinGtk_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_CoinGtk_path  ECHO Can't find CoinGtk package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_CoinGtk_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_684
IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%\CoinGtk_coin_config.exe" GOTO end_if_copy_685
  COPY "%obuild_CoinGtk_path%\%obuild_dir_bin%\CoinGtk_coin_config.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_685
IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%\soqt-config.exe" GOTO end_if_copy_686
  COPY "%obuild_CoinGtk_path%\%obuild_dir_bin%\soqt-config.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_686
:end_if_release_684
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinGtk v1r50p4`) DO SET obuild_CoinGtk_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_CoinGtk_path  ECHO Can't find CoinGtk package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_CoinGtk_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_687
IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%\CoinGtk_config_save.exe" GOTO end_if_copy_688
  COPY "%obuild_CoinGtk_path%\%obuild_dir_bin%\CoinGtk_config_save.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_688
IF NOT EXIST "%obuild_CoinGtk_path%\%obuild_dir_bin%\CoinGtk_config_save.save" GOTO end_if_copy_689
  COPY "%obuild_CoinGtk_path%\%obuild_dir_bin%\CoinGtk_config_save.save" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_689
:end_if_release_687
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  CoinPython v1r0p2`) DO SET obuild_CoinPython_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_CoinPython_path  ECHO Can't find CoinPython package.  && GOTO obuild_return

IF NOT EXIST "%obuild_CoinPython_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_CoinPython_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_690
IF NOT EXIST "%obuild_CoinPython_path%\%obuild_dir_bin%\CoinPython_exa_0.exe" GOTO end_if_copy_691
  COPY "%obuild_CoinPython_path%\%obuild_dir_bin%\CoinPython_exa_0.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_691
:end_if_release_690
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  SoSDL v1r1p0`) DO SET obuild_SoSDL_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_SoSDL_path  ECHO Can't find SoSDL package.  && GOTO obuild_return

IF NOT EXIST "%obuild_SoSDL_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_SoSDL_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_692
IF NOT EXIST "%obuild_SoSDL_path%\%obuild_dir_bin%\SoSDL_test_cube.exe" GOTO end_if_copy_693
  COPY "%obuild_SoSDL_path%\%obuild_dir_bin%\SoSDL_test_cube.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_693
:end_if_release_692
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  SoSDL v1r1p0`) DO SET obuild_SoSDL_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_SoSDL_path  ECHO Can't find SoSDL package.  && GOTO obuild_return

IF NOT EXIST "%obuild_SoSDL_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_SoSDL_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_694
IF NOT EXIST "%obuild_SoSDL_path%\%obuild_dir_bin%\SDL_query_video.exe" GOTO end_if_copy_695
  COPY "%obuild_SoSDL_path%\%obuild_dir_bin%\SDL_query_video.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_695
:end_if_release_694
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_696
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_test_freetype.exe" GOTO end_if_copy_697
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_test_freetype.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_697
:end_if_release_696
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_698
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisToStdIv.exe" GOTO end_if_copy_699
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVisToStdIv.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_699
:end_if_release_698
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_700
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_convert.exe" GOTO end_if_copy_701
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_convert.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_701
:end_if_release_700
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_702
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_iv2pov.exe" GOTO end_if_copy_703
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_iv2pov.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_703
:end_if_release_702
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_704
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_hiv2pov.exe" GOTO end_if_copy_705
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_hiv2pov.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_705
:end_if_release_704
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_706
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Pyramid_Win.exe" GOTO end_if_copy_707
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Pyramid_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_707
:end_if_release_706
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_708
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_SimpleButton_Win.exe" GOTO end_if_copy_709
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_SimpleButton_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_709
:end_if_release_708
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_710
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextTTF_Win.exe" GOTO end_if_copy_711
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextTTF_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_711
:end_if_release_710
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_712
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextHershey_Win.exe" GOTO end_if_copy_713
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextHershey_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_713
:end_if_release_712
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_714
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_ImageRegion_Win.exe" GOTO end_if_copy_715
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_ImageRegion_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_715
:end_if_release_714
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_716
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_FontTTF_Win.exe" GOTO end_if_copy_717
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_FontTTF_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_717
:end_if_release_716
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_718
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_MarkerSet_Win.exe" GOTO end_if_copy_719
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_MarkerSet_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_719
:end_if_release_718
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_720
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Image_Win.exe" GOTO end_if_copy_721
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Image_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_721
:end_if_release_720
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_722
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_SplineCurve_Win.exe" GOTO end_if_copy_723
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_SplineCurve_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_723
:end_if_release_722
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_724
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextVtk_Win.exe" GOTO end_if_copy_725
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextVtk_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_725
:end_if_release_724
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_726
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TestTexture_Win.exe" GOTO end_if_copy_727
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TestTexture_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_727
:end_if_release_726
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_728
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_HEPVis99_Win.exe" GOTO end_if_copy_729
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_HEPVis99_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_729
:end_if_release_728
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_730
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_FillContour_Win.exe" GOTO end_if_copy_731
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_FillContour_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_731
:end_if_release_730
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_732
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_LatexImage_Win.exe" GOTO end_if_copy_733
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_LatexImage_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_733
:end_if_release_732
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_734
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Grid_Win.exe" GOTO end_if_copy_735
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Grid_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_735
:end_if_release_734
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_736
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_RulerRegion_Win.exe" GOTO end_if_copy_737
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_RulerRegion_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_737
:end_if_release_736
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_738
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axis_Win.exe" GOTO end_if_copy_739
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axis_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_739
:end_if_release_738
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_740
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axes2D_Win.exe" GOTO end_if_copy_741
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axes2D_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_741
:end_if_release_740
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_742
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axes3D_Win.exe" GOTO end_if_copy_743
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axes3D_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_743
:end_if_release_742
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_744
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_HatchBox_Win.exe" GOTO end_if_copy_745
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_HatchBox_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_745
:end_if_release_744
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_746
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Polyhedron_Win.exe" GOTO end_if_copy_747
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Polyhedron_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_747
:end_if_release_746
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_748
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_CoordinateAxis_Win.exe" GOTO end_if_copy_749
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_CoordinateAxis_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_749
:end_if_release_748
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_750
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Torus_Win.exe" GOTO end_if_copy_751
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Torus_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_751
:end_if_release_750
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_752
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Box_Win.exe" GOTO end_if_copy_753
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Box_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_753
:end_if_release_752
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_754
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Cons_Win.exe" GOTO end_if_copy_755
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Cons_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_755
:end_if_release_754
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_756
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Trap_Win.exe" GOTO end_if_copy_757
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Trap_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_757
:end_if_release_756
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_758
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Trd_Win.exe" GOTO end_if_copy_759
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Trd_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_759
:end_if_release_758
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_760
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Tubs_Win.exe" GOTO end_if_copy_761
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Tubs_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_761
:end_if_release_760
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_762
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Arrow_Win.exe" GOTO end_if_copy_763
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Arrow_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_763
:end_if_release_762
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_764
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Ellipsoid_Win.exe" GOTO end_if_copy_765
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Ellipsoid_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_765
:end_if_release_764
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_766
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_EllipsoidSegment_Win.exe" GOTO end_if_copy_767
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_EllipsoidSegment_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_767
:end_if_release_766
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_768
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_EllipticalPrism_Win.exe" GOTO end_if_copy_769
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_EllipticalPrism_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_769
:end_if_release_768
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_770
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Pcon_Win.exe" GOTO end_if_copy_771
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Pcon_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_771
:end_if_release_770
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_772
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_PolyVol_Win.exe" GOTO end_if_copy_773
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_PolyVol_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_773
:end_if_release_772
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_774
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Test2D_Win.exe" GOTO end_if_copy_775
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Test2D_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_775
:end_if_release_774
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_776
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_DetectorTreeKit_Win.exe" GOTO end_if_copy_777
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_DetectorTreeKit_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_777
:end_if_release_776
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_778
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_TestWedge_Win.exe" GOTO end_if_copy_779
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_TestWedge_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_779
:end_if_release_778
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_780
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_HelicalTrack_Win.exe" GOTO end_if_copy_781
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_HelicalTrack_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_781
:end_if_release_780
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_782
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_DblSiStripDetKit_Win.exe" GOTO end_if_copy_783
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_DblSiStripDetKit_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_783
:end_if_release_782
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_784
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_ReconTrack_Win.exe" GOTO end_if_copy_785
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_ReconTrack_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_785
:end_if_release_784
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_786
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_SiStripDetKit_Win.exe" GOTO end_if_copy_787
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_SiStripDetKit_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_787
:end_if_release_786
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_788
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_SiStrips_Win.exe" GOTO end_if_copy_789
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_SiStrips_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_789
:end_if_release_788
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_790
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_StereoSiStripDetKit_Win.exe" GOTO end_if_copy_791
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_StereoSiStripDetKit_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_791
:end_if_release_790
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_792
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_CrystalHit_Win.exe" GOTO end_if_copy_793
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_CrystalHit_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_793
:end_if_release_792
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_794
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_HadEmCrystalHit_Win.exe" GOTO end_if_copy_795
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_HadEmCrystalHit_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_795
:end_if_release_794
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_796
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_Jet_Win.exe" GOTO end_if_copy_797
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_Jet_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_797
:end_if_release_796
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_798
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_VtxReconTrack_Win.exe" GOTO end_if_copy_799
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_VtxReconTrack_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_799
:end_if_release_798
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_800
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_IdealTrackKit_Win.exe" GOTO end_if_copy_801
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_IdealTrackKit_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_801
:end_if_release_800
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_802
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_MeterStickKit_Win.exe" GOTO end_if_copy_803
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_MeterStickKit_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_803
:end_if_release_802
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_804
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_Plotter_Win.exe" GOTO end_if_copy_805
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_Plotter_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_805
:end_if_release_804
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_806
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_Page_Win.exe" GOTO end_if_copy_807
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_Page_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_807
:end_if_release_806
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_808
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Shell_Win.exe" GOTO end_if_copy_809
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Shell_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_809
:end_if_release_808
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_810
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Command_Win.exe" GOTO end_if_copy_811
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Command_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_811
:end_if_release_810
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_812
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Text_Win.exe" GOTO end_if_copy_813
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Text_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_813
:end_if_release_812
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_814
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Primitive_Win.exe" GOTO end_if_copy_815
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Primitive_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_815
:end_if_release_814
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_816
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_List_Win.exe" GOTO end_if_copy_817
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_List_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_817
:end_if_release_816
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_818
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_PushButton_Win.exe" GOTO end_if_copy_819
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_PushButton_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_819
:end_if_release_818
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_820
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_ArrowButton_Win.exe" GOTO end_if_copy_821
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_ArrowButton_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_821
:end_if_release_820
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_822
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_FileSelectionBox_Win.exe" GOTO end_if_copy_823
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_FileSelectionBox_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_823
:end_if_release_822
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_824
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Form_Win.exe" GOTO end_if_copy_825
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Form_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_825
:end_if_release_824
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_826
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_ScrolledList_Win.exe" GOTO end_if_copy_827
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_ScrolledList_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_827
:end_if_release_826
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_828
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_SelectionBox_Win.exe" GOTO end_if_copy_829
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_SelectionBox_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_829
:end_if_release_828
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_830
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_FileSelection_Win.exe" GOTO end_if_copy_831
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_FileSelection_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_831
:end_if_release_830
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_832
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Selection_Win.exe" GOTO end_if_copy_833
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Selection_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_833
:end_if_release_832
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_834
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_GUI_Plotters_Win.exe" GOTO end_if_copy_835
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_GUI_Plotters_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_835
:end_if_release_834
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_836
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_PainterViewer_Win.exe" GOTO end_if_copy_837
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_PainterViewer_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_837
:end_if_release_836
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_838
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_Read_Win.exe" GOTO end_if_copy_839
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_Read_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_839
:end_if_release_838
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_840
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_IvRead_Win.exe" GOTO end_if_copy_841
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_IvRead_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_841
:end_if_release_840
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_842
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_Show_Win.exe" GOTO end_if_copy_843
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_Show_Win.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_843
:end_if_release_842
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_844
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextTTF_Qt.exe" GOTO end_if_copy_845
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextTTF_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_845
:end_if_release_844
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_846
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Pyramid_Qt.exe" GOTO end_if_copy_847
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Pyramid_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_847
:end_if_release_846
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_848
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_SimpleButton_Qt.exe" GOTO end_if_copy_849
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_SimpleButton_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_849
:end_if_release_848
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_850
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextHershey_Qt.exe" GOTO end_if_copy_851
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextHershey_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_851
:end_if_release_850
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_852
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_ImageRegion_Qt.exe" GOTO end_if_copy_853
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_ImageRegion_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_853
:end_if_release_852
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_854
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_FontTTF_Qt.exe" GOTO end_if_copy_855
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_FontTTF_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_855
:end_if_release_854
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_856
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_MarkerSet_Qt.exe" GOTO end_if_copy_857
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_MarkerSet_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_857
:end_if_release_856
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_858
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Image_Qt.exe" GOTO end_if_copy_859
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Image_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_859
:end_if_release_858
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_860
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_SplineCurve_Qt.exe" GOTO end_if_copy_861
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_SplineCurve_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_861
:end_if_release_860
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_862
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextVtk_Qt.exe" GOTO end_if_copy_863
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextVtk_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_863
:end_if_release_862
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_864
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TestTexture_Qt.exe" GOTO end_if_copy_865
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TestTexture_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_865
:end_if_release_864
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_866
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_HEPVis99_Qt.exe" GOTO end_if_copy_867
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_HEPVis99_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_867
:end_if_release_866
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_868
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_FillContour_Qt.exe" GOTO end_if_copy_869
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_FillContour_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_869
:end_if_release_868
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_870
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_LatexImage_Qt.exe" GOTO end_if_copy_871
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_LatexImage_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_871
:end_if_release_870
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_872
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Grid_Qt.exe" GOTO end_if_copy_873
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Grid_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_873
:end_if_release_872
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_874
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_RulerRegion_Qt.exe" GOTO end_if_copy_875
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_RulerRegion_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_875
:end_if_release_874
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_876
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axis_Qt.exe" GOTO end_if_copy_877
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axis_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_877
:end_if_release_876
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_878
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axes2D_Qt.exe" GOTO end_if_copy_879
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axes2D_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_879
:end_if_release_878
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_880
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axes3D_Qt.exe" GOTO end_if_copy_881
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axes3D_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_881
:end_if_release_880
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_882
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_HatchBox_Qt.exe" GOTO end_if_copy_883
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_HatchBox_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_883
:end_if_release_882
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_884
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Polyhedron_Qt.exe" GOTO end_if_copy_885
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Polyhedron_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_885
:end_if_release_884
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_886
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_CoordinateAxis_Qt.exe" GOTO end_if_copy_887
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_CoordinateAxis_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_887
:end_if_release_886
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_888
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Torus_Qt.exe" GOTO end_if_copy_889
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Torus_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_889
:end_if_release_888
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_890
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Box_Qt.exe" GOTO end_if_copy_891
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Box_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_891
:end_if_release_890
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_892
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Cons_Qt.exe" GOTO end_if_copy_893
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Cons_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_893
:end_if_release_892
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_894
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Trap_Qt.exe" GOTO end_if_copy_895
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Trap_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_895
:end_if_release_894
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_896
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Trd_Qt.exe" GOTO end_if_copy_897
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Trd_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_897
:end_if_release_896
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_898
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Tubs_Qt.exe" GOTO end_if_copy_899
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Tubs_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_899
:end_if_release_898
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_900
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Arrow_Qt.exe" GOTO end_if_copy_901
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Arrow_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_901
:end_if_release_900
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_902
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Ellipsoid_Qt.exe" GOTO end_if_copy_903
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Ellipsoid_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_903
:end_if_release_902
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_904
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_EllipsoidSegment_Qt.exe" GOTO end_if_copy_905
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_EllipsoidSegment_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_905
:end_if_release_904
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_906
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_EllipticalPrism_Qt.exe" GOTO end_if_copy_907
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_EllipticalPrism_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_907
:end_if_release_906
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_908
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Pcon_Qt.exe" GOTO end_if_copy_909
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Pcon_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_909
:end_if_release_908
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_910
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_PolyVol_Qt.exe" GOTO end_if_copy_911
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_PolyVol_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_911
:end_if_release_910
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_912
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Test2D_Qt.exe" GOTO end_if_copy_913
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Test2D_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_913
:end_if_release_912
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_914
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_DetectorTreeKit_Qt.exe" GOTO end_if_copy_915
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_DetectorTreeKit_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_915
:end_if_release_914
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_916
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_TestWedge_Qt.exe" GOTO end_if_copy_917
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_TestWedge_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_917
:end_if_release_916
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_918
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_HelicalTrack_Qt.exe" GOTO end_if_copy_919
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_HelicalTrack_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_919
:end_if_release_918
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_920
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_DblSiStripDetKit_Qt.exe" GOTO end_if_copy_921
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_DblSiStripDetKit_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_921
:end_if_release_920
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_922
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_ReconTrack_Qt.exe" GOTO end_if_copy_923
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_ReconTrack_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_923
:end_if_release_922
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_924
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_SiStripDetKit_Qt.exe" GOTO end_if_copy_925
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_SiStripDetKit_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_925
:end_if_release_924
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_926
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_SiStrips_Qt.exe" GOTO end_if_copy_927
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_SiStrips_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_927
:end_if_release_926
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_928
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_StereoSiStripDetKit_Qt.exe" GOTO end_if_copy_929
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_StereoSiStripDetKit_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_929
:end_if_release_928
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_930
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_CrystalHit_Qt.exe" GOTO end_if_copy_931
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_CrystalHit_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_931
:end_if_release_930
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_932
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_HadEmCrystalHit_Qt.exe" GOTO end_if_copy_933
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_HadEmCrystalHit_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_933
:end_if_release_932
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_934
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_Jet_Qt.exe" GOTO end_if_copy_935
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_Jet_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_935
:end_if_release_934
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_936
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_VtxReconTrack_Qt.exe" GOTO end_if_copy_937
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_VtxReconTrack_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_937
:end_if_release_936
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_938
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_IdealTrackKit_Qt.exe" GOTO end_if_copy_939
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_IdealTrackKit_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_939
:end_if_release_938
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_940
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_MeterStickKit_Qt.exe" GOTO end_if_copy_941
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_MeterStickKit_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_941
:end_if_release_940
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_942
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_Plotter_Qt.exe" GOTO end_if_copy_943
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_Plotter_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_943
:end_if_release_942
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_944
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_Page_Qt.exe" GOTO end_if_copy_945
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_Page_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_945
:end_if_release_944
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_946
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Shell_Qt.exe" GOTO end_if_copy_947
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Shell_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_947
:end_if_release_946
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_948
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Command_Qt.exe" GOTO end_if_copy_949
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Command_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_949
:end_if_release_948
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_950
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Text_Qt.exe" GOTO end_if_copy_951
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Text_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_951
:end_if_release_950
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_952
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Primitive_Qt.exe" GOTO end_if_copy_953
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Primitive_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_953
:end_if_release_952
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_954
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_List_Qt.exe" GOTO end_if_copy_955
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_List_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_955
:end_if_release_954
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_956
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_PushButton_Qt.exe" GOTO end_if_copy_957
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_PushButton_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_957
:end_if_release_956
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_958
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_ArrowButton_Qt.exe" GOTO end_if_copy_959
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_ArrowButton_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_959
:end_if_release_958
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_960
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_FileSelectionBox_Qt.exe" GOTO end_if_copy_961
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_FileSelectionBox_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_961
:end_if_release_960
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_962
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Form_Qt.exe" GOTO end_if_copy_963
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Form_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_963
:end_if_release_962
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_964
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_ScrolledList_Qt.exe" GOTO end_if_copy_965
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_ScrolledList_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_965
:end_if_release_964
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_966
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_SelectionBox_Qt.exe" GOTO end_if_copy_967
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_SelectionBox_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_967
:end_if_release_966
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_968
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_FileSelection_Qt.exe" GOTO end_if_copy_969
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_FileSelection_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_969
:end_if_release_968
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_970
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Selection_Qt.exe" GOTO end_if_copy_971
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Selection_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_971
:end_if_release_970
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_972
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_GUI_Plotters_Qt.exe" GOTO end_if_copy_973
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_GUI_Plotters_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_973
:end_if_release_972
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_974
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_PainterViewer_Qt.exe" GOTO end_if_copy_975
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_PainterViewer_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_975
:end_if_release_974
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_976
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_Game_SDL.exe" GOTO end_if_copy_977
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_Game_SDL.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_977
:end_if_release_976
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_978
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_Show_SDL.exe" GOTO end_if_copy_979
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_Show_SDL.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_979
:end_if_release_978
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_980
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GameCube_SDL.exe" GOTO end_if_copy_981
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GameCube_SDL.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_981
:end_if_release_980
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_982
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextTTF_gtk.exe" GOTO end_if_copy_983
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextTTF_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_983
:end_if_release_982
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_984
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Pyramid_gtk.exe" GOTO end_if_copy_985
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Pyramid_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_985
:end_if_release_984
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_986
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_SimpleButton_gtk.exe" GOTO end_if_copy_987
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_SimpleButton_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_987
:end_if_release_986
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_988
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextHershey_gtk.exe" GOTO end_if_copy_989
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextHershey_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_989
:end_if_release_988
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_990
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_ImageRegion_gtk.exe" GOTO end_if_copy_991
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_ImageRegion_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_991
:end_if_release_990
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_992
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_FontTTF_gtk.exe" GOTO end_if_copy_993
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_FontTTF_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_993
:end_if_release_992
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_994
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_MarkerSet_gtk.exe" GOTO end_if_copy_995
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_MarkerSet_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_995
:end_if_release_994
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_996
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Image_gtk.exe" GOTO end_if_copy_997
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Image_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_997
:end_if_release_996
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_998
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_SplineCurve_gtk.exe" GOTO end_if_copy_999
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_SplineCurve_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_999
:end_if_release_998
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1000
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextVtk_gtk.exe" GOTO end_if_copy_1001
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TextVtk_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1001
:end_if_release_1000
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1002
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TestTexture_gtk.exe" GOTO end_if_copy_1003
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_TestTexture_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1003
:end_if_release_1002
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1004
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_HEPVis99_gtk.exe" GOTO end_if_copy_1005
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_HEPVis99_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1005
:end_if_release_1004
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1006
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_FillContour_gtk.exe" GOTO end_if_copy_1007
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_FillContour_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1007
:end_if_release_1006
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1008
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_LatexImage_gtk.exe" GOTO end_if_copy_1009
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_LatexImage_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1009
:end_if_release_1008
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1010
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Grid_gtk.exe" GOTO end_if_copy_1011
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Grid_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1011
:end_if_release_1010
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1012
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_RulerRegion_gtk.exe" GOTO end_if_copy_1013
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_RulerRegion_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1013
:end_if_release_1012
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1014
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axis_gtk.exe" GOTO end_if_copy_1015
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axis_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1015
:end_if_release_1014
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1016
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axes2D_gtk.exe" GOTO end_if_copy_1017
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axes2D_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1017
:end_if_release_1016
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1018
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axes3D_gtk.exe" GOTO end_if_copy_1019
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_Axes3D_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1019
:end_if_release_1018
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1020
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_HatchBox_gtk.exe" GOTO end_if_copy_1021
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_utils_HatchBox_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1021
:end_if_release_1020
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1022
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Polyhedron_gtk.exe" GOTO end_if_copy_1023
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Polyhedron_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1023
:end_if_release_1022
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1024
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_CoordinateAxis_gtk.exe" GOTO end_if_copy_1025
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_CoordinateAxis_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1025
:end_if_release_1024
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1026
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Torus_gtk.exe" GOTO end_if_copy_1027
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Torus_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1027
:end_if_release_1026
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1028
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Box_gtk.exe" GOTO end_if_copy_1029
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Box_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1029
:end_if_release_1028
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1030
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Cons_gtk.exe" GOTO end_if_copy_1031
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Cons_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1031
:end_if_release_1030
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1032
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Trap_gtk.exe" GOTO end_if_copy_1033
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Trap_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1033
:end_if_release_1032
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1034
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Trd_gtk.exe" GOTO end_if_copy_1035
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Trd_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1035
:end_if_release_1034
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1036
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Tubs_gtk.exe" GOTO end_if_copy_1037
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Tubs_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1037
:end_if_release_1036
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1038
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Arrow_gtk.exe" GOTO end_if_copy_1039
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Arrow_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1039
:end_if_release_1038
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1040
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Ellipsoid_gtk.exe" GOTO end_if_copy_1041
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Ellipsoid_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1041
:end_if_release_1040
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1042
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_EllipsoidSegment_gtk.exe" GOTO end_if_copy_1043
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_EllipsoidSegment_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1043
:end_if_release_1042
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1044
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_EllipticalPrism_gtk.exe" GOTO end_if_copy_1045
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_EllipticalPrism_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1045
:end_if_release_1044
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1046
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Pcon_gtk.exe" GOTO end_if_copy_1047
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Pcon_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1047
:end_if_release_1046
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1048
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_PolyVol_gtk.exe" GOTO end_if_copy_1049
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_PolyVol_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1049
:end_if_release_1048
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1050
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Test2D_gtk.exe" GOTO end_if_copy_1051
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_geometry_Test2D_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1051
:end_if_release_1050
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1052
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_DetectorTreeKit_gtk.exe" GOTO end_if_copy_1053
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_DetectorTreeKit_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1053
:end_if_release_1052
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1054
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_TestWedge_gtk.exe" GOTO end_if_copy_1055
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_TestWedge_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1055
:end_if_release_1054
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1056
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_HelicalTrack_gtk.exe" GOTO end_if_copy_1057
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_HelicalTrack_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1057
:end_if_release_1056
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1058
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_DblSiStripDetKit_gtk.exe" GOTO end_if_copy_1059
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_DblSiStripDetKit_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1059
:end_if_release_1058
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1060
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_ReconTrack_gtk.exe" GOTO end_if_copy_1061
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_ReconTrack_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1061
:end_if_release_1060
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1062
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_SiStripDetKit_gtk.exe" GOTO end_if_copy_1063
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_SiStripDetKit_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1063
:end_if_release_1062
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1064
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_SiStrips_gtk.exe" GOTO end_if_copy_1065
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_SiStrips_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1065
:end_if_release_1064
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1066
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_StereoSiStripDetKit_gtk.exe" GOTO end_if_copy_1067
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_StereoSiStripDetKit_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1067
:end_if_release_1066
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1068
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_CrystalHit_gtk.exe" GOTO end_if_copy_1069
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_CrystalHit_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1069
:end_if_release_1068
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1070
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_HadEmCrystalHit_gtk.exe" GOTO end_if_copy_1071
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_HadEmCrystalHit_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1071
:end_if_release_1070
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1072
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_Jet_gtk.exe" GOTO end_if_copy_1073
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_Jet_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1073
:end_if_release_1072
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1074
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_VtxReconTrack_gtk.exe" GOTO end_if_copy_1075
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_VtxReconTrack_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1075
:end_if_release_1074
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1076
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_IdealTrackKit_gtk.exe" GOTO end_if_copy_1077
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_IdealTrackKit_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1077
:end_if_release_1076
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1078
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_MeterStickKit_gtk.exe" GOTO end_if_copy_1079
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_detector_MeterStickKit_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1079
:end_if_release_1078
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1080
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_Plotter_gtk.exe" GOTO end_if_copy_1081
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_Plotter_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1081
:end_if_release_1080
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1082
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_Page_gtk.exe" GOTO end_if_copy_1083
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_Page_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1083
:end_if_release_1082
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1084
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Shell_gtk.exe" GOTO end_if_copy_1085
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Shell_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1085
:end_if_release_1084
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1086
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Command_gtk.exe" GOTO end_if_copy_1087
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Command_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1087
:end_if_release_1086
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1088
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Text_gtk.exe" GOTO end_if_copy_1089
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Text_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1089
:end_if_release_1088
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1090
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Primitive_gtk.exe" GOTO end_if_copy_1091
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Primitive_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1091
:end_if_release_1090
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1092
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_List_gtk.exe" GOTO end_if_copy_1093
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_List_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1093
:end_if_release_1092
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1094
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_PushButton_gtk.exe" GOTO end_if_copy_1095
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_PushButton_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1095
:end_if_release_1094
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1096
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_ArrowButton_gtk.exe" GOTO end_if_copy_1097
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_ArrowButton_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1097
:end_if_release_1096
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1098
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_FileSelectionBox_gtk.exe" GOTO end_if_copy_1099
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_FileSelectionBox_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1099
:end_if_release_1098
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1100
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Form_gtk.exe" GOTO end_if_copy_1101
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Form_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1101
:end_if_release_1100
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1102
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_ScrolledList_gtk.exe" GOTO end_if_copy_1103
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_ScrolledList_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1103
:end_if_release_1102
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1104
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_SelectionBox_gtk.exe" GOTO end_if_copy_1105
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_SelectionBox_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1105
:end_if_release_1104
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1106
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_FileSelection_gtk.exe" GOTO end_if_copy_1107
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_FileSelection_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1107
:end_if_release_1106
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1108
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Selection_gtk.exe" GOTO end_if_copy_1109
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_GUI_Selection_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1109
:end_if_release_1108
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1110
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_GUI_Plotters_gtk.exe" GOTO end_if_copy_1111
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_plotter_GUI_Plotters_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1111
:end_if_release_1110
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1112
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_PainterViewer_gtk.exe" GOTO end_if_copy_1113
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_PainterViewer_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1113
:end_if_release_1112
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HEPVis v6r10p0`) DO SET obuild_HEPVis_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_HEPVis_path  ECHO Can't find HEPVis package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HEPVis_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1114
IF NOT EXIST "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_exa_detector.exe" GOTO end_if_copy_1115
  COPY "%obuild_HEPVis_path%\%obuild_dir_bin%\HEPVis_exa_detector.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1115
:end_if_release_1114
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  KUIP v1r950303p18`) DO SET obuild_KUIP_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_KUIP_path  ECHO Can't find KUIP package.  && GOTO obuild_return

IF NOT EXIST "%obuild_KUIP_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_KUIP_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1116
IF NOT EXIST "%obuild_KUIP_path%\%obuild_dir_bin%\kuipcc.exe" GOTO end_if_copy_1117
  COPY "%obuild_KUIP_path%\%obuild_dir_bin%\kuipcc.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1117
:end_if_release_1116
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  KUIP v1r950303p18`) DO SET obuild_KUIP_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_KUIP_path  ECHO Can't find KUIP package.  && GOTO obuild_return

IF NOT EXIST "%obuild_KUIP_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_KUIP_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1118
IF NOT EXIST "%obuild_KUIP_path%\%obuild_dir_bin%\kuipsh.exe" GOTO end_if_copy_1119
  COPY "%obuild_KUIP_path%\%obuild_dir_bin%\kuipsh.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1119
:end_if_release_1118
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1120
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_onx.exe" GOTO end_if_copy_1121
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_onx.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1121
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\onx.exe" GOTO end_if_copy_1122
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\onx.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1122
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\osc.exe" GOTO end_if_copy_1123
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\osc.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1123
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_onx.save" GOTO end_if_copy_1124
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_onx.save" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1124
:end_if_release_1120
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1125
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_onx_config.exe" GOTO end_if_copy_1126
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_onx_config.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1126
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\onx-config.exe" GOTO end_if_copy_1127
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\onx-config.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1127
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\osc-config.exe" GOTO end_if_copy_1128
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\osc-config.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1128
:end_if_release_1125
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1129
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_obatch.exe" GOTO end_if_copy_1130
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_obatch.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1130
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\obatch.exe" GOTO end_if_copy_1131
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\obatch.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1131
:end_if_release_1129
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1132
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_test_GetLine.exe" GOTO end_if_copy_1133
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_test_GetLine.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1133
:end_if_release_1132
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1134
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_owin.exe" GOTO end_if_copy_1135
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_owin.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1135
:end_if_release_1134
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1136
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_oqt.exe" GOTO end_if_copy_1137
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_oqt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1137
:end_if_release_1136
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1138
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_test_Qt.exe" GOTO end_if_copy_1139
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_test_Qt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1139
:end_if_release_1138
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1140
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_test_Qt_page.exe" GOTO end_if_copy_1141
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_test_Qt_page.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1141
:end_if_release_1140
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1142
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_ogtk.exe" GOTO end_if_copy_1143
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_ogtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1143
:end_if_release_1142
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1144
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_test_gtk.exe" GOTO end_if_copy_1145
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_test_gtk.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1145
:end_if_release_1144
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1146
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_test_gtk_page.exe" GOTO end_if_copy_1147
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_test_gtk_page.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1147
:end_if_release_1146
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1148
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_oSDL.exe" GOTO end_if_copy_1149
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_oSDL.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1149
:end_if_release_1148
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1150
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_server.exe" GOTO end_if_copy_1151
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_server.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1151
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\oserver.exe" GOTO end_if_copy_1152
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\oserver.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1152
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_server.save" GOTO end_if_copy_1153
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_server.save" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1153
:end_if_release_1150
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1154
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_client.exe" GOTO end_if_copy_1155
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_client.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1155
:end_if_release_1154
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1156
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_test_Python.exe" GOTO end_if_copy_1157
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_test_Python.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1157
:end_if_release_1156
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1158
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_test_Python_1.exe" GOTO end_if_copy_1159
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_test_Python_1.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1159
:end_if_release_1158
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1160
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_exa_hello.exe" GOTO end_if_copy_1161
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_exa_hello.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1161
:end_if_release_1160
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1162
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_exa_OnX.exe" GOTO end_if_copy_1163
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_exa_OnX.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1163
:end_if_release_1162
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1164
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_exa_cube.exe" GOTO end_if_copy_1165
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_exa_cube.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1165
:end_if_release_1164
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1166
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_exa_detector.exe" GOTO end_if_copy_1167
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_exa_detector.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1167
:end_if_release_1166
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1168
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_exa_cylinder.exe" GOTO end_if_copy_1169
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_exa_cylinder.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1169
:end_if_release_1168
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1170
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_exa_images.exe" GOTO end_if_copy_1171
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_exa_images.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1171
:end_if_release_1170
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1172
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_exa_shapes.exe" GOTO end_if_copy_1173
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_exa_shapes.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1173
:end_if_release_1172
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1174
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_exa_menu.exe" GOTO end_if_copy_1175
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_exa_menu.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1175
:end_if_release_1174
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1176
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_exa_tree.exe" GOTO end_if_copy_1177
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_exa_tree.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1177
:end_if_release_1176
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1178
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_test_Java_hello.exe" GOTO end_if_copy_1179
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_test_Java_hello.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1179
:end_if_release_1178
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1180
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_exa_Java_cube.exe" GOTO end_if_copy_1181
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_exa_Java_cube.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1181
:end_if_release_1180
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1182
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_exa_Java_detector.exe" GOTO end_if_copy_1183
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_exa_Java_detector.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1183
:end_if_release_1182
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1184
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_exa_Java_hello.exe" GOTO end_if_copy_1185
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_exa_Java_hello.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1185
:end_if_release_1184
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1186
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_exa_Java_shapes.exe" GOTO end_if_copy_1187
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_exa_Java_shapes.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1187
:end_if_release_1186
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1188
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_exa_Java_std_vector.exe" GOTO end_if_copy_1189
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_exa_Java_std_vector.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1189
:end_if_release_1188
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnX v17r5p0`) DO SET obuild_OnX_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnX_path  ECHO Can't find OnX package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnX_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1190
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnX_exa_Java_typemaps.exe" GOTO end_if_copy_1191
  COPY "%obuild_OnX_path%\%obuild_dir_bin%\OnX_exa_Java_typemaps.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1191
:end_if_release_1190
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1192
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_aida_config.exe" GOTO end_if_copy_1193
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_aida_config.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1193
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\aida-config.exe" GOTO end_if_copy_1194
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\aida-config.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1194
:end_if_release_1192
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1195
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_config.exe" GOTO end_if_copy_1196
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_config.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1196
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_config.save" GOTO end_if_copy_1197
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_config.save" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1197
:end_if_release_1195
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1198
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_onx.exe" GOTO end_if_copy_1199
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_onx.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1199
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\onxlab.exe" GOTO end_if_copy_1200
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\onxlab.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1200
:end_if_release_1198
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1201
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_oxt.exe" GOTO end_if_copy_1202
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_oxt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1202
:end_if_release_1201
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1203
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_oqt.exe" GOTO end_if_copy_1204
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_oqt.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1204
:end_if_release_1203
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1205
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_analysis.exe" GOTO end_if_copy_1206
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_analysis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1206
:end_if_release_1205
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1207
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_plotter_factory.exe" GOTO end_if_copy_1208
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_plotter_factory.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1208
:end_if_release_1207
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1209
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_0.exe" GOTO end_if_copy_1210
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_0.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1210
:end_if_release_1209
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1211
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_1.exe" GOTO end_if_copy_1212
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_1.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1212
:end_if_release_1211
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1213
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_2.exe" GOTO end_if_copy_1214
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_2.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1214
:end_if_release_1213
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1215
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_3.exe" GOTO end_if_copy_1216
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_3.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1216
:end_if_release_1215
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1217
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_4.exe" GOTO end_if_copy_1218
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_4.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1218
:end_if_release_1217
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1219
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_5.exe" GOTO end_if_copy_1220
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_5.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1220
:end_if_release_1219
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1221
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_6.exe" GOTO end_if_copy_1222
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_6.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1222
:end_if_release_1221
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1223
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_7.exe" GOTO end_if_copy_1224
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_7.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1224
:end_if_release_1223
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1225
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_8.exe" GOTO end_if_copy_1226
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_8.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1226
:end_if_release_1225
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1227
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_9.exe" GOTO end_if_copy_1228
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_9.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1228
:end_if_release_1227
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1229
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_10.exe" GOTO end_if_copy_1230
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_10.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1230
:end_if_release_1229
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1231
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_11.exe" GOTO end_if_copy_1232
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_11.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1232
:end_if_release_1231
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1233
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_12.exe" GOTO end_if_copy_1234
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_12.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1234
:end_if_release_1233
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1235
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_13.exe" GOTO end_if_copy_1236
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_13.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1236
:end_if_release_1235
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1237
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_14.exe" GOTO end_if_copy_1238
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_14.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1238
:end_if_release_1237
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1239
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_quite_aida_0.exe" GOTO end_if_copy_1240
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_quite_aida_0.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1240
:end_if_release_1239
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1241
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_quite_aida_1.exe" GOTO end_if_copy_1242
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_quite_aida_1.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1242
:end_if_release_1241
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1243
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_quite_aida_3.exe" GOTO end_if_copy_1244
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_quite_aida_3.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1244
:end_if_release_1243
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1245
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_quite_aida_4.exe" GOTO end_if_copy_1246
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_quite_aida_4.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1246
:end_if_release_1245
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1247
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_quite_aida_5.exe" GOTO end_if_copy_1248
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_quite_aida_5.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1248
:end_if_release_1247
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1249
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_quite_aida_6.exe" GOTO end_if_copy_1250
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_quite_aida_6.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1250
:end_if_release_1249
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1251
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_quite_aida_7.exe" GOTO end_if_copy_1252
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_quite_aida_7.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1252
:end_if_release_1251
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1253
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_OnX_0.exe" GOTO end_if_copy_1254
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_OnX_0.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1254
:end_if_release_1253
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1255
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_OnX_1.exe" GOTO end_if_copy_1256
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_OnX_1.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1256
:end_if_release_1255
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1257
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_OnX_2.exe" GOTO end_if_copy_1258
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_OnX_2.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1258
:end_if_release_1257
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1259
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_OnX_3.exe" GOTO end_if_copy_1260
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_aida_OnX_3.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1260
:end_if_release_1259
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1261
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_update.exe" GOTO end_if_copy_1262
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_update.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1262
:end_if_release_1261
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1263
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_aida_0.exe" GOTO end_if_copy_1264
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_aida_0.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1264
:end_if_release_1263
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1265
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_aida_13.exe" GOTO end_if_copy_1266
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_aida_13.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1266
:end_if_release_1265
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1267
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_Chi2FitToHistogram.exe" GOTO end_if_copy_1268
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_Chi2FitToHistogram.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1268
:end_if_release_1267
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1269
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_Cloud.exe" GOTO end_if_copy_1270
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_Cloud.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1270
:end_if_release_1269
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1271
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_CloudCreate.exe" GOTO end_if_copy_1272
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_CloudCreate.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1272
:end_if_release_1271
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1273
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_ComplexFit.exe" GOTO end_if_copy_1274
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_ComplexFit.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1274
:end_if_release_1273
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1275
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_CreateAndFitDataPointSet.exe" GOTO end_if_copy_1276
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_CreateAndFitDataPointSet.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1276
:end_if_release_1275
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1277
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_DataPointSetCreateAndFill.exe" GOTO end_if_copy_1278
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_DataPointSetCreateAndFill.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1278
:end_if_release_1277
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1279
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_DataPointSetCreateFromData.exe" GOTO end_if_copy_1280
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_DataPointSetCreateFromData.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1280
:end_if_release_1279
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1281
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_FilterAndEvaluator.exe" GOTO end_if_copy_1282
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_FilterAndEvaluator.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1282
:end_if_release_1281
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1283
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_Fit.exe" GOTO end_if_copy_1284
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_Fit.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1284
:end_if_release_1283
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1285
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_Histogram.exe" GOTO end_if_copy_1286
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_Histogram.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1286
:end_if_release_1285
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1287
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_HistogramArithmetic.exe" GOTO end_if_copy_1288
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_HistogramArithmetic.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1288
:end_if_release_1287
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1289
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_Plot.exe" GOTO end_if_copy_1290
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_Plot.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1290
:end_if_release_1289
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1291
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_ProfileCreate.exe" GOTO end_if_copy_1292
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_ProfileCreate.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1292
:end_if_release_1291
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1293
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_ProfileFill.exe" GOTO end_if_copy_1294
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_ProfileFill.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1294
:end_if_release_1293
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1295
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_ProfileFitAndPlot.exe" GOTO end_if_copy_1296
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_ProfileFitAndPlot.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1296
:end_if_release_1295
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1297
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_Restore.exe" GOTO end_if_copy_1298
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_Restore.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1298
:end_if_release_1297
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1299
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_ScanAndContour.exe" GOTO end_if_copy_1300
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_ScanAndContour.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1300
:end_if_release_1299
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1301
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_SimpleFit.exe" GOTO end_if_copy_1302
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_SimpleFit.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1302
:end_if_release_1301
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1303
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_Store.exe" GOTO end_if_copy_1304
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_Store.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1304
:end_if_release_1303
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1305
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_Tree.exe" GOTO end_if_copy_1306
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_Tree.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1306
:end_if_release_1305
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1307
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_Tuple.exe" GOTO end_if_copy_1308
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_Tuple.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1308
:end_if_release_1307
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1309
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_TupleCreate.exe" GOTO end_if_copy_1310
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_TupleCreate.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1310
:end_if_release_1309
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OnXLab v1r2p0`) DO SET obuild_OnXLab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OnXLab_path  ECHO Can't find OnXLab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OnXLab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1311
IF NOT EXIST "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_createAndFillTupleWithComplexStructure.exe" GOTO end_if_copy_1312
  COPY "%obuild_OnXLab_path%\%obuild_dir_bin%\OnXLab_exa_Java_SLAC_createAndFillTupleWithComplexStructure.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1312
:end_if_release_1311
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1313
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_ChainedAndFilteredTuplesExample_vis.exe" GOTO end_if_copy_1314
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_ChainedAndFilteredTuplesExample_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1314
:end_if_release_1313
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1315
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_Cloud_vis.exe" GOTO end_if_copy_1316
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_Cloud_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1316
:end_if_release_1315
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1317
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_CloudCreate_vis.exe" GOTO end_if_copy_1318
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_CloudCreate_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1318
:end_if_release_1317
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1319
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_DataPointSetCreateAndFill_vis.exe" GOTO end_if_copy_1320
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_DataPointSetCreateAndFill_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1320
:end_if_release_1319
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1321
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_FilterAndEvaluatorExample_vis.exe" GOTO end_if_copy_1322
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_FilterAndEvaluatorExample_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1322
:end_if_release_1321
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1323
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_Histogram_vis.exe" GOTO end_if_copy_1324
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_Histogram_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1324
:end_if_release_1323
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1325
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_HistogramArithmetic_vis.exe" GOTO end_if_copy_1326
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_HistogramArithmetic_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1326
:end_if_release_1325
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1327
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_PlotExample_vis.exe" GOTO end_if_copy_1328
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_PlotExample_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1328
:end_if_release_1327
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1329
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_PlotWithStyles_vis.exe" GOTO end_if_copy_1330
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_PlotWithStyles_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1330
:end_if_release_1329
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1331
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_ProfileCreate_vis.exe" GOTO end_if_copy_1332
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_ProfileCreate_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1332
:end_if_release_1331
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1333
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_ProfileFill_vis.exe" GOTO end_if_copy_1334
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_ProfileFill_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1334
:end_if_release_1333
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1335
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_Tree_vis.exe" GOTO end_if_copy_1336
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_Tree_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1336
:end_if_release_1335
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1337
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_Tuple_vis.exe" GOTO end_if_copy_1338
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_Tuple_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1338
:end_if_release_1337
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1339
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_TupleCreate_vis.exe" GOTO end_if_copy_1340
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_TupleCreate_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1340
:end_if_release_1339
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1341
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_createAndFillTupleWithComplexStructure_vis.exe" GOTO end_if_copy_1342
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_createAndFillTupleWithComplexStructure_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1342
:end_if_release_1341
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1343
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_DataPointSetCreateFromData_vis.exe" GOTO end_if_copy_1344
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_DataPointSetCreateFromData_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1344
:end_if_release_1343
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1345
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_Store_vis.exe" GOTO end_if_copy_1346
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_Store_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1346
:end_if_release_1345
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1347
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_Restore_vis.exe" GOTO end_if_copy_1348
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_Restore_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1348
:end_if_release_1347
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1349
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_Chi2FitToHistogram_vis.exe" GOTO end_if_copy_1350
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_Chi2FitToHistogram_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1350
:end_if_release_1349
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1351
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_ComplexFit_vis.exe" GOTO end_if_copy_1352
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_ComplexFit_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1352
:end_if_release_1351
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1353
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_CreateAndFitDataPointSet_vis.exe" GOTO end_if_copy_1354
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_CreateAndFitDataPointSet_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1354
:end_if_release_1353
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1355
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_FitExample_vis.exe" GOTO end_if_copy_1356
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_FitExample_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1356
:end_if_release_1355
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1357
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_ProfileFitAndPlot_vis.exe" GOTO end_if_copy_1358
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_ProfileFitAndPlot_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1358
:end_if_release_1357
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1359
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_ScanAndContour_vis.exe" GOTO end_if_copy_1360
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_ScanAndContour_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1360
:end_if_release_1359
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1361
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_SimpleFit_vis.exe" GOTO end_if_copy_1362
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_SimpleFit_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1362
:end_if_release_1361
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1363
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b1_vis.exe" GOTO end_if_copy_1364
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b1_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1364
:end_if_release_1363
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1365
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b2_vis.exe" GOTO end_if_copy_1366
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b2_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1366
:end_if_release_1365
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1367
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b3_vis.exe" GOTO end_if_copy_1368
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b3_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1368
:end_if_release_1367
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1369
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b4_vis.exe" GOTO end_if_copy_1370
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b4_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1370
:end_if_release_1369
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1371
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b5_vis.exe" GOTO end_if_copy_1372
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b5_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1372
:end_if_release_1371
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1373
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b6_vis.exe" GOTO end_if_copy_1374
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b6_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1374
:end_if_release_1373
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1375
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b7_vis.exe" GOTO end_if_copy_1376
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b7_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1376
:end_if_release_1375
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1377
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b8_vis.exe" GOTO end_if_copy_1378
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b8_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1378
:end_if_release_1377
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1379
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b11_vis.exe" GOTO end_if_copy_1380
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_anaphe_b11_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1380
:end_if_release_1379
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1381
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_jec_vis.exe" GOTO end_if_copy_1382
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_jec_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1382
:end_if_release_1381
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  VisAIDA v1r0p4`) DO SET obuild_VisAIDA_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_VisAIDA_path  ECHO Can't find VisAIDA package.  && GOTO obuild_return

IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_VisAIDA_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1383
IF NOT EXIST "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_rmason_vis.exe" GOTO end_if_copy_1384
  COPY "%obuild_VisAIDA_path%\%obuild_dir_bin%\AIDA_example_rmason_vis.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1384
:end_if_release_1383
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  OpenPAW v3r2p0`) DO SET obuild_OpenPAW_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_OpenPAW_path  ECHO Can't find OpenPAW package.  && GOTO obuild_return

IF NOT EXIST "%obuild_OpenPAW_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_OpenPAW_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1385
IF NOT EXIST "%obuild_OpenPAW_path%\%obuild_dir_bin%\OpenPAW_opaw.exe" GOTO end_if_copy_1386
  COPY "%obuild_OpenPAW_path%\%obuild_dir_bin%\OpenPAW_opaw.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1386
IF NOT EXIST "%obuild_OpenPAW_path%\%obuild_dir_bin%\opaw.exe" GOTO end_if_copy_1387
  COPY "%obuild_OpenPAW_path%\%obuild_dir_bin%\opaw.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1387
:end_if_release_1385
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  G4Lab v8r3p0`) DO SET obuild_G4Lab_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_G4Lab_path  ECHO Can't find G4Lab package.  && GOTO obuild_return

IF NOT EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_G4Lab_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1388
IF NOT EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%\G4Lab_g4lab_config.exe" GOTO end_if_copy_1389
  COPY "%obuild_G4Lab_path%\%obuild_dir_bin%\G4Lab_g4lab_config.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1389
IF NOT EXIST "%obuild_G4Lab_path%\%obuild_dir_bin%\g4lab-config.exe" GOTO end_if_copy_1390
  COPY "%obuild_G4Lab_path%\%obuild_dir_bin%\g4lab-config.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1390
:end_if_release_1388
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  G4Simple v2r2p0`) DO SET obuild_G4Simple_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_G4Simple_path  ECHO Can't find G4Simple package.  && GOTO obuild_return

IF NOT EXIST "%obuild_G4Simple_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_G4Simple_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1391
IF NOT EXIST "%obuild_G4Simple_path%\%obuild_dir_bin%\G4Simple_session.exe" GOTO end_if_copy_1392
  COPY "%obuild_G4Simple_path%\%obuild_dir_bin%\G4Simple_session.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1392
:end_if_release_1391
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  G4Examples v1r2p0`) DO SET obuild_G4Examples_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_G4Examples_path  ECHO Can't find G4Examples package.  && GOTO obuild_return

IF NOT EXIST "%obuild_G4Examples_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_G4Examples_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1393
IF NOT EXIST "%obuild_G4Examples_path%\%obuild_dir_bin%\G4Examples_N02.exe" GOTO end_if_copy_1394
  COPY "%obuild_G4Examples_path%\%obuild_dir_bin%\G4Examples_N02.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1394
:end_if_release_1393
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  G4Examples v1r2p0`) DO SET obuild_G4Examples_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_G4Examples_path  ECHO Can't find G4Examples package.  && GOTO obuild_return

IF NOT EXIST "%obuild_G4Examples_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_G4Examples_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1395
IF NOT EXIST "%obuild_G4Examples_path%\%obuild_dir_bin%\G4Examples_N03.exe" GOTO end_if_copy_1396
  COPY "%obuild_G4Examples_path%\%obuild_dir_bin%\G4Examples_N03.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1396
:end_if_release_1395
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  G4Examples v1r2p0`) DO SET obuild_G4Examples_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_G4Examples_path  ECHO Can't find G4Examples package.  && GOTO obuild_return

IF NOT EXIST "%obuild_G4Examples_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_G4Examples_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1397
IF NOT EXIST "%obuild_G4Examples_path%\%obuild_dir_bin%\G4Examples_N04.exe" GOTO end_if_copy_1398
  COPY "%obuild_G4Examples_path%\%obuild_dir_bin%\G4Examples_N04.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1398
:end_if_release_1397
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  G4Examples v1r2p0`) DO SET obuild_G4Examples_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_G4Examples_path  ECHO Can't find G4Examples package.  && GOTO obuild_return

IF NOT EXIST "%obuild_G4Examples_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_G4Examples_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1399
IF NOT EXIST "%obuild_G4Examples_path%\%obuild_dir_bin%\G4Examples_N05.exe" GOTO end_if_copy_1400
  COPY "%obuild_G4Examples_path%\%obuild_dir_bin%\G4Examples_N05.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1400
:end_if_release_1399
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  G4Examples v1r2p0`) DO SET obuild_G4Examples_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_G4Examples_path  ECHO Can't find G4Examples package.  && GOTO obuild_return

IF NOT EXIST "%obuild_G4Examples_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_G4Examples_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1401
IF NOT EXIST "%obuild_G4Examples_path%\%obuild_dir_bin%\G4Examples_N06.exe" GOTO end_if_copy_1402
  COPY "%obuild_G4Examples_path%\%obuild_dir_bin%\G4Examples_N06.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1402
:end_if_release_1401
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  G4Examples v1r2p0`) DO SET obuild_G4Examples_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_G4Examples_path  ECHO Can't find G4Examples package.  && GOTO obuild_return

IF NOT EXIST "%obuild_G4Examples_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_G4Examples_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1403
IF NOT EXIST "%obuild_G4Examples_path%\%obuild_dir_bin%\G4Examples_N07.exe" GOTO end_if_copy_1404
  COPY "%obuild_G4Examples_path%\%obuild_dir_bin%\G4Examples_N07.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1404
:end_if_release_1403
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  G4Examples v1r2p0`) DO SET obuild_G4Examples_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_G4Examples_path  ECHO Can't find G4Examples package.  && GOTO obuild_return

IF NOT EXIST "%obuild_G4Examples_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_G4Examples_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1405
IF NOT EXIST "%obuild_G4Examples_path%\%obuild_dir_bin%\G4Examples_AnaEx01.exe" GOTO end_if_copy_1406
  COPY "%obuild_G4Examples_path%\%obuild_dir_bin%\G4Examples_AnaEx01.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1406
:end_if_release_1405
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  G4Examples v1r2p0`) DO SET obuild_G4Examples_path=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
IF NOT DEFINED obuild_G4Examples_path  ECHO Can't find G4Examples package.  && GOTO obuild_return

IF NOT EXIST "%obuild_G4Examples_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_G4Examples_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_1407
IF NOT EXIST "%obuild_G4Examples_path%\%obuild_dir_bin%\G4Examples_A01.exe" GOTO end_if_copy_1408
  COPY "%obuild_G4Examples_path%\%obuild_dir_bin%\G4Examples_A01.exe" "%obuild_dir_project%\bin\." 1> copy_exe_error
  @IF ERRORLEVEL 1 @TYPE copy_exe_error && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL copy_exe_error
:end_if_copy_1408
:end_if_release_1407

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OpenScientist_1=%%d
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe`) DO SET obuild_platform_signature=%%j
cd "%obuild_pwd_OpenScientist_1%"
SET obuild_pwd_OpenScientist_1=
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF EXIST osc_vis-v16r5-%obuild_platform_signature%.zip DEL osc_vis-v16r5-%obuild_platform_signature%.zip
zip -q -r osc_vis-v16r5-%obuild_platform_signature%.zip OpenScientist
cd "%obuild_OpenScientist_path%\obuild"
cd "%obuild_OpenScientist_path%\%obuild_dir_bin%"
IF EXIST obuild_platform.exe DEL obuild_platform.exe
cd "%obuild_pwd_OpenScientist_0%"
SET obuild_pwd_OpenScientist_0=
:obuild_return
ENDLOCAL
@ECHO ON
